if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ET Explosion efects.. 101!!
// nuke done in 2 hours.

datablock ShockwaveData(ETRingShockwave)
{
   width = 36.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 90;
   acceleration = -30;
   lifetimeMS = 3000;
   height = 4.0;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.9 0.8 0.1 0.5";
   colors[1] = "0.9 0.8 0.1 0.8";
   colors[2] = "1.0 1.0 1.0 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = true;
};

datablock ShockwaveData(ETMainRingShockwave)
{
   width = 64.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 180;
   acceleration = -20;
   lifetimeMS = 5000;
   height = 3.0;
   verticalCurve = 0.5;
   is2D = false;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1 1 1 0.5";
   colors[1] = "1 1 1 0.8";
   colors[2] = "1 1 1 0.0";

   mapToTerrain = false;
   orientToNormal = false;
   renderBottom = true;
};

datablock ExplosionData(ETMortarExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   playSpeed = 0.1;
   faceViewer = true;

   sizes[0] = "7.5 7.5 7.5";
   sizes[1] = "7.5 7.5 7.5";
   times[0] = 0.0;
   times[1] = 1.0;

   soundProfile   = HugeExplosionSound;

   subExplosion[0] = ImpactSubExplosion1;
   subExplosion[1] = ImpactSubExplosion2;
   subExplosion[2] = ImpactSubExplosion3;

   emitter[0] = MortarExplosionSmokeEmitter;
   emitter[1] = ImpactCrescentEmitter;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};

datablock ExplosionData(ETMainRingExplosion)
{

   soundProfile   = HugeExplosionSound;

   shockwave = ETMainRingShockwave;

   emitter[0] = MortarExplosionSmokeEmitter;
   emitter[1] = MortarCrescentEmitter;

   shakeCamera = true;
   camShakeFreq = "15.0 15.0 15.0";
   camShakeAmp = "50.0 50.0 50.0";
   camShakeDuration = 3.5;
   camShakeRadius = 375.0;
};

datablock ExplosionData(ETRingExplosion)
{
   soundProfile   = MortarExplosionSound;

   shockwave = ETRingShockwave;

   emitter[0] = MortarExplosionSmokeEmitter;
   emitter[1] = ImpactCrescentEmitter;
   subExplosion[0] = ImpactSubExplosion1;
   subExplosion[1] = ImpactSubExplosion2;
   subExplosion[2] = ImpactSubExplosion3;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 12.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.0;
   camShakeRadius = 35.0;
};

datablock ExplosionData(TacMechRingExplosion)
{
   soundProfile   = MortarExplosionSound;

   shockwave = TacMechShockwave;

   emitter[0] = MortarExplosionSmokeEmitter;
   emitter[1] = ImpactCrescentEmitter;
   subExplosion[0] = ImpactSubExplosion1;
   subExplosion[1] = ImpactSubExplosion2;
   subExplosion[2] = ImpactSubExplosion3;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 12.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.0;
   camShakeRadius = 35.0;
};

datablock ExplosionData(ETMissileExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   playSpeed = 0.1;
   soundProfile   = MissileExplosionSound;
   faceViewer = true;

   sizes[0] = "6 6 6";
   sizes[1] = "6 6 6";
   times[0] = 0.0;
   times[1] = 1.0;

   subExplosion[0] = LargeMissileSubExplosion;
   emitter[0] = MortarExplosionSmokeEmitter;
   emitter[1] = MissileCrescentEmitter;
   emitter[2] = MissileSparkEmitter;

   shakeCamera = true;
   camShakeFreq = "6.0 7.0 7.0";
   camShakeAmp = "70.0 70.0 70.0";
   camShakeDuration = 1.0;
   camShakeRadius = 7.0;
};

datablock LinearFlareProjectileData(TacMechArmorBlowout)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 50.0;
   damageRadius        = 30.0;
   radiusDamageType    = $DamageType::Mortar;
   kickBackStrength    = 10000;

   explosion           = "TacMechRingExplosion";
   underwaterExplosion = "TacMechRingExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock LinearFlareProjectileData(ETD)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 15.0;
   damageRadius        = 375.0;
   radiusDamageType    = $DamageType::Nuke;
   kickBackStrength    = 0;

   explosion           = "ETMainRingExplosion";
   underwaterExplosion = "ETMainRingExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock LinearFlareProjectileData(ETMortar) : ETD
{
   indirectDamage      = 5.0;
   damageRadius        = 65.0;
   radiusDamageType    = $DamageType::Nuke;
   kickBackStrength    = 2000;

   explosion           = "ETMortarExplosion";
   underwaterExplosion = "UnderwaterMortarExplosion";
};

datablock LinearFlareProjectileData(ETMissile) : ETD
{
   indirectDamage      = 0.5;
   damageRadius        = 40.0;
   radiusDamageType    = $DamageType::Nuke;
   kickBackStrength    = 2000;

   explosion           = "ETMissileExplosion";
   underwaterExplosion = "UnderwaterHandGrenadeExplosion";
};

datablock LinearFlareProjectileData(ETSmallWave) : ETD
{
   indirectDamage      = 0.8;
   damageRadius        = 35.0;
   radiusDamageType    = $DamageType::Nuke;
   kickBackStrength    = 2000;

   explosion           = "ETRingExplosion";
   underwaterExplosion = "ETRingExplosion";
};

datablock LinearFlareProjectileData(ETMainWave) : ETD
{
   indirectDamage      = 50;
   damageRadius        = 100.0;
   radiusDamageType    = $DamageType::Nuke;
   kickBackStrength    = 2000;

   explosion           = "ETMainRingExplosion";
   underwaterExplosion = "ETMainRingExplosion";
};

function etExplode(%src, %option, %pos, %mod)
{
   if(isObject(%src))
   {
      %final = vectorAdd(%pos, %mod);
      %p = new LinearFlareProjectile()
      {
         dataBlock        = %option;
         initialDirection = "0 0 0";
         initialPosition  = %final;
         sourceObject     = %src.bks;
         sourceSlot       = 0;
      };
      MissionCleanup.add(%p);

//      %p.sourceObject = %src;
   }
}

function etShock(%src, %option, %pos, %mod)
{
   if(isObject(%src))
   {
      %final = vectorAdd(%pos, %mod);
      %p = new LinearFlareProjectile()
      {
         dataBlock        = %option;
         initialDirection = "0 0 1";
         initialPosition  = %final;
         sourceObject     = %src.bks;
         sourceSlot       = 0;
      };
      MissionCleanup.add(%p);

//      %p.sourceObject = %src;
   }
}

function beginNuke(%obj, %pos, %bool) // 90 + random generated from loopFX() explosions total
{
   %obj.bks = new StaticShape()
   {
      dataBlock        = mReflector;
   };
   MissionCleanup.add(%obj.bks);
   %obj.bks.setPosition(%pos);
   %obj.bks.schedule(5000, delete);

   loopDamageFX2(%obj, vectorAdd(%pos, "0 0 150"), 30, 100, 20, LinearFlareProjectile, ETMortar); // random explosion effect

   etExplode(%obj, ETMissile, %pos, "10 0 5"); // base
   etExplode(%obj, ETMissile, %pos, "-10 0 5");
   etExplode(%obj, ETMissile, %pos, "0 10 5");
   etExplode(%obj, ETMissile, %pos, "0 -10 5");
   etExplode(%obj, ETMissile, %pos, "10 10 5");
   etExplode(%obj, ETMissile, %pos, "-10 -10 5");
   etExplode(%obj, ETMissile, %pos, "-10 10 5");
   etExplode(%obj, ETMissile, %pos, "10 -10 5");

   etExplode(%obj, ETMissile, %pos, "0 0 5"); // stem (recursive loop rendering)
   etExplode(%obj, ETMissile, %pos, "0 0 10");
   for(%i = 0; %i < 17; %i++)
   {
      if(%z < 10)
         %z = 10;
      else
         %z += 5;

      %mod = "0 0 "@%z;

      etExplode(%obj, ETMortar, %pos, %mod);
   }

   if(!%bool)
      schedule(250, 0, nukStage2, %obj, %pos);
}

function nukStage2(%obj, %pos)
{
   etExplode(%obj, ETSmallWave, %pos, "0 0 20"); // 4 mini-shockwaves
   etExplode(%obj, ETSmallWave, %pos, "0 0 45");
   etExplode(%obj, ETSmallWave, %pos, "0 0 62.5");
   etExplode(%obj, ETSmallWave, %pos, "0 0 80");

   etExplode(%obj, ETMainWave, %pos, "0 0 45"); // huge shockwave

   etExplode(%obj, ETD, %pos, "0 0 44"); // Nuke Damage Blast

   etExplode(%obj, ETMissile, %pos, "10 0 100"); // Top of nuke, slice 1
   etExplode(%obj, ETMissile, %pos, "-10 0 100");
   etExplode(%obj, ETMissile, %pos, "0 10 100");
   etExplode(%obj, ETMissile, %pos, "0 -10 100");
   etExplode(%obj, ETMissile, %pos, "10 10 100");
   etExplode(%obj, ETMissile, %pos, "-10 -10 100");
   etExplode(%obj, ETMissile, %pos, "-10 10 100");
   etExplode(%obj, ETMissile, %pos, "10 -10 100");

   etExplode(%obj, ETMissile, %pos, "15 0 110"); // Top of nuke, slice 2
   etExplode(%obj, ETMissile, %pos, "-15 0 110");
   etExplode(%obj, ETMissile, %pos, "0 15 110");
   etExplode(%obj, ETMissile, %pos, "0 -15 110");
   etExplode(%obj, ETMissile, %pos, "15 15 110");
   etExplode(%obj, ETMissile, %pos, "-15 -15 110");
   etExplode(%obj, ETMissile, %pos, "-15 15 110");
   etExplode(%obj, ETMissile, %pos, "15 -15 110");

   etExplode(%obj, ETMissile, %pos, "20 0 120"); // Top of nuke, slice 3
   etExplode(%obj, ETMissile, %pos, "-20 0 120");
   etExplode(%obj, ETMissile, %pos, "0 20 120");
   etExplode(%obj, ETMissile, %pos, "0 -20 120");
   etExplode(%obj, ETMissile, %pos, "20 20 120");
   etExplode(%obj, ETMissile, %pos, "-20 -20 120");
   etExplode(%obj, ETMissile, %pos, "-20 20 120");
   etExplode(%obj, ETMissile, %pos, "20 -20 120");

   etExplode(%obj, ETMissile, %pos, "25 0 130"); // Top of nuke, slice 4
   etExplode(%obj, ETMissile, %pos, "-25 0 130");
   etExplode(%obj, ETMissile, %pos, "0 25 130");
   etExplode(%obj, ETMissile, %pos, "0 -25 130");
   etExplode(%obj, ETMissile, %pos, "25 25 130");
   etExplode(%obj, ETMissile, %pos, "-25 -25 130");
   etExplode(%obj, ETMissile, %pos, "-25 25 130");
   etExplode(%obj, ETMissile, %pos, "25 -25 130");

   etExplode(%obj, ETMissile, %pos, "20 0 140"); // Top of nuke, slice 5
   etExplode(%obj, ETMissile, %pos, "-20 0 140");
   etExplode(%obj, ETMissile, %pos, "0 20 140");
   etExplode(%obj, ETMissile, %pos, "0 -20 140");
   etExplode(%obj, ETMissile, %pos, "20 20 140");
   etExplode(%obj, ETMissile, %pos, "-20 -20 140");
   etExplode(%obj, ETMissile, %pos, "-20 20 140");
   etExplode(%obj, ETMissile, %pos, "20 -20 140");

   etExplode(%obj, ETMissile, %pos, "15 0 150"); // Top of nuke, slice 6
   etExplode(%obj, ETMissile, %pos, "-15 0 150");
   etExplode(%obj, ETMissile, %pos, "0 15 150");
   etExplode(%obj, ETMissile, %pos, "0 -15 150");
   etExplode(%obj, ETMissile, %pos, "15 15 150");
   etExplode(%obj, ETMissile, %pos, "-15 -15 150");
   etExplode(%obj, ETMissile, %pos, "-15 15 150");
   etExplode(%obj, ETMissile, %pos, "15 -15 150");

   etExplode(%obj, ETMissile, %pos, "10 0 160"); // Top of nuke, slice 7
   etExplode(%obj, ETMissile, %pos, "-10 0 160");
   etExplode(%obj, ETMissile, %pos, "0 10 160");
   etExplode(%obj, ETMissile, %pos, "0 -10 160");
   etExplode(%obj, ETMissile, %pos, "10 10 160");
   etExplode(%obj, ETMissile, %pos, "-10 -10 160");
   etExplode(%obj, ETMissile, %pos, "-10 10 160");
   etExplode(%obj, ETMissile, %pos, "10 -10 160");

   etExplode(%obj, ETMissile, %pos, "0 0 170"); // Cap of nuke

   schedule(750, 0, beginNuke, %obj, %pos, true);
}

function beginMiniNuke(%cl, %pos)
{
   %obj = %cl.player;
   loopDamageFX2(%obj, vectorAdd(%pos, "0 0 20"), 5, 50, 20, LinearFlareProjectile, ReaverCharge); // random explosion effect

   etExplode(%obj, ReaverCharge, %pos, "1 0 0.5"); // base
   etExplode(%obj, ReaverCharge, %pos, "-1 0 0.5");
   etExplode(%obj, ReaverCharge, %pos, "0 1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "0 -1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "1 1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "-1 -1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "-1 1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "1 -1 0.5");

   etExplode(%obj, ReaverCharge, %pos, "0 0 0.5"); // stem (recursive loop rendering)
   etShock(%obj, BAArmorBlowout, %pos, "0 0 8"); // shockwave

   for(%i = 0; %i < 15; %i++)
   {
      %mod = "0 0 "@%i;

      etExplode(%obj, ReaverCharge, %pos, %mod);
   }

   schedule(1500, 0, continueMiniNuke, %cl, %pos);
}

function continueMiniNuke(%cl, %pos)
{
   %obj = %cl.player;

   etExplode(%obj, ReaverCharge, %pos, "1 0 0.5"); // base
   etExplode(%obj, ReaverCharge, %pos, "-1 0 0.5");
   etExplode(%obj, ReaverCharge, %pos, "0 1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "0 -1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "1 1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "-1 -1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "-1 1 0.5");
   etExplode(%obj, ReaverCharge, %pos, "1 -1 0.5");

   etExplode(%obj, ReaverCharge, %pos, "0 0 0.5"); // stem (recursive loop rendering)

   for(%i = 0; %i < 15; %i++)
   {
      %mod = "0 0 "@%i;

      etExplode(%obj, ReaverCharge, %pos, %mod);
   }
}
