// DataBlocks

datablock ForceFieldBareData(VehicleField)
{
   fadeMS           = 3000;
   baseTranslucency = 0.8;
   powerOffTranslucency = 0.0;
   teamPermiable    = false; //no...bad munkie
   otherPermiable   = false;
   color            = "0.6 0.6 0.4";
   powerOffColor    = "0.6 0.6 0.1";
   targetNameTag    = 'Force Field';
   targetTypeTag    = 'ForceField';

   texture[0] = "LiquidTiles/LavaPool01";
   texture[1] = "LiquidTiles/LavaPool02";
   texture[2] = "LiquidTiles/LavaPool03";

   framesPerSec = 8;
   numFrames = 3;
   scrollSpeed = 0.0;
   umapping = 0.15;
   vmapping = 0.15;
};

datablock TriggerData(VpadTrigger)
{
  tickPeriodMS = 80;
};

datablock StaticShapeData(DBasePiece) : StaticShapeDamageProfile
{
   shapeFile      = "pmiscf.dts";
   explosion      = ShapeExplosion;

   maxDamage      = 30;
   destroyedLevel = 30;
   disabledLevel  = 30;

   expDmgRadius = 5.0;
   expDamage = 0.1;
   expImpulse = 1500.0;

   isShielded = false;
   targetTypeTag = 'Defense Base';

//   debrisShapeName = "debris_generic.dts";
//   debris = StaticShapeDebris;
};

datablock StaticShapeData(DBaseBlock) : DBasePiece
{
   shapeFile      = "dmiscf.dts";
};

datablock StaticShapeData(DBotBooster) : DBasePiece
{
   shapeFile      = "nexuscap.dts";
   targetTypeTag = 'Defense Base Antigrav Unit';
};

datablock StaticShapeData(DBBotBoostPlatform) : DBasePiece
{
   shapeFile      = "stackable3l.dts";
};

datablock StaticShapeData(DBBotBoostSide) : DBasePiece
{
   shapeFile      = "stackable5l.dts";
};

datablock StaticShapeData(DBRoof) : DBasePiece
{
   shapeFile      = "stackable3m.dts";
};

datablock StaticShapeData(BBasePiece) : BombardmentDamageProfile
{
   shapeFile      = "pmiscf.dts";
   explosion      = ShapeExplosion;

   maxDamage      = 7.5;
   destroyedLevel = 7.5;
   disabledLevel  = 7.5;

   expDmgRadius = 5.0;
   expDamage = 0.1;
   expImpulse = 1500.0;

   isShielded = false;
   targetTypeTag = 'Bombardment Base';

//   debrisShapeName = "debris_generic.dts";
//   debris = StaticShapeDebris;
};

datablock StaticShapeData(VBasePiece) : DBasePiece
{
   maxDamage      = 15;
   destroyedLevel = 15;
   disabledLevel  = 15;

   targetTypeTag = 'Vehicle Base';
};

function VBasePiece::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

function DBasePiece::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

function BBasePiece::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

function DBaseBlock::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

function DBRoof::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

function DBBotBoostPlatform::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

function DBBotBoostSide::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

function DBotBooster::onDestroyed(%this, %obj, %prevState)
{
   if(isObject(%obj.parent))
      %obj.parent.setDamageState(Destroyed);

   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(250, "delete");
}

datablock ForceFieldBareData(BlueTransparentField)
{
   fadeMS           = 1000;
   baseTranslucency = 0.2;
   powerOffTranslucency = 0.0;

   teamPermiable    = true;
   otherPermiable   = false;
   color            = "0.28 0.28 0.99";
   powerOffColor    = "0.28 0.28 0.99";

   texture[0] = "skins/forcef1";
   texture[1] = "skins/forcef2";
   texture[2] = "skins/forcef3";
   texture[3] = "skins/forcef4";
   texture[4] = "skins/forcef5";

   framesPerSec = 10;
   numFrames = 5;
   scrollSpeed = 15;
   umapping = 1.0;
   vmapping = 0.15;
};

datablock ForceFieldBareData(YellowTransparentField) : BlueTransparentField
{
   color            = "0.99 0.87 0.28";
   powerOffColor    = "0.99 0.87 0.28";
   //they are secure..but not THAT secure
   teamPermiable    = true;
   otherPermiable   = true;
};

// Functions
function addTrigger(%plyr, %data, %pos, %rot, %vec, %scale, %parent)
{
   %Tg = new Trigger()
   {
      position = %pos;
      rotation = %rot;
      scale = %scale;
      dataBlock = %data;
      team = %plyr.client.team;
   };
   %Tg.setDeployRotation(%pos, %vec);

   %ff.target = createTarget(%TG, "Trigger", "", "", "", 0, 0);
   MissionCleanup.add(%Tg);
   //%Tg.parent = %parent;

   //if(!%parent.attachedFF)
   //   %parent.attachedFF = 0;

   //%parent.shield[%parent.attachedFF] = %Tg;
   //%parent.attachedFF++;

   //return %Tg;
}

function buildBombardmentBase(%obj, %pos, %item)
{
   %pos = vectorAdd(%pos, "0 0 5.3"); // +7m (all buildings centered)

   %trans = vectorAdd(%pos, "0 0 0.5") SPC "0 1 0 0";
   %parent = addMultiObjectManager(%obj, %trans);
   %parent.randExplode = true;
   %parent.type = 1;
   %parent.play3d(%item.deploySound);
   %trans = vectorAdd(%pos, "-4.32835 -4.4766 -4.875") SPC "0.0 0.0 1" SPC mDegToRad(45);
   %deplObjGen = addObject(%obj, "BaseGenerator", %trans, %parent);
   %deplObjGen.blastechCanRecharge = true;
   %deplObjGen.playThread(0, "power");
   %deplObjGen.protectedByFFBase = true;
   genUpdate(%deplObjGen);
   %trans = vectorAdd(%pos, "5.48525 5.5147 -4.875") SPC "0.0 0.0 1" SPC mDegToRad(45);
   addStation(%obj, %trans, %parent);
   addForcefield(%obj, "YellowTransparentField", vectorAdd(%pos, "-3.75125 -3.2702 0.614998"), "0.00472327 -0.000700689 -0.999989 0.153233", "7.52021 6.52029 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "-7.76095 7.7392 -4.885"), "-0.578387 0.576829 0.576834 119.911", "15.5203 5.52 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "7.78235 -8.239 -4.885"), "-0.00095513 0.707104 0.707109 179.891", "15.5201 5.52 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "7.73925 7.761 -4.885"), "-0.00095513 0.707104 0.707109 179.891", "15.5202 5.52 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "7.76095 -7.7391 -4.885"), "0.576311 0.577868 0.57787 239.912", "15.5201 5.52 0.52", %parent);

   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "0.0068512 -7.75 -5.125");rotation = "-0.000951887 0.707104 0.707109 179.891";scale = "3.88201 0.166666 31";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-3.99125 -3.2608 0.875");rotation = "-0.000953296 0.707108 0.707105 179.89";scale = "0.125 0.166666 13.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-7.97775 -8.2716 -5.125");rotation = "-0.000954121 0.707103 0.70711 179.891";scale = "0.125 0.166666 33.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "4.25965 -3.4885 0.875");rotation = "-0.578389 0.576828 0.576832 119.91";scale = "0.125 0.166666 17.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "4.24075 3.5117 0.875");rotation = "-0.57631 -0.577867 0.577872 239.911";scale = "0.125 0.166666 17.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-6.01715 7.7339 0.875");rotation = "-0.999998 -0.00134762 -0.00134427 90.0005";scale = "0.876927 0.166666 31.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "3.99135 3.261 0.875");rotation = "-0.000957474 0.707108 -0.707105 180.109";scale = "0.125 0.166666 13.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.77155 -7.9791 -5.125");rotation = "-0.578388 0.576827 0.576834 119.911";scale = "0.125 0.166666 31";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.72845 8.0209 -5.125");rotation = "-0.578388 0.576827 0.576834 119.911";scale = "0.125 0.166666 31.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-4.22695 -5.7458 0.875");rotation = "0.578386 -0.576834 0.57683 119.911";scale = "1.00783 0.166666 16.9608";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-4.25785 5.7137 0.875");rotation = "0.578386 -0.576834 0.57683 119.911";scale = "1.01242 0.166666 16.9609";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-8.02095 7.7286 0.875");rotation = "0.577869 -0.576315 0.577866 239.911";scale = "0.125 0.166666 31.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-8.02095 7.7286 1.375");rotation = "0.577869 -0.576315 0.577866 239.911";scale = "0.125 0.166666 31.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "6.01485 -7.7339 0.875");rotation = "0.999998 0.00134465 -0.00134728 90.0005";scale = "0.878019 0.166666 31.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.97785 8.2716 -5.125");rotation = "-0.999998 -0.00134792 -0.0013464 90.0005";scale = "0.125 0.166666 33.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "0.0121498 -7.75 4.875");rotation = "0.999998 0.00134465 -0.00134728 90.0005";scale = "3.87937 0.166666 31.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-7.72845 -8.0209 0.875");rotation = "0.707107 0.000951374 0.707106 179.891";scale = "0.125 0.166666 31.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-7.77165 7.9792 0.875");rotation = "0.707107 0.000951374 0.707106 179.891";scale = "0.125 0.166666 31.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.77165 -7.979 1.375");rotation = "-0.00134886 0.999998 -0.00134707 90.0006";scale = "0.125 0.166666 31.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.72855 8.021 1.375");rotation = "-0.00134886 0.999998 -0.00134707 90.0006";scale = "0.125 0.166666 31.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.97925 7.7717 0.875");rotation = "0.577871 -0.576312 0.577866 239.911";scale = "0.125 0.166666 31.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.97925 7.7717 1.375");rotation = "0.577871 -0.576312 0.577866 239.911";scale = "0.125 0.166666 31.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-7.97845 -8.0216 5.125");rotation = "0.706155 0.708058 4.35983e-07 180";scale = "0.125 0.166666 20";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-8.02165 7.9785 5.125");rotation = "0.706155 0.708058 4.35983e-07 180";scale = "0.125 0.166666 20";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-7.97915 -7.7716 4.875");rotation = "0.576833 0.578387 0.57683 119.911";scale = "0.125 0.166666 31.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-7.72845 -8.0209 4.875");rotation = "0.707107 0.000951374 0.707106 179.891";scale = "0.125 0.166666 31.0004";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "-7.77165 7.9792 4.875");rotation = "0.707107 0.000951374 0.707106 179.891";scale = "0.125 0.166666 31.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "8.02165 -7.9783 5.125");rotation = "0.708059 -0.706154 -7.82708e-07 180";scale = "0.125 0.166666 20";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "7.97855 8.0217 5.125");rotation = "0.708059 -0.706154 -7.82708e-07 180";scale = "0.125 0.166666 20";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "BBasePiece";position = vectorAdd(%pos, "8.02095 -7.7284 4.875");rotation = "0.576831 0.578389 0.57683 119.911";scale = "0.125 0.166666 31.0002";}; addAttachment(%parent, %building);
}

function buildVehicleBase(%obj, %pos, %deployed, %item)
{
   %pos = vectorAdd(%pos, "0 0 11.3");
   %trans = vectorAdd(%pos, "0 2.5 0.5") SPC "0 0 1 3.14";
   %parent = addMultiObjectManager(%obj, %trans);
   %parent.randExplode = true;
   %parent.play3d(%item.deploySound);
   %parent.type = 2;
   %trans = vectorAdd(%pos, "2.5 0 -13.75") SPC "0 0 1 -1.57";
   %vpad = addObject(%obj, %deployed, %trans, %parent);
   %trans = vectorAdd(%pos, "-18.4309 16.4977 -10.7482") SPC "0.0 0.0 1" SPC mDegToRad(135);//-0.785";
   %deplObjGen = addObject(%obj, "BaseGenerator", %trans, %parent, "1.50925 1.14727 1.28956");
   %deplObjGen.blastechCanRecharge = true;
   %deplObjGen.playThread(0, "power");
   %deplObjGen.protectedByFFBase = true;
   genUpdate(%deplObjGen);
   %trans = vectorAdd(%pos, "-20.4003 -17.9093 -10.7992") SPC "0.0 0.0 1" SPC mDegToRad(-135);
   addStation(%obj, %trans, %parent);
   addForcefield(%obj, "YellowTransparentField", vectorAdd(%pos, "-23.2363 -2.97432 -6.25216"), "-0.000597697 -1 0.000594477 89.9997", "4.52 6.02 0.52", %parent);
     //Death~bot test
   //VpadCreateTrigger(%obj);
   //addForcefield(%obj, "VehicleField", vectorAdd(%pos, "22.5 -14 9"), "-0.000597697 -1 0.000594477 89.9997", "20 28 0.4", %parent);
   //addTrigger(%obj, "VpadTrigger", vectorAdd(%pos, "20.5 -14 9"), "-0.000597697 -1 0.000594477 89.9997", "20 28 0.4", %parent);
   //$VpadTriggerDeactivated = false;

   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "2.9816 0.161485 -11.2509");rotation = "5.32783e-06 -1.68479e-05 1 180.069";scale = "9.67472 9.33012 1";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-16.7805 14.1805 -11.0127");rotation = "0.000418794 0.707116 -0.707098 179.951";scale = "0.21468 0.166666 56.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.2073 -14.3471 -11.0137");rotation = "0.575871 0.58098 -0.575182 119.629";scale = "0.244659 0.166666 80.8769";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-17.2053 14.6046 -11.0127");rotation = "-0.576888 0.577591 -0.577571 239.96";scale = "0.211879 0.166666 80.8862";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-23.2012 18.0315 -11.0125");rotation = "-0.57782 -0.577118 -0.577113 119.961";scale = "1.50212 0.166666 92.886";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-20.1948 15.0237 -11.0125");rotation = "-1 0.000596305 0.000612173 90.0003";scale = "1.50499 0.166666 59.5842";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-23.245 -17.7726 -11.0478");rotation = "0.57495 -0.581446 0.575633 119.708";scale = "1.50401 0.166666 92.8962";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9688 3.28536 -5.76215");rotation = "-0.706685 0.707529 8.96857e-07 180";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9766 -3.21464 -5.76215");rotation = "-0.706685 0.707529 8.96857e-07 180";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9763 -2.96464 -6.01215");rotation = "0.577121 -0.57781 -0.577119 119.961";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "0.020401 18.2796 11.2378");rotation = "0.0004226 0.707111 -0.707102 179.951";scale = "11.6108 0.147102 72.859";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.7451 20.7218 -0.999153");rotation = "0.00059802 1 0.000598018 90.0003";scale = "4.88205 0.161043 90.886";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.6999 -20.6845 -1.03216");rotation = "-0.00440794 0.999975 0.00559933 90.0008";scale = "4.89747 0.165811 90.8964";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9602 3.53535 -8.23116");rotation = "0.577121 -0.57781 -0.577119 119.961";scale = "1.26554 0.161101 34";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9727 -0.00369418 -5.76215");rotation = "0 0 -1 89.9315";scale = "10.2748 0.166666 28.984";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.987 -20.3097 -8.31516");rotation = "0.575648 0.574953 0.581428 119.709";scale = "1.31248 0.159342 33.7415";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.7906 14.1933 -11.0067");rotation = "0.000418794 0.707116 -0.707098 179.951";scale = "0.221381 0.170626 56.1011";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.242 18.2174 11.2508");rotation = "-0.57689 0.577576 0.577585 120.04";scale = "0.249272 0.166666 92.886";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.7451 20.7302 8.98685");rotation = "0.00059802 1 0.000598018 90.0003";scale = "0.125 0.166666 90.886";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9482 20.5353 8.97984");rotation = "-0.577121 0.577811 -0.577119 119.961";scale = "0.125 0.166666 82.0338";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.2028 -18.2899 11.2118");rotation = "0.575876 0.580971 -0.575186 119.63";scale = "0.252617 0.166666 92.8964";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.7 -20.7854 8.92284");rotation = "-0.00440789 0.999975 0.00559928 90.0008";scale = "0.125 0.166666 90.8964";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.245 20.5381 9.69884");rotation = "-0.190883 0.962645 0.192036 92.194";scale = "0.250087 0.166666 92.886";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.2434 19.17 11.0628");rotation = "-0.485114 0.726965 0.485989 108.012";scale = "0.254257 0.166666 92.886";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.2001 -20.6012 9.63784");rotation = "0.187427 0.964454 -0.186279 92.0589";scale = "0.250664 0.166666 92.8964";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.2017 -19.2537 11.0118");rotation = "0.483398 0.730402 -0.482535 107.667";scale = "0.250773 0.166666 92.8964";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.2444 19.9879 10.5198");rotation = "-0.356822 0.862911 0.357859 98.4451";scale = "0.253777 0.166666 92.886";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "23.2007 -20.0611 10.4628");rotation = "0.354207 0.86591 -0.353182 98.1924";scale = "0.252836 0.166666 92.8964";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.965 0.0329738 9.22984");rotation = "0 0 1 90.0678";scale = "9.14507 0.161555 3.574";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9879 14.7299 -10.7632");rotation = "0 0 1 0.068528";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.957 -14.5886 -10.7662");rotation = "2.63264e-06 -0.00500043 0.999987 180.069";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9479 20.7853 -10.7622");rotation = "0 0 1 0.068528";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9983 -20.5333 -10.8252");rotation = "-0.992987 -0.000932233 0.118218 0.577428";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9876 14.4799 8.98685");rotation = "-0.577121 0.577811 -0.577119 119.961";scale = "0.125 0.166666 58.0322";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9838 14.9799 -0.978157");rotation = "0.577582 0.57689 0.577579 120.04";scale = "4.89271 0.163762 10.9998";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9511 -14.9366 -0.978157");rotation = "-0.579034 0.579729 -0.573266 120.291";scale = "4.896 0.162953 10.9994";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9883 -0.0460242 9.09384");rotation = "0 0 1 90.0678";scale = "9.14815 0.151426 3.84505";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9951 20.7299 -10.7632");rotation = "0 0 1 0.068528";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9499 -20.5881 -10.8262");rotation = "-0.992987 -0.000932233 0.118218 0.577428";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9465 18.2741 9.79385");rotation = "0.577115 -0.577813 -0.577123 119.96";scale = "0.282055 0.163674 4.49213";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9913 -18.2148 9.75185");rotation = "0.579494 0.578808 -0.573731 239.629";scale = "0.262358 0.163971 4.54111";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9445 19.0917 9.72984");rotation = "0 0 -1 89.9309";scale = "0.408738 0.162971 2.542";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "-22.9891 -19.031 9.71784");rotation = "-0.00499474 -0.00500003 0.999975 90.0701";scale = "0.408262 0.161855 2.47012";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9948 20.4799 8.98685");rotation = "-0.577121 0.577811 -0.577119 119.961";scale = "0.125 0.166666 10.9998";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9567 -15.0361 8.97984");rotation = "-0.579036 0.579725 -0.573268 120.292";scale = "0.125 0.166666 10.9998";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.992 18.2192 9.76084");rotation = "0.577115 -0.577813 -0.577123 119.96";scale = "0.261819 0.166665 4.509";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.952 -18.2696 9.74384");rotation = "0.579494 0.578808 -0.573731 239.629";scale = "0.273525 0.166163 4.56971";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9926 19.0439 9.73685");rotation = "0 0 -1 89.9309";scale = "0.412385 0.166354 2.528";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "VBasePiece";position = vectorAdd(%pos, "22.9501 -19.0819 9.68784");rotation = "-0.00499474 -0.00500003 0.999975 90.0701";scale = "0.406379 0.165541 2.53012";}; addAttachment(%parent, %building);
}

function VpadTrigger::onEnterTrigger(%data, %trigger,%player)
{
  if (!$VpadTriggerDeactivated)
  {
    if (%parent.type == 2)
    {
       %obj.setpowerstate(false);
       %obj.basePoweredNow = false;
       //%obj.basePowered = false;
    }
  }
}
function VpadTrigger::onLeaveTrigger(%data, %obj, %colObj)
{
  //usually this is all you need.
   return;
}
function VpadTrigger::onTickTrigger(%data, %obj)
{
    // leave blank for most needs
}
//Those functions are required: here you set up "deactivate"
function VpadTrigger::deactivate()
{
  $VpadTriggerDeactivated = true;
}
function VpadTrigger::activate()
{
  $VpadTriggerDeactivated = false;
}

function buildDefenseBase(%obj, %pos, %item)
{
   %rotMod = 25;
   %rotModHalf = %rotMod / 2;
   %posix = vectorAdd(%pos, "0 0 1");
   %trans = vectorAdd(%pos, "0 0 0.5") SPC "0 1 0 0";
   %parent = addMultiObjectManager(%obj, %trans);
   %parent.randExplode = true;
   %parent.play3d(%item.deploySound);
   %parent.type = 3;
   %trans = vectorAdd(%pos, "-12.1472 0.070549 -3.53") SPC "0 0 1" SPC mDegToRad(%rotMod);
   %deplObjGen = addObject(%obj, "BaseGenerator", %trans, %parent, "7.14895 3.9076 2.57762");
   %deplObjGen.blastechCanRecharge = true;
   %deplObjGen.playThread(0, "power");
   %deplObjGen.protectedByFFBase = true;
   genUpdate(%deplObjGen);
   %trans = vectorAdd(%pos, "5.53961 -8.27495 -3.53") SPC "0 0 1" SPC mDegToRad(%rotMod);
   %deplObjGen = addObject(%obj, "BaseGenerator", %trans, %parent, "7.12978 3.77063 2.58666");
   %deplObjGen.blastechCanRecharge = true;
   %deplObjGen.playThread(0, "power");
   %deplObjGen.protectedByFFBase = true; // 35* offset for rotation
   genUpdate(%deplObjGen);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "25.4655 10.0917 10.077"), "0.476139 -0.73931 -0.476143 107.048", "4.525 38.02 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "9.76881 -25.5934 10.076"), "-0.207035 -0.956176 0.207034 92.5664", "4.525 38.5199 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "-25.6881 -10.5816 -9.59999"), "0.643522 0.414443 0.643519 134.978", "5.52 38.0201 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "-9.14159 25.8355 -9.59999"), "0.643522 0.414443 0.643519 134.978", "5.52 38.0201 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "10.2506 -25.8122 -9.59999"), "0.207037 0.956175 0.207038 92.567", "5.52 38.52 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "-25.7115 -9.47265 -9.59999"), "0.207037 0.956175 0.207038 92.567", "5.52 38.52 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "-26.1761 -9.26165 10.081"), "-0.207035 -0.956176 0.207034 92.5664", "4.53199 38.52 0.52", %parent);
   addForcefield(%obj, "BlueTransparentField", vectorAdd(%pos, "-25.4699 -10.1011 10.077"), "-0.643519 -0.414446 0.64352 134.977", "4.526 38.0201 0.52", %parent);
   %trans = vectorAdd(%pos, "22.944 8.79685 -9.59") SPC "0 0 1" SPC mDegToRad(55+%rotModHalf);
   addStation(%obj, %trans, %parent);
   %trans = vectorAdd(%pos, "-8.46589 23.0683 -3.601") SPC "0 0 1" SPC mDegToRad(-40+%rotModHalf);
   addStation(%obj, %trans, %parent);
   %trans = vectorAdd(%pos, "-8.34979 22.9987 -9.59") SPC "0 0 1" SPC mDegToRad(-40+%rotModHalf);
   addStation(%obj, %trans, %parent);
   %trans = vectorAdd(%pos, "8.46581 -23.0682 -9.59") SPC "0 0 1" SPC mDegToRad(-210+%rotModHalf);
   addStation(%obj, %trans, %parent);
   %trans = vectorAdd(%pos, "-8.46589 23.0681 4.41") SPC "0 0 1" SPC mDegToRad(-40+%rotModHalf);
   addStation(%obj, %trans, %parent);
   %trans = vectorAdd(%pos, "-22.8806 -8.82555 -9.59") SPC "0 0 1" SPC mDegToRad(-120+%rotModHalf);
   addStation(%obj, %trans, %parent);
   %trans = vectorAdd(%pos, "-1.53918 0.207348 4.811") SPC "0 0 1 0";
   %telepadA = addObject(%obj, "DefenseTelePad", %trans, %parent);
   %telepadA.playThread(0, "power");
   %trans = vectorAdd(%pos, "-0.748188 1.10745 16.78") SPC "0 0 1 0";
   %telepadB = addObject(%obj, "DefenseTelePad", %trans, %parent);
   %telepadB.playThread(0, "power");
   %telepadA.teletgt = %telepadB;
   %telepadB.teletgt = %telepadA;
   %building = new (StaticShape) () {datablock = "DBRoof";position = vectorAdd(%pos, "0.0058136 0.0379486 21.911");rotation = "0 0 1 24.5427";scale = "9.83888 19.8355 0.240872";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBBotBoostSide";position = vectorAdd(%pos, "-22.1384 9.93725 -10.059");rotation = "-0.546429 0.837506 1.26469e-06 180";scale = "11.0691 3.85206 3.52695";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBBotBoostSide";position = vectorAdd(%pos, "-9.87019 -22.3054 -10.059");rotation = "0.9776 -0.210472 -1.28707e-06 180";scale = "10.8179 3.83612 3.54552";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBBotBoostSide";position = vectorAdd(%pos, "22.2087 -9.57725 -10.059");rotation = "0.838823 0.544405 -1.26844e-06 180";scale = "11.073 3.80059 3.57281";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBBotBoostSide";position = vectorAdd(%pos, "10.0082 22.6372 -10.059");rotation = "0.208838 0.97795 1.26738e-06 180";scale = "10.8229 3.19339 3.47512";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBBotBoostPlatform";position = vectorAdd(%pos, "0.0555153 0.146851 -10.09");rotation = "0.211824 0.977308 1.2338e-06 180";scale = "7.11983 14.5587 2.38439";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBotBooster";position = vectorAdd(%pos, "0.295216 0.515648 -22.16");rotation = "0 0 1 203.639";scale = "14.3058 14.3034 21.381";}; addAttachment(%parent, %building); %building.playThread(0, "ambient");
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-1.90449 3.06165 -3.84");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-2.11129 2.60645 -4.34");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-2.31808 2.15125 -4.84");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-2.52489 1.69605 -5.34");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-2.73169 1.24085 -5.84");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-2.93849 0.785648 -6.34");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-3.14529 0.330448 -6.84");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-3.35209 -0.124752 -7.34");rotation = "0.698963 -0.151345 0.698961 197.211";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-3.55889 -0.579952 -7.84");rotation = "-0.739312 -0.476138 -0.476141 107.047";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "6.49621 -0.206051 -3.84");rotation = "-0.476138 0.739315 -0.476137 107.048";scale = "0.25 0.333333 16";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "-2.15289 3.72365 -3.84");rotation = "-0.476144 0.739313 -0.476134 107.048";scale = "0.25 0.333333 16";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "4.06821 -5.55065 -9.20999");rotation = "0.870339 -0.18845 0.454969 50.9011";scale = "0.25 0.333333 14.8564";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "-4.58079 -1.62055 -9.20999");rotation = "0.0825756 0.381371 0.920727 202.55";scale = "0.25 0.333333 14.8408";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-3.76569 -1.03515 -8.34");rotation = "-0.739312 -0.476138 -0.476141 107.047";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "-4.80009 -3.31145 -3.84");rotation = "-0.414445 0.643526 -0.643513 225.023";scale = "0.25 0.333333 16.9998";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "1.52588e-05 4.95911e-05 -10.09");rotation = "1.05833e-05 -1.95947e-06 1 114.435";scale = "9.87498 13 1";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "11.4654 25.2708 -9.909");rotation = "-0.151344 -0.69896 0.698964 197.212";scale = "13.7575 0.1 111";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-3.97248 -1.49035 -8.84");rotation = "-0.739312 -0.476138 -0.476141 107.047";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-4.17929 -1.94555 -9.34");rotation = "-0.207041 -0.956175 0.207033 92.5665";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "7.21851 7.97395 -3.356");rotation = "-0.643424 -0.414741 0.643425 134.948";scale = "0.25 0.333333 1.93964";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "3.55941 -5.46165 -9.34");rotation = "-0.207041 -0.956175 0.207033 92.5665";scale = "0.25 0.333333 1.98003";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "-4.18518 -1.94285 -9.34");rotation = "0.698964 -0.151341 -0.69896 162.788";scale = "0.25 0.333333 1.97987";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-13.2207 18.0424 -3.834");rotation = "-0.414444 0.643522 -0.643518 225.023";scale = "4.39624 0.155345 77.9998";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-19.9234 3.29075 4.16101");rotation = "-0.739313 -0.476139 -0.476138 107.047";scale = "7.25229 0.166666 78.0006";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "7.13841 7.47995 -3.22499");rotation = "-0.188176 -0.870745 0.454305 50.8807";scale = "0.25 0.333333 20.53";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.55541 -10.3488 -3.84");rotation = "0.151344 0.698963 0.69896 197.212";scale = "3.25973 0.15845 15.2688";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "14.3043 4.22895 4.144");rotation = "0.20667 0.956335 0.206667 92.5573";scale = "0.25 0.333333 16";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "10.7346 15.7287 -3.356");rotation = "0.643425 0.414741 -0.643424 225.052";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "11.1899 15.5224 -2.856");rotation = "-0.956332 0.20667 0.206679 92.5566";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "11.6453 15.3158 -2.356");rotation = "-0.956332 0.20667 0.206679 92.5566";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.79949 6.83055 -3.838");rotation = "-0.956177 0.207033 0.207035 92.5671";scale = "3.8763 0.155227 15.2681";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "12.1007 15.1094 -1.856");rotation = "-0.956332 0.20667 0.206679 92.5566";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "12.556 14.903 -1.356");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.0114 14.6965 -0.856003");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "12.5372 -19.5465 -3.842");rotation = "0.739316 0.476135 -0.476137 107.048";scale = "3.57025 0.156453 77.9994";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.4668 14.4902 -0.356003");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.9221 14.2837 0.143997");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "14.3775 14.0772 0.643997");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "14.8328 13.8708 1.144");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "11.1899 15.5227 4.144");rotation = "-0.151056 -0.698991 0.698995 197.18";scale = "0.25 0.333333 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "15.2883 13.6644 1.644");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "15.7436 13.458 2.144");rotation = "-0.476362 0.739019 -0.476372 107.07";scale = "0.125 0.166666 17.0001";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "12.6892 5.50995 2.644");rotation = "0.643424 0.414746 0.643421 134.948";scale = "0.125 0.166666 17.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.1446 5.30355 3.144");rotation = "0.643424 0.414746 0.643421 134.948";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-17.75 8.07395 13.475");rotation = "-0.414444 0.643522 -0.643518 225.023";scale = "9.87918 1.9369 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.6 5.09715 3.644");rotation = "0.643424 0.414746 0.643421 134.948";scale = "0.125 0.166666 17.0002";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "0.794415 21.332 4.16");rotation = "0.151345 0.698963 -0.698961 162.788";scale = "5.6995 0.166666 20.9814";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "10.7414 15.7436 -3.356");rotation = "0.47637 -0.73902 -0.476363 107.07";scale = "0.25 0.333333 1.96016";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "14.0554 4.89075 4.144");rotation = "0.643424 0.414746 0.643421 134.948";scale = "0.125 0.166666 17";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.48029 26.2749 -3.84");rotation = "0.698963 -0.151344 0.698961 197.211";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.81112 -26.1508 -3.84");rotation = "0.64352 0.414445 0.643519 134.978";scale = "0.125 0.166666 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.0225 10.1331 0.972");rotation = "0.207036 0.956176 0.207035 92.5671";scale = "2.29486 0.160026 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "11.0596 16.132 -3.226");rotation = "0.381381 -0.0824156 0.920737 202.507";scale = "0.25 0.333333 20.5825";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.80731 -26.1491 0.96701");rotation = "0.64352 0.414445 0.643519 134.978";scale = "2.29736 0.163871 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.48029 26.2749 -9.84");rotation = "-0.739315 -0.476141 -0.476134 107.048";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.81121 -26.1508 -9.84");rotation = "0.956175 -0.207039 0.207035 92.5669";scale = "0.125 0.166666 80";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBaseBlock";position = vectorAdd(%pos, "18.2271 12.8811 4.144");rotation = "0.20667 0.956335 0.206667 92.5573";scale = "0.25 0.333333 16";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "22.0557 11.6718 4.153");rotation = "0.151345 0.698963 -0.698961 162.788";scale = "2.12397 0.162295 20.9816";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.81129 26.1507 -3.84");rotation = "-0.476139 0.739314 -0.476137 107.048";scale = "0.125 0.166666 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.80639 26.1486 0.971008");rotation = "-0.476139 0.739314 -0.476137 107.048";scale = "2.29395 0.163084 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.48011 -26.275 -3.84");rotation = "0.207037 0.956176 0.207036 92.5671";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.1509 -9.81125 -9.84");rotation = "0.956175 -0.207039 0.207035 92.5669";scale = "0.125 0.166666 80";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.48441 -26.2656 0.968002");rotation = "0.207037 0.956176 0.207036 92.5671";scale = "2.29661 0.159778 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.4819 -9.93545 -9.84");rotation = "0.698963 -0.151344 0.69896 197.212";scale = "0.125 0.166666 80";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.0191 10.1257 13.064");rotation = "0.207036 0.956176 0.207035 92.5671";scale = "1.49851 0.154596 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.80272 -26.147 13.046");rotation = "0.64352 0.414445 0.643519 134.978";scale = "1.49003 0.160542 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "25.799 10.2458 -9.59");rotation = "0 0 1 24.4348";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.0473 9.58365 -4.09");rotation = "0.840731 0.541453 6.86341e-07 180";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.2542 10.0388 -9.59");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.1421 -9.81525 13.113");rotation = "0.64352 0.414445 0.643519 134.978";scale = "1.52097 0.1602 78.9998";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.48029 26.2749 16.16");rotation = "0.698963 -0.151344 0.698961 197.211";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-13.4543 36.8676 -9.11099");rotation = "0.698962 -0.151347 0.69896 197.212";scale = "0.260267 0.166666 110";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.1508 9.81125 16.16");rotation = "-0.476139 0.739314 -0.476137 107.048";scale = "0.125 0.166666 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "36.7436 13.7855 -9.12599");rotation = "-0.47614 0.739313 -0.476137 107.048";scale = "0.267745 0.166666 111";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "36.6194 14.1166 -9.84");rotation = "-0.414441 0.64352 0.643522 134.977";scale = "0.125 0.166666 110";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "36.9504 14.2407 -9.84");rotation = "-0.956175 0.207034 0.207041 92.5665";scale = "0.125 0.166666 113";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.0234 -10.1351 13.084");rotation = "0.698963 -0.151343 0.69896 197.212";scale = "1.50863 0.161432 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.48029 26.2749 16.66");rotation = "0.698963 -0.151344 0.698961 197.211";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.81112 -26.1508 16.66");rotation = "0.64352 0.414445 0.643519 134.978";scale = "0.125 0.166666 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.25269 26.1715 -4.09");rotation = "0.977353 -0.211616 -2.68242e-07 180";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.91469 25.9231 -4.09");rotation = "-0.541455 0.84073 1.0657e-06 180";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.2542 10.0388 -3.59");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.70789 26.3783 -9.59");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "25.7949 10.2365 5.562");rotation = "0 0 1 204.435";scale = "0.125 0.166666 9.01";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.0435 9.58535 5.562");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 9.00602";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.91451 -25.9232 -4.09");rotation = "0.840731 0.541453 6.86341e-07 180";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.25251 -26.1716 -4.09");rotation = "0.211624 0.977351 1.23888e-06 180";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.70771 -26.3784 -9.59");rotation = "0 0 1 24.4349";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.81129 26.1507 16.16");rotation = "-0.476139 0.739314 -0.476137 107.048";scale = "0.125 0.166666 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.81129 26.1507 16.66");rotation = "-0.476139 0.739314 -0.476137 107.048";scale = "0.125 0.166666 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.48011 -26.275 16.16");rotation = "0.207037 0.956176 0.207036 92.5671";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-13.7853 36.7434 -9.118");rotation = "-0.476136 0.739318 -0.476134 107.048";scale = "0.26403 0.166666 111";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.48011 -26.275 16.66");rotation = "0.207037 0.956176 0.207036 92.5671";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.70789 26.3783 -3.59");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-36.9504 -14.2407 -9.84");rotation = "0.151346 0.698959 0.698964 197.212";scale = "0.125 0.166666 113";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.25679 26.1623 5.562");rotation = "0 0 1 204.435";scale = "0.125 0.166666 9.01";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.90979 25.921 5.55901");rotation = "0 0 1 114.435";scale = "0.125 0.166666 9.02398";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.0473 -9.58375 -4.09");rotation = "-0.541455 0.84073 1.0657e-06 180";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-25.7992 -10.2457 -4.09");rotation = "0.211624 0.977351 1.23888e-06 180";scale = "0.125 0.166666 11";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.4545 -36.8676 -9.10199");rotation = "0.207035 0.956176 0.207034 92.567";scale = "0.255936 0.166666 110";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.70771 -26.3784 -3.59");rotation = "0 0 1 24.4349";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.4545 -36.8677 -9.84");rotation = "-0.414441 0.64352 0.643522 134.977";scale = "0.125 0.166666 110";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.91071 -25.9215 5.562");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 9.00802";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.2543 -10.0389 -9.59");rotation = "0 0 1 24.4349";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.25681 -26.1622 5.561");rotation = "0 0 1 204.435";scale = "0.125 0.166666 9.012";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.0266 10.1423 22.16");rotation = "0.207036 0.956176 0.207035 92.5671";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.2543 -10.0389 -3.59");rotation = "0 0 1 24.4349";scale = "0.125 0.166666 40";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.1508 9.81125 22.16");rotation = "-0.476139 0.739314 -0.476137 107.048";scale = "0.125 0.166666 79";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.0424 -9.58595 5.55901");rotation = "0 0 1 114.435";scale = "0.125 0.166666 9.02398";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-25.7949 -10.2363 5.561");rotation = "0 0 1 204.435";scale = "0.125 0.166666 9.012";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.1509 -9.81125 22.16");rotation = "0.64352 0.414445 0.643519 134.978";scale = "0.125 0.166666 78.9998";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.48011 -26.275 22.16");rotation = "0.207037 0.956176 0.207036 92.5671";scale = "0.125 0.166666 78";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "25.7991 10.2458 16.91");rotation = "0 0 1 24.4345";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.0473 9.58365 16.91");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "26.2542 10.0388 16.41");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.25269 26.1715 16.91");rotation = "0 0 1 24.4345";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.91469 25.9231 16.91");rotation = "0 0 1 114.435";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-9.70789 26.3783 16.41");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.91451 -25.9232 16.91");rotation = "0 0 -1 65.5653";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.25251 -26.1716 16.91");rotation = "0 0 1 204.435";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "9.70771 -26.3784 16.41");rotation = "0 0 1 24.4349";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.0473 -9.58375 16.91");rotation = "0 0 1 114.435";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-25.7992 -10.2457 16.91");rotation = "0 0 1 204.435";scale = "0.125 0.166666 10";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "36.847 14.0131 -9.59");rotation = "0 0 1 114.435";scale = "0.125 0.166666 2";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-26.2543 -10.0389 16.41");rotation = "0 0 1 24.4349";scale = "0.125 0.166666 12";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-13.6819 36.971 -9.59");rotation = "0 0 -1 65.5647";scale = "0.125 0.166666 2";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "13.6821 -36.9711 -9.59");rotation = "0 0 1 114.435";scale = "0.125 0.166666 2";}; addAttachment(%parent, %building);
   %building = new (StaticShape) () {datablock = "DBasePiece";position = vectorAdd(%pos, "-36.847 -14.0131 -9.59");rotation = "0 0 -1 65.5647";scale = "0.125 0.166666 2";}; addAttachment(%parent, %building);
}
