if(!isObject(MeltdownClient))
{
   new ScriptObject(MeltdownClient)
   {
      class = MeltdownClient;
   };
}

function clientCmdMissionStartPhase1(%seq, %missionName, %musicTrack)
{
   echo( "got client StartPhase1..." );

   // Reset the loading progress controls:
   LoadingProgress.setValue( 0 );
   DB_LoadingProgress.setValue( 0 );
   LoadingProgressTxt.setValue( "Downloading Datablocks..." );
   DB_LoadingProgressTxt.setValue( "Downloading Datablocks..." );

   clientCmdPlayMusic(%musicTrack);
   commandToServer('MissionStartPhase1Done', %seq);
   clientCmdResetCommandMap();
}

function ghostAlwaysStarted(%ghostCount)
{
   echo( "starting to ghost " @ %ghostCount @ " server objects....");

   LoadingProgress.setValue( 0.5 );
   DB_LoadingProgress.setValue( 0.5 );
   LoadingProgressTxt.setValue( "Loading Datablocks..." );
   DB_LoadingProgressTxt.setValue( "Loading Datablocks..." );
   Canvas.repaint();
   $ghostCount = %ghostCount;
   $ghostsRecvd = 0;
}

function ghostAlwaysObjectReceived()
{
   $ghostsRecvd++;
   %pct = ($ghostsRecvd / $ghostCount) / 2;

   if(%pct <= 0.5)
        %pct += 0.5;

   %lpct = mFloor(($ghostsRecvd / $ghostCount)*100);
   LoadingProgress.setValue( %pct );
   DB_LoadingProgress.setValue( %pct );
   LoadingProgressTxt.setValue( "Loading Objects... "@$ghostsRecvd@"/"@$ghostCount@" ("@%lpct@"%)" );
   DB_LoadingProgressTxt.setValue( "Loading Objects... "@$ghostsRecvd@"/"@$ghostCount@" ("@%lpct@"%)" );

    if(%pct == 1)
    {
        LoadingProgressTxt.setValue( "- Objects Loaded -" );
        DB_LoadingProgressTxt.setValue( "- Objects Loaded -" );
        LoadingProgress.setValue( 1 );
        DB_LoadingProgress.setValue( 1 );
    }

   Canvas.repaint();
}

function ClientReceivedDataBlock(%index, %total)
{
   %pct = (%index / %total) / 2;
   %dpct = mFloor((%index / %total)*100);
   LoadingProgress.setValue( %pct );
   LoadingProgress.setValue( %pct );
   LoadingProgressTxt.setValue( "Downloading Datablocks... "@%index@"/"@%total@" ("@%dpct@"%)" );
   DB_LoadingProgressTxt.setValue( "Downloading Datablocks... "@%index@"/"@%total@" ("@%dpct@"%)" );

    if(%pct == 0.5)
    {
        LoadingProgressTxt.setValue( "- Download Complete -" );
        DB_LoadingProgressTxt.setValue( "- Download Complete -" );
    }

   Canvas.repaint();
}

function clientCmdMissionStartPhase3(%seq, %missionName)
{
   $MSeq = %seq;

   //Reset Inventory Hud...
   if($Hud['inventoryScreen'] !$= "")
   {
      %favList = $Hud['inventoryScreen'].data[0, 1].type TAB $Hud['inventoryScreen'].data[0, 1].getValue();
      for ( %i = 1; %i < $Hud['inventoryScreen'].count; %i++ )
         if($Hud['inventoryScreen'].data[%i, 1].getValue() $= invalid)
            %favList = %favList TAB $Hud['inventoryScreen'].data[%i, 1].type TAB "EMPTY";
         else
            %favList = %favList TAB $Hud['inventoryScreen'].data[%i, 1].type TAB $Hud['inventoryScreen'].data[%i, 1].getValue();
      commandToServer( 'setClientFav', %favList );
   }
   else
      commandToServer( 'setClientFav', $pref::Favorite[$pref::FavCurrentSelect]);

   // needed?
   $MissionName = %missionName;
   //commandToServer( 'getScores' );

   // only show dialog if actually lights
   if(lightScene("sceneLightingComplete", $LaunchMode $= "SceneLight" ? "forceWritable" : ""))
   {
      error("beginning SceneLighting....");
      schedule(1, 0, "updateLightingProgress");
      $lightingMission = true;
      LoadingProgress.setValue( 0.0 );
      DB_LoadingProgress.setValue( 0.0 );
      LoadingProgressTxt.setValue( "Building Map Lights..." );
      DB_LoadingProgressTxt.setValue( "Building Map Lights..." );
      $missionLightStarted = true;
      Canvas.repaint();
   }
}

function sceneLightingComplete()
{
   LoadingProgress.setValue( 1 );
   DB_LoadingProgress.setValue( 1 );

   LoadingProgressTxt.setValue( "Get ready to rock and roll!" );
   DB_LoadingProgressTxt.setValue( "Get ready to rock and roll!" );

   echo("Scenelighting done...");
   $lightingMission = false;

   cleanUpHuds();

   if($LaunchMode $= "SceneLight")
   {
      quit();
      return;
   }

   clientCmdResetHud();
   commandToServer('SetVoiceInfo', $pref::Audio::voiceChannels, $pref::Audio::decodingMask, $pref::Audio::encodingLevel);
   commandToServer('EnableVehicleTeleport', $pref::Vehicle::pilotTeleport );
   commandToServer('MissionStartPhase3Done', $MSeq);
}

function GuiControl::updateAltitude(%this)
{
   %alt = getControlObjectAltitude();
   vAltitudeText.setValue(%alt);
   %this.altitudeCheck = %this.schedule(100, "updateAltitude");
}

function GuiControl::updateSpeed(%this)
{
   %vel = getControlObjectSpeed();
   // convert from m/s to km/h
   %cVel = mFloor(%vel * 3.6); // m/s * (3600/1000) = km/h
   vSpeedText.setValue(%cVel);
   %this.speedCheck = %this.schedule(100, "updateSpeed");
}

function clientCmdAuthMD2Client()
{
   commandToServer('AckAuthMD2Client');
}

function serverCmdAckAuthMD2Client(%client)
{
   %client.hasMD2Client = true;
   commandToClient(%client, 'ClientEchoText', %client.guid@"@"@%client.getAddress()@": Meltdown2 client active!");
}

function clientCmdClientEchoText(%text)
{
   echo(%text);
}

function clientCmdClientWarnText(%text)
{
   warn(%text);
}

function clientCmdClientErrorText(%text)
{
   error(%text);
}

function clientCmdCreateMessageBoxOK(%title, %text)
{
   MessageBoxOK(%title, %text);
}

function clientCmdGraphWindowDynamic(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag)
{
   csGraphWindowDynamicLoop(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag);
}

function csGraphWindowDynamicLoop(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag, %count) // founder points out the obvious on this one... LOL
{
   if(MeltdownClient.graphWindowThread)
      cancel(MeltdownClient.graphWindowThread);

      if(%count $= "")
         %count = 0;

      if(%lines $= "")
         %lines = 1;

      if(%timeout $= "")
         %timeout = 1;

      if(%timeMS $= "")
         %timeMS = 100;

      %length = strlen(%message);

      if(%count <= %length)
      {
         %count++;

         if((%count - 3) < 0)
            %ncount = 0;
         else
            %ncount = (%count - 3);

         %msfHdr = "<color:ffffff>"@getSubStr(%message, %ncount, 3); // <font:Univers:16>
         %out = getSubStr(%message, 0, %ncount);

         %time = (%timeMS + 250) / 1000;

         if(%bCenter)
            clientCmdCenterPrint(%colorTag@""@%out@""@%msfhdr, %time+1, %lines);
         else
            clientCmdBottomPrint(%colorTag@""@%out@""@%msfhdr, %time+1, %lines);

         MeltdownClient.graphWindowThread = schedule(%timeMS, 0, csGraphWindowDynamicLoop, %message, %timeMS, %lines, %timeout, %bCenter, %colorTag, %count);
      }
      else
      {
         if(%bCenter)
            clientCmdCenterPrint(%colorTag@""@%message, %timeout, %lines);
         else
            clientCmdBottomPrint(%colorTag@""@%message, %timeout, %lines);
      }
}

function clientCmdFlashWindowDynamic(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag)
{
   csFlashWindowDynamicLoop(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag);
}

function csFlashWindowDynamicLoop(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag, %count) // founder points out the obvious on this one... LOL
{
   if(MeltdownClient.graphWindowThread)
      cancel(MeltdownClient.graphWindowThread);

      if(%count $= "")
         %count = 0;

      if(%lines $= "")
         %lines = 1;

      if(%timeout $= "")
         %timeout = 1;

      if(%timeMS $= "")
         %timeMS = 75;

      if(%colorTag $= "")
         %colorTag = "<color:42dbea>";

      %length = strlen(%message);

      if(%count <= %length)
      {
         %count++;

         if((%count - 5) < 0)
            %ncount = 0;
         else
            %ncount = (%count - 5);

         %nLength = %length - %count;

         if(%nLength < 0)
            %nLength = 0;

         if(%count < 5)
            %hcount = %count;
         else
            %hcount = 5;

         %msfHdr = "<color:ffffff>"@getSubStr(%message, %ncount, %hcount)@""@%colorTag; // <font:Univers:16>
         %out = getSubStr(%message, 0, %ncount);
         %end = getSubStr(%message, %count, %nlength);

         %time = (%timeMS + 250) / 1000;

         if(%bCenter)
            clientCmdCenterPrint(%colorTag@""@%out@""@%msfhdr@""@%end, %time+1, %lines);
         else
            clientCmdBottomPrint(%colorTag@""@%out@""@%msfhdr@""@%end, %time+1, %lines);

         MeltdownClient.graphWindowThread = schedule(%timeMS, 0, csFlashWindowDynamicLoop, %message, %timeMS, %lines, %timeout, %bCenter, %colorTag, %count);
      }
      else
      {
         if(%bCenter)
            clientCmdCenterPrint(%colorTag@""@%message, %timeout, %lines);
         else
            clientCmdBottomPrint(%colorTag@""@%message, %timeout, %lines);
      }
}

function clientCmdLineWindowDynamic(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag)
{
   csLineWindowDynamicLoop(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag);
}

function csLineWindowDynamicLoop(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag, %count) // founder points out the obvious on this one... LOL
{
   if(MeltdownClient.graphWindowThread)
      cancel(MeltdownClient.graphWindowThread);

      if(%count $= "")
         %count = 0;

      if(%lines $= "")
         %lines = 1;

      if(%timeout $= "")
         %timeout = 1;

      if(%timeMS $= "")
         %timeMS = 100;

      if(%colorTag $= "")
         %colorTag = "<color:42dbea>";

      %length = strlen(%message);

      if(%count <= %length)
      {
         %count++;

         if((%count - 3) < 0)
            %ncount = 0;
         else
            %ncount = (%count - 3);

         %nLength = %length - %count;

         if(%nLength < 0)
            %nLength = 0;

         %msfHdr = "<color:ffffff>"@getSubStr(%message, %ncount, 3)@""@%colorTag; // <font:Univers:16>
         %out = getSubStr(%message, 0, %ncount);
         %end = getSubStr($g_line100, %count, %nlength);


         %time = (%timeMS + 250) / 1000;

         if(%bCenter)
            clientCmdCenterPrint(%colorTag@""@%out@""@%msfhdr@""@%end, %time+1, %lines);
         else
            clientCmdBottomPrint(%colorTag@""@%out@""@%msfhdr@""@%end, %time+1, %lines);

         MeltdownClient.graphWindowThread = schedule(%timeMS, 0, csLineWindowDynamicLoop, %message, %timeMS, %lines, %timeout, %bCenter, %colorTag, %count);
      }
      else
      {
         if(%bCenter)
            clientCmdCenterPrint(%colorTag@""@%message, %timeout, %lines);
         else
            clientCmdBottomPrint(%colorTag@""@%message, %timeout, %lines);
      }
}

function clientGraphWindowDynamicAll(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag)
{
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++)
	{
		%cl = ClientGroup.getObject(%i);

      if(!%cl.isAIControlled() && %cl.hasMD2Client)
      {
         %client.excludeFromWDA = true;
         commandToClient(%client, 'GraphWindowDynamic', %message, %timeMS, %lines, %timeout, %bCenter, %colorTag);
      }
   }
}

function clientFlashWindowDynamicAll(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag)
{
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++)
	{
		%cl = ClientGroup.getObject(%i);

      if(!%cl.isAIControlled() && %cl.hasMD2Client)
      {
         %client.excludeFromWDA = true;
         commandToClient(%client, 'FlashWindowDynamic', %message, %timeMS, %lines, %timeout, %bCenter, %colorTag);
      }
   }
}

function clientLineWindowDynamicAll(%message, %timeMS, %lines, %timeout, %bCenter, %colorTag)
{
   %count = ClientGroup.getCount();
   for(%i = 0; %i < %count; %i++)
	{
		%cl = ClientGroup.getObject(%i);

      if(!%cl.isAIControlled() && %cl.hasMD2Client)
      {
         %client.excludeFromWDA = true;
         commandToClient(%client, 'LineWindowDynamic', %message, %timeMS, %lines, %timeout, %bCenter, %colorTag);
      }
   }
}
