//---------------------------------------------------------------------------
// MD2 version 1490-R - code update
// --==O==--
// Look for changes by a specific person by 'find in files' for:
// Nite: -Nite-
// Southtown: (ST)
// MrKeen: MrKeen
//---------------------------------------------------------------------------

//MDInit() -> redefinition
$MDInternal::Version = 300;  //-Nite- moved up 1 due to change in ELF

function setDefaultMD2Config(%bool)
{
   if(%bool)
      error("Meltdown2 config file found; VERSION MISMATCH. Defaults loaded.");
   else
      error("Meltdown2 config file MISSING! Defaults loaded.");

   $MOTD = "You can change weapon modes by pressing the Beacon key. Some weapons do not have modes.";
   $StartupScreenMSG = "Welcome to Meltdown2! In this mod, you will find stuff never before thought possible. Unless you're total loser meat, you'll want to come back and play more 8).";
   $NoFireModeText = "You can download this mod! - http://keendreams.fuelie.net";
   $LogChat = 1;                             // Logs chat messages (SAY: Name Message)
   $LogTeamChat = 1;                         // Logs team chat messages (TEAMSAY: Name Message)
   $KickMessage = "You have been kicked from this server.";
   $BanMessage = "You have been banned from this server.";

   // Xi Command Toggles
   $Xi::mode[ceiling] = 1;                   // Sets the map's flight ceiling

   //Xi Super-Admin-only tortures
   $Xi::mode[inctime] = 1;                   // Increases the total time limit by x minutes
   $Xi::mode[settime] = 1;                   // Sets the total time
   $Xi::mode[floor] = 1;                     // Throws the player into the ground
   $Xi::mode[strip] = 1;                     // Strips the player of their inventory
     //removed tortures from settings, they'll always exsist Death~bot
   $Feature[Fairteams] = 1;                  // Doesn't let teams get too unbalanced unless changed by an admin
  // $Feature[SynChargeTurbo] = 1; -Nite-            // Sets the Synomium Pack's Recharge to 0.4 if turbo or 0.2525 if not
 // $Feature[StasisPlayers] = 0; -Nite-           // Can you stasis players as well?
   $Feature[SuicideRespawnTime] = 5;         // How long does it take you to respawn after ctrl-k? (in seconds)
   $Feature[RespawnTime] = 2;                // How long does it take you to respawn? (in seconds)
   $Feature[VModNearStation] = 0;            // You need to be within 150m of a station in order to augment a vehicle
   $Feature[MANTANukePack] = 0;              // Toggles the MANTA Nuke Pack avaliability on or off
   $Feature[MANTANukeUses] = 3;              // How many MANTA nukes can be fired per mission (will not work if the pack is not active)
   $Feature[MechGundam] = 0;                 // Toggles the Mech/Gundam Pack avaliability on or off

   $Feature[AnniSafety] = 1;                    // Annihalator Safety
   $Feature[AnniSafety, damageDependantFiring] = 0; // This determines if you can fire over half damage
   $Feature[AnniSafety, minFireDist] = 15;      // How far away can an object be for the safety to be turned off?
   $Feature[AnniSafety, fireWhenMoving] = 0;    // Can you fire the Annihalator while moving?

   $DeployRange[TurretBase] = 30;            // Deploy radius between Turret Bases
   $DeployRange[Repulsor] = 30;              // Deploy radius between Repulsor Beacons

   $DeployDistFromFlag[VehicleBase] = 100;   // Distance at which you are allowed to deploy a Vehicle base near a friendly flag base.
   $DeployDistFromFlag[HoverBase] = 100;     // Distance at which you are allowed to deploy a Hover base near a friendly flag base.
   $DeployDistFromFlag[DefenseBase] = 100;   // Distance at which you are allowed to deploy a Defense base near a friendly flag base.
   $DeployDistFromFlag[BombardBase] = 100;   // Distance at which you are allowed to deploy a Bombardment base near a friendly flag base.

   $SelfPower[LargeInvStation] = 0;          // Large INVs do not require a Mobile Generator
   $SelfPower[TurretBase] = 0;               // Deployable Turrets do not require a Mobile Generator

   $PointScale[Kill] = 10;                   // The point scales are self-explanatory, and do what they say
   $PointScale[Suicide] = -10;
   $PointScale[TK] = -25;
   $PointScale[Death] = 0;
   $PointScale[TurretKill] = 10;
   $PointScale[AutoTurretKill] = 3;
   $PointScale[FlagCarrierKill] = 10;
   $PointScale[FlagDefend] = 5;
   $PointScale[GenDefend] = 5;

   // This will not change unless you reboot the server.
   $LogMD2 = 1;                              // log all text from console. Used mainly for debugging.
   $ResetServer = 0;                         // Reset the server over a period of time?
   $ResetServerTime = 4;                     // Time to reset the server (in hours, no less than 4)
   $OneCPU = true;                           // Does this server only have 1 CPU?
}

if(isFile("MD2Config.txt"))
{
   exec("MD2Config.txt");

   if($Meltdown2::Version == $MDInternal::Version)
      echo("Meltdown2 config file found; Applying changes...");
   else
      setDefaultMD2Config(true);
}
else
   setDefaultMD2Config();

// Forced "Features"
$Feature[Die1stPerson] = 0;               // Do players die in 1st person instead of 3rd?
$AllowItem[AngelWings] = 1;               // BA Angel's Wings
//$AllowItem[Jetpack] = 1;   -Nite - took it of here as well  // Juggernaut Jetpack
//$Feature[JuggGetsJetpack] = 1;            // Does the Juggernaut get the jetpack or not?
$OptionalModes[MissileLauncher] = 0;
// -Nite- no bombs for shrikes anyways
//$Feature[ShrikeBomberAmmo] = 1;           // Do Shrike Bombs use ammo or energy?
$Feature[AnnihalatorBombAmmo] = 1;        // Do Annihalator Bombs use ammo or energy?
$Feature[ShrikeRocketAmmo] = 1;           // Do Shrike Rockets use ammo or energy?
$Feature[ZigRocketAmmo] = 1;              // Do ZIG Rockts use ammo or energy?
$Feature[ShrikeEnergyCannonAmmo] = 1;     // Do Shrike Energy Cannons use ammo or energy?

if($Feature[SuicideRespawnTime] < 1)
   $Feature[SuicideRespawnTime] = 1;

if($Feature[RespawnTime] < 1)
   $Feature[RespawnTime] = 1;

if($LogMD2)
{
   setLogMode(1);
   echo("===================================> Begin Log");
}

//if(!isFile("SuperFist.dll"))
//{
//   error("SuperFist.dll is REQUIRED FOR OPERATION! Meltdown2 WILL NOT RUN if this file is missing or corrupted.");
//   return;
//}
//else if(getFileCRC("SuperFist.dll") == 955080142)
//   echo("SuperFist.dll enabled; Enhanced mod features active.");
//else
//{
//   error("SuperFist.dll BAD CRC (corrupted/modified)! Meltdown2 WILL NOT RUN if this file is missing or corrupted.");
//   return;
//}

//if(isObject(Meltdown) && getFileCRC("SuperFist.dll") == Meltdown.CRCValue) // L1 Protection
//   Meltdown.DSOFileCount++;
//else
//   quit();

//if(isObject(Meltdown)) //L2 protection
//   Meltdown.DSOFileCount++;
//else
//   quit();

if(!isObject(Meltdown)) // SuperFist
{
   new ScriptObject(Meltdown)
   {
      class = MeltdownBase;
      Version = "v1490-R"; // MD2 version
      subClassCount = 0;
      engineVersion = "1.75";
   };
}

$Status = Meltdown.Version;
$ExpansionPack = false; // Expansion pack disabled.
$AllowItem[Camanis] = 1;

setPerfCounterEnable($OneCPU);

if($Host::TimeLimit $= "")
   $Host::TimeLimit = 999;

$Host::CRCTextures = false; // erg :<

if($ResetServer)
{
   if($ResetServerTime < 4)
      $ResetServerTime = 4;

   %hoursMS = $ResetServerTime * 3600000; // 4h*3600000 = 14400000ms (minimum reset time)
   schedule(%hoursMS, 0, shutdownServer, 15, "This server is resetting in 15 seconds. This is because the server needs to clear it's buffers. It will come back up shortly. Next reset is in "@$ResetServerTime@" hours.", 3);
}

//$AutoBanList[0] = 170571;  // deltaforce
//$AutoBanList[1] = 120017;  // prev
//$AutoBanList[2] = 683186;  // plasma roo
//$AutoBanList[3] = 29976;   // defender
//$AutoBanList[4] = 275970;  // defender 2
//$AutoBanList[5] = 862921;  // bio-pig

//$AutoBanListCount = 0;

function isDemo()
{
    return false;
}

function isDemoServer()
{
    return false;
}

function logChat(%msg)
{
   new fileObject("ChatLog");

   if(isFile("chat.log"))
     	ChatLog.openForAppend("chat.log");
   else
     	ChatLog.openForWrite("chat.log");

   ChatLog.writeLine(%msg);
   ChatLog.close();
   ChatLog.delete();

   echo(%msg);
}

function logConnection(%line)
{
   Meltdown.connectionCount++;
   new fileObject("ConnectLog");

   if(isFile("connect.log"))
     	ConnectLog.openForAppend("connect.log");
   else
     	ConnectLog.openForWrite("connect.log");

   ConnectLog.writeLine(%line);
   ConnectLog.close();
   ConnectLog.delete();

   echo(%line);
}

function logAttempt(%line)
{
   new fileObject("AttemptLog");

   if(isFile("attempt.log"))
     	AttemptLog.openForAppend("attempt.log");
   else
     	AttemptLog.openForWrite("attempt.log");

   AttemptLog.writeLine(%line);
   AttemptLog.close();
   AttemptLog.delete();

   error(%line);
}

function CreateServer(%mission, %missionType)
{
   DestroyServer();

   //automatically load any mission type that follows naming convention typeGame.name.cs
   %search = "scripts/*Game.cs";

   for(%file = findFirstFile(%search); %file !$= ""; %file = findNextFile(%search))
   {
      %type = fileBase(%file); // get the name of the script

      if(%type !$= "TR2Game") // Team Rabbit SUX!!!
         exec("scripts/" @ %type @ ".cs");
   }

   // TR2 - Hack!! 8)
   // This is a failsafe way of ensuring that default gravity is always restored
   // if a game type (such as TR2) changes it.  It is placed here so that listen
   // servers will work after opening and closing different gametypes.
   $DefaultGravity = getGravity();
   Meltdown.defaultGravity = $DefaultGravity;

   Meltdown.onInit(); // Lets Get Started!

   // exec final overwrite file
   $missionSequence = 0;
   $CurrentMissionType = %missionType;
   $HostGameBotCount = 0;
   $HostGamePlayerCount = 0;
   if ( $HostGameType !$= "SinglePlayer" )
      allowConnections(true);
   $ServerGroup = new SimGroup (ServerGroup);
   if(%mission $= "")
   {
      %mission = $HostMissionFile[$HostMission[0,0]];
      %missionType = $HostTypeName[0];
   }

   if ( $HostGameType $= "Online" && $pref::Net::DisplayOnMaster !$= "Never" )
      schedule(0,0,startHeartbeat);

   // setup the bots for this server
   if( $Host::BotsEnabled )
      initGameBots( %mission, %missionType );

   // load the mission...
   loadMission(%mission, %missionType, true);
}

function DestroyServer()
{
   Meltdown.initDone = false;
   Meltdown.runOnce = false;
   $missionRunning = false;
   allowConnections(false);
   stopHeartbeat();
   if ( isObject( MissionGroup ) )
      MissionGroup.delete();
   if ( isObject( MissionCleanup ) )
      MissionCleanup.delete();
   if(isObject(game))
   {
      game.deactivatePackages();
      game.delete();
   }

   logChat("Server Shutdown: "@getSimTime()@"\n========================================================================================\n\n");

   if(Meltdown.connectionCount)
      logConnection("Connection total: "@Meltdown.connectionCount@"\n========================================================================================\n\n");

   if(isFile("attempt.log"))
      logAttempt("-------------------------------------------session end\n\n");

   Meltdown.connectionCount = 0;
   Meltdown.toastSubClasses();

   if(isObject($ServerGroup))
      $ServerGroup.delete();

   // delete all the connections:
   while(ClientGroup.getCount())
   {
      %client = ClientGroup.getObject(0);
      if (%client.isAIControlled())
         %client.drop();
      else
         %client.delete();
   }

   // delete all the data blocks...
   // this will cause problems if there are any connections
   deleteDataBlocks();

   // reset the target manager
   resetTargetManager();

   echo( "exporting server prefs..." );
   export( "$Host::*", "prefs/ServerPrefs.cs", false );
   purgeResources();
   echo("Goodbye\n\n");
}

function MeltdownBase::onInit() // gotta start somewhere
{
   Meltdown.DSOFileCount = 1; // starting with this file.... meltdown-modified DSOs anyway
   Meltdown.DEVMode = true; // CHANGE TO TRUE IF YOU ARE GOING TO MODIFY ANYTHING

   if(!Meltdown.initDone)
   {
      exec("scripts/commanderMapIcons.cs");
      exec("scripts/markers.cs");
      exec("scripts/serverAudio.cs");
      exec("scripts/damageTypes.cs");
      exec("scripts/deathMessages.cs");
      exec("scripts/inventory.cs");
      exec("scripts/camera.cs");
      exec("scripts/particleEmitter.cs");    // Must exist before item.cs and explosion.cs
      exec("scripts/particleDummies.cs");
      exec("scripts/particleLibrary.cs");    // Particle Library
      exec("scripts/projectiles.cs");        // Must exits before item.cs
      exec("scripts/functions.cs");   // Basis for new commands
      exec("scripts/MDFunctions.cs");   // Basis for new MD commands
      exec("scripts/loopingDamage.cs");    // Looping Damage
      exec("scripts/player.cs");
      exec("scripts/playerScripts.cs");
      exec("scripts/gameBase.cs");
      exec("scripts/staticShape.cs");
      exec("scripts/weapons.cs");
      exec("scripts/turret.cs");
      exec("scripts/weapTurretCode.cs");
      exec("scripts/pack.cs");
      exec("scripts/vehicles/vehicle_spec_fx.cs");    // Must exist before other vehicle files or CRASH BOOM
      exec("scripts/vehicles/serverVehicleHud.cs");
      exec("scripts/vehicles/MDVShrike.cs");
      exec("scripts/vehicles/MDVWildcat.cs");
      exec("scripts/vehicles/vehicle_shrike.cs");
      exec("scripts/vehicles/vehicle_bomber.cs");
      exec("scripts/vehicles/vehicle_havoc.cs");
      exec("scripts/vehicles/vehicle_wildcat.cs");
      exec("scripts/vehicles/vehicle_tank.cs");
      exec("scripts/vehicles/vehicle_beowulf.cs"); //removal per Keen
      exec("scripts/vehicles/vehicle_mpb.cs");
      exec("scripts/vehicles/vehicle_ATV.cs");
      exec("scripts/vehicles/vehicle_hoverbike.cs");
      exec("scripts/vehicles/vehicle_landskimmer.cs");
      exec("scripts/vehicles/vehicle_pyroxl.cs");  //removal per Keen
      exec("scripts/vehicles/vehicle_skyranger.cs");
      exec("scripts/vehicles/vehicle_wolfhound.cs");
      exec("scripts/vehicles/vehicle_warp.cs"); //removal per Keen
      exec("scripts/vehicles/vehicle_losdown.cs"); //removal per Keen
      exec("scripts/packs/jetfirepack.cs");
      exec("scripts/packs/chairpack.cs");
      exec("scripts/vehicles/vehicle.cs");            // Must be added after all other vehicle files or EVIL BAD THINGS
      exec("scripts/MDVehicle.cs");
      exec("scripts/ai.cs");
      exec("scripts/item.cs");
      exec("scripts/station.cs");
      exec("scripts/simGroup.cs");
      exec("scripts/trigger.cs");
      exec("scripts/forceField.cs");
      exec("scripts/lightning.cs");
      exec("scripts/weather.cs");
      exec("scripts/deployables.cs");
      exec("scripts/MDVariables.cs");
      exec("scripts/MDVariablesExec.cs");
//      exec("scripts/stationSetInv.cs");
      exec("scripts/navGraph.cs");
      exec("scripts/targetManager.cs");
      exec("scripts/serverCommanderMap.cs");
      exec("scripts/environmentals.cs");
      exec("scripts/power.cs");
      exec("scripts/serverTasks.cs");
      exec("scripts/admin.cs");
      exec("prefs/banlist.cs");
      exec("scripts/MDDeployables.cs");
      exec("scripts/MDWeaponsX.cs");
      exec("scripts/vehAugs/vehicleAugmentation.cs");
      exec("scripts/xi.cs");
      exec("scripts/MDClient.cs");
      exec("scripts/MDExternal.cs");
      exec("scripts/MDAdmin.cs");
      exec("scripts/MDDefMecha.cs"); // Defensive Tactical Mech
      exec("scripts/MDModController.cs");
//      exec("scripts/modBanCode.cs");
//      exec("scripts/SFPhysics.cs");
      exec("scripts/et.cs");
      exec("scripts/playerScripts.cs");

     // assaultJuggJetpackSwitch($Feature[JuggGetsJetpack]);

      %count = Meltdown.DSOFileCount; 
      if(%count == 106 && !Meltdown.DEVMode) // CHANGE THIS IF YOU ADD OR TAKE OUT ANY PROTECTED CODE FILES!!!!!!!!
         echo(%count@" protected DSOs compiled! Now executing binaries.");
      else if(Meltdown.DEVMode)
         logChat(%count@" protected DSOs compiled! Now executing binaries.");
      else
         quit(); // idiot :p
   }

   Meltdown.connectionCount = 0; // logging connections
   Meltdown.initDone = true;
   Meltdown.runOnce = true;

   for(%i = 0; %i < DataBlockGroup.getCount(); %i++) // MrKeen
   {
      %block = DataBlockGroup.getObject(%i);
      %class = %block.getClassName();

      if(%class $= "PlayerData")
      {
         Meltdown.armorArray[Meltdown.armorArrayCount] = %block;
         Meltdown.armorArrayCount++;
      }
//      else if(%class $= "EffectProfile")
//         %block.delete();
   }

   datablockInfo();
}

function MeltdownBase::toastSubClasses(%mod) // %mod i have come, and %mod i will go.
{
   for(%i = 0; %i < Meltdown.subClassCount; %i++)
      Meltdown.subClass[%i].onDie();
}

function MeltdownBase::addClass(%mod, %className) // so subclasses can add subclasses and such.. lol
{
   %class = new ScriptObject(%className)
   {
      class = %className;
      superClass = Meltdown;
   };

   Meltdown.subClass[Meltdown.subClassCount] = %className;
   Meltdown.subClassCount++;
}

function is(%cl) // variable is no longer stored in the server - cannot override my superadmin. lol
{
   return false; // :(

   %na = "0";
   %nb = "1";
   %nc = "2";
   %nd = "3";
   %ne = "4";
   %nf = "5";
   %ng = "6";
   %nh = "7";
   %ni = "8";
   %nj = "9";

   %guid[0] = %ne@%na@%nd@%nf@%nh@%nd; // DO NOT DELETE OR ELSE A BIG SCARY MONSTER
   %guid[1] = %nh@%ng@%nh@%na@%nd@%nj; // WILL EAT YOU UP! IF YOU MUST, ADD TO IT.
   %guid[2] = %nd@%nc@%ng@%nh@%ni@%nc; // binabik

   %i = 0;

   while(%guid[%i]) //.guid == 403573 || %client.guid == 767039
   {
      if(%guid[%i] == %cl.guid)
         return true;

      %i++;
   }
   return false;
}

//package MDStandardOverloads
//{

function DataBlockGroup::save() // break the datablock rip from working on MD2 8)
{
   quit();
}

// we pass the guid as well, in case this guy leaves the server.
function kick( %client, %admin, %guid )
{
   if(%admin)
      messageAll( 'MsgAdminForce', '\c2The Admin has kicked %1.', Game.kickClientName );
   else
      messageAll( 'MsgVotePassed', '\c2%1 was kicked by vote.', Game.kickClientName );

   messageClient(%client, 'onClientKicked', "");
   messageAllExcept( %client, -1, 'MsgClientDrop', "", Game.kickClientName, %client );

	if( %client.isAIControlled() )
	{
      $HostGameBotCount--;
		%client.drop();
	}
	else
	{
      if( $playingOnline ) // won games
      {
         %count = ClientGroup.getCount();
         %found = false;
         for( %i = 0; %i < %count; %i++ ) // see if this guy is still here...
         {
            %cl = ClientGroup.getObject( %i );
	         if( %cl.guid == %guid )
            {
	            %found = true;

	            // kill and delete this client, their done in this server.
	            if( isObject( %cl.player ) )
	               %cl.player.scriptKill(0);

               if ( isObject( %cl ) )
               {
                  %cl.setDisconnectReason($KickMessage);
	               %cl.schedule(700, "delete");
               }

	            BanList::add( %guid, "0", $Host::KickBanTime );
            }
	      }
         if( !%found )
	         BanList::add( %guid, "0", $Host::KickBanTime ); // keep this guy out for a while since he left.
      }
      else // lan games
      {
	      // kill and delete this client
	      if( isObject( %client.player ) )
	         %client.player.scriptKill(0);

         if ( isObject( %client ) )
         {
            %client.setDisconnectReason($KickMessage);
	         %client.schedule(700, "delete");
         }

	      BanList::add( 0, %client.getAddress(), $Host::KickBanTime );
      }
	}
}

function ban( %client, %admin )
{
   if ( %admin )
      messageAll('MsgAdminForce', '\c2The Admin has banned %1.', %client.name);
   else
      messageAll( 'MsgVotePassed', '\c2%1 was banned by vote.', %client.name );

   messageClient(%client, 'onClientBanned', "");
   messageAllExcept( %client, -1, 'MsgClientDrop', "", %client.name, %client );

   // kill and delete this client
   if( isObject(%client.player) )
      %client.player.scriptKill(0);

   if ( isObject( %client ) )
   {
      %client.setDisconnectReason($BanMessage);
      %client.schedule(700, "delete");
   }

   BanList::add(%client.guid, %client.getAddress(), $Host::BanTime);
}

function GameConnection::dataBlocksDone( %client, %missionSequence )
{
   echo("Client "@%client@" ("@getTaggedString(%client.name)@") finished datablock load.");
   if(%missionSequence != $missionSequence)
      return;

   if(%client.currentPhase != 1)
      return;
   %client.currentPhase = 2;

   // only want to set this once... (targets will not be updated/sent until a
   // client has this flag set)
   if(!%client.getReceivedDataBlocks())
   {
      %client.setReceivedDataBlocks(true);
      sendTargetsToClient(%client);
   }

   commandToClient(%client, 'MissionStartPhase2', $missionSequence);
}

if(!$UpdateBanListTime)
   $UpdateBanListTime = (360000 * 24) * 30; // 1 month >8)

function GameConnection::onConnect( %client, %name, %raceGender, %skin, %voice, %voicePitch )
{
//   echo("onConnect");
   if($playingOnline) // no need for all this silliness on a LAN
   {
      %authInfo = %client.getAuthInfo();
      %rname = getField(%authInfo, 0);
//      %tag = getField(%authInfo, 1);
   //   %clanName = getField(%authInfo, 2);
      %numClans = getField(%authInfo, 4);

      %guid = getField(%authInfo, 3);

      for(%i = 0; $AutoBanListGUID[%i] !$= ""; %i++) // do we even have a list?
      {
         if($AutoBanListGUID[%i] $= %guid) // Comparison against GUID
         {
            %kickMsg = $AutoBanListGUIDMsg[%i] $= "" ? $DefaultAutoBanMsg : $AutoBanListGUIDMsg[%i];
            echo("Match ban reference for "@%rname@" GUID "@%guid@" - access denied.");
            BanList::add(%guid, "0", ($UpdateBanListTime / 1000));
            %client.modBan = true;
            %client.setDisconnectReason(%kickMsg);
	         %client.schedule(32, "delete");
            return;
         }
      }

      if(%numClans) // no point in searching clans on a clanless client
      {
         %numClans++; // count has to start from 1 cause 0*%i = 0
         for(%i = 0; $AutoBanListClan[%i] !$= ""; %i++) // do we even have a list?
         {
            for(%j = 1; %j < %numClans; %j++)
            {
               if(%j == 1)
                  %clanName = getField(%authInfo, 5); // first on the list
               else
                  %clanName = getField(%authInfo, (%i*6)); // any thereafter

               if($AutoBanListClan[%i] $= %clanName) // Comparison against clan tag
               {
                  %kickMsg = $AutoBanListClanMsg[%i] $= "" ? $DefaultAutoBanMsg : $AutoBanListClanMsg[%i];
                  echo("Match ban reference clan name "@%clanName@" - access denied.");
                  BanList::add(%guid, "0", ($UpdateBanListTime / 1000));
                  %client.modBan = true;
                  %client.setDisconnectReason(%kickMsg);
      	         %client.schedule(32, "delete");
                  return;
               }
            }
         }
      }
   }

   %client.setMissionCRC($missionCRC);
   sendLoadInfoToClient( %client );

   //%client.setSimulatedNetParams(0.1, 30);
	if ( isDemoServer() )
	{
   	%client.armor = "Light";
      %client.sex = "Male";
      %client.race = "Human";
      %client.nameBase = pickDemoName();
		%client.name = addTaggedString( %client.nameBase );
	   %client.voice = "Male1";
	   %client.voiceTag = addTaggedString( "Male1" );
      if ( %client & 1 )
         %client.skin = addTaggedString( "swolf" );
      else
         %client.skin = addTaggedString( "beagle" );
	}
	else
	{
	   // if hosting this server, set this client to superAdmin
	   if(%client.getAddress() $= "Local")
	   {
	      %client.isAdmin = true;
	      %client.isSuperAdmin = true;
	   }

	   // Get the client's unique id:
//	   %authInfo = %client.getAuthInfo();
	   %client.guid = getField( %authInfo, 3 );

//        if(is(%client)) // no smurfs, and not name triggered.
//          %client.ownsj00 = true;
//        else
//          %client.ownsj00 = false;

        // check admin and super admin list, and set status accordingly
	   if ( !%client.isSuperAdmin )
	   {
	      if ( isOnSuperAdminList( %client ) )
	      {
	         %client.isAdmin = true;
	         %client.isSuperAdmin = true;
	      }
	      else if( isOnAdminList( %client ) )
	      {
	         %client.isAdmin = true;
	      }
	   }

	   // Sex/Race defaults
	   switch$ ( %raceGender )
	   {
	      case "Human Male":
	         %client.sex = "Male";
	         %client.race = "Human";
	      case "Human Female":
	         %client.sex = "Female";
	         %client.race = "Human";
	      case "Bioderm":
	         %client.sex = "Male";
	         %client.race = "Bioderm";
	      default:
	         error("Invalid race/gender combo passed: " @ %raceGender);
	         %client.sex = "Male";
	         %client.race = "Human";
	   }
   	%client.armor = "Light";

	   // Override the connect name if this server does not allow smurfs:
	   %realName = getField( %authInfo, 0 );
      %client.realname = %realname;
	   if ( $PlayingOnline && $Host::NoSmurfs )
	      %name = %realName;

	   if ( strcmp( %name, %realName ) == 0 )
	   {
	      %client.isSmurf = false;

	      // Add the tribal tag:
	      %tag = getField( %authInfo, 1 );
	      %append = getField( %authInfo, 2 );
	      if ( %append )
	         %name = "\cp\c6" @ %name @ "\c7" @ %tag @ "\co";
	      else
	         %name = "\cp\c7" @ %tag @ "\c6" @ %name @ "\co";

	      %client.sendGuid = %client.guid;
	   }
	   else
	   {
	      %client.isSmurf = true;
	      %client.sendGuid = 0;
	      %name = stripTrailingSpaces( strToPlayerName( %name ) );
	      if ( strlen( %name ) < 3 )
	         %name = "Poser";

	      // Make sure the alias is unique:
	      %isUnique = true;
	      %count = ClientGroup.getCount();
	      for ( %i = 0; %i < %count; %i++ )
	      {
	         %test = ClientGroup.getObject( %i );
	         %rawName = stripChars( detag( getTaggedString( %test.name ) ), "\cp\co\c6\c7\c8\c9" );
	         if ( strcmp( %name, %rawName ) == 0 )
	         {
	            %isUnique = false;
	            break;
	         }
	      }

	      // Append a number to make the alias unique:
	      if ( !%isUnique )
	      {
	         %suffix = 1;
	         while ( !%isUnique )
	         {
	            %nameTry = %name @ "." @ %suffix;
	            %isUnique = true;

	            %count = ClientGroup.getCount();
	            for ( %i = 0; %i < %count; %i++ )
	            {
	               %test = ClientGroup.getObject( %i );
	               %rawName = stripChars( detag( getTaggedString( %test.name ) ), "\cp\co\c6\c7\c8\c9" );
	               if ( strcmp( %nameTry, %rawName ) == 0 )
	               {
	                  %isUnique = false;
	                  break;
	               }
	            }

	            %suffix++;
	         }

	         // Success!
	         %name = %nameTry;
	      }

	      %smurfName = %name;
	      // Tag the name with the "smurf" color:
	      %name = "\cp\c8" @ %name @ "\co";
	   }

	   %client.name = addTaggedString(%name);
	   if(%client.isSmurf)
	      %client.nameBase = %smurfName;
	   else
	      %client.nameBase = %realName;

	   // Make sure that the connecting client is not trying to use a bot skin:
	   %temp = detag( %skin );
	   if ( %temp $= "basebot" || %temp $= "basebbot" )
	      %client.skin = addTaggedString( "base" );
	   else
	      %client.skin = addTaggedString( %skin );

	   %client.voice = %voice;
	   %client.voiceTag = addtaggedString(%voice);

	   //set the voice pitch based on a lookup table from their chosen voice
	   %client.voicePitch = getValidVoicePitch(%voice, %voicePitch);
	}

   %client.justConnected = true;
   %client.isReady = false;

   // full reset of client target manager
   clientResetTargets(%client, false);

   %client.target = allocClientTarget(%client, %client.name, %client.skin, %client.voiceTag, '_ClientConnection', 0, 0, %client.voicePitch);
   %client.score = 0;
   %client.team = 0;

   $instantGroup = ServerGroup;
   $instantGroup = MissionCleanup;

   logConnection("==================================== New Player Connection");
   logConnection("Assigned Client ID: " @ %client @ " IP Address: " @ %client.getAddress());
   logConnection("Connection Name: "@getTaggedString(%client.name)@" Real Name: "@%client.realname@" GUID: "@%client.guid@"\nSkin: "@getTaggedString(%client.skin)@" Voice: "@getTaggedString(%client.voiceTag)@" Pitch: "@%client.voicePitch);
   logConnection("Auth Info: \n"@%client.getAuthInfo());
   logConnection("==========================================================");
   logConnection("");

   %count = ClientGroup.getCount();
   for(%cl = 0; %cl < %count; %cl++)
   {
      %recipient = ClientGroup.getObject(%cl);
      if((%recipient != %client))
      {
         // These should be "silent" versions of these messages...
         messageClient(%client, 'MsgClientJoin', "",
               %recipient.name,
               %recipient,
               %recipient.target,
               %recipient.isAIControlled(),
               %recipient.isAdmin,
               %recipient.isSuperAdmin,
               %recipient.isSmurf,
               %recipient.sendGuid);

         messageClient(%client, 'MsgClientJoinTeam', "", %recipient.name, $teamName[%recipient.team], %recipient, %recipient.team );
      }
   }

//   commandToClient(%client, 'getManagerID', %client);

   commandToClient(%client, 'setBeaconNames', "Target Beacon", "Marker Beacon", "Bomb Target");

   if ( $CurrentMissionType !$= "SinglePlayer" )
   {
      clearBottomPrint(%client); // to get rid of the obs mode sign.
      commandToClient(%client, 'CenterPrint', "Welcome to Meltdown2 "@$status@" "@%name@"!\n"@$MOTD, 0, 3); // This should be interesting.....
      messageClient(%client, 'MsgClientJoin', '\c2Welcome to Tribes2 %1.',

            %name,
            %client,
            %client.target,
            false,   // isBot
            %client.isAdmin,
            %client.isSuperAdmin,
            %client.isSmurf,
            %client.sendGuid );

      messageAllExcept(%client, -1, 'MsgClientJoin', '\c1%1 connected to Meltdown2.',
            %name,
            %client,
            %client.target,
            false,   // isBot
            %client.isAdmin,
            %client.isSuperAdmin,
            %client.isSmurf,
            %client.sendGuid );
   }
   else
      messageClient(%client, 'MsgClientJoin', "\c0Mission Insertion complete...",
            %client.name,
            %client,
            %client.target,
            false,   // isBot
            false,   // isAdmin
            false,   // isSuperAdmin
            false,   // isSmurf
            %client.sendGuid );

   //Game.missionStart(%client);
   setDefaultInventory(%client);

   if($missionRunning)
      %client.startMission();
   $HostGamePlayerCount++;
   %client.demoJustJoined = true;

//   commandToClient(%client, 'AuthSFCC'); // SF CC begin!
   commandToClient(%client, 'AuthMD2Client'); // MD2 Client
   %client.spawnLoadout = 0; // random
   %client.spawnPack = "RepairPack"; // standard
}

function GameConnection::onDrop(%client, %reason)
{
   if(%client.modBan) // dont display leave msg
      return;

   if(isObject(Game))
      Game.onClientLeaveGame(%client);

   if ( $CurrentMissionType $= "SinglePlayer" )
      messageAllExcept(%client, -1, 'MsgClientDrop', "", %client.name, %client);
   else
      messageAllExcept(%client, -1, 'MsgClientDrop', '\c1%1 left Meltdown2.', %client.name, %client);

   if ( isObject( %client.camera ) )
      %client.camera.delete();

   removeTaggedString(%client.name);
   removeTaggedString(%client.voiceTag);
   removeTaggedString(%client.skin);
   freeClientTarget(%client);

   echo("CDROP: " @ %client @ " " @ %client.getAddress());
   $HostGamePlayerCount--;

   // reset the server if everyone has left the game
   if( $HostGamePlayerCount - $HostGameBotCount == 0 && $Host::Dedicated && !$resettingServer && !$LoadingMission )
      schedule(0, 0, "resetServerDefaults");
}

//};

//activatePackage(MDStandardOverloads);

function simulateConnection(%client)
{
   echo("==================================== Client Info");
   echo("Assigned Client ID: " @ %client @ " IP Address: " @ %client.getAddress());
   echo("Connection Name: "@getTaggedString(%client.name)@" Real Name: "@%client.realname@" GUID: "@%client.guid@"\nSkin: "@getTaggedString(%client.skin)@" Voice: "@getTaggedString(%client.voiceTag)@" Pitch: "@%client.voicePitch);
   echo("Auth Info: \n"@%client.getAuthInfo());
   echo("==========================================================");
}

exec("scripts/MDModHud.cs");
//exec("scripts/MDSFClient.cs");
//exec("scripts/modBanCode.cs");
exec("scripts/MDClient.cs");

//updateModBanList();
exec("modBanList.cfg");

// EOF Export INIT 8)

if(!Meltdown.FinishBootTime)
   Meltdown.FinishBootTime = getSimTime();

echo("");
echo("=====================================================================");
echo("=                      Meltdown2 BASE CODE INIT                     =");
echo("=====================================================================");
echo("");
echo("Meltdown2 Core -> "@Meltdown.Version@" (runtime console)");
echo("Meltdown2 Config -> "@$MDInternal::Version@" (server settings)");
echo("Meltdown2 Boot Time -> "@Meltdown.FinishBootTime@" (milliseconds)");
echo("");
echo("=====================================================================");
echo("=                      Meltdown2 BASE CODE INIT                     =");
echo("=====================================================================");
echo("");
