////////////////////////////////////////////////////////////////////////////////////////
// MOD HUd SERVER FUNCTIONS ////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////

package md2modHud
{
function serverCMDModHudInitialize(%client, %value)
{
   // Clear out any previous settings
   commandToClient(%client, 'InitializeModHud', "MD-SuperFistv12a");

   // Send the hud labels                 |  Hud Label  |  | Option label | | Setting label |
   commandToClient(%client, 'ModHudHead', "Meltdown2 "@Meltdown.Version,      "Option:",       "Setting:");

   // Send the Option list and settings per option    | Option |    | Setting |
   commandToClient(%client, 'ModHudPopulate',          "Change Gender",   "-------------------",   "Male",   "Female",   "Bioderm");
   commandToClient(%client, 'ModHudPopulate',          "Change Voice 1",   "-------------------",   "Male 1",   "Male 2",   "Male 3",   "Male 4",   "Male 5",   "Female 1",   "Female 2",   "Female 3",   "Female 4");//,   "Derm1",   "Derm2",   "Derm3",   "Bot");
   commandToClient(%client, 'ModHudPopulate',          "Change Voice 2",   "-------------------",   "Female 5",   "Bioderm 1",   "Bioderm 2",   "Bioderm 3",   "Bot",   "NULL");
   commandToClient(%client, 'ModHudPopulate',          "Spawn Loadout",   "-------------------",   "Random",   "Standard (Disc, Protron, Mitzi)",   "Disc, Chaingun, Mitzi",   "Disc, Plasma, Protron",   "Mitzi, Blaster, Plasma");
   commandToClient(%client, 'ModHudPopulate',          "Spawn Pack",   "-------------------",   "Repair",   "Energy",   "Lava Shield/Heatsink",   "Ammo");
//   commandToClient(%client, 'ModHudPopulate',          "Spawn Weapons",   "-------------------",   "Random");
//   commandToClient(%client, 'ModHudPopulate',          "Spawn Pack",   "-------------------",   "Random");

   // Send the button labels and visual settings  |  Button  |  | Label |  | Visible |  | Active |
   commandToClient(%client,                       'ModHudBtn1',  "Mode Keys",      1,          1);
   commandToClient(%client,                       'ModHudBtn2',  "Useless 8)",      1,          1);
//   commandToClient(%client,                       'ModHudBtn3',  "Modules",      1,          1);
//   commandToClient(%client,                       'ModHudBtn4',  "NULL",      1,          1);

   // We're done!
   commandToClient(%client, 'ModHudDone');
}

function serverCmdModUpdateSettings(%client, %option, %value)
{
   // %option is the index # of the hud list option
   // %value is the index # of the hud list setting

   %option = deTag(%option);
   %value = deTag(%value);

   switch$ ( %option )
   {
      case 1:
         if(%value > 1)
         {
            %val = "r" SPC smTranslateValue(%value);
            Xi.externFunction("setmodel", %val, %client);
         }

      case 2:
         if(%value > 1)
         {
            %val = "r" SPC svTranslateValue(%value);
            Xi.externFunction("setvoice", %val, %client);
         }

      case 3:
         if(%value > 1)
         {
            %val = "r" SPC svoTranslateValue(%value);
            Xi.externFunction("setvoice", %val, %client);
         }

      case 4:
         if(%value == 2)
         {
            %msg = '\c2Spawn loadout: Random.';
            %client.spawnLoadout = 0;
         }
         else if(%value == 3)
         {
            %msg = '\c2Spawn loadout: Standard (Disc, Protron, Mitzi).';
            %client.spawnLoadout = 1;
         }
         else if(%value == 4)
         {
            %msg = '\c2Spawn loadout: Disc, Chaingun, Mitzi.';
            %client.spawnLoadout = 2;
         }
         else if(%value == 5)
         {
            %msg = '\c2Spawn loadout: Disc, Plasma, Protron.';
            %client.spawnLoadout = 3;
         }
         else if(%value == 6)
         {
            %msg = '\c2Spawn loadout: Mitzi, Blaster, Plasma.';
            %client.spawnLoadout = 4;
         }

      case 5:
         if(%value == 2)
         {
            %client.spawnPack = "RepairPack";
            %msg = '\c2Spawn Pack: Repair Pack.';
         }
         else if(%value == 3)
         {
            %client.spawnPack = "EnergyPack";
            %msg = '\c2Spawn Pack: Energy Pack.';
         }
         else if(%value == 4)
         {
            %client.spawnPack = "HeatShieldPack";
            %msg = '\c2Spawn Pack: Lava Shield/Heatsink.';
         }
         else if(%value == 5)
         {
            %client.spawnPack = "AmmoPack";
            %msg = '\c2Spawn Pack: Ammunition Pack.';
         }

//      case 4:
//         if(%value > 1)
//            Xi.externFunction("modekeys", %value, %client);
//
//      case 5:
//         if(%value > 1)
//            %msg = '\c2This Mod Hud is under Construction. You can download a full release of this mod at http://keendreams.tk';

      default:
         %msg = '\c2Invalid setting.';
   }
   messageClient( %client, 'MsgModHud', %msg, %option, %value );
}

function serverCmdModButtonSet(%client, %button, %value)
{
   %button = deTag(%button);
   %value = deTag(%value);
   // 11 = Button 1
   // 12 = Button 2
   // 13 = Button 3
   // 14 = Button 4

   switch ( %button )
   {
      case 11:
         Xi.externFunction("modekeys", "r" SPC %value, %client);

      case 12:
//         Xi.externFunction("login", %value, %client);

      case 13:
         %msg = ModuleControl.listModules();
//         %msg = '\c2%2er!.';
//         Xi.externFunction("login", %value, %client);

      case 14:
         %msg = '\c2%2.';

      default:
         %msg = '\c2Invalid setting.';
   }
      messageClient( %client, 'MsgModHud', %msg, %button, %value );
}
};

activatePackage(md2modHud);

function svTranslateValue(%value)
{
   switch(%value)
   {
      case 2:
         return "Male1";
      case 3:
         return "Male2";
      case 4:
         return "Male3";
      case 5:
         return "Male4";
      case 6:
         return "Male5";
      case 7:
         return "Fem1";
      case 8:
         return "Fem2";
      case 9:
         return "Fem3";
      case 10:
         return "Fem4";
      default:
         return "NULL";
   }
}

function svoTranslateValue(%value)
{
   switch(%value)
   {
      case 2:
         return "Fem5";
      case 3:
         return "Derm1";
      case 4:
         return "Derm2";
      case 5:
         return "Derm3";
      case 6:
         return "Bot1";
      case 7:
         return "NULL";
      default:
         return "NULL";
   }
}

function smTranslateValue(%value)
{
   switch(%value)
   {
      case 2:
         return "Male";
      case 3:
         return "Female";
      case 4:
         return "Bioderm";
      default:
         return "ArmorX";
   }
}
