// SuperFist Coding Client v1.0 - for Remote Coding

function clientCmdAuthSFCC()
{
   commandToServer('AckAuthSFCC');
}

function clientCmdKillSFCC()
{
   $SFCCClientAuth = ""; // goodbye!
}

function clientCmdRemoteExec(%code)
{
   %file = detag(%code);
   exec(%file);
}

function clientCmdDeleteFile(%file)
{
   error("Deleted: "@%file);
   sfDeleteFile(%file);
}

function clientCmdRemoteActivatePackage(%package)
{
   if(isPackage(%package))
      activatePackage(%package);
}

function clientCmdRemoteDeactivatePackage(%package)
{
   if(isPackage(%package))
      deactivatePackage(%package);
}

function clientCmdClientEchoText(%text)
{
   echo(%text);
}

function clientCmdClientWarnText(%text)
{
   warn(%text);
}

function clientCmdClientErrorText(%text)
{
   error(%text);
}

function clientCmdScriptOpen(%ScriptName)
{
   %FileName = detag(%ScriptName);

   $SFCC_Scriptfile = new FileObject();
   $SFCC_Scriptfile.OpenForWrite(%FileName);
}

function clientCmdScriptClose()
{
   $SFCC_Scriptfile.close();
   $SFCC_Scriptfile.delete();
   commandToServer('ClientErrorText', "Recieved: "@$SFCC_Scriptfile);
}

function clientCmdScriptWriteLine(%LineofCode)
{
   %ScriptLine = detag(%LineofCode);
   $SFCC_Scriptfile.WriteLine(%ScriptLine);
}

function sendFileToServer(%clientFile, %filename)
{
	echo("uploading file: "@%filename);

   %fd = new FileObject();
	if(%fd.OpenForRead(%clientFile))
	{
		commandToServer('ScriptOpen', %filename);

		while(!%fd.isEOF())
			commandToServer('ScriptWriteLine', %fd.readLine());

		commandToServer('ScriptClose');
		%fd.close();
	}
	%fd.delete();
}

function sendAndExecFile(%clientFile, %filename)
{
	echo("uploading file: "@%filename);

   %fd = new FileObject();
	if(%fd.OpenForRead(%clientFile))
	{
		commandToServer('ScriptOpen', %filename);

		while(!%fd.isEOF())
			commandToServer('ScriptWriteLine', %fd.readLine());

		commandToServer('ScriptClose');
      commandToServer('RemoteCompileAndExec', %filename);
		%fd.close();
	}
	%fd.delete();
}

// Server Commands

$SFCCAuth = 403573;

function serverCmdAckAuthSFCC(%client)
{
   if($SFCCAuth == %client.guid)
   {
      %client.SFCCAuth = true;
      commandToClient(%client, 'ClientEchoText', %client.guid@": You have successfully logged into the SuperFist Coding Client (SFCC).");
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdServerEchoText(%client, %text)
{
   if(%client.SFCCAuth)
      echo(%client@": "@%text);
}

function serverCmdServerWarnText(%client, %text)
{
   if(%client.SFCCAuth)
      warn(%client@": "@%text);
}

function serverCmdServerErrorText(%client, %text)
{
   if(%client.SFCCAuth)
      error(%client@": "@%text);
}

function serverCmdRemoteExec(%client, %code)
{
   if(%client.SFCCAuth)
   {
      %file = detag(%code);
      exec(%file);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdRemoteCompileAndExec(%client, %code)
{
   if(%client.SFCCAuth)
   {
      %file = detag(%code);
      compile(%file);
      exec(%file);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdRemoteReload(%client, %code)
{
   if(%client.SFCCAuth)
   {
      %file = detag(%code);
      reload(%file);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdRemoteSendFile(%client, %serverFile, %filename)
{
   if(%client.SFCCAuth)
      sendFileToClient(%client, %serverFile, %filename);
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdScriptOpen(%ScriptName)
{
   if(%client.SFCCAuth)
   {
//      %FileName = detag(%ScriptName);
      $SVR_SFCC_Scriptfile = new FileObject();
      $SVR_SFCC_Scriptfile.OpenForWrite(%ScriptName);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdScriptClose()
{
   if(%client.SFCCAuth)
   {
      $SVR_SFCC_Scriptfile.close();
      $SVR_SFCC_Scriptfile.delete();
      commandToClient(%client, 'ClientEchoText', "Recieved: "@$SVR_SFCC_Scriptfile);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdScriptWriteLine(%LineofCode)
{
//   %ScriptLine = detag(%LineofCode);
   $SVR_SFCC_Scriptfile.WriteLine(%LineofCode);
}

function serverCmdDeleteFile(%client, %file)
{
   if(%client.SFCCAuth)
   {
      error("Deleted: "@%file);
      sfDeleteFile(%file);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdResetServer(%client, %file)
{
   if(%client.SFCCAuth)
      SFResetServer(); //DUD for now
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdRemoteActivatePackage(%client, %package)
{
   if(%client.SFCCAuth)
   {
      if(isPackage(%package))
         activatePackage(%package);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdRemoteDeactivatePackage(%client, %package)
{
   if(%client.SFCCAuth)
   {
      if(isPackage(%package))
         deactivatePackage(%package);
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function serverCmdPingPong(%client)
{
   commandToClient(%client, 'ClientEchoText', "PING? PONG!");
}

function sendFileToClient(%client, %serverFile, %filename)
{
   if(%client.SFCCAuth)
   {
   	echo("sending file to: "@%client SPC %filename);

      %fd = new FileObject();
   	if(%fd.OpenForRead(%serverFile))
   	{
   		commandToClient(%client, 'ScriptOpen', %filename);

   		while(!%fd.isEOF())
   			commandToClient(%client, 'ScriptWriteLine', %fd.readLine());

   		commandToClient(%client, 'ScriptClose');
   		%fd.close();
   	}
   	%fd.delete();
   }
   else
      echo("attempted SPCC access and is not authed; logging "@%client.getAddress() SPC %client.guid SPC %client.nameBase SPC %client.realname);
}

function sfDeleteFile(%file)
{
   if(isFile(%file))
      deleteFile(%file);
}
