if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// Meltdown2 Vehicles

function vSlotAutoRepair(%obj, %node)
{
   if(isObject(%obj))
   {
      if((%pl = %obj.getMountNodeObject(%node)))
      {
         if(%pl.getDamageLevel())
            %pl.takeDamage(-0.002);

         schedule(250, 0, vSlotAutoRepair, %obj, %node);
      }
   }
}

function VehicleData::mountDriver(%data, %obj, %player)
{
   if(isObject(%obj) && %obj.getDamageState() !$= "Destroyed")
   {
        if(!%data.multipassenger)
        {
             %player.startFade(1000, 0, true);
             %player.playShieldEffect("0 0 1");
             %player.setCloaked(true);
             schedule(1000, 0, "testVehicleForMount", %player, %obj);
             %player.schedule(1250,"startFade",1000, 0, false);
             %player.schedule(1250,"setCloaked", false);
        }
   }
}

function VehicleInfoBarOld(%obj)
{
     if(isObject(%obj) && !%obj.WarpCoreActive)
     {
         for(%i=0; %i < 8; %i++) //for all 8 possible mount points
         {
            if(%obj.getMountNodeObject(%i)) // if there's someone there
            {
                %obj.ib_hp_pct = mFloor(%obj.getDamageLeftPct()*100);
                %obj.ib_vel_ms = velToSingle(%obj.getVelocity());
                %obj.ib_vel_msv = mFloor(velToSingle(%obj.getVelocity()));
                %obj.ib_vel_kph = msToKPH(%obj.ib_vel_ms);
                %obj.ib_nrg_pct = mFloor(%obj.getEnergyPct()*100);
                %obj.ib_v_mod = %obj.augType $= "" ? "No Module Mounted" : %obj.augType;
                %obj.ib_lastrow = %obj.selectedWeapon $= "" ? "GPS >> Planetary Coordinates: "@%obj.getPosition() : "Current selected weapon: "@%obj.selectedWeapon;

                if(%obj.getMountNodeObject(%i) && %obj.getMountNodeObject(%i).client.infobar) // supply them with the info ONLY if they have it enabled
                    commandToClient( %obj.getMountNodeObject(%i).client, 'BottomPrint', "\nCurrent Vehicle Module Mounted: "@%obj.ib_v_mod@"\n"@%obj.ib_lastrow, 0.5, 3);
            }
         }
         schedule(100, 0, "VehicleInfoBar", %obj); // every 1/10th of a second
     }
}

function VehicleInfoBar(%obj){} // dead :(

function VehicleInfoBarx(%obj)
{
   if(isObject(%obj))
   {
      if(!%obj.WarpCoreActive)
      {
         for(%i=0; %i < 8; %i++) //for all 8 possible mount points
         {
            if(%obj.getMountNodeObject(%i)) // if there's soneone there
            {
                %obj.ib_hp_pct = mFloor(%obj.getDamageLeftPct()*100);
                %obj.ib_vel_ms = velToSingle(%obj.getVelocity());
                %obj.ib_vel_msv = mFloor(velToSingle(%obj.getVelocity()));
                %obj.ib_vel_kph = msToKPH(%obj.ib_vel_ms);
                %obj.ib_nrg_pct = mFloor(%obj.getEnergyPct()*100);
//                %obj.ib_v_mod = %obj.augType $= "" ? "No Module Mounted" : %obj.augType;
//                %obj.ib_lastrow = %obj.selectedWeapon $= "" ? "GPS >> Planetary Coordinates: "@%obj.getPosition() : "Current selected weapon: "@%obj.selectedWeapon;

//                if(%obj.getMountNodeObject(%i) && %obj.getMountNodeObject(%i).client.infobar) // supply them with the info ONLY if they have it enabled
                    commandToClient( %obj.getMountNodeObject(%i).client, 'BottomPrint', "Structural Integrity: "@%obj.ib_hp_pct@"% | Energy: "@%obj.ib_nrg_pct@"% | Speed: "@%obj.ib_vel_kph@" KPH | "@%obj.ib_vel_msv@" M/S", 0.5, 1);
            }
         }
         schedule(100, 0, "VehicleInfoBar", %obj); // every 1/10th of a second
      }
      else
         schedule(100, 0, "VehicleInfoBar", %obj); // every 1/10th of a second
   }
}

function VehicleInfoBare(%obj) // base weapon structure
{
   if(isObject(%obj))
   {
      if(%obj.getMountNodeObject(0))
      {
         if(!%obj.haltInfoBar)
         {
            %obj.ib_hp_pct = mFloor(%obj.getDamageLeftPct()*100);
            %obj.ib_nrg_pct = mFloor(%obj.getEnergyPct()*100);

            %obj.ib_Weapon1 = %obj.veh_weapon[0]; //!%obj.veh_weapon[0] ? "NONE" : %obj.veh_weapon[0];
            %obj.ib_Weapon2 = %obj.veh_weapon[1]; //!%obj.veh_weapon[1] ? "NONE" : %obj.veh_weapon[1];
            %obj.ib_WeaponAmmo1 = !%obj.veh_weapon_ammo[0] ? "inf" : %obj.veh_weapon_ammo[0];
            %obj.ib_WeaponAmmo2 = !%obj.veh_weapon_ammo[1] ? "inf" : %obj.veh_weapon_ammo[1];

            %obj.ib_mountedWeapon = %obj.selectedWeapon == 1 ? %obj.ib_showWeapon1 = "<just:left><color:ff1212>><color:42dbea>" : %obj.ib_showWeapon2 = "<just:left><color:ff1212>><color:42dbea>";
            %obj.ib_mountedWeapon = %obj.selectedWeapon == 1 ? %obj.ib_showWeapon2 = "<just:left><color:42dbea>>" : %obj.ib_showWeapon1 = "<just:left><color:42dbea>>";

            commandToClient( %obj.getMountNodeObject(0).client, 'BottomPrint', %obj.ib_showWeapon1@" Weapon 2: "@%obj.ib_Weapon1@" <just:right>Ammo: "@%obj.ib_WeaponAmmo1@"\n"@%obj.ib_showWeapon2@" Weapon 1: "@%obj.ib_Weapon2@" <just:right>Ammo: "@%obj.ib_WeaponAmmo2@"\n<just:left><color:ffffff>Structural Integrity: "@%obj.ib_hp_pct@"% <just:right>Energy: "@%obj.ib_nrg_pct@"%", 1, 3);
         }
      }
      schedule(250, 0, "VehicleInfoBar", %obj);
   }
}

function VehicleInfoBarx(%obj) // base weapon structure
{
   if(isObject(%obj))
   {
      if(%obj.getMountNodeObject(0))
      {
         if(!%obj.haltInfoBar)
         {
            %obj.ib_hp_pct = mFloor(%obj.getDamageLeftPct()*100);
            %obj.ib_hp_now = mFloor(%obj.getDamageLeftPct()*100);
            %obj.ib_hp_max = mFloor(%obj.getDamageLeftPct()*100);
            %obj.ib_nrg_pct = mFloor(%obj.getEnergyPct()*100);
            %obj.ib_nrg_now = mFloor(%obj.getEnergyPct()*100);
            %obj.ib_nrg_max = mFloor(%obj.getEnergyPct()*100);

            %obj.ib_Weapon1 = %obj.veh_weapon[0]; //!%obj.veh_weapon[0] ? "NONE" : %obj.veh_weapon[0];
            %obj.ib_Weapon2 = %obj.veh_weapon[1]; //!%obj.veh_weapon[1] ? "NONE" : %obj.veh_weapon[1];
//            %obj.ib_WeaponAmmo1 = !%obj.veh_weapon_ammo[0] ? "inf" : %obj.veh_weapon_ammo[0];
//            %obj.ib_WeaponAmmo2 = !%obj.veh_weapon_ammo[1] ? "inf" : %obj.veh_weapon_ammo[1];

            %obj.ib_mountedWeapon = %obj.selectedWeapon == 1 ? %obj.ib_showWeapon1 = "<just:left><color:ff1212>><color:42dbea>" : %obj.ib_showWeapon2 = "<just:left><color:ff1212>><color:42dbea>";
            %obj.ib_mountedWeapon = %obj.selectedWeapon == 1 ? %obj.ib_showWeapon2 = "<just:left><color:42dbea>>" : %obj.ib_showWeapon1 = "<just:left><color:42dbea>>";

            commandToClient( %obj.getMountNodeObject(0).client, 'BottomPrint', %obj.ib_showWeapon1@" Weapon 2: "@%obj.ib_Weapon1@"\n"@%obj.ib_showWeapon2@" Weapon 1: "@%obj.ib_Weapon2@"\n<just:left><color:ffffff>Structural Integrity: "@%obj.ib_hp_pct@"% <just:right>Energy: "@%obj.ib_nrg_pct@"%", 1, 3);
         }
      }
      schedule(250, 0, "VehicleInfoBar", %obj);
   }
}


// ---------------------------------------------------------
// z0dd - ZOD, 6/18/02. Get the name of the vehicle node and 
// pass to Armor::onMount and Armor::onDismount in playerScripts.cs
function findNodeName(%vehicle, %node)
{
   %vName = %vehicle.getDataBlock().getName();
   if(%vName !$= "HAPCFlyer")
   {
      if(%node == 0)
         return 'pilot';
      else if(%node == 1)
         return 'gunner';
      else
         return 'tailgunner';
   }
   else
   {
      if(%node == 0)
         return 'pilot';
      else if(%node == 1)
         return 'tailgunner';
      else
         return 'passenger';
   }
}
// End z0dd - ZOD
// ---------------------------------------------------------

datablock DebrisData(HitDebrisFX)
{
   explodeOnMaxBounce = false;
//   emitters[0] = PlayerBloodEmitter;

   elasticity = 0.35;
   friction = 0.5;

   lifetime = 12.0;
   lifetimeVariance = 4.0;

   minSpinSpeed = 20;
   maxSpinSpeed = 800;

   numBounces = 3;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 30.0;
   velocityVariance = 15.0;
};

datablock ExplosionData(DebrisFXExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   soundProfile   = plasmaExpSound;
//   particleEmitter = PlasmaExplosionEmitter;
//   particleDensity = 150;
//   particleRadius = 1.25;
   faceViewer = true;

   sizes[0] = "0.5 0.5 0.5";
   sizes[1] = "0.5 0.5 0.5";
   times[0] = 0.0;
   times[1] = 1.5;
};

datablock LinearFlareProjectileData(DebrisExplosive)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0.0;
   directDamageType    = -1;
   hasDamageRadius     = false;
   kickBackStrength    = 3000;

   explosion           = "DebrisFXExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 32;
   lifetimeMS        = 32;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 32;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock StaticShapeData(DebrisExplosiveS) : StaticShapeDamageProfile
{
   shapeFile      = "turret_muzzlepoint.dts";
   explosion      = DebrisFXExplosion;

   maxDamage      = 1;
   destroyedLevel = 1;
   disabledLevel  = 1;

   isShielded = false;
   energyPerDamagePoint = 0;
   maxEnergy = 0;
   rechargeRate = 0.0;

   debrisShapeName = "debris_generic.dts";
   debris = HitDebrisFX;
};

datablock StaticShapeData(SmallDebrisExplosive) : StaticShapeDamageProfile
{
   shapeFile      = "turret_muzzlepoint.dts";
   explosion      = DebrisFXExplosion;

   maxDamage      = 1;
   destroyedLevel = 1;
   disabledLevel  = 1;

   isShielded = false;
   energyPerDamagePoint = 0;
   maxEnergy = 0;
   rechargeRate = 0.0;

   debrisShapeName = "debris_generic_small.dts";
   debris = StaticShapeDebris; //HitDebrisFX;
};

function createHitDebris(%pos)
{
   %d = new StaticShape()
   {
      dataBlock        = DebrisExplosive;
   };
   MissionCleanup.add(%d);
   %d.setPosition(%pos);
   %d.setDamageState(Destroyed); // boom :o
}

function createSmallHitDebris(%pos)
{
   %d = new StaticShape()
   {
      dataBlock        = SmallDebrisExplosive;
   };
   MissionCleanup.add(%d);
   %d.setPosition(%pos);
   %d.setDamageState(Destroyed); // boom :o
}

// OnAdd Defs

function ScoutVehicle::onAdd(%this, %obj)
{
   %obj.veh_weapon[0] = "Plasma Rifles";
   %obj.veh_weapon_ammo[0] = 150;

   %obj.veh_weapon[1] = "";
   %obj.veh_weapon_ammo[1] = "";

   Parent::onAdd(%this, %obj);
   %obj.mountImage(WildcatChaingunParam, 0);
   %obj.mountImage(WildcatChaingunImage, 2);
   %obj.mountImage(WildcatChaingunPairImage, 3);
   %obj.nextWeaponFire = 2;
   %obj.schedule(6000, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(6300, "playThread", $ActivateThread, "activate");

   %obj.veh_description = "Standard wildcat. Comes with shields but not as fast as Turbocat.";
}

function ATV::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.schedule(6000, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(1000, "playThread", $ActivateThread, "activate");
   %obj.veh_description = "Big brother to the Wildcat and Turbocat, this is more for fun than for utility.";

   %obj.mountImage(ATVFrontDecal, 0);
   %obj.mountImage(ATVLeftDecal, 1);
   %obj.mountImage(ATVRightDecal, 2);
}

function Stingray::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(SRDecal1, 6);
   %obj.mountImage(SRDecal2, 7);
   %obj.schedule(6000, "playShieldEffect", "0.0 0.0 1.0");
//   startSub(%obj);
}

function Skyranger::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(ZIGWingsAndParam, 0);
//   %obj.mountImage(ZigWingsImage, 1);
   %obj.mountImage(ZigWeaponImage, 2);
   %obj.mountImage(ZigWeaponPairImage, 3);
   %obj.mountImage(ZigQuadGun1, 4);
   %obj.mountImage(ZigQuadGun2, 5);
   %obj.mountImage(ZigQuadGun3, 6);
   %obj.mountImage(ZigQuadGun4, 7);
   %obj.selectedWeapon = 1;

   %obj.veh_weapon[0] = "Dual Guass Chainguns";
   %obj.veh_weapon_ammo[0] = "inf";

   %obj.veh_weapon[1] = "";
   %obj.veh_weapon_ammo[1] = "inf";

   %obj.schedule(6000, "playShieldEffect", "0.0 0.0 1.0");

   %obj.weapon[1, Display] = true;
   %obj.weapon[1, Name] = "Dual Guass Chainguns";
   %obj.weapon[1, Description] = "";

   %obj.weapon[2, Display] = true;
   %obj.weapon[2, Name] = "Weapon B";
   %obj.weapon[2, Description] = "";

   %obj.veh_description = "2-person AA patrol vehicle, suited for both air and ground combat.";
//   $numVWeapons = 2;

   %turret = TurretData::create(SSTurret);
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.selectedWeapon = 1;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(SSTurretBarrel,2);
   %turret.mountImage(SSTurretBarrelPair,3);
   %obj.turretObject = %turret;
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %turret.vehicleMounted = %obj;

   %turret.weapon[1, Display] = true;
   %turret.weapon[1, Name] = "Dual KM-Band Blaster Array";
   %turret.weapon[1, Description] = "";

   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);

   //for this particular weapon - a non-firing datablock used only so the AI can aim the turret
   //Also needed so we can set the turret parameters..
   %turret.mountImage(AIAimingTurretBarrel, 0);

   %obj.schedule(4000, "playThread", $ActivateThread, "activate");
}

function Skyranger::deleteAllMounted(%data, %obj)
{
   %turret = %obj.getMountNodeObject(10);
   if(!%turret)
      return;

   %turret.altTrigger = 0;
   %turret.fireTrigger = 0;

   if(%client = %turret.getControllingClient())
   {
      %client.player.setControlObject(%client.player);
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
      %client.player.mountVehicle = false;

      %client.player.bomber = false;
      %client.player.isBomber = false;
   }
   %turret.delete();
}

function PyroXL::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.schedule(5700, "playShieldEffect", "0.0 0.0 1.0");
   %obj.veh_description = "Fast Ground transport. Very useful in the heat of battle.";
}

function HoverBike::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(TurbocatFrontDecal,0);
   %obj.mountImage(HBEngineParam, 2);
   //%obj.mountImage(HBChaingunImage, 2);
   //%obj.mountImage(HBChaingunPairImage, 3);
   %obj.mountImage(HBBomberImage, 3); //nuevo!
   %obj.mountImage(HBDiscImage, 4);
   %obj.mountImage(HBDecal1, 5);
   %obj.mountImage(HBDecal2, 6);
   %obj.mountImage(HBEngine1, 1);
   %obj.mountImage(HBEngine2, 7);
   %obj.selectedWeapon = 2;
   %obj.schedule(5200, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(5300, "playThread", $ActivateThread, "activate");

   %obj.veh_weapon[0] = "Flare Bomb Launcher";
   %obj.veh_weapon_ammo[0] = "";

   %obj.veh_weapon[1] = "";
   %obj.veh_weapon_ammo[1] = "";

   HBContrailLoop(%obj);

   %obj.veh_description = "Antigrav Wildcat. Has flare-bomb support and better sensors.";
}

function TurboCat::onAdd(%this, %obj)
{
//   createSlotExtension(%obj, 1);

//   %obj.slotExtension[1].mountImage(GBDecalAImage, 0);
//   %obj.slotExtension[1].mountImage(GBDecalBImage, 1);
//   %obj.slotExtension[1].mountImage(GBDecalCImage, 2);
//   %obj.slotExtension[1].mountImage(ASRDecalAImage, 3);
//   %obj.slotExtension[1].mountImage(ASRDecalBImage, 4);
//   %obj.slotExtension[1].mountImage(ASRDecalCImage, 5);
//   %obj.slotExtension[1].mountImage(LaserCannonDecalBImage, 6);
//   %obj.slotExtension[1].mountImage(LaserCannonDecalCImage, 7);

   Parent::onAdd(%this, %obj);
//   %obj.mountImage(HBDecal1, 5);
//   %obj.mountImage(HBDecal2, 6);

   %obj.mountImage(TurbocatFrontDecal, 5);
   %obj.mountImage(TurbocatLeftDecal, 6);
   %obj.mountImage(TurbocatRightDecal, 7);

   %obj.schedule(5200, "playShieldEffect", "0.0 0.0 1.0");
//   %obj.schedule(5300, "playThread", $ActivateThread, "activate");
   %obj.veh_description = "Modified Wildcat. Shields have been replaced with larger reactor and engine.";
}

function Explorer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.schedule(5200, "playShieldEffect", "0.0 0.0 1.0");
   %obj.veh_description = "Cloaked reconnaisance ship. Speed is limited however.";
}

function WarpFlyer::onAdd(%this, %obj)
{
    %field = new StaticShape()
    {
        scale = "5 5 5";
        dataBlock = "WarpBubble";
    };
    %obj.mountObject(%field, 6);
    %obj.field = %field;

    %core = new StaticShape()
    {
        scale = "1 1 1";
        dataBlock = "WarpCore";
    };

    %obj.mountObject(%core, 7);
    %obj.core = %core;

    %field.startFade(1000, 0, true);

   Parent::onAdd(%this, %obj);
   %obj.mountImage(WarpFlyerParam, 0);
   %obj.mountImage(WarpPlasmaMainImage, 2);
   %obj.mountImage(WarpPlasmaSideAImage, 3);
   %obj.mountImage(WarpPlasmaSideBImage, 4);
   %obj.mountImage(GenWing1Image, 5);
   %obj.mountImage(GenWing2Image, 6);
   %obj.mountImage(CamanisMuzzleImage, 7);
   %obj.selectedWeapon = 1;
   %obj.canWarp = true;

   %obj.veh_weapon[0] = "Multi Gauss Cannon";
   %obj.veh_weapon_ammo[0] = "";

   %obj.veh_weapon[1] = "";
   %obj.veh_weapon_ammo[1] = "";

   %obj.schedule(5200, "playShieldEffect", "0.0 0.0 1.0");

   %obj.augmented = true;
   %obj.augType = "Camanis* Warp Core";
   %obj.augName = "WarpCore";
   %core.playThread(0, "power");
   %field.playThread(0, "deploy");

   %obj.usesCPS = true;
   %obj.veh_description = "Modified Shrike; comes with a warp core. Press pack to use. (CPS)";
}

function WarpFlyer::deleteAllMounted(%data, %obj)
{
   %field = %obj.getMountNodeObject(6);
   if(!%field)
      return;

   %field.delete();

   %core = %obj.getMountNodeObject(7);
   if(!%core)
      return;

   %core.delete();

   if(isObject(%obj.wormhole))
      %obj.wormhole.delete();
   if(isObject(%obj.wormhole2))
      %obj.wormhole2.delete();

//   deleteSlotExtension(%obj, 5);
}
//-nite-
//function DroneBike::deleteAllMounted(%data, %obj)
//{
//   %decal = %obj.getMountNodeObject(1);
//   if(!%decal)
//      return;
//
//   %decal.delete();
//
//   $TeamDeployedCount[%obj.team, "WildcatPack"]--;
//}

function TurboCat::deleteAllMounted(%data, %obj)
{
   deleteSlotExtension(%obj, 1);
}

function LOSDownFlyer::deleteAllMounted(%data, %obj)
{
   %turret = %obj.getMountNodeObject(10);
   if(!%turret)
      return;

   %turret.altTrigger = 0;
   %turret.fireTrigger = 0;

   if(%client = %turret.getControllingClient())
   {
      %client.player.setControlObject(%client.player);
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
      %client.player.mountVehicle = false;

      %client.player.bomber = false;
      %client.player.isBomber = false;
   }
   %turret.delete();
}

function SuicideFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.schedule(5800, "playShieldEffect", "0.0 0.0 1.0");
   %obj.veh_description = "Thermo-nuclear pilotable bomb. Very hard to control; use jets.";
}

function ScoutFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(ScoutChaingunZParam, 0);
   %obj.mountImage(ScoutChaingunZImage, 2);
   %obj.mountImage(ScoutChaingunZPairImage, 3);
   %obj.mountImage(ScoutChaingunParam, 4);
   %obj.mountImage(ScoutChaingunImage, 5);
   %obj.mountImage(ScoutChaingunPairImage, 6);
   %obj.nextWeaponFire = 5;
   %obj.selectedWeapon = 2;

   %obj.veh_weapon[0] = "Bolter";
   %obj.veh_weapon_ammo[0] = 1000;

   %obj.veh_weapon[1] = "Shrike Blasters";
   %obj.veh_weapon_ammo[1] = "inf";

   %obj.weapon[1, Display] = true;
   %obj.weapon[1, Name] = "Bolter";
   %obj.weapon[1, Description] = "";

   %obj.weapon[2, Display] = true;
   %obj.weapon[2, Name] = "Shrike Blasters";
   %obj.weapon[2, Description] = "";

   %obj.schedule(5400, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(3750, "playThread", $ActivateThread, "activate");
   $numVWeapons = 2;

   %obj.veh_description = "Standard Interceptor. The vehicle legends are made from.";
}

function tPOC::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(tPOCMissileParam, 0);
   %obj.mountImage(tPOCMissileImage, 2);
   %obj.mountImage(tPOCMissilePairImage, 3);
   %obj.mountImage(tPOCCannonParam, 4);
   %obj.mountImage(tPOCCannonImage, 5);
   %obj.mountImage(tPOCCannonPairImage, 6);

   %obj.mountImage(MarantzWingRightDecal, 1);
   %obj.mountImage(MarantzWingLeftDecal, 7);

   %obj.veh_weapon[0] = "Dual Flare Burst Cannons";
   %obj.veh_weapon_ammo[0] = "inf";

   %obj.veh_weapon[1] = "Protron";
   %obj.veh_weapon_ammo[1] = "inf";

   %obj.weapon[1, Display] = true;
   %obj.weapon[1, Name] = "Dual Flare Burst Cannons";
   %obj.weapon[1, Description] = "";

   %obj.weapon[2, Display] = true;
   %obj.weapon[2, Name] = "Protron";
   %obj.weapon[2, Description] = "";

   %obj.nextWeaponFire = 4;
   %obj.selectedWeapon = 2;
   %obj.schedule(5400, "playShieldEffect", "0.0 0.0 1.0");
   %obj.schedule(5000, "playThread", $ActivateThread, "activate");
//   %obj.schedule(3075, "pauseThread", $ActivateThread);
   $numVWeapons = 2;

   %obj.veh_description = "Modified Shrike. Shields have been replaced with better engine.";
}

function tPOC::deleteAllMounted(%data, %obj)
{
   %decal = %obj.getMountNodeObject(1);
   if(!%decal)
      return;

   %decal.delete();
}

function ATV2::onAdd(%this, %obj)
{
    %field = new StaticShape()
    {
        scale = "7 7 7";
        dataBlock = "WarpBubble";
    };
    %obj.mountObject(%field, 6);
    %obj.field = %field;

    %core = new StaticShape()
    {
        scale = "1 1 1";
        dataBlock = "WarpCore";
    };

    %obj.mountObject(%core, 7);
    %obj.core = %core;

    %field.startFade(1000, 0, true);

   Parent::onAdd(%this, %obj);
   %obj.canWarp = true;

   %obj.veh_weapon[0] = "";
   %obj.veh_weapon_ammo[0] = "";

   %obj.veh_weapon[1] = "";
   %obj.veh_weapon_ammo[1] = "";

   %obj.schedule(5200, "playShieldEffect", "0.0 0.0 1.0");

   %obj.augmented = true;
   %obj.augType = "StarShine Warp Core";
   %obj.augName = "WarpCore";
   %core.playThread(0, "power");
   %field.playThread(0, "deploy");

   %obj.usesCPS = true;
   %obj.veh_description = "3-Troop transporter. Comes with a warp core. Press pack to use. (CPS)";
}

function ATV2::deleteAllMounted(%data, %obj)
{
   %field = %obj.getMountNodeObject(6);
   if(!%field)
      return;

   %field.delete();

   %core = %obj.getMountNodeObject(7);
   if(!%core)
      return;

   %core.delete();

   if(isObject(%obj.wormhole))
      %obj.wormhole.delete();
   if(isObject(%obj.wormhole2))
      %obj.wormhole2.delete();

//   deleteSlotExtension(%obj, 5);
}

function AssaultFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);

   %turret = TurretData::create(AssaultFlyerMainTurret);
   %turret.selectedWeapon = 1;
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(MissileBarrelLarge, 2); // lol
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %obj.turretObject = %turret;

   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);

   //Needed so we can set the turret parameters..
   %turret.mountImage(AssaultTurretParam, 0);
   %obj.schedule(6000, "playThread", $ActivateThread, "activate");

   // set the turret's target info
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);

   %obj.mountImage(TankPilotChaingunParam, 5);
   %obj.mountImage(TankPilotChaingunImage, 6);

   %obj.veh_weapon[0] = "Gauss Cannon";
   %obj.veh_weapon_ammo[0] = "inf";

   %obj.veh_weapon[1] = "";
   %obj.veh_weapon_ammo[1] = "inf";

   %obj.veh_description = "Modified Beowulf. This one flies but only has one turret weapon.";
}

function BomberFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);

   %turret = TurretData::create(BomberTurret);
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.selectedWeapon = 1;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(BomberTurretBarrel,2);
   %turret.mountImage(BomberTurretBarrelPair,3);
   %turret.mountImage(BomberBombImage, 4);
   %turret.mountImage(BomberBombPairImage, 5);
   %turret.mountImage(BomberTargetingImage, 6);
   %obj.turretObject = %turret;
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %turret.vehicleMounted = %obj;

   %turret.weapon[1, Display] = true;
   %turret.weapon[1, Name] = "Bomber Plasma Cannon Array";
   %turret.weapon[1, Description] = "";

   %turret.weapon[2, Display] = true;
   %turret.weapon[2, Name] = "Bomber 100k bombs";
   %turret.weapon[2, Description] = "";

   %turret.weapon[3, Display] = true;
   %turret.weapon[3, Name] = "Incendiary Bomb";
   %turret.weapon[3, Description] = "";

   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);

   //for this particular weapon - a non-firing datablock used only so the AI can aim the turret
   //Also needed so we can set the turret parameters..
   %turret.mountImage(AIAimingTurretBarrel, 0);

   // setup the turret's target info
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
   %obj.ammo[ABomb] = 5; // incendiary bomb

   %obj.usesCPS = true;
   %obj.veh_description = "The Thundersword has a dual Plasma Cannon array and 2 types of bombs. (CPS)";
}

function LOSDownFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);

   %turret = TurretData::create(LOSDownTurret);
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(AIAimingTurretBarrel, 0);
   %turret.mountImage(LOSDownTeleporterImage, 1);
   %obj.turretObject = %turret;
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %turret.vehicleMounted = %obj;
   %turret.setAutoFire(false);
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);

   %obj.usesCPS = true;
   %obj.veh_description = "The gunner of this craft controls a teleportation device. Use it wisely. (CPS)";
}

function Wolfhound::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.mountImage(WolfDecal1, 7);
   %obj.schedule(5000, "playThread", $ActivateThread, "activate");

   %turret = TurretData::create(WolfSideTurret);
   %turret.selectedWeapon = 1;
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 2);
   %turret.mountImage(DiscBarrelLarge, 2);
//   %turret.mountImage(PlasmaBarrelLarge, 4); // lol
//   %turret.mountImage(WolfhoundBarrelLarge, 2); // lol
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %turret.mountImage(AssaultTurretParam, 0);
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
   %turret.setAutoFire(false);
   %turret.setCloaked(true);
   %turret.schedule(5500, "setCloaked", false);

   %turret = TurretData::create(WolfSideTurret);
   %turret.selectedWeapon = 1;
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 1);
   %turret.mountImage(AABarrelLarge, 2);
//   %turret.mountImage(DiscBarrelLarge, 4); // lol
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %turret.mountImage(AssaultTurretParam, 0);
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);
   %turret.setAutoFire(false);
   %turret.setCloaked(true);
   %turret.schedule(5500, "setCloaked", false);

   %obj.usesCPS = true;
   %obj.veh_description = "Ground transport/Assault vehicle. Comes with interchangeable turrets. (CPS)";
}

function HAPCFlyer::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.schedule(6000, "playThread", $ActivateThread, "activate");
   %obj.usesCPS = true;
   %obj.veh_description = "Large air transport vehicle. Carries up to 5 people + pilot. (CPS)";
}

function AssaultVehicle::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);

   %turret = TurretData::create(AssaultPlasmaTurret);
   %turret.selectedWeapon = 1;
   MissionCleanup.add(%turret);
   %turret.team = %obj.teamBought;
   %turret.setSelfPowered();
   %obj.mountObject(%turret, 10);
   %turret.mountImage(TankMinigunImage1, 2);
   %turret.mountImage(TankMinigunImage2, 3);
   %turret.mountImage(TankMinigunImage3, 5);
   %turret.mountImage(TankMinigunImage4, 6);
   %turret.mountImage(AssaultMortarTurretBarrel, 4);
   %turret.setCapacitorRechargeRate( %turret.getDataBlock().capacitorRechargeRate );
   %obj.turretObject = %turret;

   %turret.weapon[1, Display] = true;
   %turret.weapon[1, Name] = "Tank MechMinigun";
   %turret.weapon[1, Description] = "";

   %turret.weapon[2, Display] = true;
   %turret.weapon[2, Name] = "Tank Star Hammer";
   %turret.weapon[2, Description] = "The weapon with extra punch!";

   //vehicle turrets should not auto fire at targets
   %turret.setAutoFire(false);

   //Needed so we can set the turret parameters..
   %turret.mountImage(AssaultTurretParam, 0);
   %obj.schedule(6000, "playThread", $ActivateThread, "activate");

   // set the turret's target info
   setTargetSensorGroup(%turret.getTarget(), %turret.team);
   setTargetNeverVisMask(%turret.getTarget(), 0xffffffff);

   %obj.mountImage(TankPilotChaingunParam, 5);
   %obj.mountImage(TankPilotChaingunImage, 6);
   %turret.flakEnabled = true;

   %obj.veh_weapon[0] = "Gauss Cannon";
   %obj.veh_weapon_ammo[0] = "inf";

   %obj.veh_weapon[1] = "";
   %obj.veh_weapon_ammo[1] = "inf";

   %obj.veh_description = "Beowulf assault tank. Pilot gets Gauss and the gunner gets 2 weapons.";
}

function AlternateMobileBase::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.station = "";
   %obj.turret = "";
   %obj.beacon = "";

   %obj.schedule(5000, "playThread", $AmbientThread, "ambient");
   %obj.veh_description = "Floating version of the Jehrico. Used for mid-water deployment.";
}

function MobileBaseVehicle::onAdd(%this, %obj)
{
   Parent::onAdd(%this, %obj);
   %obj.station = "";
   %obj.turret = "";
   %obj.beacon = "";

   %obj.schedule(5000, "playThread", $AmbientThread, "ambient");
   %obj.veh_description = "This base can go anywhere and deploy.. even underwater!";
}

function AlternateMobileBase::deleteAllMounted(%data, %obj)
{
   if(isObject(%obj.station))
   {
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.unmountObject(%obj.station);
      %obj.station.trigger.delete();
      %obj.station.delete();
   }
   if(isObject(%obj.turret))
   {
      %obj.turret.getDataBlock().onLosePowerDisabled(%obj.turret);
      %obj.unmountObject(%obj.turret);
      %obj.turret.delete();
   }
   if(isObject(%obj.shield))
      %obj.shield.delete();

//   if (isObject(%obj.teleporter))
//   {
//      %obj.teleporter.setThreadDir($ActivateThread, FALSE);
//      %obj.teleporter.playThread($ActivateThread,"activate");
//      %obj.teleporter.playAudio($ActivateSound, StationTeleportDeacitvateSound);
//   }
   if(isObject(%obj.beacon))
//   {
      %obj.beacon.delete();
//   }
}

// Player Mounting Calls

function vehicleOnPlayerMounted(%data, %obj, %client)
{
   %sr = 0;

   if(%data.isShielded && %data.energyPerDamagePoint)
      %sr = %data.energyPerDamagePoint;

   %w1 = %obj.veh_weapon[0] $= "" ? "N/A" : %obj.veh_weapon[0];
   %w2 = %obj.veh_weapon[1] $= "" ? "N/A" : %obj.veh_weapon[1];

   commandToClient(%client, 'BottomPrint', "Hit Points "@(%data.maxDamage * 100)@" | Shield: "@%sr@" MW per 100 HP | Energy Capacitor: "@%data.maxEnergy@" MW\nWeapon 1: "@%w1@" | Weapon 2: "@%w2@"\n"@%obj.veh_description, 10, 3);
}

function ScoutFlyer::playerMounted(%data, %obj, %player, %node)
{
   // scout flyer == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);
   commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
   $numVWeapons = 2;

   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function TurboCat::playerMounted(%data, %obj, %player, %node)
{
   // scout flyer == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);

   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function Stingray::playerMounted(%data, %obj, %player, %node)
{
   // scout flyer == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function WarpFlyer::playerMounted(%data, %obj, %player, %node)
{
   // scout flyer == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);

   %obj.client = %player.client;
   %obj.warpcore = true;
   VehicleInfoBar(%obj);

   %player.client.setWeaponsHudActive("ELFGun");

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function tPOC::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);
   commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
   $numVWeapons = 2;

   %obj.owner = %player.client;
   VehicleInfoBar(%obj);
   %player.client.setWeaponsHudActive("Blaster");

      // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}
//-Nite-  drones
//function DroneBike::playerMounted(%data, %obj, %player, %node)
//{
//   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
//
//      // update observers who are following this guy...
//   if( %player.client.observeCount > 0 )
//      resetObserveFollow( %player.client, false );
//}

function Skyranger::playerMounted(%data, %obj, %player, %node)
{
//   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
//   commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
//   $numVWeapons = 2;
//   commandToClient(%player.client, 'setRepairReticle');

//   %obj.owner = %player.client;
//   VehicleInfoBar(%obj);
//   %player.client.setWeaponsHudActive("MissileLauncher");

   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
      VehicleInfoBar(%obj);
      %player.client.setWeaponsHudActive("Blaster");
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
   }
   else if(%node == 1)
   {
      // bombardier position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      %turret.bomber = %player;
      $bWeaponActive = 0;
      %obj.getMountNodeObject(10).selectedWeapon = 1;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);

	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
      %player.isBomber = true;
   }

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function PyroXL::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
        %obj.owner = %player.client;
        VehicleInfoBar(%obj);
   }
   else
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function ScoutVehicle::playerMounted(%data, %obj, %player, %node)
{
   // scout vehicle == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
   %obj.owner = %player.client;
   VehicleInfoBar(%obj);
//   commandToClient(%player.client, 'setRepairReticle');
   %player.client.setWeaponsHudActive("Plasma");

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function ATV::playerMounted(%data, %obj, %player, %node)
{
   // scout vehicle == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Shrike", %node);
   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function HoverBike::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
//   commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
   $numVWeapons = 2;
//   commandToClient(%player.client, 'setRepairReticle');

   %obj.owner = %player.client;
   VehicleInfoBar(%obj);
   %player.client.setWeaponsHudActive("Mortar");

      if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function SuicideFlyer::playerMounted(%data, %obj, %player, %node)
{
     commandToClient(%player.client, 'setHudMode', 'Pilot', "MPB", %node);
     %obj.owner = %player.client;
     VehicleInfoBar(%obj);
}

function ATV2::playerMounted(%data, %obj, %player, %node)
{
     %obj.stasisProof = true;
   if(%node == 0)
   {
          commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
          %obj.client = %player.client;
   }
   else
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function AlternateMobileBase::playerMounted(%data, %obj, %player, %node)
{
   commandToClient(%player.client, 'setHudMode', 'Pilot', "MPB", %node);
   %obj.owner = %player.client;
   VehicleInfoBar(%obj);

   if(%obj.deploySchedule)
   {
      %obj.deploySchedule.clear();
      %obj.deploySchedule = "";
   }

   if(%obj.deployed !$= "" && %obj.deployed == 1)
   {
      %obj.setThreadDir($DeployThread, false);
      %obj.playThread($DeployThread,"deploy");
      %obj.playAudio($DeploySound, MobileBaseUndeploySound);
      %obj.station.setThreadDir($DeployThread, false);
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.station.clearSelfPowered();
      %obj.station.goingOut=false;
      %obj.station.notDeployed = 1;
      %obj.station.playAudio($DeploySound, MobileBaseStationUndeploySound);

      if((%turretClient = %obj.turret.getControllingClient()) !$= "")
      {
         CommandToServer( 'resetControlObject', %turretClient );
      }

      %obj.turret.setThreadDir($DeployThread, false);
      %obj.turret.clearTarget();
      %obj.turret.setTargetObject(-1);

      %obj.turret.playAudio($DeploySound, MobileBaseTurretUndeploySound);
      %obj.shield.open();
      %obj.shield.schedule(1000,"delete");
      %obj.deploySchedule = "";

//      %obj.teleporter.setThreadDir($ActivateThread, FALSE);
//      %obj.teleporter.playThread($ActivateThread,"activate");
//      %obj.teleporter.playAudio($ActivateSound, StationTeleportDeacitvateSound);
      %obj.fullyDeployed = 0;

      %obj.noEnemyControl = 0;
   }
   %obj.deployed = 0;

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function vehicleDeployAMB(%data, %obj, %player, %force)
{
   %fun = true; // HACK! lol
   if(%fun || %force)
   {
      %deployMessage = "";
      if( (%deployMessage = %data.checkTurretDistance(%obj)) $= "" || %force)
      {
         if(%obj.station $= "")
         {
            if(%force || %fun) //(%deployMessage = %data.checkDeploy(%obj)) $= "" ||
            {
               %obj.station = new StaticShape() {
                  scale = "1 1 1";
                  dataBlock = "MobileInvStation";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
                  vehicle = %obj;
               };
               %obj.station.startFade(0,0,true);
               %obj.mountObject(%obj.station, 2);
               %obj.station.getDataBlock().createTrigger(%obj.station);
               %obj.station.setSelfPowered();
               %obj.station.playThread($PowerThread,"Power");
               %obj.station.playAudio($HumSound,StationHumSound);
               %obj.station.vehicle = %obj;
               %obj.turret = new turret() {
                  scale = "1 1 1";
                  dataBlock = "MobileTurretBase";
                  lockCount = "0";
                  homingCount = "0";
                  team = %obj.team;
               };
               %obj.turret.setDamageLevel(%obj.getDamageLevel());
               %obj.mountObject(%obj.turret, 1);
               %obj.turret.setSelfPowered();
               %obj.turret.playThread($PowerThread,"Power");
               %obj.turret.mountImage(MissileBarrelLarge, 0 ,false);

               %obj.beacon = new ScopeAlwaysShape() {
                  dataBlock = "DeployedBeacon";
                  position = %obj.position;
                  rotation = %obj.rotation;
                  team = %obj.team;
               };
//               %obj.beacon.setBeaconType(friend);
               %obj.beacon.setTarget(%obj.team);
            }
         }
         else
         {
            %obj.station.setSelfPowered();
            %obj.station.playThread($PowerThread,"Power");
            %obj.turret.setSelfPowered();
            %obj.turret.playThread($PowerThread,"Power");
         }
         if(%deployMessage $= "" || %force)
         {
            if(%obj.turret.getTarget() == -1)
            {
               %obj.turret.setTarget(%obj.turret.target);
            }
            %obj.turret.setThreadDir($DeployThread, true);
            %obj.turret.playThread($DeployThread,"deploy");
            %obj.turret.playAudio($DeploySound, MobileBaseTurretDeploySound);

            %obj.station.notDeployed = 1;
            %obj.setThreadDir($DeployThread, true);
            %obj.playThread($DeployThread,"deploy");
            %obj.playAudio($DeploySound, MobileBaseDeploySound);
            %obj.deployed = 1;
            %obj.deploySchedule = "";
            %obj.disableMove = true;
            %obj.setFrozenState(true);
            if(isObject(%obj.shield))
               %obj.shield.delete();

            %obj.shield = new forceFieldBare()
            {
               scale = "1.22 1.8 1.1";
               dataBlock = "defaultTeamSlowFieldBare";
               team = %obj.team;
            };
            %obj.shield.open();
            setTargetSensorData(%obj.getTarget(), MPBDeployedSensor);
         }
      }
      if(%deployMessage !$= "")
         messageClient(%player.client, '', %deployMessage);

      return true;
   }
   else
   {
      return false;
   }
}

function AlternateMobileBase::playerDismounted(%data, %obj, %player)
{
   schedule(500, %obj, "vehicleDeployAMB", %data, %obj, %player); // SIMPLE AS 3.14
   Parent::playerDismounted( %data, %obj, %player );
}

function AlternateMobileBase::onEndSequence(%data, %obj, %thread)
{
   if(%thread == $DeployThread && !%obj.deployed)
   {
      %obj.unmountObject(%obj.station);
      %obj.station.trigger.delete();
      %obj.station.delete();
      %obj.station = "";

	  %obj.beacon.delete();

      %obj.unmountObject(%obj.turret);
      %obj.turret.delete();
      %obj.turret = "";

      if(!%obj.immobilized)
      {
         %obj.disableMove = false;
         %obj.setFrozenState(false);
      }
      setTargetSensorData(%obj.getTarget(), %data.sensorData);
   }
   else
   {
      %obj.station.startFade(0,0,false);
      %obj.station.setThreadDir($DeployThread, true);
      %obj.station.playThread($DeployThread,"deploy");
      %obj.station.playAudio($DeploySound, MobileBaseStationDeploySound);
      %obj.station.goingOut = true;
      %obj.shield.setTransform(%obj.getSlotTransform(3));
      %obj.shield.close();
      %obj.isDeployed = true;
      %obj.noEnemyControl = 1;
   }

   Parent::onEndSequence(%data, %obj, %thread);
}

function AlternateMobileBase::checkDeploy(%data, %obj)
{
   %mask = $TypeMasks::VehicleObjectType | $TypeMasks::MoveableObjectType |
           $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType |
           $TypeMasks::ItemObjectType | $TypeMasks::PlayerObjectType |
           $TypeMasks::TurretObjectType | //$TypeMasks::StaticTSObjectType |
           $TypeMasks::InteriorObjectType;

   //%slot 1 = turret   %slot 2 = station
   %height[1] = 0;
   %height[2] = 0;
   %radius[1] = 2.4;
   %radius[2] = 2.4;
   %stationFailed = false;
   %turretFailed = false;

   for(%x = 1; %x < 3; %x++)
   {
      %posXY = getWords(%obj.getSlotTransform(%x), 0, 1);
      %posZ = (getWord(%obj.getSlotTransform(%x), 2) + %height[%x]);
      InitContainerRadiusSearch(%posXY @ " " @ %posZ, %radius[%x], %mask);

      while ((%objFound = ContainerSearchNext()) != 0)
      {
         if(%objFound != %obj)
         {
            if(%x == 1)
               %turretFailed = true;
            else
               %stationFailed = true;
            break;
         }
      }
   }

   //If turret, station or both fail the send back the error message...
//   if(%turretFailed &&  %stationFailed)
//      return "Both Turret and Station are blocked and unable to deploy.";
//   if(%turretFailed)
//      return "Turret is blocked and unable to deploy.";
//   if(%stationFailed)
//      return "Station is blocked and unable to deploy.";

   %turretFailed = false; // HACK!
   %stationFailed = false; // HACK!
   //Check the station for collision with the Terrain
   %mat = %obj.getTransform();
   for(%x = 1; %x < 7; %x+=2)
   {
      %startPos = MatrixMulPoint(%mat, %data.stationPoints[%x]);
      %endPos = MatrixMulPoint(%mat, %data.stationPoints[%x+1]);

      %rayCastObj = containerRayCast(%startPos, %endPos, $TypeMasks::TerrainObjectType, 0);
      if(%rayCastObj)
         return "Station is blocked by terrain and unable to deploy.";
   }

   return "";
}

function AlternateMobileBase::checkTurretDistance(%data, %obj)
{
   %pos = getWords(%obj.getTransform(), 0, 2);
   InitContainerRadiusSearch(%pos, 25, $TypeMasks::TurretObjectType | $TypeMasks::InteriorObjectType);
   while ((%objFound = ContainerSearchNext()) != 0)
   {
      if(%objFound.getType() & $TypeMasks::TurretObjectType)
      {
         if(%objFound.getDataBlock().ClassName $= "TurretBase")
            return "Turret Base is in the area. Unable to deploy.";
      }
      else
      {
         %subStr = getSubStr(%objFound.interiorFile, 1, 4);
         if(%subStr !$= "rock" && %subStr !$= "spir" && %subStr !$= "misc")
            return "Building is in the area. Unable to deploy.";
      }
   }
   return "";
}

function MobileBaseVehicle::checkDeploy(%data, %obj)
{
   %mask = $TypeMasks::VehicleObjectType | $TypeMasks::MoveableObjectType |
           $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType |
           $TypeMasks::ItemObjectType | $TypeMasks::PlayerObjectType |
           $TypeMasks::TurretObjectType | //$TypeMasks::StaticTSObjectType |
           $TypeMasks::InteriorObjectType;

   //%slot 1 = turret   %slot 2 = station
   %height[1] = 0;
   %height[2] = 0;
   %radius[1] = 2.4;
   %radius[2] = 2.4;
   %stationFailed = false;
   %turretFailed = false;

   for(%x = 1; %x < 3; %x++)
   {
      %posXY = getWords(%obj.getSlotTransform(%x), 0, 1);
      %posZ = (getWord(%obj.getSlotTransform(%x), 2) + %height[%x]);
      InitContainerRadiusSearch(%posXY @ " " @ %posZ, %radius[%x], %mask);

      while ((%objFound = ContainerSearchNext()) != 0)
      {
         if(%objFound != %obj)
         {
            if(%x == 1)
               %turretFailed = true;
            else
               %stationFailed = true;
            break;
         }
      }
   }

   //If turret, station or both fail the send back the error message...
//   if(%turretFailed &&  %stationFailed)
//      return "Both Turret and Station are blocked and unable to deploy.";
//   if(%turretFailed)
//      return "Turret is blocked and unable to deploy.";
//   if(%stationFailed)
//      return "Station is blocked and unable to deploy.";

   %turretFailed = false; // HACK!
   %stationFailed = false; // HACK!

   //Check the station for collision with the Terrain
   %mat = %obj.getTransform();
   for(%x = 1; %x < 7; %x+=2)
   {
      %startPos = MatrixMulPoint(%mat, %data.stationPoints[%x]);
      %endPos = MatrixMulPoint(%mat, %data.stationPoints[%x+1]);

      %rayCastObj = containerRayCast(%startPos, %endPos, $TypeMasks::TerrainObjectType, 0);
      if(%rayCastObj)
         return "Station is blocked by terrain and unable to deploy.";
   }

   return "";
}

function MobileBaseVehicle::checkTurretDistance(%data, %obj)
{
   %pos = getWords(%obj.getTransform(), 0, 2);
   InitContainerRadiusSearch(%pos, 25, $TypeMasks::TurretObjectType | $TypeMasks::InteriorObjectType);
   while ((%objFound = ContainerSearchNext()) != 0)
   {
      if(%objFound.getType() & $TypeMasks::TurretObjectType)
      {
         if(%objFound.getDataBlock().ClassName $= "TurretBase")
            return "Turret Base is in the area. Unable to deploy.";
      }
      else
      {
         %subStr = getSubStr(%objFound.interiorFile, 1, 4);
         if(%subStr !$= "rock" && %subStr !$= "spir" && %subStr !$= "misc")
            return "Building is in the area. Unable to deploy.";
      }
   }
   return "";
}

//----------------------------
// THUNDERSWORD BOMBER
//----------------------------

function BomberFlyer::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
       VehicleInfoBar(%obj);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
   }
   else if(%node == 1)
   {
      // bombardier position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      commandToClient(%player.client, 'startBomberSight');
      %turret.bomber = %player;
      $bWeaponActive = 0;
      %obj.getMountNodeObject(10).selectedWeapon = 1;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);

	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
      %player.isBomber = true;
   }
   else
   {
      // tail gunner position     
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);
   }
   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function xBomberFlyer::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
       VehicleInfoBar(%obj);
   }
   else if(%node == 1)
   {
      // bombardier position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      commandToClient(%player.client, 'startBomberSight');
      %turret.bomber = %player;
      $bWeaponActive = 0;
      %obj.getMountNodeObject(10).selectedWeapon = 1;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);

	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
      %player.isBomber = true;
   }
   else
   {
      // tail gunner position
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);
   }
   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function LOSDownFlyer::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
       VehicleInfoBar(%obj);
   }
   else if(%node == 1)
   {
      // bombardier position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 0);
      }
      %turret.bomber = %player;
      $bWeaponActive = 0;
      %obj.getMountNodeObject(10).selectedWeapon = 1;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);

	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Bomber", %node);
      %player.isBomber = true;
   }
   else
   {
      // tail gunner position
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "Bomber", %node);
      vSlotAutoRepair(%obj, %node);
   }
   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

function LOSDownFlyer::onDamage(%this, %obj)
{
   if(isObject(%obj.getMountNodeObject(10)))
      (%obj.getMountNodeObject(10)).setDamagelevel(%obj.getDamageLevel());
   Parent::onDamage(%this, %obj);
}

function Wolfhound::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0)
   {
      // pilot position
      %player.setPilot(true);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "HAPC", %node);
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
       VehicleInfoBar(%obj);
   }
   else if(%node == 3)
   {
      %turret = %obj.getMountNodeObject(2);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      %turret.turreteer = %player;

      $aWeaponActive = 0;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
//      %player.setControlObject(%turret);
      %obj.getMountNodeObject(2).selectedWeapon = 1;
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "HAPC", %node);
      commandToClient(%player.client, 'setRepairReticle');
   }
   else if(%node == 4)
   {
      %turret = %obj.getMountNodeObject(1);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      %turret.turreteer = %player;

      $aWeaponActive = 0;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
      %obj.getMountNodeObject(5).selectedWeapon = 1;
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "HAPC", %node);
      commandToClient(%player.client, 'setRepairReticle');
   }
   else
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "HAPC", %node);

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

//----------------------------
// HAVOC TRANSPORT FLIER
//----------------------------

function HAPCFlyer::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0) {
      // pilot position
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "HAPC", %node);
       VehicleInfoBar(%obj);
   }
   else {
      // all others
	   commandToClient(%player.client, 'setHudMode', 'Passenger', "HAPC", %node);
   }
   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 0 1 1 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

//----------------------------
// WILDCAT GRAV CYCLE
//----------------------------

function ScoutVehicle::playerMounted(%data, %obj, %player, %node)
{
   // scout vehicle == SUV (single-user vehicle)
   commandToClient(%player.client, 'setHudMode', 'Pilot', "Hoverbike", %node);
       VehicleInfoBar(%obj);
   commandToClient(%player.client, 'setRepairReticle');

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

//----------------------------
// BEOWULF ASSAULT VEHICLE
//----------------------------


function AssaultVehicle::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0) {
      // driver position
      // is there someone manning the turret?
      //%turreteer = %obj.getMountedNodeObject(1);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
      %player.client.setWeaponsHudActive("Shocklance");
       VehicleInfoBar(%obj);
   }
   else if(%node == 1)
   {
      // turreteer position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;   
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      %turret.turreteer = %player;
      // if the player is the turreteer, show vehicle's weapon icons
      //commandToClient(%player.client, 'showVehicleWeapons', %data.getName());
      //%player.client.setVWeaponsHudActive(1); // plasma turret icon (default)
      
      $aWeaponActive = 0;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
      %obj.getMountNodeObject(10).selectedWeapon = 1;
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
   }

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);
}

function xAssaultVehicle::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0) {
      // driver position
      // is there someone manning the turret?
      //%turreteer = %obj.getMountedNodeObject(1);
//      commandToClient(%player.client, 'setRepairReticle');
      %player.client.setWeaponsHudActive("Shocklance");

   // update observers who are following this guy...
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
       VehicleInfoBar(%obj);
   }
   else if(%node == 1)
   {
      // turreteer position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      %turret.turreteer = %player;
      // if the player is the turreteer, show vehicle's weapon icons
      //commandToClient(%player.client, 'showVehicleWeapons', %data.getName());
      //%player.client.setVWeaponsHudActive(1); // plasma turret icon (default)

      $aWeaponActive = 0;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
      %obj.getMountNodeObject(10).selectedWeapon = 1;
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
   }

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);
}

function AssaultFlyer::playerMounted(%data, %obj, %player, %node)
{
   if(%node == 0) {
      // driver position
      // is there someone manning the turret?
      //%turreteer = %obj.getMountedNodeObject(1);
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
      VehicleInfoBar(%obj);
//      commandToClient(%player.client, 'setRepairReticle');
      %player.client.setWeaponsHudActive("Shocklance");
   }
   else if(%node == 1)
   {
      // turreteer position
      %turret = %obj.getMountNodeObject(10);
      %player.vehicleTurret = %turret;
      %player.setTransform("0 0 0 0 0 1 0");
      %player.lastWeapon = %player.getMountedImage($WeaponSlot);
      %player.unmountImage($WeaponSlot);
      if(!%player.client.isAIControlled())
      {
         %player.setControlObject(%turret);
         %player.client.setObjectActiveImage(%turret, 2);
      }
      %turret.turreteer = %player;
      // if the player is the turreteer, show vehicle's weapon icons
      //commandToClient(%player.client, 'showVehicleWeapons', %data.getName());
      //%player.client.setVWeaponsHudActive(1); // plasma turret icon (default)

      $aWeaponActive = 0;
      commandToClient(%player.client,'SetWeaponryVehicleKeys', true);
      %obj.getMountNodeObject(10).selectedWeapon = 1;
	   commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
      commandToClient(%player.client, 'setRepairReticle');
   }

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);
}

function Explorer::playerMounted(%data, %obj, %player, %node)
{
//   if(%node == 0)
      commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);
//   else
//      commandToClient(%player.client, 'setHudMode', 'Pilot', "Assault", %node);

   %player.setCloaked(true);

   if(!%obj.isCloaked())
      %obj.setCloaked(true);

   VehicleInfoBar(%obj);

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );

   // build a space-separated string representing passengers
   // 0 = no passenger; 1 = passenger (e.g. "1 0 ")
   %passString = buildPassengerString(%obj);
	// send the string of passengers to all mounted players
	for(%i = 0; %i < %data.numMountPoints; %i++)
		if(%obj.getMountNodeObject(%i) > 0)
		   commandToClient(%obj.getMountNodeObject(%i).client, 'checkPassengers', %passString);
}

//----------------------------
// JERICHO FORWARD BASE
//----------------------------

function MobileBaseVehicle::playerMounted(%data, %obj, %player, %node)
{
   // MPB vehicle == SUV (single-user vehicle)
       VehicleInfoBar(%obj);
   commandToClient(%player.client, 'setHudMode', 'Pilot', "MPB", %node);
   if(%obj.deploySchedule)
   {
      %obj.deploySchedule.clear();
      %obj.deploySchedule = "";
   }

   if(%obj.deployed !$= "" && %obj.deployed == 1)
   {
      %obj.setThreadDir($DeployThread, false);
      %obj.playThread($DeployThread,"deploy");
      %obj.playAudio($DeploySound, MobileBaseUndeploySound);
      %obj.station.setThreadDir($DeployThread, false);
      %obj.station.getDataBlock().onLosePowerDisabled(%obj.station);
      %obj.station.clearSelfPowered();
      %obj.station.goingOut=false;
      %obj.station.notDeployed = 1;
      %obj.station.playAudio($DeploySound, MobileBaseStationUndeploySound);

      if((%turretClient = %obj.turret.getControllingClient()) !$= "")
      {
         CommandToServer( 'resetControlObject', %turretClient );
      }

      %obj.turret.setThreadDir($DeployThread, false);
      %obj.turret.clearTarget();
      %obj.turret.setTargetObject(-1);

      %obj.turret.playAudio($DeploySound, MobileBaseTurretUndeploySound);
      %obj.shield.open();
      %obj.shield.schedule(1000,"delete");
      %obj.deploySchedule = "";

      %obj.fullyDeployed = 0;

      %obj.noEnemyControl = 0;
   }
   %obj.deployed = 0;

   // update observers who are following this guy...
   if( %player.client.observeCount > 0 )
      resetObserveFollow( %player.client, false );
}

//------------------------------------------------------------------------------
function HoverVehicleData::create(%block, %team, %oldObj)
{
   if(%oldObj $= "")
   {
      %obj = new HoverVehicle()
      {
         dataBlock  = %block;
         respawn    = "0";
         teamBought = %team;
         team = %team;
      };
   }
   else
   {
      %obj = new HoverVehicle()
      {
         dataBlock  = %data;
         respawn    = "0";
         teamBought = %team;
         team = %team;
         mountable = %oldObj.mountable;
         disableMove = %oldObj.disableMove;
         resetPos = %oldObj.resetPos;
         respawnTime = %oldObj.respawnTime;
         marker = %oldObj;
      };
   }

//   MountAPEsToObject(%obj);
   return(%obj);
}

function WheeledVehicleData::create(%data, %team, %oldObj)
{
   if(%oldObj $= "")
   {
      %obj = new WheeledVehicle()
      {
         dataBlock  = %data;
         respawn    = "0";
         teamBought = %team;
         team = %team;
      };
   }
   else
   {
      %obj = new WheeledVehicle()
      {
         dataBlock  = %data;
         respawn    = "0";
         teamBought = %team;
         team = %team;
         mountable = %oldObj.mountable;
         disableMove = %oldObj.disableMove;
         resetPos = %oldObj.resetPos;
         deployed = %oldObj.deployed;
         respawnTime = %oldObj.respawnTime;
         marker = %oldObj;
      };
   }

//   MountAPEsToObject(%obj);
   return(%obj);
}

function FlyingVehicleData::create(%data, %team, %oldObj)
{
   if(%oldObj $= "")
   {
      %obj = new FlyingVehicle()
      {
         dataBlock  = %data;
         respawn    = "0";
         teamBought = %team;
         team = %team;
      };
   }
   else
   {
      %obj = new FlyingVehicle()
      {
         dataBlock  = %data;
         teamBought = %team;
         team = %team;
         mountable = %oldObj.mountable;
         disableMove = %oldObj.disableMove;
         resetPos = %oldObj.resetPos;
         respawnTime = %oldObj.respawnTime;
         marker = %oldObj;
      };
   }

//   MountAPEsToObject(%obj);
   return(%obj);
}
