if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// Meltdown2 Extra weapons data

function projObserveCheck(%obj, %cl)
{
   if(isObject(%cl))
   {
      if(isObject(%obj))
         schedule(1250, 0, "projObserveCheck", %obj, %cl);
      else
         %cl.setControlObject(%cl.player);
   }
}

function assignTrackerTo(%obj, %proj)
{
   if(!%obj.lockedMissileCount)
      %obj.lockedMissileCount = 0;

   %proj.setObjectTarget(%obj);
   %obj.lockedMissile[%obj.lockedMissileCount] = %proj;
   %obj.lockedMissileCount++;
}

function checkTrackerObj(%obj, %pl)
{
   if(!%obj.lockedMissileCount)
      return;

   for(%i = 0; %i < %obj.lockedMissileCount; %i++)
   {
      if(%obj.lockedMissile[%i])
      {
         if(isObject(%obj.lockedMissile[%i]))
         {
            %pl.setHeat(1.0);
            %obj.lockedMissile[%i].setObjectTarget(%pl);
         }
      }
   }
}

function setLoadingFlag(%data, %obj)
{
   if(!%obj.wep_reloading[%data])
   {
      %obj.wep_reloading[%data] = true;
      schedule(%data.reloadTime, %obj, clearLoadingFlag, %data, %obj);
   }
}

function clearLoadingFlag(%data, %obj)
{
   if(isObject(%obj))
      if(%obj.wep_reloading[%data])
         %obj.wep_reloading[%data] = false;
}

function MissileLauncherImage::onFire(%data,%obj,%slot)
{
   if(%obj.wep_reloading[%data])
      return;

   %data.lightStart = getSimTime();

   %weapon = %obj.getMountedImage(0).item;

         if(%obj.client.mode[%weapon] == 0)
               %projectile = "ShoulderMissile";
         else if(%obj.client.mode[%weapon] == 1)
               %projectile = "EMPMissile";
         else if(%obj.client.mode[%weapon] == 2)
               %projectile = "ConcussionMissile";
         else if(%obj.client.mode[%weapon] == 3)
               %projectile = "IncendiaryMissile";
         else if(%obj.client.mode[%weapon] == 4)
               %projectile = "FastMissile";
         else if(%obj.client.mode[%weapon] == 5)
               %projectile = "ShoulderMissile";
         else if(%obj.client.mode[%weapon] == 6)
               %projectile = "MegaMissile";

      %p = new (%data.projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = 0;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.decInventory(%data.ammo,1);

   MissileSet.add(%p);

   %target = %obj.getLockedTarget();
   if(%target)
   {
      if(%target.getDatablock().jetfire || %target.getDatablock().MegaDisc)
         assignTrackerTo(%target, %p);
      else
         %p.setObjectTarget(%target);
   }
   else if(%obj.isLocked())
      %p.setPositionTarget(%obj.getLockedPosition());
   else
      %p.setNoTarget();

      if(%obj.client.mode[%weapon] == 5) // new EO mode
      {
         %cl = %obj.client;
         projObserveCheck(%p, %cl);

         %cl.camera.setTransform(%p.getTransform());
         %cl.camera.getDataBlock().setMode( %cl.camera, "pre-game", %p);
//         %cl.camera.setOrbitMode(%p, %p.getTransform(), 0.75, 9.5, 9.5);
         %cl.setControlObject(%cl.camera);
      }

   setLoadingFlag(%data, %obj);
}

function MissileLauncherImage::onWetFire(%data, %obj, %slot)
{
   if(%obj.wep_reloading[%data])
      return;

   %data.lightStart = getSimTime();
   %weapon = %obj.getMountedImage(0).item;

         if(%obj.client.mode[%weapon] == 0)
               %projectile = "ShoulderMissile";
         else if(%obj.client.mode[%weapon] == 1)
               %projectile = "EMPMissile";
         else if(%obj.client.mode[%weapon] == 2)
               %projectile = "ConcussionMissile";
         else if(%obj.client.mode[%weapon] == 3)
               %projectile = "IncendiaryMissile";
         else if(%obj.client.mode[%weapon] == 4)
               %projectile = "FastMissile";
         else if(%obj.client.mode[%weapon] == 5)
               %projectile = "ShoulderMissile";
         else if(%obj.client.mode[%weapon] == 6)
               %projectile = "MegaMissile";

      %p = new (%data.projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = 0;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.decInventory(%data.ammo,1);
   MissileSet.add(%p);

   %p.setObjectTarget(0);

      if(%obj.client.mode[%weapon] == 5)
      {
         %cl = %obj.client;
         projObserveCheck(%p, %cl);

         %cl.camera.setTransform(%p.getTransform());
         %cl.camera.getDataBlock().setMode( %cl.camera, "pre-game", %p);
//         %cl.camera.setOrbitMode(%p, %p.getTransform(), 0.5, 9, 9);
         %cl.setControlObject(%cl.camera);
      }
   setLoadingFlag(%data, %obj);
}

function MissileBarrelLarge::onFire(%data,%obj,%slot)
{
   %p = Parent::onFire(%data,%obj,%slot);

   if (%obj.getControllingClient())
   {
      // a player is controlling the turret
      %target = %obj.getLockedTarget();
   }
   else
   {
      // The ai is controlling the turret
      %target = %obj.getTargetObject();
   }

   if(%target)
   {
      if(%target.getDatablock().jetfire || %target.getDatablock().MegaDisc)
         assignTrackerTo(%target, %p);
      else
         %p.setObjectTarget(%target);
   }
   else if(%obj.isLocked())
      %p.setPositionTarget(%obj.getLockedPosition());
   else
      %p.setNoTarget(); // set as unguided. Only happens when itchy trigger can't wait for lock tone.
}

function ELFGunImage::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

   %vehicle = 0;
   %energy = %obj.getEnergyLevel();
   if(%energy < %data.minEnergy)
         return;

   if(%obj.isCloaked())
      return;

   %weapon = %obj.getMountedImage(0).item;

         if(%obj.client.mode[%weapon] == 0)
               %projectile = "BasicELF";
         else if(%obj.client.mode[%weapon] == 1)
               %projectile = "TractorElf";
         else if(%obj.client.mode[%weapon] == 2)
               %projectile = "PullElf";
        // else if(%obj.client.mode[%weapon] == 3) -Nite- bye bye
              //%projectile = "StasisElf";
         else if(%obj.client.mode[%weapon] >= 3) //-Nite- fins uberelf theres some stuff done there too.
               %projectile = "UberElf";

      %p = new (%data.projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

//   %obj.setEnergyLevel(%energy - %data.fireEnergy);

     if(!%p.hasTarget())
     {
          %obj.playAudio(0, ELFFireWetSound);

          %q = new ShockLanceProjectile()
          {
               dataBlock        = "BasicShocker";
               initialDirection = %obj.getMuzzleVector(%slot);
               initialPosition  = %obj.getMuzzlePoint(%slot);
               sourceObject     = %obj;
               sourceSlot       = %slot;
          };

          MissionCleanup.add(%q);
     }
   return %p;
}

function TargetingLaserImage::onMount(%this,%obj,%slot)
{
   %size = %obj.getArmorSize();

   if(%size $= "Engineer")
   {
      if(%obj.keychain[%size] == 0)
      {
         %obj.unmountImage(%slot);
         %obj.mountImage(EBarrelSwapperImage, %slot);
         commandToClient(%obj.client, 'setRepairReticle');
         commandToClient(%obj.client, 'BottomPrint', "<font:times new roman:18>Now using a barrel swapper\nThis combines all the turret barrel packs into one gun. Each mode is a different barrel.", 4, 2); // This should be interesting.....
      }
      else if(%obj.keychain[%size] == 1)
      {
         %obj.unmountImage(%slot);
         %obj.mountImage(ReassemblerImage, %slot);
         commandToClient(%obj.client, 'setRepairReticle');
         commandToClient(%obj.client, 'BottomPrint', "<font:times new roman:18>Now using a reassembler\nThis is the Engineer's version of a repair pack. It repairs a lot faster.", 4, 2); // This should be interesting.....
      }
      else if(%obj.keychain[%size] == 2)
      {
         %obj.unmountImage(%slot);
         %obj.mountImage(EDisassemblerImage, %slot);
         commandToClient(%obj.client, 'setRepairReticle');
         commandToClient(%obj.client, 'BottomPrint', "<font:times new roman:18>Now using a disassembler\nThis is the Engineer's special deployable object remover. Use with care.", 4, 2); // This should be interesting.....
      }

      %obj.keychain[%size]++;

      if(%obj.keychain[%size] > 2)
         %obj.keychain[%size] = 0;

      return;
   }
   else if(%size $= "Light")
   {
      if(%obj.keychain[%size] == 0)
      {
         %obj.unmountImage(%slot);
         %obj.mountImage(SVehicleAugmenterImage, %slot);
         commandToClient(%obj.client, 'setRepairReticle');
         commandToClient(%obj.client, 'BottomPrint', "<font:times new roman:18>Now using a vehicle augmenter\nThis combines all the vehicle packs into one gun. Each mode is a different pack.", 4, 2); // This should be interesting.....
      }
      else if(%obj.keychain[%size] == 1)
      {
         %obj.unmountImage(%slot);
         %obj.mountImage(TargetingLaserMountImage, %slot);
         commandToClient(%obj.client, 'setRepairReticle');
         commandToClient(%obj.client, 'BottomPrint', "<font:times new roman:18>Now using a targeting laser\nThis is nothing more than your standard laser pointer.", 4, 2); // This should be interesting.....
      }

      %obj.keychain[%size]++;

      if(%obj.keychain[%size] > 1)
         %obj.keychain[%size] = 0;

      return;
   }

//   %obj.unmountImage(%slot);
//   commandToClient(%obj.client, 'setRepairReticle');

   if(%obj.keychain[%size] == 0)
   {
      %obj.unmountImage(%slot);
      %obj.mountImage(TargetingLaserOptionImage, %slot);
      commandToClient(%obj.client, 'setRepairReticle');
      commandToClient(%obj.client, 'BottomPrint', "<font:times new roman:18>Now using a class-specific targeting laser\nThis item is class-specific, meaning each class has it do something different.", 4, 2); // This should be interesting.....
   }
   else if(%obj.keychain[%size] == 1)
   {
      %obj.unmountImage(%slot);
      %obj.mountImage(TargetingLaserMountImage, %slot);
      commandToClient(%obj.client, 'setRepairReticle');
      commandToClient(%obj.client, 'BottomPrint', "<font:times new roman:18>Now using a standard targeting laser\nThis is nothing more than your standard laser pointer.", 4, 2); // This should be interesting.....
   }

   %obj.keychain[%size]++;

   if(%obj.keychain[%size] > 1)
      %obj.keychain[%size] = 0;
}

function TargetingLaserMountImage::onFire(%data,%obj,%slot)
{
   %p = Parent::onFire(%data,%obj,%slot);
   %p.setTarget(%obj.team);
}

function instanceReflectObject(%obj, %dist)
{
   if(!isObject(%obj))
      return;

   InitContainerRadiusSearch(%obj.getWorldBoxCenter(), %dist, $TypeMasks::ProjectileObjectType);

   while((%int = ContainerSearchNext()) != 0)
   {
      if(%int.lastReflectedFrom == %obj)
         continue;

      if(isReflectableProjectile(%int, $DefaultReflectableProjectles))
      {
//         echo(%int);
//         echo(%int.getDatablock());
//         echo(%int.getDatablock().getName()); // name of projectile (discProjectile)
//         echo(%int.getDatablock().getClassName()); // name of Projectile Datablock type (LinearProjectileData)
//         echo(%int.getClassName()); // name of Projectile for spawning (LinearProjectile)
//         echo(%int.getType()); // returns type of object it is
//         %int.dump();

         %FFRObject = new StaticShape()
         {
            dataBlock = mReflector;
         };
         MissionCleanup.add(%FFRObject);
         %FFRObject.setPosition(%int.getPosition());

         %vector = vectorNeg(%int.initialDirection);
         %x = (getRandom() - 0.5) * 2 * 3.1415926 * (48 / 1000); //0.785398;
         %y = (getRandom() - 0.5) * 2 * 3.1415926 * (48 / 1000); //0.785398;
         %z = (getRandom() - 0.5) * 2 * 3.1415926 * (48 / 1000); //0.785398;
         %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
         %vector = MatrixMulVector(%mat, %vector);

         %p = new(%int.getClassName())()
         {
            dataBlock         = %int.getDatablock().getName();
            initialDirection  = %vector; //vectorNeg(%int.initialDirection);
            initialPosition   = %int.getPosition();
            sourceObject      = %FFRObject;
            sourceSlot        = %int.sourceSlot;
            lastReflectedFrom = %obj;
            bkSourceObject    = %int.sourceObject;
            starburstMode     = %int.starburstMode;
         };
         MissionCleanup.add(%p);

         if(%int.trailThread)
            projectileTrail(%p, %int.trailThreadTime, %int.trailThreadProjType, %int.trailThreadProj, false, %int.trailThreadOffset);

         if(%int.proxyThread)
            rBeginProxy(%p);

         createLifeEmitter(%int.getPosition(), "PCRSparkEmitter", 750);

         %nrg = %obj.getEnergyLevel();

         if(%int.getDatablock().hasDamageRadius)
         {
            if(%int.getDatablock().indirectDamage < %nrg)
               %obj.useEnergy(%int.getDatablock().indirectDamage * getRandom(40, 60));
            else
               JPSelfDestruct(%obj);
         }
         else
         {
            if(%int.getDatablock().directDamage < %nrg)
               %obj.useEnergy(%int.getDatablock().directDamage * getRandom(40, 60));
            else
               JPSelfDestruct(%obj);
         }

         %int.delete();
         %FFRObject.schedule(32, delete);
      }
      else continue;
   }
}

function TLRFLTimeout(%obj)
{
   %obj.tlm_rfl_time = 0;
   %obj.reflectGun = false;
}

function TargetingLaserOptionImage::onFire(%data,%obj,%slot)
{
   %armor = %obj.getArmorSize();
   %data.lightStart = getSimTime();

   %vehicle = 0;
   if(%data.usesEnergy)
   {
      %energy = %obj.getEnergyLevel();

      if(%energy < %data.minEnergy)
         return;
   }

   if(%armor $= "Medium")
   {
      if(%obj.getEnergyLevel() < 10)
      {
         %obj.setImageTrigger(%slot, false);
         return;
      }

      if(!%obj.tlm_rfl_time)
      {
         %obj.tlm_rfl_time = 50;
         schedule(%obj.tlm_rfl_time, 0, TLRFLTimeout, %obj);
         instanceReflectObject(%obj, 11);
         %obj.playShieldEffect(%obj.getMuzzleVector(0));
         %obj.useEnergy(0.5);
         %obj.setImageTrigger(%slot, false);
         return;
      }
//      %f = new FlareProjectile()
//      {
//         dataBlock        = FlareGrenadeProj;
//         initialDirection = %obj.getMuzzleVector(%slot);
//         initialPosition  = %obj.getMuzzlePoint(%slot);
//         sourceObject     = %obj;
//         sourceSlot       = %slot;
//      };
//      FlareSet.add(%f);
//      MissionCleanup.add(%f);
//      %obj.play3D(GrenadeThrowSound);
//      %f.schedule(10000, "delete");
      %obj.setImageTrigger(%slot, false);
      return;
   }
   else if(%armor $= "MagIon")
   {
      if(%obj.getEnergyLevel() < 50)
         return;

      %f = new LinearFlareProjectile()
      {
         dataBlock        = MitziEMPBlast;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
      };
      MissionCleanup.add(%f);
      %obj.play3D(PlasmaFireSound);
      %obj.useEnergy(80);
      return;
   }
   else if(%armor $= "Heavy")
   {
      if($IControl)
      {
         %obj.tl_func = "drone control";
         %vec = %obj.getMuzzleVector(0);
         %pos = %obj.getMuzzlePoint(0);
         %nVec = VectorNormalize(%vec);
         %scVec = VectorScale(%nVec, 100);
         %end = VectorAdd(%pos, %scVec);
         %searchResult = containerRayCast(%pos, %end, $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::TurretObjectType, 0);

         if(%searchResult)
         {
            if(!$ConMode)
               %obj.client.setControlObject(getWord(%searchResult, 0));
            else
               %obj.setControlObject(getWord(%searchResult, 0));
         }

         return;
      }
      else
      {
         %projectile = "PullElf";
         %projectileType = "ELFProjectile";
      }
   }
   else if(%armor $= "BattleAngel")
   {
      %projectile = "JugElf";
      %projectileType = "ELFProjectile";
   }
   else if(%obj.getDatablock().isBlastech)
   {
      %projectile = "TBELF";
      %projectileType = "ELFProjectile";
   }
   else
   {
      %projectile = "BasicTargeter";
      %projectileType = "TargetProjectile";
   }

   %p = new (%projectileType)() {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
   };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.setEnergyLevel(%energy - %data.fireEnergy);
   %p.setTarget(%obj.team);
}

function ShockLanceImage::onFire(%this, %obj, %slot)
{
  %weapon = %obj.getMountedImage(0).item;

     if(%obj.client.mode[%weapon] == 0)
        %projectile = "BasicShocker";
     else if(%obj.client.mode[%weapon] == 1)
        %projectile = "FireLanceBolt";
     else if(%obj.client.mode[%weapon] == 2)
        %projectile = "BasicShocker2"; //-Nite-
     else if(%obj.client.mode[%weapon] == 3)
        %projectile = "SFXBolt";


     //-Nite- sets energy used when target is hit
      if(%obj.client.mode[%weapon] == 0)
         %this.hitEnergy = 15; //base
     else if(%obj.client.mode[%weapon] == 1)
         %this.hitEnergy =15; //base
     else if(%obj.client.mode[%weapon] == 2)
          %this.hitEnergy = 30; // times 2 energy
        //-Nite- Extended Range Mode 30 meters
     else if(%obj.client.mode[%weapon] == 3)
         %this.hitEnergy = 15; // dunno why i put that here *shrugs*





  if( %obj.isCloaked() )
  {
   if( %obj.respawnCloakThread !$= "" )
   {
     Cancel(%obj.respawnCloakThread);
     %obj.setCloaked( false );
   }
   else
   {
     if( %obj.getEnergyLevel() > 20 )
     {
      %obj.setCloaked( false );
      %obj.reCloak = %obj.schedule( 500, "setCloaked", true );
     }
   }
  }

  %muzzlePos = %obj.getMuzzlePoint(%slot);
  %muzzleVec = %obj.getMuzzleVector(%slot);

  if (%obj.client.mode[%weapon] == 2)
  {
  %endPos  = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, 33)); //Extended Range mode - Nite-
  }
  else
  %endPos  = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, 15));// -Nite- Increased a tad to get a full 16m's outta it//%projectile.extension));

  %damageMasks = $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType |
   $TypeMasks::StationObjectType | $TypeMasks::GeneratorObjectType |
   $TypeMasks::SensorObjectType | $TypeMasks::TurretObjectType;

  %everythingElseMask = $TypeMasks::TerrainObjectType |
             $TypeMasks::InteriorObjectType |
             $TypeMasks::ForceFieldObjectType |
             $TypeMasks::StaticObjectType |
             $TypeMasks::MoveableObjectType |
             $TypeMasks::DamagableItemObjectType;

  // did I miss anything? players, vehicles, stations, gens, sensors, turrets
  %hit = ContainerRayCast(%muzzlePos, %endPos, %damageMasks | %everythingElseMask, %obj);

  %noDisplay = true;

  if (%hit !$= "0")
  {

   %obj.setEnergyLevel(%obj.getEnergyLevel() - %this.hitEnergy);

   %hitobj = getWord(%hit, 0);
   %hitpos = getWord(%hit, 1) @ " " @ getWord(%hit, 2) @ " " @ getWord(%hit, 3);

   if ( %hitObj.getType() & %damageMasks )
   {
     %hitobj.applyImpulse(%hitpos, VectorScale(%muzzleVec, %projectile.impulse));
     %obj.playAudio(0, ShockLanceHitSound);

     // This is truly lame, but we need the sourceobject property present...
     %p = new ShockLanceProjectile() {
      dataBlock    = %projectile;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition = %obj.getMuzzlePoint(%slot);
      sourceObject   = %obj;
      sourceSlot    = %slot;
      targetId     = %hit;
     };
     MissionCleanup.add(%p);

     %damageMultiplier = 1.0;

     if(%hitObj.getDataBlock().getClassName() $= "PlayerData")
     {
      // Now we see if we hit from behind...
      %forwardVec = %hitobj.getForwardVector();
      %objDir2D  = getWord(%forwardVec, 0) @ " " @ getWord(%forwardVec,1) @ " " @ "0.0";
      %objPos   = %hitObj.getPosition();
      %dif    = VectorSub(%objPos, %muzzlePos);
      %dif    = getWord(%dif, 0) @ " " @ getWord(%dif, 1) @ " 0";
      %dif    = VectorNormalize(%dif);
      %dot    = VectorDot(%dif, %objDir2D);

      // 120 Deg angle test...
      // 1.05 == 60 degrees in radians
      if (%dot >= mCos(1.05)) {
        // Rear hit
        %damageMultiplier = 3.0;
      }
     }

     if(!%damageMultiplier)
      %damageMultiplier = 1.0;

     if(%this.Projectile.DirectDamage !$= "")
      %totalDamage = %this.Projectile.DirectDamage * %damageMultiplier;
     else
      %totalDamage = 0.45 * %damageMultiplier;

     %hitObj.getDataBlock().damageObject(%hitobj, %p.sourceObject, %hitpos, %totalDamage, %projectile.radiusdamageType); //$DamageType::ShockLance); -Nite-
     //-Nite- Now it will call the data block radiusDamageType (be that lance or burn or Emp so on) *fixes that setting someone on fire with the Heatsink packs
    // if(%obj.client.mode[%weapon] == 1 && (%hitobj.client.team != %obj.client.team || %hitobj.team != %obj.client.team)) <-Dont need now
    //%hitobj.burnObject(%p.sourceObject);|<--Dont need now//-Nite- need proj.source


     %noDisplay = false;
   }
  }

  if( %noDisplay )
  {
   // Miss
   %obj.setEnergyLevel(%obj.getEnergyLevel() - %this.missEnergy);
   %obj.playAudio(0, ShockLanceMissSound);

   %p = new ShockLanceProjectile() {
     dataBlock    = %projectile;
     initialDirection = %obj.getMuzzleVector(%slot);
     initialPosition = %obj.getMuzzlePoint(%slot);
     sourceObject   = %obj;
     sourceSlot    = %slot;
   };
   MissionCleanup.add(%p);

  }
}

function EDisassemblerImage::onFire(%this, %obj, %slot)
{
   %muzzlePos = %obj.getMuzzlePoint(%slot);
   %muzzleVec = %obj.getMuzzleVector(%slot);

   %endPos    = VectorAdd(%muzzlePos, VectorScale(%muzzleVec, 10));

   %damageMasks = $TypeMasks::StationObjectType | $TypeMasks::SensorObjectType | $TypeMasks::TurretObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::ForceFieldObjectType;

   // did I miss anything? players, vehicles, stations, gens, sensors, turrets
   %hit = ContainerRayCast(%muzzlePos, %endPos, %damageMasks, %obj);

   %noDisplay = true;

   if (%hit !$= "0")
   {
      %obj.setEnergyLevel(%obj.getEnergyLevel() - %this.hitEnergy);

      %hitobj = getWord(%hit, 0);
      %hitpos = getWord(%hit, 1) @ " " @ getWord(%hit, 2) @ " " @ getWord(%hit, 3);

      if ( %hitObj.getType() & %damageMasks )
      {
         if(%hitobj.team == %obj.client.team && %hitobj.team == %obj.client.team)
         {
            %obj.playAudio(0, ShockLanceHitSound);
            if(%hitObj.getClassName() $= "ForceFieldBare" && %hitobj.parent) // && %hitobj.deployBase.getDamageState !$= "Enabled")
            {
               if(isObject(%hitObj.deployBase))
                  return;

               if(isObject(%hitObj.parent))
                  return;

               %hitObj.getDatablock().losePower(%hitObj);
               %hitObj.pz.setPosition("-1111 -10000 -100000");
               %hitObj.delete();
            }
            else if(%hitObj.getClassName() $= "ForceFieldBare" && %hitobj.deployBase)
            {
               if(isObject(%hitObj.deployBase))
                  return;

               if(isObject(%hitObj.parent))
                  return;

               %hitObj.getDatablock().losePower(%hitObj);
               %hitObj.pz.setPosition("-1111 -10000 -100000");
               %hitObj.delete();
            }
            else if(isObject(%hitObj.parent))
            {
               %hitObj.killOnDestroyed = true;
               %hitObj.parent.setDamageLevel(10000);
               %hitobj.parent.setDamageState(Destroyed);
            }
            else
            {
               %hitObj.killOnDestroyed = true;
               %hitObj.setDamageLevel(10000);
               %hitobj.setDamageState(Destroyed);
            }

            %p = new ShockLanceProjectile()
            {
               dataBlock        = "Deconstructor";
               initialDirection = %obj.getMuzzleVector(%slot);
               initialPosition  = %obj.getMuzzlePoint(%slot);
               sourceObject     = %obj;
               sourceSlot       = %slot;
               targetId         = %hit;
            };
            MissionCleanup.add(%p);

            %noDisplay = false;
         }
      }
   }

   if( %noDisplay )
   {
      // Miss
      %obj.setEnergyLevel(%obj.getEnergyLevel() - %this.missEnergy);
      %obj.playAudio(0, ShockLanceMissSound);

      %p = new ShockLanceProjectile() {
         dataBlock        = "Deconstructor";
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
      };
      MissionCleanup.add(%p);
   }
}

datablock ItemData(BarrelSwapper)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = EBarrelSwapperImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a barrel swapper";
   emap = true;
};

datablock ItemData(VehicleAugmenter)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = SVehicleAugmenterImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a vehicle augmenter";
   emap = true;
};

datablock ShapeBaseImageData(EBarrelSwapperImage)
{
   classname = WeaponImage;
   shapeFile = "weapon_targeting.dts";
   item = BarrelSwapper;
   offset = "0 0 0";
   emap = true;

   usesEnergy = true;
   missEnergy = 0;
   hitEnergy  = 5;
   minEnergy  = 5;       // needs to change to be datablock's energy drain for a hit

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateSound[0] = ShockLanceSwitchSound;
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.4;
   stateFire[3] = true;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
   stateSound[3] = ShockLanceDryFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.1;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = ShockLanceReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Ready";

   stateName[6]                  = "DryFire";
   stateSound[6]                 = ShockLanceDryFireSound;
   stateTimeoutValue[6]          = 1.0;
   stateTransitionOnTimeout[6]   = "Ready";
};

datablock ShapeBaseImageData(SVehicleAugmenterImage)
{
   classname = WeaponImage;
   shapeFile = "weapon_targeting.dts";
   item = VehicleAugmenter;
   offset = "0 0 0";
   emap = true;

   usesEnergy = true;
   missEnergy = 0;
   hitEnergy  = 5;
   minEnergy  = 5;       // needs to change to be datablock's energy drain for a hit

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateSound[0] = ShockLanceSwitchSound;
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.4;
   stateFire[3] = true;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
   stateSound[3] = ShockLanceDryFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.1;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = ShockLanceReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Ready";

   stateName[6]                  = "DryFire";
   stateSound[6]                 = ShockLanceDryFireSound;
   stateTimeoutValue[6]          = 1.0;
   stateTransitionOnTimeout[6]   = "Ready";
};

function convertToUsableItemB(%int)
{
   switch(%int)
   {
      case 0:
         return "AABarrelLarge";
      case 1:
         return "ELFBarrelLarge";
      case 2:
         return "MissileBarrelLarge";
      case 3:
         return "MortarBarrelLarge";
      case 4:
         return "PlasmaBarrelLarge";
      case 5:
         return "DiscBarrelLarge";
      case 6:
         return "EnergyBarrelLarge";
      //case 7:
         //return "GatLaserBarrelLarge"; laser goodness?
      case 7:
         return "ChaingunBarrelLarge"; //laser now
      case 8:
         return "FlameBarrelLarge";//death~bot
      //case 8:
         //return "PhaserBarrelLarge";
      case 9:
         return "MitziBarrelLarge";
      default:
         return "PlasmaBarrelLarge";
   }
}

function cInitBarrelSwap(%turret, %obj)
{
   %barrel = convertToUsableItemB(%obj.client.mode[BarrelSwapper]);
   %turret.unmountImage(0);
   %turret.mountImage(%barrel, 0, false);
}

function wInitBarrelSwap(%turret, %obj)
{
   %barrel = convertToUsableItemB(%obj.client.mode[BarrelSwapper]);
   %turret.unmountImage(0);
   %turret.mountImage(AssaultTurretParam, 0);
   %turret.unmountImage(2);
   %turret.mountImage(%barrel, 2); //, false);

//   if(%obj.client.mode[BarrelSwapper] == 2)
//   {
//      %turret.unmountImage(0);
//      %turret.mountImage(CMissileTurretParam, 0);
//   }
//   else
//   {
//      %turret.unmountImage(0);
//      %turret.mountImage(AssaultTurretParam, 0);
//   }
}

function EBarrelSwapperImage::onFire(%this, %obj, %slot)
{
   // search for a turret base in player's LOS
   %eyeVec = VectorNormalize(%obj.getMuzzleVector(0));
   %srchRange = VectorScale(%eyeVec, 10); // look 5m for a turret base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potTurret = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::TurretObjectType);
   if(%potTurret != 0)
   {
      if(%potTurret.getDatablock().getName() $= "TurretBaseLarge" || %potTurret.getDatablock().getName() $= "MobileTurretBase" || %potTurret.getDatablock().getName() $= "FreeBaseTurret" || %potTurret.getDatablock().getName() $= "WolfSideTurret" || %potTurret.getDatablock().getName() $= "AssaultFlyerMainTurret")
      {
         // found a turret base, what team is it on?
         if(%potTurret.team == %obj.client.team)
         {
				if(%potTurret.getDamageState() !$= "Enabled")
				{
					// the base is destroyed
					messageClient(%obj.client, 'MsgBaseDestroyed', "\c2Turret base is disabled, cannot mount barrel.");
					%obj.setImageTrigger($BackpackSlot, false);
				}
				else
				{
		         // it's a functional turret base on our team! stick the barrel on it
		         messageClient(%obj.client, 'MsgTurretMount', "\c2Mounting pack on turret base.");
		         serverPlay3D(TurretPackActivateSound, %potTurret.getTransform());
//		         %potTurret.initiateBarrelSwap(%obj);
               if(%potTurret.getDatablock().getName() $= "WolfSideTurret" || %potTurret.getDatablock().getName() $= "AssaultFlyerMainTurret")
                  wInitBarrelSwap(%potTurret, %obj);
               else
                  cInitBarrelSwap(%potTurret, %obj);
				}
         }
         else
         {
            // whoops, wrong team
            messageClient(%obj.client, 'MsgTryEnemyTurretMount', "\c2Cannot mount a barrel on an enemy turret base!");
            %obj.setImageTrigger($BackpackSlot, false);
         }
      }
      else
      {
         // tried to mount barrel on some other turret type
         messageClient(%obj.client, 'MsgNotTurretBase', "\c2Can only mount a barrel on a turret base.");
         %obj.setImageTrigger($BackpackSlot, false);
      }
   }
   else
   {
      // I don't see any turret
      messageClient(%obj.client, 'MsgNoTurretBase', "\c2No turret within range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

function sCheckForInvs(%pl)
{
   InitContainerRadiusSearch(%pl.getPosition(), 150, $TypeMasks::StationObjectType);
   while((%int = ContainerSearchNext()) != 0)
   {
      if(%int.team == %pl.client.team && %int.getDamageState() $= "Enabled")
         return true;
   }
   return false;
}

function SVehicleAugmenterImage::onFire(%this, %obj, %slot)
{
   if($Feature[VModNearStation])
   {
      if(sCheckForInvs(%obj))
      {
         %mode = %obj.client.mode[VehicleAugmenter];

         if(%mode <= 7)
            AttemptAugmentVehicle(%data, %obj, %slot);
         else if(%mode == 8)
//            vehicleRocketModImage::onActivate(%data, %obj, %slot);
            vehicleEnergyModImage::onActivate(%data, %obj, %slot);
//-Nite- //else if(%mode == 9)
          //  vehicleBomberModImage::onActivate(%data, %obj, %slot);
         else if(%mode == 9)
            vehicleChaingunModImage::onActivate(%data, %obj, %slot);
         else if(%mode == 10)
            vehicleMitziModImage::onActivate(%data, %obj, %slot);
         else if(%mode == 11)
            vehiclePhaserModImage::onActivate(%data, %obj, %slot);
//         else if(%mode == 12)
      }
      else
         messageClient(%obj.client, 'MsgVModDistLimit', "\c2You must be within 150m of one of your teams working stations in order to use this gun.");
   }
   else
   {
      %mode = %obj.client.mode[VehicleAugmenter];

         if(%mode <= 7)
            AttemptAugmentVehicle(%data, %obj, %slot);
         else if(%mode == 8)
//            vehicleRocketModImage::onActivate(%data, %obj, %slot);
            vehicleEnergyModImage::onActivate(%data, %obj, %slot);
//-Nite- //else if(%mode == 9)
          //  vehicleBomberModImage::onActivate(%data, %obj, %slot);
         else if(%mode == 9)
            vehicleChaingunModImage::onActivate(%data, %obj, %slot);
         else if(%mode == 10)
            vehicleMitziModImage::onActivate(%data, %obj, %slot);
         else if(%mode == 11)
            vehiclePhaserModImage::onActivate(%data, %obj, %slot);
//         else if(%mode == 12)
   }
}

function ELFProjectileData::zapTarget(%data, %projectile, %target, %targeter)
{
	%oldERate = %target.getRechargeRate();
	%target.teamDamageStateOnZap = $teamDamage;
   %teammates = %target.client.team == %targeter.client.team;

	if( %target.teamDamageStateOnZap || !%teammates )
		%target.setRechargeRate(%oldERate - %data.drainEnergy);
	else
		%target.setRechargeRate(%oldERate);

//	%oldERateT = %targeter.getRechargeRate();

//	if( %target.teamDamageStateOnZap || !%teammates )
//		%targeter.setRechargeRate(%oldERateT + %data.drainEnergy);
//	else
//		%targeter.setRechargeRate(%oldERateT);

	%projectile.checkELFStatus(%data, %target, %targeter);
}

function ELFProjectileData::unzapTarget(%data, %projectile, %target, %targeter)
{
	cancel(%projectile.ELFrecur);
	%target.stopAudio($ELFZapSound);
	%targeter.stopAudio($ELFFireSound);
	%target.zapSound = false;
	%targeter.zappingSound = false;
   %teammates = %target.client.team == %targeter.client.team;

	if(!%target.isDestroyed())
	{
		%oldERate = %target.getRechargeRate();
		if( %target.teamDamageStateOnZap || !%teammates )
			%target.setRechargeRate(%oldERate + %data.drainEnergy);
		else
			%target.setRechargeRate(%oldERate);

//		%oldERateT = %targeter.getRechargeRate();
//		if( %targeter.teamDamageStateOnZap || !%teammates )
//			%targeter.setRechargeRate(%oldERateT - %data.drainEnergy);
//		else
//			%targeter.setRechargeRate(%oldERateT);
	}

//	if(isObject(%targeter))
//	{
//		%oldERateT = %targeter.getRechargeRate();
//		if( %targeter.teamDamageStateOnZap || !%teammates )
//			%targeter.setRechargeRate(%oldERateT - %data.drainEnergy);
//		else
//			%targeter.setRechargeRate(%oldERateT);
//	}

}

function ELFProjectileData::targetDestroyedCancel(%data, %projectile, %target, %targeter)
{
   cancel(%projectile.ELFrecur);
	%target.stopAudio($ELFZapSound);
   %targeter.stopAudio($ELFFireSound);
	%target.zapSound = false;
	%targeter.zappingSound = false;
	%projectile.delete();
}

function ELFProjectile::checkELFStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
		if(%target.getDamageState() $= "Destroyed")
		{
			%data.targetDestroyedCancel(%this, %target, %targeter);
			return;
		}

//		if(%target.isSyn)
//		{
//			%data.targetDestroyedCancel(%this, %target, %targeter);
//			return;
//		}

      %targeter.useEnergy(%data.drainEnergy * -1.5);

      %enLevel = %target.getEnergyLevel();
      if(%enLevel < 10.0)
      {
         %dataBlock = %target.getDataBlock();
         %dataBlock.damageObject(%target, %this.sourceObject, %target.getPosition(), %data.drainHealth * 0.666, %data.directDamageType);
      }
      else
      {
         %normal = "0.0 0.0 1.0";
         %target.playShieldEffect( %normal );
      }
      %this.ELFrecur = %this.schedule(32, checkELFStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
   // -------------------------------------------------------
   // z0dd - ZOD, 5/27/02. Stop firing if there is no target,
   // fixes continuous fire bug.
	//else if(%targeter.zappingSound)
	//{
	//	%targeter.stopAudio($ELFFireSound);
	//	%targeter.zappingSound = false;
	//}
   else
   {
      if(%targeter.zappingSound)
      {
         %targeter.stopAudio($ELFFireSound);
         %targeter.zappingSound = false;
      }
      %data.targetDestroyedCancel(%this, %target, %targeter);
      return;
   }
   // End z0dd - ZOD
   // -------------------------------------------------------
}

function JugElf::checkELFStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
		if(%target.getDamageState() $= "Destroyed")
		{
			%data.targetDestroyedCancel(%this, %target, %targeter);
			return;
		}

      %enLevel = %target.getEnergyLevel();
      if(%enLevel < 10.0)
      {
         %dataBlock = %target.getDataBlock();
         %dataBlock.damageObject(%target, %this.sourceObject, %target.getPosition(), %data.drainHealth*0.5, %data.directDamageType);
      }
      else
      {
         %targeter.useEnergy(-5);
         %normal = "0.0 0.0 1.0";
         %targeter.playShieldEffect( %normal );
         %target.playShieldEffect( %normal );
      }
      %this.ELFrecur = %this.schedule(32, checkELFStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
   // -------------------------------------------------------
   // z0dd - ZOD, 5/27/02. Stop firing if there is no target,
   // fixes continuous fire bug.
	//else if(%targeter.zappingSound)
	//{
	//	%targeter.stopAudio($ELFFireSound);
	//	%targeter.zappingSound = false;
	//}
   else
   {
      if(%targeter.zappingSound)
      {
         %targeter.stopAudio($ELFFireSound);
         %targeter.zappingSound = false;
      }
      %data.targetDestroyedCancel(%this, %target, %targeter);
      return;
   }
   // End z0dd - ZOD
   // -------------------------------------------------------
}

function ELFProjectile::checkPullStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
		if(%target.getDamageState() $= "Destroyed")
		{
			%data.targetDestroyedCancel(%this, %target, %targeter);
			return;
		}

//		if(%target.isSyn)
//		{
//			%data.targetDestroyedCancel(%this, %target, %targeter);
//			return;
//		}

   if(!%target.isSyn)
   {
     %vec = %targeter.getMuzzleVector(0); // aaahahahaha jetpack code!!
     %force = %targeter.getDatablock().mass*1.5; // pullmod
     %newVec = VectorScale(%vec, %force);
     %targeter.applyImpulse(%targeter.getTransform(), %newVec);
   }

//     %force = vectorScale(velToForce(%target.getMass(), %targeter.getVelocity()), 32);
//     %target.applyImpulse(%target.getPosition(), %force);

//    %tgV = velToSingle(%targeter.getVelocity());
//    %tV = velToSingle(%target.getVelocity());
//
//    if(%tV > %tgV)
//        %force = vectorNeg(getTowForce(%targeter, %target));
//    else if(%tV < %tgV)
//        %force = vectorScale(getTowForce(%targeter, %target), 32);
//    else
//        %force = vectorScale(getTowForce(%targeter, %target), 32);
//
//    %target.applyImpulse(%target.getTransform(), %force);

//    if(isObject(%targeter.getObjectMount()))
//        %target.setRotation(%targeter.getObjectMount().getRotation());

    %this.ELFrecur = %this.schedule(32, checkPullStatus, %data, %target, %targeter);
    %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
   // -------------------------------------------------------
   // z0dd - ZOD, 5/27/02. Stop firing if there is no target,
   // fixes continuous fire bug.
	//else if(%targeter.zappingSound)
	//{
	//	%targeter.stopAudio($ELFFireSound);
	//	%targeter.zappingSound = false;
	//}
   else
   {
      if(%targeter.zappingSound)
      {
         %targeter.stopAudio($ELFFireSound);
         %targeter.zappingSound = false;
      }
      %data.targetDestroyedCancel(%this, %target, %targeter);
      return;
   }
   // End z0dd - ZOD
   // -------------------------------------------------------
}

function ELFProjectile::checkUberStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
		if(%target.getDamageState() $= "Destroyed")
		{
			%data.targetDestroyedCancel(%this, %target, %targeter);
			return;
		}

//		if(%target.isSyn)
//		{
//			%data.targetDestroyedCancel(%this, %target, %targeter);
//			return;
//		}

//     %vec = vectorNeg(%targeter.getMuzzleVector(0));
//     echo("vec: "@%vec);
//     %force = velToSingle(%targeter.getVelocity()) * 10;
//     echo("force: "@%force);
//     %newVec = VectorScale(%vec, %force);
//     echo("newVec: "@%newVec);
//     %target.applyImpulse(%target.getTransform(), %newVec);

     %weapon = %targeter.getMountedImage(0).item;

     if(%targeter.client.mode[%weapon] == 3)  //this is the PullBeam -Nite- was mode 4
     {

         %vec = %targeter.getMuzzleVector(0);
         %force = ((%targeter.getDatablock().mass * 0.75) - getRandom(32, 16)) * -1;
         %newVec = VectorScale(%vec, %force);
         %impulse = %target.applyImpulse(%target.getTransform(), %newVec);
//       %force = vectorScale(velToForce(%target.getMass(), %targeter.getVelocity()), 32);
//       %target.applyImpulse(%target.getPosition(), %force);
     }
     else if(%targeter.client.mode[%weapon] == 5)
     {
          %vec = vectorScale(%target.getMuzzleVector(0), 2);
          %force = %targeter.getDatablock().mass*4;
          %newVec = VectorScale(%vec, %force);
          %impulse = %target.applyImpulse(%target.getTransform(), %newVec);
     }
     else if(%targeter.client.mode[%weapon] == 6)
     {
//           if(%target.getDatablock().cameraLag || %target.getDatablock().jetForce)
//               return;

           %target.maxScaleFactor = 10000;
           %target.countGrow--;
           %scVal = %target.countGrow / 75;

           if(%scVal < 0.2)
               %scVal = 0.2;

           if(%scVal > 300)
               %scVal = 300;

           %target.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.trigger)
                %target.trigger.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.getDatablock().barrel)
                %target.getDatablock().barrel.setScale(%scVal@" "@%scVal@" "@%scVal);
     }
     else if(%targeter.client.mode[%weapon] == 7)
     {
//           if(%target.getDatablock().cameraLag || %target.getDatablock().jetForce)
//               return;

           %target.maxScaleFactor = 10000;
           %target.countGrow++;
           %scVal = %target.countGrow / 25;

           if(%scVal > 500)
               %scVal = 500;

           if(%scVal < 0.2)
               %scVal = 0.2;

           %target.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.trigger)
                %target.trigger.setScale(%scVal@" "@%scVal@" "@%scVal);

           if(%target.getDatablock().barrel)
                %target.getDatablock().barrel.setScale(%scVal@" "@%scVal@" "@%scVal);
     }
     else if(%targeter.client.mode[%weapon] == 8)
     {
           %target.setScale("1 1 1");
           %target.countGrow = 75;

           if(%target.trigger)
                %target.trigger.setScale("1 1 1");

           if(%target.getDatablock().barrel)
                %target.getDatablock().barrel.setScale("1 1 1");
     }

     %this.ELFrecur = %this.schedule(32, checkUberStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
   // -------------------------------------------------------
   // z0dd - ZOD, 5/27/02. Stop firing if there is no target,
   // fixes continuous fire bug.
	//else if(%targeter.zappingSound)
	//{
	//	%targeter.stopAudio($ELFFireSound);
	//	%targeter.zappingSound = false;
	//}
   else
   {
      if(%targeter.zappingSound)
      {
         %targeter.stopAudio($ELFFireSound);
         %targeter.zappingSound = false;
      }
      %data.targetDestroyedCancel(%this, %target, %targeter);
      return;
   }
   // End z0dd - ZOD
   // -------------------------------------------------------
}

function ELFProjectile::checkTractorStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
//		if(%target.isSyn)
//		{
//			%data.targetDestroyedCancel(%this, %target, %targeter);
//			return;
//		}

          %vel = %target.getVelocity();
          %vx = getWord(%vel, 0);
          %vy = getWord(%vel, 1);
          %vz = getWord(%vel, 2) + 0.95;
          %newVel = %vx@" "@%vy@" "@%vz;
          %targeter.setVelocity(%newVel);


      %this.ELFrecur = %this.schedule(32, checkTractorStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
   // -------------------------------------------------------
   // z0dd - ZOD, 5/27/02. Stop firing if there is no target,
   // fixes continuous fire bug.
	//else if(%targeter.zappingSound)
	//{
	//	%targeter.stopAudio($ELFFireSound);
	//	%targeter.zappingSound = false;
	//}
   else
   {
      if(%targeter.zappingSound)
      {
         %targeter.stopAudio($ELFFireSound);
         %targeter.zappingSound = false;
      }
      %data.targetDestroyedCancel(%this, %target, %targeter);
      return;
   }
   // End z0dd - ZOD
   // -------------------------------------------------------
}

function ELFProjectile::checkStasisStatus(%this, %data, %target, %targeter)
{
   if(isObject(%target))
   {
      if(%target.stasisProof)
         return;

//		if(%target.isSyn)
//		{
//			%data.targetDestroyedCancel(%this, %target, %targeter);
//			return;
//		}

     if($Feature[StasisPlayers])
     {
        %targeter.useEnergy(8/32);
        %target.setVelocity("0 0 0.91");
     }

     if((%target.getDatablock().className $= WheeledVehicleData || %target.getDatablock().className $= FlyingVehicleData || %target.getDatablock().className $= HoverVehicleData) && !%target.getDatablock().chair)
           %target.setFrozenState(true);

      %this.ELFrecur = %this.schedule(32, checkStasisStatus, %data, %target, %targeter);

      %targeter.playAudio($ELFFireSound, ELFGunFireSound);
      if(!%target.zapSound)
		{
         %target.playAudio($ELFZapSound, ELFHitTargetSound);
			%target.zapSound = true;
			%targeter.zappingSound = true;
		}
   }
   // -------------------------------------------------------
   // z0dd - ZOD, 5/27/02. Stop firing if there is no target,
   // fixes continuous fire bug.
	//else if(%targeter.zappingSound)
	//{
	//	%targeter.stopAudio($ELFFireSound);
	//	%targeter.zappingSound = false;
	//}
   else
   {
      if(%targeter.zappingSound)
      {
         %targeter.stopAudio($ELFFireSound);
         %targeter.zappingSound = false;
         %target.setFrozenState(false);
         %targeter.countGrow = 0;

      }
      %data.targetDestroyedCancel(%this, %target, %targeter);
      return;
   }
   // End z0dd - ZOD
   // -------------------------------------------------------
}

function StasisElf::unzapTarget(%data, %projectile, %target, %targeter)
{
     if(%target.getDatablock().className $= WheeledVehicleData || %target.getDatablock().className $= FlyingVehicleData || %target.getDatablock().className $= HoverVehicleData)
          %target.setFrozenState(false);

     Parent::unzapTarget(%data, %projectile, %target, %targeter);
}
