if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//========================================

function destroyAttachments(%obj)     // Death~Bot
{
   %inc = 0;
   while((%int = %obj.attachment[%inc]) !$= "")
   {
      %int.setDamageState(Destroyed);

      %obj.attachment[%inc] = "";
      %inc++;
   }
}

//====================================== Remote Missile System
$TeamDeployableMax[RMSSPack] = 1;
//$TeamDeployableMax[DeployedRMSSTargetPack] = $Feature[RMSsalvoMax];  // --- (ST)
//$RMSChargeTime = 60000;

datablock AudioProfile(RMSSHumSound)
{
filename = "fx/powered/turret_heavy_idle.wav";
description = ClosestLooping3d;
    preload = true;
};

datablock AudioProfile(RMSSDeploySound)
{
filename = "fx/vehicles/MPB_deploy_turret.wav";
description = AudioBIGExplosion3d;
    preload = true;
};

datablock AudioProfile(RMSSBDeploySound)
{
filename = "fx/misc/red_alert.wav";
description = AudioBIGExplosion3d;
    preload = true;
};

datablock ParticleData(RMSSMissileSmokeParticle)
{
   dragCoeffiecient     = 0.0;
   gravityCoefficient   = -0.0;
   inheritedVelFactor   = 0.1;

   lifetimeMS           = 2000;
   lifetimeVarianceMS   = 100;

   textureName          = "particleTest";

   useInvAlpha = true;
   spinRandomMin = -90.0;
   spinRandomMax = 90.0;

   colors[0]     = "1.0 0.75 0.0 0.0";
   colors[1]     = "0.4 0.4 0.4 1.0";
   colors[2]     = "0.1 0.1 0.1 0.0";
   sizes[0]      = 4;
   sizes[1]      = 4.5;
   sizes[2]      = 5.5;
   times[0]      = 0.0;
   times[1]      = 0.1;
   times[2]      = 1.0;

};

datablock ParticleEmitterData(RMSSMissileSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionVelocity = 1.5;
   velocityVariance = 0.3;

   thetaMin         = 0.0;
   thetaMax         = 80.0;

   particles = "RMSSMissileSmokeParticle";
};

datablock StaticShapeData(RMSStube) : BombardmentDamageProfile
{
   shapeFile = "stackable2l.dts";   // stackable2m
   maxDamage = 5;
   destroyedLevel = 5;
   disabledLevel = 5;
   explosion = VehicleExplosion;

   deployedObject = true;
   heatSignature = 1;
   humSound = RMSSHumSound;

   targetNameTag = 'Remote Missile';
   targetTypeTag = 'System';

   cmdCategory = "Support";
   cmdIcon = "CMDSwitchIcon";//CMDGeneratorIcon
   cmdMiniIconName = "commander/MiniIcons/com_switch_grey";
   //targetTypeTag = 'Remote Missile Salvo System';

   debrisShapeName = "debris_generic_small.dts";
   debris = DeployableDebris;
};

datablock StaticShapeData(RMSST2) : BombardmentDamageProfile
{
   shapeFile = "stackable2m.dts";   // teamlogo_projector
   maxDamage = 5;
   destroyedLevel = 5;
   disabledLevel = 5;
   explosion = deployablesExplosion;

   deployedObject = true;
   heatSignature = 1;
   humSound = RMSSHumSound;

   targetNameTag = 'Remote Missile';
   targetTypeTag = 'System';

   //cmdCategory = "Support";
   //cmdIcon = "CMDSwitchIcon";//CMDGeneratorIcon
   //cmdMiniIconName = "commander/MiniIcons/com_switch_grey";
   //targetTypeTag = 'Remote Missile Salvo System';

   debrisShapeName = "debris_generic_small.dts";
   debris = DeployableDebris;
};

datablock ShapeBaseImageData(RMSSImage)
{
   mass = 10;

   shapeFile = "stackable2m.dts";
   item = RMSSPack;
   mountPoint = 1;
   offset = "0 -0.2 -0.2";
   deployed = RMSStube;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateTransitionOnTriggerUp[1] = "Idle";

   isLarge = true;
   emap = true;

   maxDepSlope = 60;
   deploySound = RMSSDeploySound;

   minDeployDis                       =  0.5;
   maxDeployDis                       =  5.0;  //meters from body
};

datablock ItemData(RMSSPack)
{
   className = Pack;
   catagory = "Deployables";
   shapeFile = "pack_deploy_inventory.dts";
   mass = 3.0;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 1;
   rotate = false;
   image = "RMSSImage";
   pickUpName = "a Remote Missile System";
   heatSignature = 0;

   emap = true;
};

datablock StaticShapeData(RMSMarker)
{
   shapeFile = "turret_muzzlepoint.dts";

   cmdCategory = "Tactical";
   cmdIcon = CMDCameraIcon;
   cmdMiniIconName = "commander/MiniIcons/com_camera_grey";
   targetTypeTag = 'RMS Missile Silo';
};

datablock StaticShapeData(DeployedRMSSTarget) : StaticShapeDamageProfile
{
   shapeFile = "teamlogo_projector.dts";   // teamlogo_projector
   maxDamage = 2;
   destroyedLevel = 2;
   disabledLevel = 2;
   explosion = deployablesExplosion;

   deployedObject = true;
   heatSignature = 0;
   humSound = RMSSHumSound;

   //targetNameTag = 'RMSS';
   //targetTypeTag = 'Beacon';

   cmdCategory = "Support";
   cmdIcon = "CMDSwitchIcon";//CMDGeneratorIcon
   cmdMiniIconName = "commander/MiniIcons/com_switch_grey";
   targetTypeTag = 'Remote Missile System Target';

   debrisShapeName = "debris_generic_small.dts";
   debris = DeployableDebris;
};

datablock ShapeBaseImageData(DeployedRMSSTargetImage)
{
   mass = 10;

   shapeFile = "teamlogo_projector.dts";
   item = DeployedRMSSTargetPack;
   mountPoint = 1;
   offset = "0 -0.2 -0.2";
   rotation = "1 0 0 -90";
   deployed = DeployedRMSSTarget;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateTransitionOnTriggerUp[1] = "Idle";

   isLarge = true;
   emap = true;

   maxDepSlope = 60;
   deploySound = RMSSBDeploySound;

   minDeployDis                       =  0.5;
   maxDeployDis                       =  150.0;  //meters from body
};

datablock ItemData(DeployedRMSSTargetPack)
{
   className = Pack;
   catagory = "Deployables";
   shapeFile = "pack_deploy_inventory.dts";
   mass = 3.0;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 1;
   rotate = false;
   image = "DeployedRMSSTargetImage";
   pickUpName = "a RMS Target";
   heatSignature = 0;

   emap = true;
};

datablock LinearProjectileData(RMSSupShot)
{
   projectileShapeName = "weapon_missile_projectile.dts";
   scale               = "5 5 5";
   faceViewer          = true;
   directDamage        = 30;
   hasDamageRadius     = true;
   indirectDamage      = 30;
   damageRadius        = 50.0;
   kickBackStrength    = 2000;
   radiusDamageType    = $DamageType::RMSS;

   explosion           = "LargeMissileExplosion";
   underwaterExplosion = UnderwaterHandGrenadeExplosion;
   splash              = PlasmaSplash;

//   baseEmitter         = RMSSMissileSmokeEmitter;
   baseEmitter         = MissileSmokeEmitter;
   delayEmitter        = MissileFireEmitter;

   dryVelocity       = 350.0;
   wetVelocity       = 350.0;
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 2000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;

   activateDelayMS = -1;
};

datablock LinearProjectileData(RMSSdownShot)
{
   projectileShapeName = "weapon_missile_projectile.dts";
   scale               = "5 5 5";
   faceViewer          = true;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 2.5;
   damageRadius        = 20.0;
   kickBackStrength    = 2000;
   radiusDamageType    = $DamageType::RMSS;

   explosion           = "LargeMissileExplosion";
   underwaterExplosion = UnderwaterHandGrenadeExplosion;
   splash              = PlasmaSplash;

   baseEmitter         = MissileSmokeEmitter;
   delayEmitter        = MissileFireEmitter;

   dryVelocity       = 250.0;
   wetVelocity       = 160.0;
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 5000;
   lifetimeMS        = 5000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 5000;

   activateDelayMS = -1;

};

function RMSSPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}

function RMSSImage::testNoTerrainFound(%item)
{
   return %item.surface.getClassName() !$= TerrainBlock;
}

//RMSS Functions

function getAreaTarget(%pos, %radius)
{
   if(!%pos)
      return;

   if(!%radius)
      %radius = 50;

   %x = getWord(%pos, 0);
   %y = getWord(%pos, 1);
   %x += getRandom(%radius * -1, %radius);
   %y += getRandom(%radius * -1, %radius);

   return %x @ " " @ %y @ " " @ getTerrainHeight(%pos);
}

// --- Not needed anymore (ST)
//function searchLoopRMSS(%obj)
//{
//   if(%obj.getDamageState !$= "Destroyed" && %obj.RMSSTarget $= "")
//   {
//      for(%i = 0; %i < Deployables.getCount(); %i++)
//      {
//         if(Deployables.getObject(%i).getDatablock().getName() $= "DeployedRMSSTarget")
//         {
//            if(Deployables.getObject(%i).team == %obj.team)
//            {
//               %obj.RMSSTarget = Deployables.getObject(%i);
//               schedule(100, 0, "sequenceRMSS", %obj);
//               return;
//            }
//         }
//      }
//      schedule(3000, 0, "SearchLoopRMSS", %obj); // oddness rox
//   }
//}

//function resetRMSSReload(%obj)
//{
//   if(isObject(%obj))
//      %obj.isLoaded = true;
//}

function sequenceRMSS(%obj, %player)
{
   for(%i = 0; %i < 48; %i++)
      schedule(%i * 200, %obj, "fireRMSS", %obj, %player, %i); // fire time varies

   %obj.RMSwarningSound = play3D(%obj, "RMSSBDeploySound"); //---before it fires play this
}

function fireRMSS(%obj, %src, %seq)
{
   if(!isObject(%obj))
      return;

//   %pos = posFromTransform(%obj.attachment[mFloor(%seq/4)].getTransform());
   %pos = posFromTransform(%obj.attachment[getRandom(5)].getWorldBoxCenter()); // much better effect... loops through all 6 attachments and fires randomly out of one
   %npos = VectorAdd(%pos, "0 0 1");

   %FFRObject = new StaticShape()
   {
      dataBlock        = mReflector;
   };
   MissionCleanup.add(%FFRObject);
   %FFRObject.setPosition(%npos);
   %FFRObject.schedule(32, delete);

   %p = new LinearProjectile()
   {
      dataBlock        = "RMSSupShot";
      initialDirection = "0 0 1";
      initialPosition  = %npos;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %src;
   };

//   %obj.playAudio(0, "MechRocketFireSound"); // --- RMSSFireSound here
   %obj.play3d(MechRocketFireSound);
   MissionCleanup.add(%p);
   schedule(10000, %obj, "rainRMSS", %obj, %src);
}

function rainRMSS(%obj, %src)
{
//   %radius = $Feature[RMSradius];
//   if(!%radius)
      %radius = 50;
      
   %pos = VectorAdd(%obj.targetPos, "0 0 1000");
   %dir = VectorSub(getAreaTarget(%pos, %radius), %pos);

   %FFRObject = new StaticShape()
   {
      dataBlock        = mReflector;
   };
   MissionCleanup.add(%FFRObject);
   %FFRObject.setPosition(%pos);
   %FFRObject.schedule(32, delete);

   %p = new (LinearProjectile)()
   {
      dataBlock        = "RMSSDownShot";
      initialDirection = VectorNormalize(%dir);
      initialPosition  = %pos;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %src;
   };
   MissionCleanup.add(%p);
}

function RMSSImage::onDeploy(%item, %plyr, %slot)
{
   %plyr.unmountImage(%slot);
   %plyr.decInventory(%item.item, 1);

   %rot = %item.getInitialRotation(%plyr);
   %plyr.setPosition(vectorAdd(%plyr.getPosition(), "0 0 4"));

   %trans[0] = vectorAdd(%item.surfacePt, "0 0 -0.5") SPC "0 1 0 0";
   %depltube = addObject(%plyr, "RMSStube", %trans[0], "", "8 10 0.8");
   %depltube.isRMS = true;
//   addObject(%plyr, "RMSMarker", %item.surfacePt SPC "0 1 0 0", %depltube);

   %trans[1] = vectorAdd(%item.surfacePt, "2 0 0") SPC "0 1 0 0";
   %deplObj1 = addObject(%plyr, "RMSST2", %trans[1], %depltube, "4 4 4");
   %trans[2] = vectorAdd(%item.surfacePt, "-2 0 0") SPC "0 1 0 0";
   %deplObj2 = addObject(%plyr, "RMSST2", %trans[2], %depltube, "4 4 4");
   %trans[3] = vectorAdd(%item.surfacePt, "2 4 0") SPC "0 1 0 0";
   %deplObj3 = addObject(%plyr, "RMSST2", %trans[3], %depltube, "4 4 4");
   %trans[4] = vectorAdd(%item.surfacePt, "-2 4 0") SPC "0 1 0 0";
   %deplObj4 = addObject(%plyr, "RMSST2", %trans[4], %depltube, "4 4 4");
   %trans[5] = vectorAdd(%item.surfacePt, "2 -4 0") SPC "0 1 0 0";
   %deplObj5 = addObject(%plyr, "RMSST2", %trans[5], %depltube, "4 4 4");
   %trans[6] = vectorAdd(%item.surfacePt, "-2 -4 0") SPC "0 1 0 0";
   %deplObj6 = addObject(%plyr, "RMSST2", %trans[6], %depltube, "4 4 4");

   %depltube.play3d(%item.deploySound);

   %depltube.attachment[0] = %deplObj1;
   %depltube.attachment[1] = %deplObj2;
   %depltube.attachment[2] = %deplObj3;
   %depltube.attachment[3] = %deplObj4;
   %depltube.attachment[4] = %deplObj5;
   %depltube.attachment[5] = %deplObj6;

   %pta = vectorAdd(%item.surfacePt, "5 5 0.5");
   %ptb = vectorAdd(%item.surfacePt, "-5 5 0.5");
   %ptc = vectorAdd(%item.surfacePt, "5 -5 0.5");
   %ptd = vectorAdd(%item.surfacePt, "-5 -5 0.5");

   %pt1337 = vectorAdd(%item.surfacePt, "-3 -2.7 0.5");
   %pt1338 = vectorAdd(%item.surfacePt, "-3 2.7 0.5");
   %pt1339 = vectorAdd(%item.surfacePt, "3 -2.7 0.5");
   %pt1340 = vectorAdd(%item.surfacePt, "3 2.7 0.5");

   %vec1 = getVectorFromPoints(%pta, %ptb);
   %vec2 = getVectorFromPoints(%ptb, %ptd);
   %vec3 = getVectorFromPoints(%ptd, %ptc);
   %vec4 = getVectorFromPoints(%ptc, %pta);

   %rota = vectorToRotZ(%vec1);
   %rotb = vectorToRotZ(%vec2);
   %rotc = vectorToRotZ(%vec3);
   %rotd = vectorToRotZ(%vec4);

   %lena = getDistance3D(%pta, %ptb);
   %lenb = getDistance3D(%ptb, %ptd);
   %lenc = getDistance3D(%ptd, %ptc);
   %lend = getDistance3D(%ptc, %pta);

   %scale = ".2 .2 5";

   %depltube.shield[0] = addForcefield(%plyr, "DeployedTeamSlowFieldBareGreen", %pta, %rota, %scale, %depltube);
   %depltube.shield[1] = addForcefield(%plyr, "DeployedTeamSlowFieldBareGreen", %ptb, %rotb, %scale, %depltube);
   %depltube.shield[2] = addForcefield(%plyr, "DeployedTeamSlowFieldBareGreen", %ptc, %rotc, %scale, %depltube);
   %depltube.shield[3] = addForcefield(%plyr, "DeployedTeamSlowFieldBareGreen", %ptd, %rotd, %scale, %depltube);

   %depltube.damageStateCounter = 0;
   %depltube.owner = %plyr;
   $TeamDeployedCount[%plyr.team, RMSSPack]++;
   $RMSSilo[%plyr.team] = %depltube; // --- (ST)
   //schedule(3000, 0, "SearchLoopRMSS", %depltube); // --- oops... old news (ST)
}

function RMSStube::onDestroyed(%this, %obj, %prevState)
{
   if(%obj.RMSSTarget $= "")
      %obj.RMSSTarget.schedule(450, "delete");

   Parent::onDestroyed(%this, %obj, %prevState);
   //$TeamDeployedCount[%obj.team, RMSSPack]--; // --- per mission limit ?? (ST)
   $RMSSilo[%obj.team] = ""; // --- Silo (ST)
   %obj.schedule(500, "delete");
   destroyAttachments(%obj);
   destroyForcefields(%obj);
}

function RMSST2::onDestroyed(%this, %obj, %prevState)
{
   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(500, "delete");
}

function RMSStube::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}

function DeployedRMSSTargetPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}

function DeployedRMSSTargetImage::testNoTerrainFound(%item)
{
   return %item.surface.getClassName() !$= TerrainBlock;
}

function DeployedRMSSTargetImage::onDeploy(%item, %plyr, %slot)
{
   %plyr.unmountImage(%slot);
   %plyr.decInventory(%item.item, 1);

   %rot = %item.getInitialRotation(%plyr);
   %plyr.setPosition(vectorAdd(%plyr.getPosition(), "0 0 2"));

   %trans[0] = vectorAdd(%item.surfacePt, "0 0 -5") SPC "0 1 0 0";
   %deplTRG = addObject(%plyr, "DeployedRMSSTarget", %trans[0], "", "7 7 12");

   %deplTRG.play3d(%item.deploySound);

   $TeamDeployedCount[%plyr.team, DeployedRMSSTargetPack]++;
}

function DeployedRMSSTargetImage::onDestroyed(%this, %obj, %prevState)
{
   Parent::onDestroyed(%this, %obj, %prevState);
   $TeamDeployedCount[%obj.team, DeployedRMSSTargetPack]--;
   %obj.schedule(500, "delete");
}

function DeployedRMSSTarget::onDestroyed(%this, %obj, %prevState)
{
   Parent::onDestroyed(%this, %obj, %prevState);
   %obj.schedule(500, "delete");
//   %obj.parent.setDamageState(Destroyed);
}


////////////////////////--------------------\\\\\\\\\\\\\\\\\\\\\\\\\
////////////////////////------end RMSS------\\\\\\\\\\\\\\\\\\\\\\\\\
////////////////////////--------------------\\\\\\\\\\\\\\\\\\\\\\\\\
