if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//================ EMP / Fire / Burn code
// Loops in 100ms chunks
// Similar (was going to do an all-in-one) but they have their own unique features.

datablock AudioProfile(IncenBurningSound) //for burning Death~bot
{
   filename = "fx/environment/icecrack2.wav";
   description = AudioClosest3d;
   preload = true;
};

Meltdown.LDOLifetimeMS = 100;

$BurnDamageMS = 0.01;
$BrnDamageMS = 0.0025;
$PoisonDamageMS = 0.01;

datablock ParticleData(EMPSparksParticle)
{
    dragCoefficient = 0.6;
    gravityCoefficient = 0;
    windCoefficient = 0;
    inheritedVelFactor = 0.2;
    constantAcceleration = 0;
    lifetimeMS = 650;
    lifetimeVarianceMS = 325;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "special/bigspark";
    times[0] = 0;
    times[1] = 0.5;
    times[2] = 1;
    colors[0] = "0.100000 0.100000 1.000000 1.000000";
    colors[1] = "0.050000 0.050000 1.000000 1.000000";
    colors[2] = "0.000000 0.000000 1.000000 0.000000";
    sizes[0] = 2.31452;
    sizes[1] = 0.25;
    sizes[2] = 0.25;
};

datablock ParticleEmitterData(EMPSparksEmitter)
{
    ejectionPeriodMS = 3;
    periodVarianceMS = 0;
    ejectionVelocity = 18;
    velocityVariance = 6.75;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 180;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
   lifeTimeMS = 200;
    orientParticles= 1;
    orientOnVelocity = 1;
    particles = "EMPSparksParticle";
};

function ShapeBase::EMPObject(%obj)
{
   EMPObject(%obj);
}

function ShapeBase::BurnObject(%obj, %attacker)
{
   BurnObject(%obj, %attacker);
}

function ShapeBase::PoisonObject(%obj, %attacker)
{
   PoisonObject(%obj, %attacker);
}

function ShapeBase::clearLoopingDamages(%obj)
{
   clearLoopingDamages(%obj);
}

function enterWaterClearIncen(%obj)
{
   if(isObject(%obj))
      if(%obj.isFlaming)
         %obj.burnTime = 1;
}

function EMPObject(%obj)
{
   lDamageObject(%obj, 0, 1);
}

function BurnObject(%obj, %attacker)
{
   lDamageObject(%obj, %attacker, 2);
}

function PoisonObject(%obj, %attacker)
{
   lDamageObject(%obj, %attacker, 3);
}

function clearLoopingDamages(%obj)
{
   %obj.isEMP = false;
   %obj.EMPTime = 1;
   %obj.isFlaming = false;
   %obj.burnTime = 1;
}

function MeltdownBase::loopDamageObject(%mod, %obj)
{
   if(isObject(%obj) && !%obj.blowedUp)
   {
      if(%obj.isEMP)
      {
         if(%obj.EMPTime)
         {
            %obj.EMPTime--;
            %obj.setEnergyLevel(0);
            createLifeEmitter(%obj.getWorldBoxCenter(), "EMPSparksEmitter", Meltdown.LDOLifetimeMS);
         }
         else
            return Meltdown.finishDamageLoop(%obj);
      }

      if(%obj.isFlaming)
      {
         if(%obj.isWet)
            return Meltdown.finishDamageLoop(%obj);

         if(%obj.burnTime)
         {
            %obj.burnTime--;
            %obj.damage(%obj.LDSrcObj, %obj.getWorldBoxCenter(), $BurnDamageMS, $DamageType::BurnLoop);
            %obj.setHeat(1);
            createLifeEmitter(vectorAdd(%obj.getWorldBoxCenter(), "0 0 -0.5"), "StarburstFlameEmitter", Meltdown.LDOLifetimeMS);
            createLifeEmitter(vectorAdd(%obj.getWorldBoxCenter(), "0 0 -0.5"), "HeavyDamageSmoke", Meltdown.LDOLifetimeMS);

            %obj.incenPlayCount++; // MrKeen

            if(%obj.incenPlayCount > 2)
            {
                %obj.play3D("IncenBurningSound"); //death~bot
                %obj.incenPlayCount = 0;
            }
         }
         else
            return Meltdown.finishDamageLoop(%obj);
      }

      if(%obj.isPoisoned)
      {
         if(%obj.poisonTime)
         {
            %obj.poisonTime--;
            if(%obj.getDataBlock().className $= "Armor")
               %obj.damage(%obj.LDSrcObj, %obj.getWorldBoxCenter(), $BurnDamageMS, $DamageType::PoisonLoop);
         }
         else
            return Meltdown.finishDamageLoop(%obj);
      }
      Meltdown.schedule(Meltdown.LDOLifetimeMS, loopDamageObject, %obj);
   }
   else
   {
      %obj.isEMP = false;
      %obj.EMPTime = 1;
      %obj.isFlaming = false;
      %obj.burnTime = 1;
   }
}

function MeltdownBase::finishDamageLoop(%mod, %obj)
{
   if(%obj.isEMP)
   {
      %obj.isEMP = false;
      %obj.EMPTime = 0;

      if(%obj.getDataBlock().className $= "Armor")
      {
         if(%obj.client.player == %obj)
            messageClient(%obj.client, '', '\c2Armor Reactor back on-line.');
      }
   }

   if(%obj.isFlaming)
   {
      %obj.isFlaming = false;
      %obj.burnTime = 0;

      if(%obj.getDataBlock().className $= "Armor")
      {
         if(%obj.client.player == %obj)
            messageClient(%obj.client, '', '\c2You have stopped burning.');
      }
   }

   if(%obj.isPoisoned)
   {
      %obj.isPoisoned = false;
      %obj.poisonTime = 0;

      if(%obj.getDataBlock().className $= "Armor")
      {
         if(%obj.client.player == %obj)
            messageClient(%obj.client, '', '\c2You have been cured of your infection.');
      }
   }
}

function lDamageObject(%obj, %attacker, %type)
{
   if(isObject(%obj))
   {
      if(!%attacker)
         %attacker = %obj;

      if(%type == 1) // type 1 == EMP
      {
         if(%obj.isSyn || %obj.getDatablock().specialLDProof) // MrKeen
            return;

         if(%obj.EMPTime > 2)
         {
            %obj.EMPTime += (50+getRandomT(10));
            if(%obj.getDataBlock().className $= "Armor")
               messageClient(%obj.client, '', '\c2You have taken more EMP damage.');

            return;
         }

         if(%obj.getDataBlock().className $= "Armor")
            messageClient(%obj.client, '', '\c2Danger! EMP detected; Armor Power Core Offine.');

         %obj.setEnergyLevel(0);
         %obj.isEMP = true;

         if(%obj.getDataBlock().className $= "Armor")
            %obj.EMPTime = (100+getRandomT(25));
         else
            %obj.EMPTime = (250+getRandomT(50));
      }
      else if(%type == 2) // type 2 == Incendiary
      {
         if(%obj.getDatablock().specialLDProof) // MrKeen
            return;

         if(%obj.getDataBlock().className !$= "Armor")
            return;

         if(%obj.burnTime > 2)
         {
            %obj.burnTime += (20+getRandomT(5));
            if(%obj.getDataBlock().className $= "Armor")
               messageClient(%obj.client, '', '\c2The fire has increased in intensity.');

            return;
         }

         if(%obj.getDataBlock().className $= "Armor")
            messageClient(%obj.client, '', '\c2Danger! You are on fire!');

         %obj.isFlaming = true;
         %obj.burnTime = (200+getRandomT(50));

         if(%obj.getDataBlock().className $= "Armor")
            %obj.dmgPct = 0.01;
         else
            %obj.dmgPct = 0.0025;

         %obj.LDSrcObj = %attacker;
      }
      else if(%type == 3) // type 3 == Poison
      {
         if(%obj.getDataBlock().className $= "Armor")
         {
            if(%obj.PoisonTime > 2)
            {
               %obj.PoisonTime += getRandomT(200);
               messageClient(%obj.client, '', '\c2You recieved another poisionous wound!');
               return;
            }


            messageClient(%obj.client, '', '\c2You recieved a poisonious wound!');

            %obj.isPoisoned = true;
            %obj.PoisonTime = 250 + getRandomT(100);
         }
      }
      Meltdown.loopDamageObject(%obj);
   }
}
