if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//================ EMP / Fire / Burn code
// Loops in 50ms chunks
// Similar (was going to do an all-in-one) but they have their own unique features.

Meltdown.LDOLifetimeMS = 50;

Meltdown.APE_mountPoint = 8;
Meltdown.APE_EMP_Mount = 0;
Meltdown.APE_FireVis_Mount = 1;
Meltdown.APE_FireSmoke_Mount = 2;

$BurnDamageMS = 0.005;
$BrnDamageMS = 0.00125;
$PoisonDamageMS = 0.005;

datablock ParticleData(EMPSparksParticle)
{
    dragCoefficient = 0.6;
    gravityCoefficient = 0;
    windCoefficient = 0;
    inheritedVelFactor = 0.2;
    constantAcceleration = 0;
    lifetimeMS = 650;
    lifetimeVarianceMS = 325;
    useInvAlpha = 0;
    spinRandomMin = 0;
    spinRandomMax = 0;
    textureName = "special/bigspark";
    times[0] = 0;
    times[1] = 0.5;
    times[2] = 1;
    colors[0] = "0.100000 0.100000 1.000000 1.000000";
    colors[1] = "0.050000 0.050000 1.000000 1.000000";
    colors[2] = "0.000000 0.000000 1.000000 0.000000";
    sizes[0] = 2.31452;
    sizes[1] = 0.25;
    sizes[2] = 0.25;
};

datablock ParticleEmitterData(EMPSparksEmitter)
{
    ejectionPeriodMS = 3;
    periodVarianceMS = 0;
    ejectionVelocity = 18;
    velocityVariance = 6.75;
    ejectionOffset =   0;
    thetaMin = 0;
    thetaMax = 180;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
//   lifeTimeMS = 200;
    orientParticles= 1;
    orientOnVelocity = 1;
    particles = "EMPSparksParticle";
};

datablock ShapeBaseImageData(EMPAPEImage) : MainAPEImage
{
   shapeFile = "turret_muzzlepoint.dts";

   offset = "0 0 1";
   rotation = "1 0 0 -90";

   stateEmitter[3]       = "EMPSparksEmitter"; // emitter
   stateEmitterTime[3]       = 0.1; // 53ms
   stateEmitterNode[3]       = 0; // model node (most models dont come with any nodes)
//   stateScript[3] = "onFire";
};

function EMPAPEImage::onFire(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   echo("EMP!");
}

datablock ShapeBaseImageData(FireVisAPEImage) : MainAPEImage
{
   offset = "0 0 1";
   rotation = "1 0 0 -90";

   stateEmitter[3]       = "StarburstFlameEmitter"; // emitter
   stateEmitterTime[3]       = 0.1; // 53ms
   stateEmitterNode[3]       = 0; // model node (most models dont come with any nodes)
//   stateScript[3] = "onFire";
};

function FireVisAPEImage::onFire(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   echo("FIRE!");
}

datablock ShapeBaseImageData(FireSmokeAPEImage) : MainAPEImage
{
   offset = "0 0 1";
   rotation = "1 0 0 -90"; // 1 0 0 90 facing down

   stateEmitter[3]       = "iFireSmokeEmitter"; // emitter
   stateEmitterTime[3]       = 0.1; // 53ms
   stateEmitterNode[3]       = 0; // model node (most models dont come with any nodes)
//   stateScript[3] = "onFire";
};

function FireSmokeAPEImage::onFire(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   echo("SMOKE!");
}

function xMountAPEsToObject(%obj)
{
   if(isObject(%obj))
   {
//      echo("APEs mounted.");
      createSlotExtension(%obj, Meltdown.APE_mountPoint, "SlotExtension2"); // APE Slot Extension (SL2 - muzzlepoint)
      %obj.slotExtension[Meltdown.APE_mountPoint].isSyn = true; // avoid EMP

      %obj.slotExtension[Meltdown.APE_mountPoint].mountImage("EMPAPEImage", Meltdown.APE_EMP_Mount);
      %obj.slotExtension[Meltdown.APE_mountPoint].mountImage("FireVisAPEImage", Meltdown.APE_FireVis_Mount);
      %obj.slotExtension[Meltdown.APE_mountPoint].mountImage("FireSmokeAPEImage", Meltdown.APE_FireSmoke_Mount);
   }
   else
      error("Error! Cannot mount an APE to a non-existant object!");
}

function ShapeBase::EMPObject(%obj)
{
   EMPObject(%obj);
}

function ShapeBase::BurnObject(%obj, %attacker)
{
   BurnObject(%obj, %attacker);
}

function ShapeBase::PoisonObject(%obj, %attacker)
{
   PoisonObject(%obj, %attacker);
}

function ShapeBase::clearLoopingDamages(%obj)
{
   clearLoopingDamages(%obj);
}

function enterWaterClearIncen(%obj)
{
   if(isObject(%obj))
      if(%obj.isFlaming)
         %obj.burnTime = 1;
}

function EMPObject(%obj)
{
   lDamageObject(%obj, 0, 1);
}

function BurnObject(%obj, %attacker)
{
   lDamageObject(%obj, %attacker, 2);
}

function PoisonObject(%obj, %attacker)
{
   lDamageObject(%obj, %attacker, 3);
}

function clearLoopingDamages(%obj)
{
   %obj.isEMP = false;
   %obj.EMPTime = 1;
   %obj.isFlaming = false;
   %obj.burnTime = 1;
}

function MeltdownBase::loopDamageObject(%mod, %obj)
{
   if(isObject(%obj) && !%obj.blowedUp && isObject(%obj.slotExtension[Meltdown.APE_mountPoint])) // jic
   {
      if(%obj.isFlaming)
      {
         if(%obj.isWet)
            return Meltdown.finishDamageLoop(%obj);

         if(%obj.burnTime)
         {
            %obj.burnTime--;
            %obj.damage(%obj.LDSrcObj, %obj.getWorldBoxCenter(), $BurnDamageMS, $DamageType::BurnLoop);
            %obj.setHeat(1);

//            if(isSlotExtension(%obj.slotExtension[Meltdown.APE_mountPoint]))
            if(%obj.getDataBlock().className $= "Armor")
            {
//               echo("loopDMG I M "@%obj.getClassName());
               %obj.slotExtension[Meltdown.APE_mountPoint].setImageTrigger(Meltdown.APE_FireSmoke_Mount, true);
               %obj.slotExtension[Meltdown.APE_mountPoint].setImageTrigger(Meltdown.APE_FireVis_Mount, true);
            }
            else
            {
//               echo("loopDMG I P "@%obj.getClassName());
               createLifeEmitter(vectorAdd(%obj.getWorldBoxCenter(), "0 0 -0.5"), "StarburstFlameEmitter", Meltdown.LDOLifetimeMS);
               createLifeEmitter(vectorAdd(%obj.getWorldBoxCenter(), "0 0 -0.5"), "HeavyDamageSmoke", Meltdown.LDOLifetimeMS);
            }
         }
         else
            return Meltdown.finishDamageLoop(%obj, 0);
      }

      if(%obj.isEMP)
      {
         if(%obj.EMPTime)
         {
            %obj.EMPTime--;
            %obj.setEnergyLevel(0);

//            if(isSlotExtension(%obj.slotExtension[Meltdown.APE_mountPoint]))
            if(%obj.getDataBlock().className $= "Armor")
               %obj.slotExtension[Meltdown.APE_mountPoint].setImageTrigger(Meltdown.APE_EMP_Mount, true);
            else
               createLifeEmitter(%obj.getWorldBoxCenter(), "EMPSparksEmitter", Meltdown.LDOLifetimeMS);
         }
         else
            return Meltdown.finishDamageLoop(%obj, 1);
      }

      if(%obj.isPoisoned)
      {
         if(%obj.poisonTime)
         {
            %obj.poisonTime--;
            if(%obj.getDataBlock().className $= "Armor")
               %obj.damage(%obj.LDSrcObj, %obj.getWorldBoxCenter(), $BurnDamageMS, $DamageType::PoisonLoop);
         }
         else
            return Meltdown.finishDamageLoop(%obj, 2);
      }
      Meltdown.schedule(Meltdown.LDOLifetimeMS, loopDamageObject, %obj);
   }
   else
   {
      %obj.isEMP = false;
      %obj.EMPTime = 1;
      %obj.isFlaming = false;
      %obj.burnTime = 1;
   }
}

function MeltdownBase::finishDamageLoop(%mod, %obj, %var)
{
   if(isObject(%obj) && isObject(%obj.slotExtension[Meltdown.APE_mountPoint])) // jic)
   {
      switch(%var)
      {
         case 0:
            if(%obj.isFlaming)
            {
               %obj.isFlaming = false;
               %obj.burnTime = 0;

               if(%obj.getDataBlock().className $= "Armor")
               {
                  if(%obj.client.player == %obj)
                     messageClient(%obj.client, 'MsgFireDone', '\c2You have stopped burning.');

                  %obj.slotExtension[Meltdown.APE_mountPoint].setImageTrigger(Meltdown.APE_FireVis_Mount, false);
                  %obj.slotExtension[Meltdown.APE_mountPoint].setImageTrigger(Meltdown.APE_FireSmoke_Mount, false);
               }

               return;
            }

         case 1:
            if(%obj.isEMP)
            {
               %obj.isEMP = false;
               %obj.EMPTime = 0;

               if(%obj.getDataBlock().className $= "Armor")
               {
                  if(%obj.client.player == %obj)
                     messageClient(%obj.client, 'MsgEMPDone', '\c2Armor Reactor back on-line.');

                  %obj.slotExtension[Meltdown.APE_mountPoint].setImageTrigger(Meltdown.APE_EMP_Mount, false);
               }

               return;
            }

         case 2:
            if(%obj.isPoisoned)
            {
               %obj.isPoisoned = false;
               %obj.poisonTime = 0;

               if(%obj.getDataBlock().className $= "Armor")
               {
                  if(%obj.client.player == %obj)
                     messageClient(%obj.client, 'MsgPoisonDone', '\c2You have been cured of your infection.');
               }

               return;
            }

         default:
            if(%obj.getDataBlock().className $= "Armor")
               if(%obj.client.player == %obj)
                  messageClient(%obj.client, 'MsgRECDError', '\c2Somehow you had some sort of recurring damage that never existed. Sorry :o');

            return;
      }
   }
}

function lDamageObject(%obj, %attacker, %type)
{
   if(isObject(%obj))
   {
      if(!%attacker)
         %attacker = %obj;

      if(%type == 1) // type 1 == EMP
      {
         if(%obj.isSyn)
            return;

         if(%obj.EMPTime > 2)
         {
            %obj.EMPTime += (100+getRandomT(20));
            if(%obj.getDataBlock().className $= "Armor")
               messageClient(%obj.client, 'MsgEMPMore', '\c2You have taken more EMP damage.');

            return;
         }

         if(%obj.getDataBlock().className $= "Armor")
            messageClient(%obj.client, 'MsgEMPStart', '\c2Danger! EMP detected; Armor Power Core Offine.');

         %obj.setEnergyLevel(0);
         %obj.isEMP = true;

         if(%obj.getDataBlock().className $= "Armor")
            %obj.EMPTime = (200+getRandomT(50));
         else
            %obj.EMPTime = (500+getRandomT(100));
      }
      else if(%type == 2) // type 2 == Incendiary
      {
         if(%obj.burnTime > 2)
         {
            %obj.burnTime += (40+getRandomT(10));
            if(%obj.getDataBlock().className $= "Armor")
               messageClient(%obj.client, 'MsgFireMore', '\c2The fire has increased in intensity.');

            return;
         }

         if(%obj.getDataBlock().className $= "Armor")
            messageClient(%obj.client, 'MsgFireStart', '\c2Danger! You are on fire!');

         %obj.isFlaming = true;
         %obj.burnTime = (400+getRandomT(100));

         if(%obj.getDataBlock().className $= "Armor")
            %obj.dmgPct = 0.005;
         else
            %obj.dmgPct = 0.00125;

         %obj.LDSrcObj = %attacker;
      }
      else if(%type == 3) // type 3 == Poison
      {
         if(%obj.getDataBlock().className $= "Armor")
         {
            if(%obj.PoisonTime > 2)
            {
               %obj.PoisonTime += getRandomT(400);
               messageClient(%obj.client, 'MsgPoisonMore', '\c2You recieved another poisionous wound!');
               return;
            }

            messageClient(%obj.client, 'MsgPoisonStart', '\c2You recieved a poisonious wound!');

            %obj.isPoisoned = true;
            %obj.PoisonTime = 500 + getRandomT(200);
         }
      }
      Meltdown.loopDamageObject(%obj);
   }
}
