if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// Inventory Pack ------------------------------------------------------------------

datablock ShapeBaseImageData(InventoryPackImage)
{
   shapeFile = "pack_upgrade_shield.dts";
   item = InventoryPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 25;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = InventoryPackActivateSound;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(InventoryPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_shield.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "InventoryPackImage";
	pickUpName = "an inventory pack";
};

function InventoryPackImage::onMount(%data, %obj, %node)
{
}

function InventoryPackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
}

function checkForInvs(%pl)
{
   InitContainerRadiusSearch(%pl.getPosition(), 305, $TypeMasks::StationObjectType);
   while((%int = ContainerSearchNext()) != 0)
   {
      if(%int.team == %pl.client.team && %int.getDamageState() $= "Enabled")
         return true;
   }
   return false;
}

function resetInvPTimeout(%obj)
{
   %obj.p_invTimeout = 0;
}

function checkCloakOff(%obj)
{
   if(%obj.isCloaked())
      %obj.setCloaked(false);
}

function buyPackFavorites(%client)
{
   %player = %client.player;
	%prevPack = %player.getMountedImage($BackpackSlot);
   %player.clearInventory();
   %client.setWeaponsHudClearAll();
   %cmt = $CurrentMissionType;

   if(!%client.player.charging)
   {
        %client.player.charging = true; //case MB
        ChargeMBC(%client.player, %client.player.getDatablock());
   }

   if(!%client.player.chargingProt)
   {
        %client.player.chargingProt = true; //case Protron
        ChargeProtron(%client.player, %client.player.getDatablock());
   }

   if(!%client.player.chargingRFL)
   {
        %client.player.chargingRFL = true; //case RFL
        ChargeRFL(%client.player);
   }

   // only new ammo, not anything else
   %weapCount = 0;
   for ( %i = 0; %i < getFieldCount( %client.weaponIndex ); %i++ )
   {
      %inv = $NameToInv[%client.favorites[getField( %client.weaponIndex, %i )]];
      if ( !($InvBanList[DeployInv, %inv]) )
      {
         %player.setInventory( %inv, 1 );
         // increment weapon count if current armor can hold this weapon
         if(%player.getDatablock().max[%inv] > 0)
            %weapCount++;

         // z0dd - ZOD, 9/13/02. Streamlining
         if ( %inv.image.ammo !$= "" )
            %player.setInventory( %inv.image.ammo, 2500 );

         if(%inv $= "MBCannon") // hack - would give 2000 ammo to MB :o lol
            %client.player.setInventory( MBCannonCapacitor, 50 );

         if(%inv $= "Protron")
            %client.player.setInventory( ProtronAmmo, 100 );

         if(%weapCount >= %player.getDatablock().maxWeapons)
            break;
      }
   }
   %player.weaponCount = %weapCount;

   // give player the grenades and mines they chose, beacons, and a repair kit
   for ( %i = 0; %i < getFieldCount( %client.grenadeIndex ); %i++)
   {
      %GInv = $NameToInv[%client.favorites[getField( %client.grenadeIndex, %i )]];
      if ( !($InvBanList[DeployInv, %GInv]) )
         %player.setInventory( %GInv, 30 );
   }

   // if player is buying cameras, show how many are already deployed
   if(%client.favorites[%client.grenadeIndex] $= "Deployable Camera")
   {
      %maxDep = $TeamDeployableMax[DeployedCamera];
      %depSoFar = $TeamDeployedCount[%client.player.team, DeployedCamera];
      if(Game.numTeams > 1)
         %msTxt = "Your team has "@%depSoFar@" of "@%maxDep@" Deployable Cameras placed.";
      else
         %msTxt = "You have placed "@%depSoFar@" of "@%maxDep@" Deployable Cameras.";
      messageClient(%client, 'MsgTeamDepObjCount', %msTxt);
   }

   for ( %i = 0; %i < getFieldCount( %client.mineIndex ); %i++ )
   {
      %MInv = $NameToInv[%client.favorites[getField( %client.mineIndex, %i )]];
      if ( !($InvBanList[DeployInv, %MInv]) )
         %player.setInventory( %MInv, 30 );
   }
//   if ( !($InvBanList[DeployInv, Beacon]) && !($InvBanList[%cmt, Beacon]) )
//      %player.setInventory( Beacon, 1000 );
//   if ( !($InvBanList[DeployInv, RepairKit]) && !($InvBanList[%cmt, RepairKit]) )
//      %player.setInventory( RepairKit, 10 );
//   if ( !($InvBanList[DeployInv, TargetingLaser]) && !($InvBanList[%cmt, TargetingLaser]) )
//      %player.setInventory( TargetingLaser, 1 );

   %player.setInventory( %prevPack.item, 1 ); // no new pack for j00!
}

function InventoryPackImage::onActivate(%data, %obj, %slot)
{
   if(!%obj.p_invTimeout)
   {
      if(!%obj.isEMP && getEnergyPct(%obj) == 1) //&& checkForInvs(%obj)
      {
         %obj.setCloaked(true);
         %obj.play3D(DepInvActivateSound);
         %obj.schedule(500, "setCloaked", false);
         schedule(1100, %obj, "checkCloakOff", %obj);
         buyPackFavorites(%obj.client);
         %obj.setEnergyLevel(0);
      	%obj.setImageTrigger(%slot,false);
         %obj.p_invTimeout = 10000;
         schedule(%obj.p_invTimeout, 0, resetInvPTimeout, %obj);
      }
      else //if(getEnergyPct(%obj) < 1)
      {
         messageClient(%obj.client, 'MsgLowPowerInvRange', '\c2You need to have full energy to use the INV pack.');
         %obj.setImageTrigger(%slot,false);
         return;
      }
//      else
//      {
//         InitContainerRadiusSearch(%obj.getPosition(), 10000, $TypeMasks::StationObjectType);
//         while((%int = ContainerSearchNext()) != 0)
//         {
//            if(%int.team == %pl.client.team && %int.getDamageState() $= "Enabled")
//               %obj.d_invdist = mFloor(getObjectDistance(%obj, %int))@"m";
//            else
//               %obj.d_invdist = "unusable";
//         }
//
//         messageClient(%obj.client, 'MsgInvOutOfRange', '\c2You must be within 300m of one of your teams working stations in order to use this pack. Closest inventory is %1.', %obj.d_invdist);
//         %obj.setImageTrigger(%slot,false);
//      }
   }
   else
      %obj.setImageTrigger(%slot,false);
}

function InventoryPackImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger(%slot,false);
}

function InventoryPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}
