if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// MANTA-HOPIC Ion Tagger

datablock ShapeBaseImageData(IonTAGPackImage)
{
   shapeFile = "pack_upgrade_energy.dts";
   item = IonTAGPack;
   mountPoint = 1;
//   offset = "-0.175 -0.2 0.2";
//   rotation = "0 1 0 180";
   emap = true;

   gun = IonTAGGunImage;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";
stateSequence[0] = "activation";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
stateSequence[1] = "activation";
   stateSound[1] = TargetingIonTAGSwitchSound;
   stateTransitionOnTriggerUp[1] = "Deactivate";

   stateName[2] = "Deactivate";
   stateScript[2] = "onDeactivate";
   stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(IonTAGPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "repair_patch.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "IonTAGPackImage";
   pickUpName = "a MANTA TAG Pack";

   emap = true;
};

function IonTAGPackImage::onUnmount(%data, %obj, %node)
{
   // dismount the IonTAGGun gun if the player had it mounted
   // need the extra "if" statement to avoid a console error message
   if(%obj.getMountedImage($WeaponSlot))
      if(%obj.getMountedImage($WeaponSlot).getName() $= "IonTAGGunImage")
         %obj.unmountImage($WeaponSlot);
}

function IonTAGPackImage::onActivate(%data, %obj, %slot)
{
   // don't activate the pack if player is piloting a vehicle
   if(%obj.isPilot())
   {
      %obj.setImageTrigger(%slot, false);
      return;
   }

   if(!isObject(%obj.getMountedImage($WeaponSlot)) || %obj.getMountedImage($WeaponSlot).getName() !$= "IonTAGGunImage")
   {
      // unmount any weapon the player may have been holding
      if(%obj.getMountedImage($WeaponSlot))
         %obj.unmountImage($WeaponSlot);

      // make sure player's arm thread is "look"
      %obj.setArmThread(look);

      // mount the IonTAGGun gun
      %obj.mountImage(IonTAGGunImage, $WeaponSlot);
//      commandToClient(%obj.client, 'setRepairReticle');
      %obj.client.setWeaponsHudActive("Chaingun");
   }
}

function IonTAGPackImage::onDeactivate(%data, %obj, %slot)
{
   //called when the player hits the "pack" key again (toggle)
   %obj.setImageTrigger(%slot, false);
   if(%obj.getMountedImage($WeaponSlot).getName() $= "IonTAGGunImage")
      %obj.unmountImage($WeaponSlot);
}

//--------------------------------------------------------------------------
// Ion Gun

datablock ShockwaveData(IonCannonBlastShockwave)
{
   width = 50.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 500;
   acceleration = -500.0;
   lifetimeMS = 500;
   height = 2.0;
   verticalCurve = 0.5;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.85 0.8 0.0 0.5";
   colors[1] = "0.85 0.8 0.0 0.25";
   colors[2] = "0.85 0.8 0.0 0.0";

   mapToTerrain = false;
   orientToNormal = true;
   renderBottom = true;
};

datablock ShockwaveData(IonCannonBlastShockwaveN) : IonCannonBlastShockwave
{
   is2D = false;
};

datablock ShockwaveData(IonCannonTrailShockwave)
{
   width = 15.0;
   numSegments = 12;
   numVertSegments = 6;
   velocity = 1;
   acceleration = -0.5;
   lifetimeMS = 3500;
   height = 1.0;
   verticalCurve = 0.5;
//   is2D = true;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.1 0.3 1.0 1.0";
   colors[1] = "0.1 0.3 1.0 0.25";
   colors[2] = "0.1 0.3 1.0 0.0";

   mapToTerrain = false;
   orientToNormal = true;
   renderBottom = true;
};

datablock ExplosionData(IonCannonTrailExplosion)
{
//   soundProfile   = plasmaExpSound;
   shockwave = IonCannonTrailShockwave;
   faceViewer = true;
};

datablock LinearFlareProjectileData(IonCannonTrailCharge)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.0001;//0; --- must be > 0 (ST)
   damageRadius        = 1;
   radiusDamageType    = $DamageType::IonCannon;
   kickBackStrength    = 1;

   explosion           = "IonCannonTrailExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock ExplosionData(IonCannonUpExplosion)
{
//   soundProfile   = plasmaExpSound;
   shockwave = IonCannonBlastShockwaveN;
   faceViewer = true;
};

datablock LinearFlareProjectileData(IonCannonUpCharge)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.0001;//0; --- must be > 0 (ST)
   damageRadius        = 1;
   radiusDamageType    = $DamageType::IonCannon;
   kickBackStrength    = 1;

   explosion           = "IonCannonUpExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock ExplosionData(IonCannonWaveExplosion)
{
   soundProfile = BombExplosionSound;
   shockwave = IonCannonBlastShockwave;
   faceViewer = true;
};

datablock LinearFlareProjectileData(IonCannonWaveCharge)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.0001;//0; --- must be > 0 (ST)
   damageRadius        = 1;
   radiusDamageType    = $DamageType::IonCannon;
   kickBackStrength    = 1;

   explosion           = "IonCannonWaveExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock ParticleData( IonCannonBlastCrescentParticle )
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent3";
   colors[0]     = "0.8 0.8 0.1 1.0";
   colors[1]     = "0.8 0.8 0.1 0.5";
   colors[2]     = "0.8 0.8 0.1 0.0";
   sizes[0]      = 4.0*6;
   sizes[1]      = 8.0*6;
   sizes[2]      = 9.0*6;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData( IonCannonBlastCrescentEmitter )
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 75;
   velocityVariance = 10.0;
   ejectionOffset   = 30.0;
   thetaMin         = 10;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 750;
   particles = "IonCannonBlastCrescentParticle";
};

datablock ParticleData(IonCannonBlastExplosionSmoke)
{
   dragCoeffiecient     = 0.4;
   gravityCoefficient   = -0.30;   // rises slowly
   inheritedVelFactor   = 0.025;

   lifetimeMS           = 5000;
   lifetimeVarianceMS   = 1000;

   useInvAlpha =  true;
   spinRandomMin = -100.0;
   spinRandomMax =  100.0;

   textureName = "special/Smoke/bigSmoke";

   colors[0]     = "0.7 0.7 0.7 0.0";
   colors[1]     = "0.4 0.4 0.4 0.5";
   colors[2]     = "0.4 0.4 0.4 0.5";
   colors[3]     = "0.4 0.4 0.4 0.0";
   sizes[0]      = 5.0*8;
   sizes[1]      = 6.0*8;
   sizes[2]      = 10.0*8;
   sizes[3]      = 12.0*8;
   times[0]      = 0.0;
   times[1]      = 0.333;
   times[2]      = 0.666;
   times[3]      = 1.0;
};

datablock ParticleEmitterData(IonCannonBlastExplosionSmokeEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;

   ejectionOffset = 40.0;


   ejectionVelocity = 2.25;
   velocityVariance = 2.2;

   thetaMin         = 0.0;
   thetaMax         = 90.0;

   lifetimeMS       = 500;

   particles = "IonCannonBlastExplosionSmoke";
};

datablock ExplosionData(IonCannonBlastSubExplosion1)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 100;
   offset = 6.0*5;
   playSpeed = 0.25;

   sizes[0] = "25 25 25";
   sizes[1] = "25 25 25";
   times[0] = 0.0;
   times[1] = 1.0;

};

datablock ExplosionData(IonCannonBlastSubExplosion2)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 50;
   offset = 5.0*6;
   playSpeed = 0.375;

   sizes[0] = "25 25 25";
   sizes[1] = "25 25 25";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(IonCannonBlastSubExplosion3)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;
   delayMS = 0;
   offset = 0.0;
   playSpeed = 0.5;

   sizes[0] = "25 25 25";
   sizes[1] = "25 25 25";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(IonCannonBlastExplosion)
{
   soundProfile   = HugeExplosionSound;

//   shockwave = IonCannonBlastShockwave;
//   shockwaveOnTerrain = true;

   subExplosion[0] = IonCannonBlastSubExplosion1;
   subExplosion[1] = IonCannonBlastSubExplosion2;
   subExplosion[2] = IonCannonBlastSubExplosion3;

   emitter[0] = IonCannonBlastExplosionSmokeEmitter;
   emitter[1] = IonCannonBlastCrescentEmitter;

   debris = MortarDebris;
   debrisThetaMin = 10;
   debrisThetaMax = 50;
   debrisNum = 32;
   debrisVelocity = 50.0;
   debrisVelocityVariance = 12.0;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "100.0 100.0 100.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
};

$IonSpeed = 500;
$IonLife = 16000;

datablock EnergyProjectileData(IONBeam)
{
   emitterDelay        = -1;
   directDamage        = 0.15;
   directDamageType    = $DamageType::IonCannon;
   kickBackStrength    = 0.0;
   bubbleEmitTime      = 1.0;

   sound = BlasterProjectileSound;
   velInheritFactor    = 1.0;

   explosion           = "IonCannonBlastExplosion";
   splash              = BlasterSplash;

   grenadeElasticity = 0.998;
   grenadeFriction   = 0.0;
   armingDelayMS     = 250;//200; --- 250 minimum? (ST)

   muzzleVelocity    = $IonSpeed;

   drag = 0.05;

   gravityMod        = 0.0;

   dryVelocity       = $IonSpeed;
   wetVelocity       = $IonSpeed;

   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = $IonLife;

   hasLight    = true;
   lightRadius = 20.0;//30.0; --- Range is 1-20 (ST)
   lightColor  = "0.1 1.0 0.2";

   scale = "1 1 1";
   crossViewAng = 0.8;
   crossSize = 1.0;

   lifetimeMS     = $IonLife;
   blurLifetime   = 0.05;
   blurWidth      = 0.05;
   blurColor = "0.1 1.0 0.2 1.0";

   texture[0] = "special/expflare";//"special/blasterBolt";
   texture[1] = "special/expflare";//"special/blasterBoltCross";
};

datablock ParticleData(IonContrailParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0;
   inheritedVelFactor   = 0.0;
   constantAcceleration = -0.05;
   lifetimeMS           = 5000;
   lifetimeVarianceMS   = 0;
   textureName          = "special/lightFallOffMono"; //"particleTest";
   colors[0]     = "0.3 1.0 0.2 1.0";
   colors[1]     = "0.6 0.6 0.6 0.75";
   colors[2]     = "1.0 1.0 1.0 0";
   sizes[0]      = 9;
   sizes[1]      = 6;
   sizes[2]      = 3;
   times[0]      = 0;
   times[1]      = 0.75;
   times[2]      = 1;
};

datablock ParticleEmitterData(IonContrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 2.0;
   thetaMin         = 0;
   thetaMax         = 10;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "IonContrailParticle";
};

datablock LinearFlareProjectileData(IONBeamHead)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "20 20 20";
   faceViewer          = true;
   directDamageType    = $DamageType::IonCannon;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 100;
   damageRadius        = 50;
   kickBackStrength    = 37500;
   radiusDamageType    = $DamageType::IonCannon;

   explosion           = "FireballAtmosphereBoltExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = IonContrailEmitter;

   dryVelocity       = $IonSpeed;
   wetVelocity       = $IonSpeed;       // faster uw
   velInheritFactor  = 1.0;
   fizzleTimeMS      = $IonLife;
   lifetimeMS        = $IonLife;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = $IonLife;

   activateDelayMS = -1;
   numFlares         = 10;
   flareColor        = "0.1 1.0 0.4";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "special/blasterboltcross";

sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 20.0;//32.0; --- Range is 1-20 (ST)
   lightColor  = "0.9 0.5 0.1";

   size[0] = 1.0;
   size[1] = 7.0;
   size[2] = 5.0;
};

function IONBeamHead::onExplode(%data, %proj, %pos, %mod)
{
   %player = %proj.client;

   if(%proj.ionnuke)
   {
      beginNuke(%proj.bkSourceObject, %pos);
      return;
   }

   %FFRObject = new StaticShape()
   {
      dataBlock        = mReflector;
   };
   MissionCleanup.add(%FFRObject);
   %FFRObject.setPosition(%pos);
   %FFRObject.schedule(32, delete);

   %h = new LinearFlareProjectile()
   {
      dataBlock        = IonCannonUpCharge;
      initialDirection = "0 0 0";
      initialPosition  = %pos;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %player;
   };
   MissionCleanup.add(%h);

   %i = new LinearFlareProjectile()
   {
      dataBlock        = IonCannonWaveCharge;
      initialDirection = "0 0 1";
      initialPosition  = %pos;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %player;
   };
   MissionCleanup.add(%i);


   Parent::onExplode(%data, %proj, %pos, %mod);
}

datablock TargetProjectileData(IonTAGBeam)
{
   directDamage        = 0.0;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;

   maxRifleRange       = 300;
   beamColor           = "1.0 0.1 0.1";
//   coupleBeam           = 0; // new

   startBeamWidth    = 0.20;
   pulseBeamWidth    = 0.25;
   beamFlareAngle    = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 6.0;
   pulseLength         = 0.150;

   textureName[0]      = "special/nonlingradient";
   textureName[1]      = "special/flare";
   textureName[2]      = "special/pulse";
   textureName[3]      = "special/blasterHit"; //"special/BlasterBoltCross";
//   beacon               = true;

   hasLight = true;
   lightColor = IonTAGBeam.BeamColor;
   lightRadius = 6;
};

datablock TargetProjectileData(RMSTAGBeam)
{
   directDamage        = 0.0;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;

   maxRifleRange       = 300;
   beamColor           = "0.1 0.1 1.0";
//   coupleBeam           = 0; // new

   startBeamWidth    = 0.20;
   pulseBeamWidth    = 0.25;
   beamFlareAngle    = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 6.0;
   pulseLength         = 0.150;

   textureName[0]      = "special/nonlingradient";
   textureName[1]      = "special/flare";
   textureName[2]      = "special/pulse";
   textureName[3]      = "special/blasterHit"; //"special/BlasterBoltCross";
//   beacon               = true;

   hasLight = true;
   lightColor = RMSTAGBeam.BeamColor;
   lightRadius = 6;
};

datablock ItemData(IonTAGGun)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_targeting.dts";
   image = IonTAGGunImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "a MANTA Ion Cannon Tagger";
   emap = true;
};

datablock ShapeBaseImageData(IonTAGGunImage)
{
   className = WeaponImage;

   shapeFile = "weapon_targeting.dts";
   item = IonTAGGun;
   offset = "0 0 0";

   projectile = IonTAGBeam;
   projectileType = TargetProjectile;
   deleteLastProjectile = true;

   usesEnergy = true;
   minEnergy = -1;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activate";
   stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "ActivateReady";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnAmmo[1]         = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateEnergyDrain[3]              = 0;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateScript[3]                   = "onFire";
   stateTransitionOnTriggerUp[3]    = "Deconstruction";
   stateTransitionOnNoAmmo[3]       = "Deconstruction";
   stateSound[3]                    = TargetingLaserPaintSound;

   stateName[4]                     = "NoAmmo";
   stateTransitionOnAmmo[4]         = "Ready";

   stateName[5]                     = "Deconstruction";
   stateScript[5]                   = "deconstruct";
   stateTransitionOnTimeout[5]      = "Ready";
};

$IonPainterCalibrateTime = 11000;
$RMSMaxFires = 4; // =S (ST)

function IonRMSErrorReset(%obj)
{
   if(isObject(%obj))
      %obj.IonRMSError = "";
}

function IonRMSReset(%obj, %text, %time)
{
   if(isObject(%obj))
   {
      %obj.IonRMSError = %text SPC %time;
      schedule(%time, 0, IonRMSErrorReset, %obj);
   }
}

$TypeMasks::MantaLOSType = $TypeMasks::StationObjectType | $TypeMasks::GeneratorObjectType | $TypeMasks::SensorObjectType | $TypeMasks::TurretObjectType | $TypeMasks::InteriorObjectType | $TypeMasks::ForceFieldObjectType | $TypeMasks::StaticShapeObjectType | $TypeMasks::StaticObjectType;

function errorResetMR(%obj, %text, %time)
{
   if(%obj.IonRMSError)
   {
      MRDisplayError(%obj);
      return;
   }

   if(%text !$= "")
      commandToClient(%obj.client, 'BottomPrint', %text, %time, 1);

   %obj.setImageTrigger(0, false);
   IonRMSReset(%obj, %text, %time*1000);
}

function MRDisplayError(%obj)
{
   %text = getWord(%obj.IonRMSError, 0);
   %time = getWord(%obj.IonRMSError, 1);

   if(%text !$= "")
      commandToClient(%obj.client, 'BottomPrint', %text, %time, 1);

   %obj.setImageTrigger(0, false);
}

function IonTAGGunImage::onFire(%data,%obj,%slot)
{
   if(%obj.IonRMSError)
   {
      MRDisplayError(%obj);
      return;
   }

   %id = 0;
   %proj = "";

   if(%obj.ionTagBeacon)
   {
      %obj.ionTagBeacon.delete();
      %obj.ionTagBeacon = "";
   }

   %mode = %obj.getMountedImage(0).item;

   if(%obj.client.mode[%mode] == 0)
   {
      %weapon = $MantaSat[%obj.client.team];
      %id = 1;
      %proj = "IonTAGBeam";
   }
   else if(%obj.client.mode[%mode] == 1)
   {
      %weapon = $RMSSilo[%obj.client.team];
      %id = 2;
      %proj = "RMSTAGBeam";
   }

   %p = new TargetProjectile()
   {
      dataBlock        = %proj;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = 0;
   };
   MissionCleanup.add(%p);
   %obj.mrtarg = %p;
   %obj.lastProjectile = %p;

//   %p = Parent::onFire(%data, %obj, %slot);
   %p.setTarget(%obj.client.team);

   if(isObject(%weapon))
   {
      if(!%weapon.isLoaded)
      {
         %text = %id == 1 ? "The MANTA is not loaded with a battery; resetting..." : "The RMS is not loaded with missiles; resetting...";
         errorResetMR(%obj, %text, 3);
         return;
      }

      %pt = getWords(%obj.lastProjectile.getTargetPoint(), 0, 2);

      if(%pt $= "0 0 0")
         %pt = getLOSOffset(%obj, %obj.getMuzzleVector(0), 300, %obj.getMuzzlePoint(0));

//      %pt2 = vectorAdd(vectorScale(vectorNormalize(vectorSub($MantaSat[%obj.client.team], %pt)), 1), %pt);
//      %result = containerRayCast($MantaSat[%obj.client.team].getPosition(), %pt2, $TypeMasks::MantaLOSType, $MantaSat[%obj.client.team]);
//      %target = getWord(%result, 0);

//      if(!%target)
//      {
      %obj.ionTAGLoop = true;
      %obj.lastPointFirePos = %pt;
      %obj.lastPointVector = %obj.getMuzzleVector(0);

      IonTAGFireLoop(%obj);
//      }
//      else
//      {
//         %obj.setImageTrigger(0, false);
//         %obj.IonTagInvalidTimeout = true;
//
//         schedule(1500, 0, IonTagInvalidTimeoutReset, %obj);
//      }
   }
   else
   {
      %error = %id == 1 ? "There is no MANTA Satellite in orbit." : "There is no RMS Silo deployed.";
      errorResetMR(%obj, %error, 4); //commandToClient(%obj.client, 'BottomPrint', ".", 4, 1);
   }
}

function IonTAGFireLoop(%obj)
{
   %weapon = %obj.getMountedImage(0).item;

   if(%obj.client.mode[%weapon] == 0)
   {
      %weapon = $MantaSat[%obj.client.team];
      %id = 1;
   }
   else if(%obj.client.mode[%weapon] == 1)
   {
      %weapon = $RMSSilo[%obj.client.team];
      %id = 2;
   }

   if(isObject(%obj) && isObject(%weapon))
   {
      if(%obj.IonTAGLoop)
      {
         if(%obj.IonRMSError)
         {
            MRDisplayError(%obj);
            return;
         }

         %pos = %obj.lastPointFirePos;
         %pointEnd = %obj.lastProjectile.getTargetPoint();
         %pointVec = %obj.getMuzzleVector(0);

//         if(!%weapon.lockDuration)
//            %weapon.lockDuration = 13000;

//         echo(%weapon.lockDuration);
         if(vectorCompare(%obj.lastPointVector, %pointVec))
         {
            %obj.IonPainterTargetCount++;

            if(%obj.IonPainterTargetCount >= 10)
            {
               %obj.IonPainterTargetCalibrate++;
               %obj.IonPainterTargetCount = 0;
            }

            if(%obj.IonPainterTargetCalibrate >= (%weapon.lockDuration / 1000))
            {
               %obj.IonPainterFireReady = true;
               %obj.IonPainterTargetCalibrate = 0;
            }
         }
         else
         {
            %obj.IonPainterTargetCount = 0;
            %obj.IonPainterTargetCalibrate = 0;
            %obj.IonPainterFireReady = false;

            %text = %id == 1 ? "The MANTA is not loaded with a battery; resetting..." : "The RMS is not loaded with missiles; resetting...";
            errorResetMR(%obj, %text, 3);
            return;
         }

         if(%obj.IonPainterFireReady)
         {
            commandToClient(%obj.client, 'BottomPrint', "Coordinates of impact: " SPC getWords(%pos, 0, 2), 4, 1);
            %obj.setImageTrigger($BackpackSlot, false);
         }
         else if(!%obj.IonTagFireTimeout)
         {
            %xFactor = getWord(%pos, 0) + getRandomT(500); // getRandomT((%obj.IonPainterTargetCalibrate - ($IonPainterCalibrateTime / 1000)));
            %yFactor = getWord(%pos, 1) + getRandomT(500); // getRandomT((%obj.IonPainterTargetCalibrate - ($IonPainterCalibrateTime / 1000)));
            %zFactor = getWord(%pos, 2) + getRandomT(500); // getRandomT((%obj.IonPainterTargetCalibrate - ($IonPainterCalibrateTime / 1000)));
            %calibratePos = %xFactor SPC %yFactor SPC %zFactor;

            commandToClient(%obj.client, 'BottomPrint', "Calibrating fire coordinates:" SPC %calibratePos, 1.5, 1);
         }

         %obj.lastPointFirePos = %pos;
         %obj.lastPointVector = %pointVec;

         schedule(100, 0, IonTAGFireLoop, %obj);
      }
   }
}

function IonZapMe(%obj)
{
   if(isObject(%obj))
   {
      %pos = %obj.getPosition();
      %pos2 = vectorAdd(%pos, "0 0 1000");

            %FFRObject = new StaticShape()
            {
               dataBlock        = mReflector;
            };
            MissionCleanup.add(%FFRObject);
            %FFRObject.setPosition(%pos2);
            %FFRObject.schedule(32, delete);

            %p = new EnergyProjectile()
            {
               dataBlock        = IONBeam;
               initialDirection = "0 0 -1"; //"0 0 -1";
               initialPosition  = %pos2;
               sourceObject     = %FFRObject;
               sourceSlot       = 0;
               vehicleObject    = 0;
               bkSourceObject   = %obj;
               ignoreReflections = true;
            };
            MissionCleanup.add(%p);

            %h = new LinearFlareProjectile()
            {
               dataBlock        = IONBeamHead;
               initialDirection = "0 0 -1"; //"0 0 -1";
               initialPosition  = %pos2;
               sourceObject     = %FFRObject;
               sourceSlot       = 0;
               vehicleObject    = 0;
               bkSourceObject   = %obj;
               ignoreReflections = true;
            };
            MissionCleanup.add(%h);

            projectileTrail(%h, 50, LinearFlareProjectile, IonCannonTrailCharge);
   }
}

function IonTAGGunImage::deconstruct(%data, %obj, %slot)
{
   %obj.IonTAGLoop = false;

   if(%obj.ionTagBeacon)
   {
      %obj.ionTagBeacon.delete();
      %obj.ionTagBeacon = "";
   }

//   if(%obj.IonRMSError)
//   {
//      MRDisplayError(%obj);
//      return;
//   }

   %weapon = %obj.getMountedImage(0).item;

   if(%obj.client.mode[%weapon] == 0)
   {
      %weapon = $MantaSat[%obj.client.team];
      %id = 1;
   }
   else if(%obj.client.mode[%weapon] == 1)
   {
      %weapon = $RMSSilo[%obj.client.team];
      %id = 2;
   }

   if(isObject(%weapon)) // is there a satellite?
   {
         if(%obj.IonPainterFireReady) // are we ready to fire?
         {
            %obj.IonPainterFireReady = false;
            %pos = %obj.lastPointFirePos;

            if(%id == 1)
            {
               %obj.ionTagBeacon = new BeaconObject()
               {
                  dataBlock = "TAGBeacon";
                  beaconType = "vehicle";
                  position = %pos;
               };

               %obj.ionTagBeacon.playThread($AmbientThread, "ambient");
               %obj.ionTagBeacon.team = %obj.client.team;
               %obj.ionTagBeacon.sourceObject = %obj;
               %obj.ionTagBeacon.setTarget(%obj.client.team);
               MissionCleanup.add(%obj.ionTagBeacon);

               %beacon = %obj.ionTagBeacon;
               %obj.ionTagBeacon = "";
               %beacon.schedule(5000, delete);

//               echo("manta satellite exists");
               %pos2 = vectorAdd($MantaSat[%obj.client.team].getPosition(), "0 0 -10");
               %pointDir = getVectorFromPoints(%pos2, %pos);
//               %hpos = getVectorOffset(%pos2, %pointDir, -20); //vectorAdd(%pos, "0 0 -20");

               %FFRObject = new StaticShape()
               {
                  dataBlock        = mReflector;
               };
               MissionCleanup.add(%FFRObject);
               %FFRObject.setPosition(%pos2);
               %FFRObject.schedule(32, delete);

               if(%weapon.loadType == 1)
                  MANTAFireIonBlast(%obj, %FFRObject, %pointdir, %pos2);
               else if(%weapon.loadType == 2)
                  MANTAFireIonNuke(%obj, %FFRObject, %pointdir, %pos2);
            }
            else if(%id == 2)
            {
               %weapon.targetPos = %pos;
               sequenceRMSS(%weapon, %obj);
            }

//            %weapon.ammo -= %ammocost;
            %weapon.isLoaded = false;
            %weapon.loadType = 0;
            %weapon.lockduration = 0;
         }
//         else if(%obj.IonTagFireTimeout)
//            commandToClient(%obj.client, 'BottomPrint', "Coordinates not similar to last, resetting.", 4, 1);
//         else if(%obj.IonTagInvalidTimeout)
//            commandToClient(%obj.client, 'BottomPrint', "Target coordinates are blocked by or in an object/building/part of terrain.", 4, 1);
//         else if(%obj.IonTagNoAmmo)
//            commandToClient(%obj.client, 'BottomPrint', "MANTA is not loaded with a battery; resetting.", 4, 1);
//         else
//            commandToClient(%obj.client, 'BottomPrint', %id SPC "coordinates not calibrated.", 4, 1);
//      else
//         commandToClient(%obj.client, 'BottomPrint', %id SPC "is recharging, please wait "@(%chargeTime / 1000) - %weapon.MASCharge@" seconds.", 4, 1);
   }

   if(isObject(%obj.mrtarg))
      %obj.mrtarg.delete();

   Parent::deconstruct(%data, %obj, %slot);
}

datablock StaticShapeData(TAGBeacon)
{
   shapeFile = "turret_muzzlepoint.dts";
   targetNameTag = 'beacon';
   isInvincible = true;

   dynamicType = $TypeMasks::SensorObjectType;
};

function MANTAFireIonBlast(%obj, %FFRObject, %pointdir, %pos2)
{
   %p = new EnergyProjectile()
   {
      dataBlock        = IONBeam;
      initialDirection = %pointDir; //"0 0 -1";
      initialPosition  = %pos2;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %obj;
      ignoreReflections = true;
   };
   MissionCleanup.add(%p);

   %h = new LinearFlareProjectile()
   {
      dataBlock        = IONBeamHead;
      initialDirection = %pointDir; //"0 0 -1";
      initialPosition  = %pos2;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %obj;
      ignoreReflections = true;
   };
   MissionCleanup.add(%h);

   schedule(750, 0, "projectileTrail", %h, 50, LinearFlareProjectile, IonCannonTrailCharge);
}

function MANTAFireIonNuke(%obj, %FFRObject, %pointdir, %pos2)
{
   %p = new EnergyProjectile()
   {
      dataBlock        = IONBeam;
      initialDirection = %pointDir; //"0 0 -1";
      initialPosition  = %pos2;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %obj;
      ignoreReflections = true;
   };
   MissionCleanup.add(%p);

   %h = new LinearFlareProjectile()
   {
      dataBlock        = IONBeamHead;
      initialDirection = %pointDir; //"0 0 -1";
      initialPosition  = %pos2;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %obj;
      ignoreReflections = true;
      ionNuke = true;
   };
   MissionCleanup.add(%h);
}
// --- Has modes now O_O (ST)
//function IonTAGGunImage::onMount(%this,%obj,%slot)
//{
//   Parent::onMount(%this,%obj,%slot);
//   commandToClient( %obj.client, 'BottomPrint', "<font:times new roman:18>Now using a MANTA Ion TAG Gun\nThis targets positions for the MANTA-HOPIC to fire at.", 4, 2);
//}

function IonTAGGunImage::onUnmount(%this,%obj,%slot)
{
   %obj.setImageTrigger(%slot, false);
   %obj.setImageTrigger($BackpackSlot, false);
}

function IonTAGPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}
