if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// LaserCannon (the l33tness!!)

datablock ShapeBaseImageData(LCCDecalImage)
{
   mountPoint = 1;
   shapeFile = "repair_patch.dts";
   offset = "0.175 -0.2 0.2";
   rotation = "0 1 0 180";
};

datablock AudioProfile(LCCBeamFireSound)
{
   filename    = "fx/vehicles/htransport_thrust.wav";
   description = AudioDefault3d;
};

datablock ShockwaveData(LCCShock)
{
   width = 2;
   numSegments = 24;
   numVertSegments = 4;
   velocity = -3;
   acceleration = -6.0;
   lifetimeMS = 500;
   height = 0.15;
   verticalCurve = 0.5;

   mapToTerrain = false;
   renderBottom = true;
   orientToNormal = true;

   texture[0] = "special/cloaktexture";
   texture[1] = "special/gradient";
   texWrap = 3.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.5 0.5 1.0";
   colors[1] = "1.0 0.5 0.5 0.5";
   colors[2] = "1.0 0.0 0.0 0.0";
};

datablock ExplosionData(LCBExplosion)
{
   soundProfile   = blasterExpSound;
   shockwave = LCCShock;
   emitter[0] = BlasterSplashEmitter;
};

datablock ShapeBaseImageData(LaserCannonPackImage)
{
   shapeFile = "repair_patch.dts";
   item = LaserCannonPack;
   mountPoint = 1;
   offset = "-0.175 -0.2 0.2";
   rotation = "0 1 0 180";
   emap = true;

   gun = LaserCannonGunImage;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateSequence[1] = "ambient";
   stateSound[1] = TargetingLaserSwitchSound;
   stateTransitionOnTriggerUp[1] = "Deactivate";

   stateName[2] = "Deactivate";
   stateScript[2] = "onDeactivate";
   stateTransitionOnTimeout[2] = "Idle";   
};

datablock ItemData(LaserCannonCapacitor)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_grenade.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some laser cannon capacitor charges";

   emap = true;
};

datablock ItemData(LaserCannonPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "repair_patch.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "LaserCannonPackImage";
   pickUpName = "a laser cannon pack";

   emap = true;
};

function LaserCannonPackImage::onMount(%data, %obj, %node)
{
   %obj.mountImage(LCCDecalImage, 7);
}

function LaserCannonPackImage::onUnmount(%data, %obj, %node)
{
    %obj.unmountImage(7);

   // dismount the LaserCannon gun if the player had it mounted
   // need the extra "if" statement to avoid a console error message
   if(%obj.getMountedImage($WeaponSlot))
      if(%obj.getMountedImage($WeaponSlot).getName() $= "LaserCannonGunImage")
         %obj.unmountImage($WeaponSlot);
}

function LaserCannonPackImage::onActivate(%data, %obj, %slot)
{
   // don't activate the pack if player is piloting a vehicle
   if(%obj.isPilot())
   {
      %obj.setImageTrigger(%slot, false);
      return;
   }

   if(!isObject(%obj.getMountedImage($WeaponSlot)) || %obj.getMountedImage($WeaponSlot).getName() !$= "LaserCannonGunImage")
   {
      // unmount any weapon the player may have been holding
      if(%obj.getMountedImage($WeaponSlot))
         %obj.unmountImage($WeaponSlot);

      // make sure player's arm thread is "look"
      %obj.setArmThread(look);

      // mount the LaserCannon gun
      %obj.mountImage(LaserCannonGunImage, $WeaponSlot);
//      commandToClient(%obj.client, 'setRepairReticle');
      %obj.client.setWeaponsHudActive("Blaster");
   }
}

function LaserCannonPackImage::onDeactivate(%data, %obj, %slot)
{
   //called when the player hits the "pack" key again (toggle)
   %obj.setImageTrigger(%slot, false);
   if(%obj.getMountedImage($WeaponSlot).getName() $= "LaserCannonGunImage")
      %obj.unmountImage($WeaponSlot);
}

//--------------------------------------------------------------------------
// Laser Cannon Gun

datablock SniperProjectileData(LaserCannonBolt)
{
   directDamage        = 0.1;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "SniperExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Laser;

   maxRifleRange       = 1000;
   rifleHeadMultiplier = 1.5;
   beamColor           = "1 1 1";
   fadeTime            = 0.5;

   startBeamWidth		  = 0.145;
   endBeamWidth 	     = 0.25;
   pulseBeamWidth 	  = 0.5;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 6.0;
   pulseLength         = 0.150;

   lightRadius         = 1.0;
   lightColor          = "0.3 0.0 0.0";

   textureName[0]      = "special/flare";
   textureName[1]      = "special/nonlingradient";
   textureName[2]      = "special/laserrip01";
   textureName[3]      = "special/laserrip02";
   textureName[4]      = "special/laserrip03";
   textureName[5]      = "special/laserrip04";
   textureName[6]      = "special/laserrip05";
   textureName[7]      = "special/laserrip06";
   textureName[8]      = "special/laserrip07";
   textureName[9]      = "special/laserrip08";
   textureName[10]     = "special/laserrip09";
   textureName[11]     = "special/sniper00";
};

datablock TargetProjectileData(LaserCannonBeam)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 1000;
   beamColor           	= "1 0.1 0.15";

   startBeamWidth			= 0.5;
   pulseBeamWidth 	   = 1.0;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 30.0;
   pulseLength         	= 0.15;

   textureName[0]      	= "special/nonlingradient";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/pulse";
   textureName[3]      	= "special/expFlare";
};

datablock SniperProjectileData(LaserCannonBeem)
{
   directDamage        = 0.06;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "LCBExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Laser;

   maxRifleRange       = 1000;
   rifleHeadMultiplier = 1.5;
   beamColor           = "0 0 0";
   fadeTime            = 0.25;

   startBeamWidth		  = 0.145;
   endBeamWidth 	     = 0.25;
   pulseBeamWidth 	  = 0.5;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 6.0;
   pulseLength         = 0.150;

   lightRadius         = 1.0;
   lightColor          = "1 0.0 0.0";

   textureName[0]      = "special/flare";
   textureName[1]      = "special/nonlingradient";
   textureName[2]      = "special/laserrip01";
   textureName[3]      = "special/laserrip02";
   textureName[4]      = "special/laserrip03";
   textureName[5]      = "special/laserrip04";
   textureName[6]      = "special/laserrip05";
   textureName[7]      = "special/laserrip06";
   textureName[8]      = "special/laserrip07";
   textureName[9]      = "special/laserrip08";
   textureName[10]     = "special/laserrip09";
   textureName[11]     = "special/sniper00";
};

function LaserCannonBeem::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
   %damageAmount = %projectile.doNormalDamage == true ? %projectile.normalDmg : (%data.directDamage * %projectile.damageFactor);

   if(%projectile.bkSourceObject)
      if(isObject(%projectile.bkSourceObject))
         %projectile.sourceObject = %projectile.bkSourceObject;

   if(%targetObject.isFF)
          %targetObject.deployBase.damage(%projectile.sourceObject, %position, %data.directDamage, %data.directDamageType);
   else
          %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage, %data.directDamageType);
}

datablock ItemData(LaserCannonGun)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = LaserCannonGunImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a laser charge cannon";
   emap = true;
};

datablock ShapeBaseImageData(LaserCannonGunImage)
{
   className = WeaponImage;
   shapeFile = "weapon_missile.dts";
   item = LaserCannonGun;
   ammo = LaserCannonCapacitor;
//   armThread = "lookMS";
   offset = "0 0 0";
   emap = true;
   usesEnergy = true;
   minEnergy = -1;

   offset = "0 0.2 0.05";
   emap = true;
   usesEnergy = true;
   minEnergy = -1;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Deploy";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";

   stateName[2]                     = "Fire";
   stateFire[2]                     = true;
   stateAllowImageChange[2]         = false;
	stateSound[2]                    = EcstacyChargeSound;
   stateScript[2]                   = "onFire";
   stateTransitionOnTriggerUp[2]    = "Deconstruction";

   stateName[3]                     = "Deconstruction";
   stateScript[3]                   = "onRelease";
   stateTimeoutValue[3]             = 0.5;
   stateTransitionOnTimeout[3]      = "Ready";
};

$LCC::Max = 512;

datablock ShapeBaseImageData(LaserCannonDecalAImage)
{
   shapeFile = "weapon_missile.dts";
   offset = "-0.03 0.7 0.05";
};

datablock ShapeBaseImageData(LaserCannonDecalBImage)
{
   shapeFile = "weapon_energy.dts";
   offset = "-0.125 0.05 0.15";
};

datablock ShapeBaseImageData(LaserCannonDecalCImage)
{
   shapeFile = "pack_upgrade_energy.dts";
   offset = "-0.1 0.4 0.3";
   rotation = "1 0 0 90";
};

function LaserCannonGunImage::onMount(%this,%obj,%slot)
{
   commandToClient( %obj.client, 'BottomPrint', "<font:times new roman:18>Now using a Laser Charge Cannon\nTo Charge, Hold down the fire button in charge (default) mode.\nTo fire, press your beacon key to switch fire modes.", 8, 3);
   %obj.setImageAmmo(%slot,true);
   %obj.lcc_LaserCannonOnHand = %obj.getMountedImage(%slot);
   %obj.mountImage(LaserCannonDecalAImage, 4);
   %obj.mountImage(LaserCannonDecalBImage, 5);
   %obj.mountImage(LaserCannonDecalCImage, 6);
}

function LaserCannonGunImage::onUnmount(%this,%obj,%slot)
{
   %obj.setImageTrigger(%slot, false);
   %obj.setImageTrigger($BackpackSlot, false);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}

function LaserCannonPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}

function LaserCannonFire(%data, %player, %LaserCannon, %isLaserCannon)
{
   %data.lightStart = getSimTime();

   if(!%player.getMountedImage(0) == %isLaserCannon)
        return false;

   if(%player.chargeProjectile)
        %player.chargeProjectile.delete();

   %weapon = %player.getMountedImage(0).item;

   if(%player.client.mode[%weapon] == 1)
   {
      if(%player.LCC_Charge <= 1)
      {
         %player.LCC_Charge = 0;
         serverPlay3D(SniperRifleDryFireSound, %player.getTransform());
         return;
      }

      if(!%player.LaserCannon)
         return;

      %p = new SniperProjectile()
      {
         dataBlock        = "LaserCannonBolt";
         initialDirection = %player.getMuzzleVector(%LaserCannon);
         initialPosition  = %player.getMuzzlePoint(%LaserCannon);
         sourceObject     = %player;
         sourceSlot       = %LaserCannon;
         vehicleObject    = 0;
         damageFactor     = 0.5;
      };

      %obj.lastProjectile = %p;
      MissionCleanup.add(%p);
      serverPlay3D(SniperRifleFireSound, %player.getTransform());
      %p.setEnergyPercentage(getRandom(65535, 16384));

      if(%obj.client)
         %obj.client.projectile = %p;

      if (isObject(%player.lastProjectile) && %player.deleteLastProjectile)
           %player.lastProjectile.delete();

        %player.lastProjectile = %p;
        %player.deleteLastProjectile = %data.deleteLastProjectile;
        MissionCleanup.add(%p);
        %player.LCC_Charge -= 2;     

        if(%player.client)
            %player.client.projectile = %p;

        %player.LCC_pct = mFloor((%player.LCC_Charge / $LCC::Max) * 100);
        %out = graphBar100C(%player.LCC_pct, 25, 40, true);

      commandToClient( %player.client, 'BottomPrint', "Laser Charge Cannon >> Fire: "@%player.LCC_Charge@"/"@$LCC::Max@" ("@%player.LCC_Pct@"%)\n"@%out, 1, 2);
      schedule(500, 0, "LaserCannonFire", %data, %player, %LaserCannon, %isLaserCannon);
   }
   else if(%player.client.mode[%weapon] == 2)
   {
      if(%player.LCC_Charge <= 0)
      {
         %player.LCC_Charge = 0;
         serverPlay3D(SniperRifleDryFireSound, %player.getTransform());
         return;
      }

      if(!%player.LaserCannon)
         return;

         %t = new TargetProjectile()
         {
            dataBlock        = "LaserCannonBeam";
            initialDirection = %player.getMuzzleVector(%LaserCannon);
            initialPosition  = %player.getMuzzlePoint(%LaserCannon);
            sourceObject     = %player;
            sourceSlot       = %LaserCannon;
            vehicleObject    = 0;
         };
         MissionCleanup.add(%t);
         %t.schedule(100, delete);

      %p = new SniperProjectile()
      {
         dataBlock        = "LaserCannonBeem";
         initialDirection = %player.getMuzzleVector(%LaserCannon);
         initialPosition  = %player.getMuzzlePoint(%LaserCannon);
         sourceObject     = %player;
         sourceSlot       = %LaserCannon;
         vehicleObject    = 0;
         damageFactor     = 0.125;
      };

      %obj.lastProjectile = %p;
      MissionCleanup.add(%p);

      serverPlay3D(LCCBeamFireSound, %player.getTransform());

      if(%obj.client)
         %obj.client.projectile = %p;

      if (isObject(%player.lastProjectile) && %player.deleteLastProjectile)
           %player.lastProjectile.delete();

        %player.lastProjectile = %p;
        %player.deleteLastProjectile = %data.deleteLastProjectile;
        MissionCleanup.add(%p);
        %player.LCC_Charge--;     // start from scratch

        if(%player.client)
            %player.client.projectile = %p;

        %player.LCC_pct = mFloor((%player.LCC_Charge / $LCC::Max) * 100);
        %out = graphBar100C(%player.LCC_pct, 25, 40, true);

      commandToClient( %player.client, 'BottomPrint', "Laser Charge Cannon >> Fire: "@%player.LCC_Charge@"/"@$LCC::Max@" ("@%player.LCC_Pct@"%)\n"@%out, 1, 2);
      schedule(100, 0, "LaserCannonFire", %data, %player, %LaserCannon, %isLaserCannon);
   }
}

function LaserCannonCharge(%data, %player, %LaserCannon)       // should work....
{
     if(!isObject(%player))
          return;

     if(%player.LaserCannon)
     {
          if(%player.getMountedImage(0) == %player.lcc_LaserCannonOnHand)
          {
            if(!%player.isEMP)
            {
               %q = new ShockLanceProjectile()
               {
                  dataBlock        = "BasicShocker";
                  initialDirection = %player.getMuzzleVector(0);
                  initialPosition  = %player.getMuzzlePoint(0);
                  sourceObject     = %player;
                  sourceSlot       = 0;
               };
               MissionCleanup.add(%q);

               %c = getRandomB() ? %player.LCC_Charge++ : %player.LCC_Charge += getRandom(4, 2);

               if(%player.LCC_Charge > $LCC::Max)
                    %player.LCC_Charge = $LCC::Max;   // quick non-overcharge hack

               %player.LCC_pct = mFloor((%player.LCC_Charge / $LCC::Max) * 100);
               %out = graphBar100C(%player.LCC_pct, 25, 40);

               commandToClient( %player.client, 'BottomPrint', "Laser Charge Cannon >> Charge: "@%player.LCC_Charge@"/"@$LCC::Max@" ("@%player.LCC_Pct@"%)\n"@%out, 1, 2);
            }
            else
               %player.LCC_Charge = 0;

            schedule(100, 0, "LaserCannonCharge", %data, %player, %LaserCannon);
          }
     }
}

function LaserCannonGunImage::onFire(%data,%obj,%slot)
{
   if(!%obj.LaserCannon || !%obj.LaserCannon == true)
   {
      %obj.LaserCannon = true;

      %weapon = %obj.getMountedImage(0).item;
      if(%obj.client.mode[%weapon] == 0)
         schedule(50, 0, "LaserCannonCharge", %data, %obj, %slot);
      else 
      {
         %LaserCannonOnHand = %obj.getMountedImage(0);
         LaserCannonFire(%data, %obj, %slot, %LaserCannonOnHand);
      }
   }
}

function LaserCannonGunImage::onRelease(%data,%obj,%slot)
{
   %obj.LaserCannon = false;

   if(isObject(%obj.lc_laser))
      %obj.lc_laser.schedule(100, delete);

}
