if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// MASC PACK
// can be used by battle angel only
// while activated, doubles speed

datablock AudioProfile(MASCPackActivateSound)
{
	filename = "fx/weapons/targetinglaser_paint.wav";
	description = ClosestLooping3d;
    preload = true;
};

$MASCLandMod = 3.5;
$MASCWaterMod = 3.75;

datablock PlayerData(BattleAngelMaleHumanMASC) : BattleAngelMaleHumanArmor
{
   maxForwardSpeed = 5*Meltdown.RunSpeedMod*$MASCLandMod;
   maxBackwardSpeed = 4*Meltdown.RunSpeedMod*$MASCLandMod;
   maxSideSpeed = 4*Meltdown.RunSpeedMod*$MASCLandMod;

   maxUnderwaterForwardSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
   maxUnderwaterBackwardSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
   maxUnderwaterSideSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
};

datablock PlayerData(BattleAngelFemaleHumanMASC) : BattleAngelFemaleHumanArmor
{
   maxForwardSpeed = 5*Meltdown.RunSpeedMod*$MASCLandMod;
   maxBackwardSpeed = 4*Meltdown.RunSpeedMod*$MASCLandMod;
   maxSideSpeed = 4*Meltdown.RunSpeedMod*$MASCLandMod;

   maxUnderwaterForwardSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
   maxUnderwaterBackwardSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
   maxUnderwaterSideSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
};

datablock PlayerData(BattleAngelMaleBiodermMASC) : BattleAngelMaleBiodermArmor
{
   maxForwardSpeed = 5*Meltdown.RunSpeedMod*$MASCLandMod;
   maxBackwardSpeed = 4*Meltdown.RunSpeedMod*$MASCLandMod;
   maxSideSpeed = 4*Meltdown.RunSpeedMod*$MASCLandMod;

   maxUnderwaterForwardSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
   maxUnderwaterBackwardSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
   maxUnderwaterSideSpeed = 3*Meltdown.WaterRunSpeedMod*$MASCWaterMod;
};

datablock ShapeBaseImageData(MASCPackImage)
{
   shapeFile = "turret_belly_base.dts";
   item = MASCPack;
   mountPoint = 1;

   offset = "0 0 -0.2";
   rotation = "75 0 0 1";

   usesEnergy = true;
   minEnergy = 3;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "activate";
	stateSound[1] = MASCPackActivateSound;
   stateEnergyDrain[1] = 10;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateSequence[2] = "turn";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(MASCPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "turret_belly_base.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "MASCPackImage";
	pickUpName = "a MASC pack";
};

function MChangeArmor(%obj, %bool)
{
   %client = %obj.client;
   %client.lastArmorN = %obj.getDatablock().getName();

   %dmg = %obj.getDamageLevel();
   %nrg = %obj.getEnergyLevel();
   %rate = %obj.getRechargeRate();

   if(%bool)
      %am = "MASC";
   else
      %am = "Armor";

   %size = "BattleAngel";

   if (%client.race $= "Bioderm")
      // Only have male bioderms.
      %armor = %size @ "Male" @ %client.race @ %am;
   else
      %armor = %size @ %client.sex @ %client.race @ %am;

   %obj.setDataBlock(%armor);
   %client.armor = %size;
   %client.armorN = %obj.getDatablock().getName();

   %obj.setDamageLevel(%dmg);
   %obj.setRechargeRate(%rate);
   %obj.setEnergyLevel(%nrg);

//   %obj.playShieldEffect("0 0 1");
   if(%client.armorN !$= %client.lastArmorN)
   {
      %obj.zapObject();
      %obj.play3d("PBWSwitchSound");
   }
}

function MASCSwitch(%obj, %bool)
{
   %obj.MASCSwitchOn = %bool;

   if(%bool)
      messageClient(%obj.client, 'MsgMASCIF', '\c2Defense+ field detected, activating MASC.');
   else
      messageClient(%obj.client, 'MsgMASCOF', '\c2Defense+ field no longer detected, deactivating MASC.');

   MChangeArmor(%obj, %bool);

//   if(%bool)
//      messageClient(%obj.client, 'MsgMASCSigP', '\c2MASC signal detected. Increasing speed.');
//   else
//      messageClient(%obj.client, 'MsgMASCSigN', '\c2MASC signal lost. Decreasing speed.');
}

function MASCDet(%obj)
{
   if(%obj.MASCing)
   {
      if(%obj.inDEDField)
      {
         if(!%obj.MASCSwitchOn)
            MASCSwitch(%obj, true);

         %obj.setHeat(1.0);
      }
      else
      {
         if(%obj.MASCSwitchOn)
            MASCSwitch(%obj, false);
      }

      schedule(250, 0, "MASCDet", %obj);
   }
}

function MASCPackImage::onMount(%data, %obj, %node)
{
//   %obj.mountImage(MASCDecalImage, 7);
   bottomPrint(%obj.client, "You must be within 250m of a defense+ device to use the MASC.", 5, 1);
}

function MASCPackImage::onUnmount(%data, %obj, %node)
{
    %obj.setImageTrigger(%node, false);
    %obj.MASCing = "";
    MASCSwitch(%obj, false);
}

function MASCPackImage::onActivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgMASCMe', '\c2MASC pack on.');
   %obj.MASCing = true;
   MASCDet(%obj);
}

function MASCPackImage::onDeactivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgUNMASCMe', '\c2MASC pack off.');
   %obj.setImageTrigger(%slot,false);
   %obj.MASCing = "";
   MASCSwitch(%obj, false);
}

function MASCPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

