if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

datablock ShapeBaseImageData(MANTANukePackImage)
{
   shapeFile = "bomb.dts";
   item = MANTANukePack;
   mountPoint = 1;
   offset = "0 0 0";
   rotation = "1 0 0 90";

   usesEnergy = true;
   minEnergy = 1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(MANTANukePack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "bomb.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "MANTANukePackImage";
	pickUpName = "a manta ion nuke battery";
};

function MANTANukePackImage::onMount(%data, %obj, %node)
{
}

function MANTANukePackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
}

function MANTANukePackImage::onActivate(%data, %obj, %slot)
{
   %manta = checkMantaCanLoad(%obj);

   if(%manta)
   {
      if(%manta == 1)
      {
         messageClient(%obj.client, 'MsgMantaBatteryUseless', '\c2The MANTA is already loaded.');
         %obj.setImageTrigger(%slot, false);
         return;
      }
      else
      {
         if(%manta.usecount[nuke] $= "")
            %manta.usecount[nuke] = 0;

         if(%manta.usecount[nuke] < $Feature[MANTANukeUses])
         {
            messageClient(%obj.client, 'MsgMantaBatteryLoaded', '\c2Reloaded MANTA with Ion Nuke (%1/%2 used).', %manta.usecount[nuke], $Feature[MANTANukeUses]);
            %obj.unmountImage(%slot);
            %obj.decInventory(%data.item, 1);
            %manta.isLoaded = true;
            %manta.loadType = 2;
            %manta.lockduration = 20000;
            %manta.usecount[nuke]++;
            %manta.play3D(MBLSwitchSound);
            return;
         }
         else
            messageClient(%obj.client, 'MsgMantaNoMoreNuke', '\c2All %1 of your team\'s nukes has been used.', $Feature[MANTANukeUses]);
      }
   }
   else
   {
      messageClient(%obj.client, 'MsgMantaBatteryRange', '\c2There is no MANTA in range.');
      %obj.setImageTrigger(%slot, false);
      return;
   }
}

function MANTANukePackImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger(%slot,false);
}

function MANTANukePack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}
