if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//PlasmaCannon ------------------------------------------------------------------
datablock ShapeBaseImageData(PlasmaCannonPackImage)
{
   shapeFile = "pack_upgrade_ammo.dts";
   item = PlasmaCannonPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(PlasmaCannonPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   image = "PlasmaCannonPackImage";
	pickUpName = "a plasma cannon";
};

datablock ShapeBaseImageData(PlasmaCannonImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   offset = "-0.5 0 0.5";
   item = PlasmaCannonPack;
   rotation = "0 1 0 32";
   emap = true;
   mountPoint = 1;

   usesEnergy = true;
   fireEnergy = -1;
   minEnergy = -1;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   stateSequence[0]                 = "Deploy";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
//   stateSequence[2]                 = "Deploy";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.8;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
//   stateSequence[3]                 = "recoil";
//   stateSound[3]                    = PBLFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.3;
   stateAllowImageChange[4]         = false;
//   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
//   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
//   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(PlasmaCannonDImage)
{
   className = WeaponImage;
   shapeFile = "TR2weapon_mortar.dts";
   item = PlasmaCannonPack;
   offset = "-0.5 0 0.5";
   rotation = "0 1 0 32";
   emap = true;
   mountPoint = 1;

   usesEnergy = true;
   fireEnergy = -1;
   minEnergy = -1;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   stateSequence[0]                 = "Deploy";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
//   stateSequence[2]                 = "Deploy";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.8;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
//   stateSequence[3]                 = "Fire";
//   stateSound[3]                    = PBLFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.3;
   stateAllowImageChange[4]         = false;
//   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
//   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
//   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

function PlasmaCannonPackImage::onMount(%this,%obj,%slot)
{
   if(%obj.client.race $= Bioderm)
      %obj.mountImage(PlasmaCannonDImage, 7);
   else
      %obj.mountImage(PlasmaCannonImage, 7);
}

function PlasmaCannonPackImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage(7);
}

function LPCFireTimeoutClear(%obj)
{
   %obj.fireTimeoutLPC = 0;
}

function PlasmaCannonPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.fireTimeoutLPC)
      return;

   if(%obj.getEnergyLevel() >= 50)
   {
      %p = new LinearFlareProjectile()
      {
         dataBlock        = PlasmaBarrelBolt;
         initialDirection = %obj.getMuzzleVector(7);
         initialPosition  = %obj.getMuzzlePoint(7);
         sourceObject     = %obj;
         sourceSlot       = 7;
      };
      MissionCleanup.add(%p);
      %obj.useEnergy(50);
      %obj.setImageTrigger(7, true);
      %obj.play3D(PBLFireSound);
      %obj.fireTimeoutLPC = 1100;
      schedule(%obj.fireTimeoutLPC, 0, "LPCFireTimeoutClear", %obj);
   }
   %obj.setImageTrigger(%slot, false);
}

function PlasmaCannonPackImage::onDeactivate(%data, %obj, %slot)
{
   %obj.setImageTrigger(7, false);
	%obj.setImageTrigger(%slot,false);
}

function PlasmaCannonPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}
