// ------------------------------------------------------------------

datablock ShapeBaseImageData(PulseCannonPackImage)
{
   shapeFile = "pack_upgrade_ammo.dts";
   item = PulseCannonPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(PulseCannonPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "PulseCannonPackImage";
	pickUpName = "a dual pulse cannon";
};

datablock ShapeBaseImageData(PulseCannon2DImage)
{
   className = WeaponImage;
   shapeFile = "turret_mortar_large.dts";
   item = Blaster;
   offset = "-0.5 0 0.5";
   rotation = "0 1 0 180";
   emap = true;
   mountPoint = 1;
   
   usesEnergy = true;
   fireEnergy = 20;
   minEnergy = 20;
   
   projectile = BomberFusionBolt;
   projectileType = LinearFlareProjectile;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateSequence[2]                 = "Deploy";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.25;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateSound[3]                    = PulseCannonFire;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.25;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(PulseCannonDImage) : PulseCannon2DImage
{
   offset = "0.5 0 0.5";
   stateSequence[2]                 = "Deploy";
   stateScript[3] = "onFire";
};

datablock ShapeBaseImageData(PulseCannon2Image)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   item = Blaster;
   offset = "-0.5 0 0.45";
   rotation = "0 1 0 45";
   emap = true;
   mountPoint = 1;
   
   usesEnergy = true;
   fireEnergy = 20;
   minEnergy = 20;
   
   projectile = BomberFusionBolt;
   projectileType = LinearFlareProjectile;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateSequence[2]                 = "Deploy";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.25;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "recoil";
   stateSound[3]                    = PulseCannonFire;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.25;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(PulseCannonImage) : PulseCannon2Image
{
   offset = "0.35 0 0.6";
   rotation = "0 1 0 -45";

   stateSequence[2]                 = "Deploy";
   stateScript[3] = "onFire";
};

function PulseCannonPackImage::onMount(%this,%obj,%slot)
{
   if(%obj.client.race $= Bioderm)
   {
      %obj.mountImage(PulseCannonDImage, 1);
      %obj.mountImage(PulseCannon2DImage, 7);
   }
   else
   {
      %obj.mountImage(PulseCannonImage, 1);
      %obj.mountImage(PulseCannon2Image, 7);
   }

   %obj.pulsecannonpack = true;
}

function PulseCannonPackImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage(1);
   %obj.unmountImage(7);
   %obj.pulsecannonpack = false;
}

function PulseCannonPackImage::onActivate(%data, %obj, %slot)
{
   %obj.setImageTrigger(0, false);

   %obj.setImageTrigger(1, true);
   %obj.setImageTrigger(7, true);
   %obj.setImageTrigger(%slot, false);
}

function PulseCannonPackImage::onDeactivate(%data, %obj, %slot)
{
   %obj.setImageTrigger(1, false);
   %obj.setImageTrigger(7, false);
	%obj.setImageTrigger(%slot,false);
}

function PulseCannonPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

function PulseCannonImage::onFire(%data, %obj, %slot)
{
   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(1);
      initialPosition  = %obj.getMuzzlePoint(1);
      sourceObject     = %obj;
      sourceSlot       = 1;
   };
   MissionCleanup.add(%p);
   %obj.lastProjectile = %p;
   %client.projectile = %p;
   %obj.useEnergy(20);
   return PulseCannon2Image::onFire(PulseCannon2Image,%obj,7);
}

function PulseCannon2Image::onFire(%data,%obj,%slot)
{
   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
   };
   MissionCleanup.add(%p);
   %obj.lastProjectile = %p;
   %client.projectile = %p;
}

function PulseCannonDImage::onFire(%data, %obj, %slot)
{
   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(1);
      initialPosition  = %obj.getMuzzlePoint(1);
      sourceObject     = %obj;
      sourceSlot       = 1;
   };
   MissionCleanup.add(%p);
   %obj.lastProjectile = %p;
   %client.projectile = %p;
   %obj.useEnergy(20);
   return PulseCannon2DImage::onFire(PulseCannon2Image,%obj,7);
}

function PulseCannon2DImage::onFire(%data,%obj,%slot)
{
   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
   };
   MissionCleanup.add(%p);
   %obj.lastProjectile = %p;
   %client.projectile = %p;
}
