if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// RAXX PAXX... lol

datablock AudioProfile(RAXXFireSound)
{
   filename    = "fx/vehicles/shrike_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock ShapeBaseImageData(RAXXDecalImage)
{
   mountPoint = 1;
   shapeFile = "pack_deploy_turreti.dts";
   offset = "0.16 0 0";
   rotation = "0 1 0 180";
};

datablock ShapeBaseImageData(RAXXPackImage)
{
   shapeFile = "pack_deploy_turreti.dts";
   item = RAXXPack;
   mountPoint = 1;
   offset = "-0.16 0 0";
   rotation = "0 1 0 180";
   emap = true;

   gun = RAXXGunImage;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateSequence[1] = "fire";
   stateSound[1] = RAXXPackActivateSound;
   stateTransitionOnTriggerUp[1] = "Deactivate";

   stateName[2] = "Deactivate";
   stateScript[2] = "onDeactivate";
   stateTransitionOnTimeout[2] = "Idle";   
};

datablock ItemData(RAXXPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_deploy_turreti.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "RAXXPackImage";
   pickUpName = "a RAXX pack";

   emap = true;
};

//--------------------------------------------------------------------------
// RAXX Gun

datablock LinearProjectileData(RAXXFlame)
{
   projectileShapeName = "plasmabolt.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.1;
   damageRadius        = 6;
   radiusDamageType    = $DamageType::Plasma;
   kickBackStrength    = 1;
   baseEmitter         = SmallFlameEmitter;
   bubbleEmitter       = MortarBubbleEmitter;

   sound 				= GrenadeProjectileSound;
   explosion           = "PlasmaBoltExplosion";
   splash              = PlayerSplash;

   dryVelocity       = 80;
   wetVelocity       = -1;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 520;
   lifetimeMS        = 520;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 32;

   activateDelayMS = 1;

   hasLight    = true;
   lightRadius = 6;
   lightColor  = "1 0.8 0.01";
};

datablock ShapeBaseImageData(RAXXGunImage)
{
   className = WeaponImage;
   shapeFile = "turret_tank_barrelchain.dts";
   item = Disruptor;
   usesEnergy = true;
   minEnergy = 6;
   fireEnergy = 2;

   projectile = RAXXFlame;
   projectileType = LinearProjectile;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activation";
   stateSound[0] = PlasmaSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "CheckWet";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Fire";
   stateTransitionOnNoAmmo[3] = "NoAmmo";
   stateTransitionOnTriggerUp[3] = "Reload";
   stateTimeoutValue[3] = 0.0375;
   stateFire[3] = true;
//   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
   stateEmitter[3]       = "SmallFlameEmitter";
   stateEmitterTime[3]       = 0.2;
   stateEmitterNode[3]       = 0;
   stateSequence[3] = "Fire_Vis";
   stateSound[3] = RAXXFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.5;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = PlasmaReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = PlasmaDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";

   stateName[7]       = "WetFire";
   stateSound[7]      = PlasmaFireWetSound;
   stateTimeoutValue[7]        = 1.5;
   stateTransitionOnTimeout[7] = "Ready";

   stateName[8]               = "CheckWet";
   stateTransitionOnWet[8]    = "WetFire";
   stateTransitionOnNotWet[8] = "Fire";
};
function RAXXPackImage::onMount(%data, %obj, %node)
{
   %obj.mountImage(RAXXDecalImage, 7);
}

function RAXXPackImage::onUnmount(%data, %obj, %node)
{
    %obj.unmountImage(7);
   // dismount the RAXX gun if the player had it mounted
   // need the extra "if" statement to avoid a console error message
   if(%obj.getMountedImage($WeaponSlot))
      if(%obj.getMountedImage($WeaponSlot).getName() $= "RAXXGunImage")
         %obj.unmountImage($WeaponSlot);
}

function RAXXPackImage::onActivate(%data, %obj, %slot)
{
   // don't activate the pack if player is piloting a vehicle
   if(%obj.isPilot())
   {
      %obj.setImageTrigger(%slot, false);
      return;
   }

   if(!isObject(%obj.getMountedImage($WeaponSlot)) || %obj.getMountedImage($WeaponSlot).getName() !$= "RAXXGunImage")
   {
      // unmount any weapon the player may have been holding
      if(%obj.getMountedImage($WeaponSlot))
         %obj.unmountImage($WeaponSlot);

      // make sure player's arm thread is "look"
      %obj.setArmThread(look);

      // mount the RAXX gun
      %obj.mountImage(RAXXGunImage, $WeaponSlot);
//      commandToClient(%obj.client, 'setRepairReticle');
      %obj.client.setWeaponsHudActive("MissileLauncher");
   }
}

function RAXXPackImage::onDeactivate(%data, %obj, %slot)
{
   //called when the player hits the "pack" key again (toggle)
   %obj.setImageTrigger(%slot, false);
   if(%obj.getMountedImage($WeaponSlot).getName() $= "RAXXGunImage")
      %obj.unmountImage($WeaponSlot);
}

datablock ShapeBaseImageData(RAXXDecalAImage)
{
   shapeFile = "ammo_disc.dts";
   offset = "0 0.9 0";
   rotation = "1 0 0 90";
};

datablock ShapeBaseImageData(RAXXDecalBImage)
{
   shapeFile = "ammo_disc.dts";
   offset = "0 0.35 0";
   rotation = "1 0 0 90";
};

datablock ShapeBaseImageData(RAXXDecalCImage)
{
   shapeFile = "repair_patch.dts";
   offset = "0 0.6 0";
   rotation = "1 0 0 90";
};

function RAXXGunImage::onMount(%this,%obj,%slot)
{
   //-Nite- rewrote this =[ no jetpack right?
   commandToClient( %obj.client, 'BottomPrint', "<font:times new roman:18>Now using a RAXX Flamethrower\nThis is a deadly short-range flamethrower.", 5, 2);
   //commandToClient( %obj.client, 'BottomPrint', "<font:times new roman:18>Now using a RAXX Flamethrower\nThis is a deadly short-range flamethrower.\nUse it on the jetpack for a surprise!", 5, 3);
   %obj.setImageAmmo(%slot,true);
   %obj.mountImage(RAXXDecalAImage, 4);
   %obj.mountImage(RAXXDecalBImage, 5);
   %obj.mountImage(RAXXDecalCImage, 6);
}

function RAXXGunImage::onUnmount(%this,%obj,%slot)
{
   %obj.setImageTrigger(%slot, false);
   %obj.setImageTrigger($BackpackSlot, false);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}

function RAXXPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}
