if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//STARHAMMER ------------------------------------------------------------------

datablock AudioProfile(StarHammerFireSound)
{
   filename    = "fx/misc/launcher.wav";
//   description = AudioDefault3d;
   description = AudioExplosion3d;
   preload = true;
};

datablock AudioProfile(StarHammerReloadSound)
{
   filename    = "fx/misc/cannonstart.wav";
   description = AudioExplosion3d;
   preload = true;
};

datablock LinearProjectileData(SBRocket)
{
   projectileShapeName = "weapon_missile_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 1.3; //-Nite- 1.5 its been this damage sense 1269 or longer..My source doesnt go back that far
   damageRadius        = 15.0;
   radiusDamageType    = $DamageType::StarHammer;
   kickBackStrength    = 2000;
   bubbleEmitTime      = 1.0;

   explosion           = "ImpactMortarExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;

//   baseEmitter         = MissileSmokeEmitter;
//   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   dryVelocity       = 150;
   wetVelocity       = 75;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;

   activateDelayMS = -1;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.175 0.175 0.5";
};

datablock ShapeBaseImageData(StarHammerPackImage)
{
   shapeFile = "pack_upgrade_ammo.dts";
   item = StarHammerPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(StarHammerPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   image = "StarHammerPackImage";
	pickUpName = "a star hammer";
};

datablock ShapeBaseImageData(StarHammerImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   offset = "-0.5 0 0.5";
   item = StarHammerPack;
   rotation = "0 1 0 32";
   emap = true;
   mountPoint = 1;

   usesEnergy = true;
   fireEnergy = -1;
   minEnergy = -1;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   stateSequence[0]                 = "Deploy";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
//   stateSequence[2]                 = "Deploy";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 1.0;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
//   stateSequence[3]                 = "recoil";
//   stateSound[3]                    = DiscFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.5;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
//   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
//   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(StarHammerDImage)
{
   className = WeaponImage;
   shapeFile = "TR2weapon_mortar.dts"; //turret_mortar_large.dts";
   item = StarHammerPack;
   offset = "-0.5 0 0.5";
   rotation = "0 1 0 32";
   emap = true;
   mountPoint = 1;

   usesEnergy = true;
   fireEnergy = -1;
   minEnergy = -1;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   stateSequence[0]                 = "Deploy";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 1.0;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
//   stateSequence[3]                 = "Fire";
//   stateSound[3]                    = DiscFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.5;
   stateAllowImageChange[4]         = false;
//   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
//   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
//   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};
//  -Nite- mech
//datablock ShapeBaseImageData(StarHammerMImage)
//{
//   className = WeaponImage;
//   shapeFile = "TR2weapon_mortar.dts"; //turret_mortar_large.dts";
//   item = StarHammerPack;
//   offset = "-0.75 0.75 1.0";
//   rotation = "0 1 0 32";
//   emap = true;
//   mountPoint = 1;
//
//   usesEnergy = true;
//   fireEnergy = -1;
//   minEnergy = -1;
//
//   // State Data
//   stateName[0]                     = "Preactivate";
//   stateTransitionOnLoaded[0]       = "Activate";
//   stateTransitionOnNoAmmo[0]       = "NoAmmo";
//   stateSequence[0]                 = "Deploy";
//
//   stateName[1]                     = "Activate";
//   stateTransitionOnTimeout[1]      = "Ready";
//   stateTimeoutValue[1]             = 0.5;
//
//   stateName[2]                     = "Ready";
//   stateTransitionOnNoAmmo[2]       = "NoAmmo";
//   stateTransitionOnTriggerDown[2]  = "Fire";
//
//   stateName[3]                     = "Fire";
//   stateTransitionOnTimeout[3]      = "Reload";
//   stateTimeoutValue[3]             = 1.0;
//   stateFire[3]                     = true;
//   stateAllowImageChange[3]         = false;
//   stateSequence[3]                 = "Fire";
//   stateSound[3]                    = DiscFireSound;
//
//   stateName[4]                     = "Reload";
//   stateTransitionOnNoAmmo[4]       = "NoAmmo";
//   stateTransitionOnTimeout[4]      = "Ready";
//   stateTimeoutValue[4]             = 0.5;
//   stateAllowImageChange[4]         = false;
//   stateSequence[4]                 = "Reload";
//
//   stateName[5]                     = "NoAmmo";
//   stateTransitionOnAmmo[5]         = "Reload";
//   stateSequence[5]                 = "NoAmmo";
//   stateTransitionOnTriggerDown[5]  = "DryFire";
//
//   stateName[6]                     = "DryFire";
//   stateSound[6]                    = MortarDryFireSound;
//   stateTimeoutValue[6]             = 1.0;
//   stateTransitionOnTimeout[6]      = "NoAmmo";
//};

function StarHammerPackImage::onMount(%this,%obj,%slot)
{
   //if(%obj.getDatablock().isTacticalMech)   -Nite-
    //  %obj.mountImage(StarHammerMImage, 7);
    if(%obj.client.race $= Bioderm)
      %obj.mountImage(StarHammerDImage, 7);
   else
      %obj.mountImage(StarHammerImage, 7);
}

function StarHammerPackImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage(7);
}

function SHCFireTimeoutClear(%obj)
{
   %obj.fireTimeoutSHC = 0;
   %obj.play3d(StarHammerReloadSound);
}

function StarHammerPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.fireTimeoutSHC)
      return;

   %obj.setImageTrigger(0, false);

   if(%obj.getEnergyLevel() >= 75)
   {
      %p = new LinearProjectile()
      {
         dataBlock        = SBRocket;
         initialDirection = %obj.getMuzzleVector(7);
         initialPosition  = %obj.getMuzzlePoint(7);
         sourceObject     = %obj;
         sourceSlot       = 7;
      };
      MissionCleanup.add(%p);

      %obj.useEnergy(75);
      %obj.setImageTrigger(7, true);
      spawnProjectile(%p, LinearFlareProjectile, MBDisplayCharge);
      projectileTrail(%p, 64, LinearFlareProjectile, ReaverCharge, true);
//      %obj.play3d(DiscFireSound);
      %obj.play3d(StarHammerFireSound);
      %obj.fireTimeoutSHC = 1500;
      schedule(%obj.fireTimeoutSHC, 0, "SHCFireTimeoutClear", %obj);
   }
   %obj.setImageTrigger(%slot, false);

}

function StarHammerPackImage::onDeactivate(%data, %obj, %slot)
{
   %obj.setImageTrigger(7, false);
	%obj.setImageTrigger(%slot,false);
}

function StarHammerPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}
