if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// Angel PACK

datablock AudioProfile(AngelPackActivateSound)
{
	filename = "fx/vehicles/tank_engine.wav";
	description = AudioDefaultLooping3d;
    preload = true;
};

datablock ShapeBaseImageData(AngelPackImage)
{
   shapeFile = "deploy_inventory.dts";
   item = AngelPack;
   mountPoint = 1;

   offset = "0 0.2 -0.375";
   rotation = "0 1 0 0";

   usesEnergy = true;
   minEnergy = 3;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "deploy";
	stateSound[1] = AngelPackActivateSound;
   stateEnergyDrain[1] = 8;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateSequence[2] = "activate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(AngelPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_deploy_inventory.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "AngelPackImage";
	pickUpName = "a pair of angels wings";
};

$Xi::AngelPackMinSpeed = -20;
$Xi::AngelPackMaxSpeed = 20;

function Angel(%obj)
{
   if(%obj.Angeling)
   {
      if(%obj.Xi_AngelPackSpeed == 0)
      {
         %obj.setHeat(1.0);
         %obj.setVelocity("0 0 0.91");
         %obj.useEnergy(1.5 / 20);
         schedule(50, 0, "Angel", %obj);
      }
      else
      {
         if(!%obj.inDEDField)
         {
            %angelPct = mAbs(%obj.Xi_AngelPackSpeed) / $Xi::AngelPackMaxSpeed;
            %energyUse = (%angelPct * 6) / 5; // 2.5
            %obj.useEnergy(%energyUse);
         }

         %obj.setHeat(1.0);
         %vec = vectorNormalize(%obj.getMuzzleVector(0));
         %obj.setVelocity(vectorScale(%vec, %obj.Xi_AngelPackSpeed));
         schedule(50, 0, "Angel", %obj);
      }
   }
}

function AngelPackImage::onMount(%data, %obj, %node)
{
    %obj.Angeling = "";
}

function AngelPackImage::onUnmount(%data, %obj, %node)
{
    %obj.setImageTrigger(%node, false);
    %obj.Angeling = "";
}

function AngelPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.Xi_AngelPackSpeed $= "")
      %obj.Xi_AngelPackSpeed = 15;

   messageClient(%obj.client, 'MsgAngelsFly', '\c2Angels Wings mounted.');
   %obj.Angeling = true;
   Angel(%obj);
}

function AngelPackImage::onDeactivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgAngelsGoToHotPlace', '\c2Angels Wings dismounted.');
   %obj.setImageTrigger(%slot,false);
   %obj.Angeling = "";
   %obj.setVelocity("0 0 0");
}

function AngelPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

