if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// Hover PACK
// can be used by any armor type
// while activated, absorbs damage at cost of energy

datablock AudioProfile(HoverPackActivateSound)
{
	filename = "fx/vehicles/outrider_engine.wav";
	description = ClosestLooping3d;
    preload = true;
};

datablock ShapeBaseImageData(HoverDecalImage)
{
   mountPoint = 1;
   shapeFile = "ammo_mortar.dts";
   offset = "0.15 -0.275 0";
   rotation = "0 1 0 90";
};

datablock ShapeBaseImageData(HoverPackImage)
{
   shapeFile = "ammo_mortar.dts";
   item = HoverPack;
   mountPoint = 1;

   offset = "-0.15 -0.275 0";
   rotation = "0 1 0 90";

   usesEnergy = true;
   minEnergy = 3;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = HoverPackActivateSound;
   stateEnergyDrain[1] = 9;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(HoverPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "HoverPackImage";
	pickUpName = "a hover pack";
};

function hover(%obj)
{
   if(%obj.hovering)
   {
      %vel = %obj.getVelocity();
      %sVel = velToSingle(%vel, true);

      if(%sVel > 3)
         %obj.setVelocity(vectorScale(%obj.hp_moveVector, (%sVel - 0.6*(1/%sVel))));
      else
         %obj.setVelocity("0 0 0.91");

      %obj.setHeat(1.0);
      %obj.playShieldEffect("0 0 1");
      schedule(50, 0, "hover", %obj);
   }
}

function HoverPackImage::onMount(%data, %obj, %node)
{
   %obj.mountImage(HoverDecalImage, 7);
}

function HoverPackImage::onUnmount(%data, %obj, %node)
{
    %obj.setImageTrigger(%node, false);
    %obj.hovering = "";
    %obj.unmountImage(7);
}

function HoverPackImage::onActivate(%data, %obj, %slot)
{
   messageClient(%obj.client, '', '\c2Hover pack on.');
   %obj.hovering = true;
   %obj.hp_moveVector = vectorNormalize(%obj.getVelocity());
   hover(%obj);
}

function HoverPackImage::onDeactivate(%data, %obj, %slot)
{
   messageClient(%obj.client, '', '\c2Hover pack off.');
   %obj.setImageTrigger(%slot,false);
   %obj.hovering = "";
}

function HoverPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

