if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Jet Pack

datablock AudioProfile(JetPackActivateSound)
{
   filename    = "fx/vehicles/outrider_engine.wav";
   description = ClosestLooping3d;
   preload = true;
};

// Scout
datablock AudioProfile(JetPackThrustSound)
{
   filename    = "fx/vehicles/bomber_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock ShapeBaseImageData(JPDecalImage)
{
   mountPoint = 1;
   shapeFile = "turret_tank_barrelchain.dts";
   offset = "-0.2 -0.25 0";
   rotation = "1 0 0 90";
   emap = true;
};

datablock ShapeBaseImageData(JetPackImage)
{
   shapeFile = "turret_tank_barrelchain.dts"; //"turret_fusion_large.dts";
   item = JetPack;
   mountPoint = 1;
   offset = "0.25 -0.25 0";
   rotation = "1 0 0 90";
   emap = true;

   usesEnergy = true;
   minEnergy = 3;
   isLarge = true;
   gun = JetGunImage;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onActivate";
   stateSequence[1] = "Deploy";
   stateEmitterTime[1] = 1;
   stateEmitter[1] = "LightDamageSmoke";
   stateEmitterNode[1] = 0;
   stateEnergyDrain[1] = 8.1;
   stateSound[1] = JetPackActivateSound;
   stateTransitionOnTriggerUp[1] = "Deactivate";

   stateName[2] = "Deactivate";
   stateSequence[2] = "fire";
   stateScript[2] = "onDeactivate";
   stateTransitionOnTimeout[2] = "Idle";   
};

datablock ItemData(JetPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_barrel_fusion.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   isLarge = true;
   image = "JetPackImage";
   pickUpName = "a jet pack";

   emap = true;
};

datablock ShapeBaseImageData(JetGunImage)
{
   shapeFile = "weapon_targeting.dts";
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 3;
   emap = true;

   stateName[0] = "Idle";
   stateTransitionOnTriggerDown[0] = "Activate";

   stateName[1] = "Activate";
   stateScript[1] = "onFire";
   stateSound[1] = JetPackThrustSound;
   stateTransitionOnTriggerUp[1] = "Deactivate";

   stateName[2] = "Deactivate";
   stateScript[2] = "onStop";
   stateTransitionOnTimeout[2] = "Idle";
};

$HoverSpeed =  0.91; //1.375;
$JetpackMaxSpeed = 57.6;
$JetpackStartSpeed = 4;

function coolOffJetpack(%obj)
{
   if(isObject(%obj) && !%obj.jetpacking && %obj.jetpackMounted)
   {
      if(%obj.jp_heatcount > 0)
      {
         if(%obj.jp_heatcount >= 2000)
         {
            BASelfDestruct(%obj);
            %obj.jp_heatcount = 0;
         }

         if(%obj.isWet)
            %obj.jp_heatcount -= 6;
         else
            %obj.jp_heatcount -= 2;

         if(%obj.jp_heatcount < 0)
            %obj.jp_heatcount = 0;
      }
      schedule(250, %obj, "coolOffJetpack", %obj);
   }
}

function jet(%obj)
{
   if(%obj.holdingFlag)
   {
          %client = %obj.client;
          %flag = %obj.holdingFlag;
          %flag.setVelocity("0 0 0");
          %flag.setTransform(%obj.getWorldBoxCenter());
          %flag.setCollisionTimeout(%obj);
          %obj.throwObject(%flag);
          messageClient(%obj.client, 'MsgJetNoFlag', '\c1You cannot use JetPack and flag at the same time.');
   }

   if(%obj.isWet)
   {
      %obj.setImageTrigger($BackpackSlot, false);
      messageClient(%obj.client, 'MsgJetWateredDown', '\c2ERROR! JetPack waterlogged!');
      %obj.setHeat(1.0);
      return;
   }

   if(%obj.getEnergyLevel() > 3)
   {
      if(%obj.jetpacking)
      {
         %obj.disableSwitch = false;

         if(%obj.jetpackTriggered)
         {
            %vel = %obj.getVelocity();
            %sVel = velToSingle(%vel, true);
            %vec = vectorNormalize(%obj.getMuzzleVector(0));
            if(%sVel <= $JetpackStartSpeed)
               %sVel = $JetpackStartSpeed;

            if(%sVel < $JetpackMaxSpeed)
               %obj.setVelocity(vectorScale(%vec, (%sVel+1.333333)));
            else
               %obj.setVelocity(vectorScale(%vec, $JetpackMaxSpeed));

            %obj.jp_heatcount += 2;

            %obj.useEnergy(0.166); // 0.2
         }
         else
         {
            %vel = %obj.getVelocity();
            %sVel = velToSingle(%vel, true);

            %obj.jp_heatcount++;

            if(%sVel > 3)
               %obj.setVelocity(vectorScale(%obj.jp_moveVector, (%sVel - (25/%sVel))));
            else
               %obj.setVelocity("0 0 0.91");
         }

         %obj.setHeat(1.0);
         %kph = mFloor(msToKPH(velToSingle(%obj.getVelocity(), true)));

         if(%obj.jp_heatcount >= 2000)
         {
            JPSelfDestruct(%obj);
            %obj.jp_heatcount = 0;
         }

         %obj.jp_heatPct = mFloor((%obj.jp_heatcount / 2000) * 100);

         if(%obj.jp_heatPct < 45)
            %color = "<color:00FF00>";
         else if(%obj.jp_heatPct < 75)
            %color = "<color:FFFF00>";
         else
            %color = "<color:FF0000>";

         commandToClient(%obj.client, 'BottomPrint', ">> Jet Pack << | Speed: "@%kph@" KPH | "@%color@"Heat level: "@%obj.jp_heatPct@"%", 1, 1);
         schedule(50, %obj, "jet", %obj);
      }
   }
   else
   {
      %obj.setImageTrigger(%slot, false);

      if((isObject(%obj.getMountedImage(0))) && (%obj.getMountedImage(0).getName() $= "JetGunImage"))
      {
         %obj.unmountImage(0);
         coolOffJetpack(%obj);
      }

      %obj.jetpacking = "";
      %obj.disableSwitch = false;
   }
}

function JetPackImage::onUnmount(%data, %obj, %node)
{
   if(%obj.getMountedImage($WeaponSlot))
      if(%obj.getMountedImage($WeaponSlot).getName() $= "JetGunImage")
         %obj.unmountImage($WeaponSlot);

   %obj.jetpacking = "";
   %obj.jetpackMounted = true;
   %obj.disableSwitch = false;
   %obj.unmountImage(7);
}

function JetPackImage::onMount(%data, %obj, %node)
{
   %obj.jp_heatcount = 0;
   %obj.jetpackMounted = true;
   %obj.mountImage(JPDecalImage, 7);
   coolOffJetpack(%obj);
}

function JetPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.isWet)
   {
      %obj.setImageTrigger(%slot, false);
      messageClient(%obj.client, 'MsgJetDrowned', "\c2JetPack cannot be used underwater.");
      return;
   }

   if(%obj.jetActiveTimeout)
   {
      %obj.setImageTrigger(%slot, false);
      messageClient(%obj.client, 'MsgJetMinC', "\c2Jetpack is not ready; please wait a few seconds.");
      return;
   }

   if(%obj.getEnergyPct() < 0.95)
   {
      %obj.setImageTrigger(%slot, false);
      messageClient(%obj.client, 'MsgJetMinP', "\c2Jetpack must have at least 95% power to ignite the engines.");
      return;
   }

   commandToClient( %obj.client, 'BottomPrint', "To use the jetpack, press fire.", 4, 1);
   %obj.jetpacking = true;
   %obj.disableSwitch = true;
   messageClient(%obj.client, 'MsgJetInit', "\c2JetPack is initialising...");
   %obj.setHeat(1.0);
   %obj.jp_moveVector = vectorNormalize(%obj.getVelocity());
   schedule(1100, 0, "jet", %obj);
   %obj.useEnergy(10);

   if(!isObject(%obj.getMountedImage($WeaponSlot)) || %obj.getMountedImage($WeaponSlot).getName() !$= "JetGunImage")
   {
      if(%obj.getMountedImage($WeaponSlot))
         %obj.unmountImage($WeaponSlot);
      %obj.setArmThread(look);
      %obj.mountImage(JetGunImage, $WeaponSlot);
      commandToClient(%obj.client, 'setRepairReticle');  // hjejeje
   }
}

function jetActiveTimeoutClear(%obj)
{
   %obj.jetActiveTimeout = 0;
}

function JetPackImage::onDeactivate(%data, %obj, %slot)
{
   %obj.setImageTrigger(%slot, false);
   if(%obj.getMountedImage($WeaponSlot).getName() $= "JetGunImage")
      %obj.unmountImage($WeaponSlot);

     %obj.jetpacking = "";
   %obj.disableSwitch = false;
}

function JetGunImage::onMount(%this,%obj,%slot)
{
   %obj.setImageAmmo(%slot,true);
   %obj.jetpacking = true;
   %obj.disableSwitch = true;
}

function JetGunImage::onFire(%this,%obj,%slot)
{
   %obj.jetpackTriggered = true;
}

function JetGunImage::onStop(%this,%obj,%slot)
{
   %obj.jetpackTriggered = "";
   %obj.jp_moveVector = vectorNormalize(%obj.getVelocity());
}

function JetGunImage::onUnmount(%this,%obj,%slot)
{
   %obj.setImageTrigger(%slot, false);
   %obj.setImageTrigger($BackpackSlot, false);
   %obj.jetpackTriggered = "";
   %obj.jetpacking = "";
   %obj.disableSwitch = false;
   coolOffJetpack(%obj);

   %obj.jetActiveTimeout = 3000;
   schedule(%obj.jetActiveTimeout, 0, "jetActiveTimeoutClear", %obj);
}

function JetPack::onPickup(%this, %obj, %shape, %amount)
{
   // created to prevent console errors
}
