// ------------------------------------------------------------------
// SHIELD PACK
// can be used by any armor type
// while activated, absorbs damage at cost of energy

datablock AudioProfile(ShieldPackActivateSound)
{
	filename = "fx/packs/shield_on.wav";
	description = ClosestLooping3d;
    preload = true;
};

datablock ShapeBaseImageData(ShieldPackImage)
{
   shapeFile = "pack_upgrade_shield.dts";
   item = ShieldPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = 3;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = ShieldPackActivateSound;
   stateEnergyDrain[1] = 8.666;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(ShieldPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_shield.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "ShieldPackImage";
	pickUpName = "a shield pack";

   computeCRC = true;
};

datablock AudioProfile(BASSEnterSound)
{
   filename    = "fx/powered/nexus_deny.wav";
   description = AudioDefault3d;
   preload = true;
};

function ShieldPackImage::onMount(%data, %obj, %node)
{
}

function ShieldPackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
   %obj.isShielded = "";
   %obj.isShieldedBASS = "";
   %obj.playedBASSSound = false;
}

function BASSDetLoop(%obj)
{
   if(isObject(%obj))
   {
      if(%obj.isShieldedBASS)
      {
         if(%obj.inDEDField)
         {
            if(!%obj.playedBASSSound)
            {
               %obj.playedBASSSound = true;
               %obj.playShieldEffect("0 0 1");
               %obj.play3d("BASSEnterSound");
            }
         }
         else
         {
            if(%obj.playedBASSSound)
            {
               %obj.playedBASSSound = false;
               %obj.playShieldEffect("0 0 1");
               %obj.play3d("BASSEnterSound");
            }
         }
         schedule(250, 0, "BASSDetLoop", %obj);
      }
   }
}

function ShieldPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.getDatablock().isBattleAngel)
   {
      messageClient(%obj.client, 'MsgShieldBASSOn', '\c2Battle Angel Shield System (BASS) enabled.');
      %obj.isShieldedBASS = true;
      BASSDetLoop(%obj);
   }
   else
   {
      messageClient(%obj.client, 'MsgShieldPackOn', '\c2Shield pack on.');
      %obj.isShielded = true;
   }
   commandToClient( %obj.client, 'setShieldIconOn' );
}

function ShieldPackImage::onDeactivate(%data, %obj, %slot)
{
   if(%obj.getDatablock().isBattleAngel)
   {
      messageClient(%obj.client, 'MsgShieldBASSOff', '\c2Battle Angel Shield System (BASS) disabled.');
      %obj.isShieldedBASS = "";
      %obj.playedBASSSound = false;
   }
   else
   {
      messageClient(%obj.client, 'MsgShieldPackOff', '\c2Shield pack off.');
      %obj.isShielded = "";
   }

	%obj.setImageTrigger(%slot,false);
   commandToClient( %obj.client, 'setShieldIconOff' );
}

function ShieldPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

