if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

$WormholeExistanceTime = 60000;

// ------------------------------------------------------------------
// Slipstream IX Pack

//datablock AudioProfile(SlipstreamExitSound)
//{
//   filename    = "fx/misc/nexus_cap.wav";
//   description = AudioDefault3d;
//   preload = true;
//};

//datablock AudioProfile(SlipstreamEnterSound)
//{
//   filename    = "fx/powered/dep_inv_station.wav";
//   description = AudioDefault3d;
//   preload = true;
//};

datablock AudioProfile(HoleFadeSound)
{
   filename    = "fx/vehicles/inventory_pad_appear.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock ShapeBaseImageData(SlipstreamPackImage)
{
   shapeFile = "pack_upgrade_sensorjammer.dts";
   item = SlipstreamPack;
   mountPoint = 1;
   offset = "0 0 0";

   usesEnergy = true;
   minEnergy = -1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";

	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(SlipstreamPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_sensorjammer.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "SlipstreamPackImage";
	pickUpName = "a slipstream-ix";
};

function ssCalSec(%obj)
{
    if(isObject(%obj))
    {
        if(%obj.ssCalTime > 0)
        {
            %obj.ssCalTime--;
            schedule(1000, 0, "ssCalSec", %obj);
        }
        else ssCalibrate(%obj, 0);
    }
}

function ssCalibrate(%obj, %time)
{
    if(isObject(%obj))
    {
        if(!%obj.ssCalibrating)
        {
            %obj.ssCalibrating = true;
            %obj.ssCalTime = mFloor(%time / 1000);
            messageClient(%obj.client, 'MsgSSRecharge', '\c2Slipstream-IX is recharging, %1 seconds.', %obj.ssCalTime);
            ssCalSec(%obj);
        }
        else
        {
            messageClient(%obj.client, 'MsgSSFinCharge', '\c2Slipstream-IX has finished recharge.');
            %obj.ssCalibrating = false;
        }
    }
}

function slipstreamTeleport(%obj, %dist)
{
     messageClient(%obj.client, 'MsgSSTeleToPoint', '\c2Slipstream-IX teleported to waypoint.');

     %obj.useEnergy(50);
     %obj.teleportStartFX();
     %obj.setPosition(%obj.client.slippoint);
     %obj.setVelocity("0 0 0");
     %obj.teleportEndFX();
//     %obj.client.slippoint.delete();
     %obj.client.slippoint = "";

    %time = (%dist / 50) * 1000;
    ssCalibrate(%obj, %time);
}

function disableIgnoreDetection(%obj)
{
   %obj.ignoreDetection = false;
}

function wormholeDetect(%obj)
{
   if(isObject(%obj) && isObject(%obj.parent))
   {
      %pos = %obj.getWorldBoxCenter();
      createLifeEmitter(%pos, "Teleporter1Emitter", 50);

      InitContainerRadiusSearch(%pos, 4, $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType | $TypeMasks::ProjectileObjectType);

      while((%int = ContainerSearchNext()) != 0)
      {
         if(%int.ignoreDetection)
            continue;

         if(%int.lastWormholedObject == %obj)
            continue;

         %endPos = %obj.end.getPosition();
//         %epx = getWord(%endPos, 0) + getRandomT(2) + getRandomT() + 5;
//         %epy = getWord(%endPos, 1) + getRandomT(2) + getRandomT() + 5;
//         %epz = getWord(%endPos, 2);
//         %epos = %epx SPC %epy SPC %epz;

         if(%int.isPlayer())
         {
            %int.setWhiteout(0.5);
            %int.setVelocity("0 0 0");
            ejectFlag(%int);
            %int.ignoreDetection = true;
            schedule(4500, 0, disableIgnoreDetection, %int);
         }
         else if(%int.isVehicle()) // MrKeen - why would vehicles need teleport?
            continue;
         else if(%int.sourceObject || %int.bkSourceObject)
         {
            instanceSSCopyObject(%int, %endPos, %obj.end);
//            %int.delete();
         }
//         else
//            %int.delete();

         if(isObject(%int))
            %int.setPosition(%endPos);

//         %int.play3d(SlipstreamExitSound);
//         %obj.play3d(SlipstreamEnterSound);
      }

      schedule(50, 0, wormholeDetect, %obj);
   }
//   else
//      SSPackOffToggle(%obj);
}

function deleteWormhole(%hole)
{
   if(isObject(%hole))
   {
      %hole.parent.player.setImageTrigger($BackpackSlot, false);
      %hole.parent = 0;
      %hole.play3d(HoleFadeSound);   //console error
      %end = %hole.end;
      %end.play3d(HoleFadeSound);    //console error
      %end.parent = 0;
      %end.delete();       //Console error
      %hole.delete();      //console error -Nite- All on use of pack (not fixed yet)
   }
}

function hclLoop(%obj)
{
   if(isObject(%obj.player))
      schedule(1000, 0, "hclLoop", %obj);
   else
      %obj.delete();
}

function SSPackOffToggle(%obj)
{
   if(isObject(%obj.wormhole))
   {
      deleteWormhole(%obj.wormhole);
      %obj.wormhole = 0;
   }
}

function createWormhole(%obj, %time, %dist)
{
   %los = getLOSInfo(%obj, 8);
   if(!%los)
   {
      %obj.useEnergy(50);
//      %obj.setVelocity("0 0 0");

      %wormholeExit = new StaticShape()
      {
         dataBlock        = mReflector;
      };
      MissionCleanup.add(%wormholeExit);
      %wormholeExit.setPosition(%obj.client.slippoint);
      %obj.client.slippoint = ""; // hehehehehe
      %obj.wormhole = %wormholeExit;

      %target = vectorAdd(getLOSOffset(%obj, %obj.getMuzzleVector(0), 4), "0 0 1");

      %wormholeEntry = new StaticShape()
      {
         dataBlock        = mReflector;
      };
      MissionCleanup.add(%wormholeEntry);
      %wormholeEntry.setPosition(%target);
//      createLifeEmitter(%target, "Teleporter1Emitter", %time);

      %rest = (%dist / 50) * 1000;
      ssCalibrate(%obj, %rest);

      %controller = new StaticShape()
      {
         dataBlock        = mReflector;
      };
      MissionCleanup.add(%controller);
      %controller.setPosition(%obj.getPosition());
      %controller.player = %obj;
      %obj.holeController = %controller;
      hclLoop(%controller);

      %wormholeExit.end = %wormholeEntry;
      %wormholeEntry.end = %wormholeExit;
      %wormholeEntry.parent = %obj.holeController;
      %wormholeExit.parent = %obj.holeController;
      wormholeDetect(%wormholeExit);
      wormholeDetect(%wormholeEntry);
//      %obj.setImageTrigger($BackpackSlot, false);
      schedule(%time, 0, "SSPackOffToggle", %obj);

      messageClient(%obj.client, 'MsgSlipStOff', '\c2Slipstream wormhole created.');
   }
   else
      messageClient(%obj.client, 'MsgSSLOSError', '\c2Object blocking Wormhole creation path. Please move to a more open space.');
}

function instanceSSCopyObject(%int, %end, %obj)
{
   if(!isObject(%int))
      return;

   if(isReflectableProjectile(%int))
   {
         %FFRObject = new StaticShape()
         {
            dataBlock        = mReflector;
         };
         MissionCleanup.add(%FFRObject);
         %FFRObject.setPosition(%end);

         %p = new(%int.getClassName())()
         {
            dataBlock        = %int.getDatablock().getName();
            initialDirection = %int.initialDirection; //vectorNeg(%int.initialDirection);
            initialPosition  = %end;
            sourceObject     = %FFRObject;
            sourceSlot       = %int.sourceSlot;
            vehicleObject    = %int.vehicleObject;
            lastWormholedObject = %obj;
            starburstMode = %int.starburstMode;
            bkSourceObject = %int.sourceObject;
         };
         MissionCleanup.add(%p);

         if(%int.trailThread)
            projectileTrail(%p, %int.trailThreadTime, %int.trailThreadProjType, %int.trailThreadProj, false, %int.trailThreadOffset);

         if(%int.proxyThread)
            rBeginProxy(%p);

      %FFRObject.schedule(32, delete);
      %int.delete();
   }
}

function SlipstreamPackImage::onMount(%data, %obj, %node)
{
     %obj.ss = true;
}

function SlipstreamPackImage::onUnmount(%data, %obj, %node)
{
     %obj.ss = false;
     SSPackOffToggle(%obj);

     if(%obj.client.slippoint !$= "")
          %obj.client.slippoint = "";
}

function SlipstreamPackImage::onActivate(%data, %obj, %slot)
{
//   if(%obj.wormhole)
//   {
//      messageClient(%obj.client, 'MsgSSAlreadyExists', '\c2Wormhole already exists.');
//      return;
// }

     if(%obj.client.slippoint !$= "")
     {
          %dist = getDistance3d(%obj.client.slippoint, %obj.getPosition());
          if(%dist < 50000)
          {
             if(!%obj.ssCalibrating)
             {
               if(%obj.getEnergyLevel() > 50)
               {
                  createWormhole(%obj, $WormholeExistanceTime, %dist);
//                  %obj.setImageTrigger(%slot,false);
               }
               else
               {
                    messageClient(%obj.client, 'MsgSSNoEnergy', '\c2Slipstream-IX does not have enough energy to create the wormhole.');
                   	%obj.setImageTrigger(%slot,false);
               }
             }
             else
             {
                  messageClient(%obj.client, 'MsgSSRecharge', '\c2Slipstream-IX is recharging, %1 seconds.', %obj.ssCalTime);
                  %obj.setImageTrigger(%slot,false);
             }
          }
          else
          {
               messageClient(%obj.client, 'MsgSSOutofRange', '\c2Slipstream-IX wormhole out of range.');
          	   %obj.setImageTrigger(%slot,false);
          }
     }
     else
     {
          if(%obj.getEnergyLevel() > 10)
          {
               messageClient(%obj.client, 'MsgSSTagMade', '\c2Slipstream-IX destination wormhole tag created.');
               %obj.useEnergy(10);
               %obj.client.slippoint = %obj.getWorldBoxCenter(); //new WayPoint()
//               {
//                   position = %obj.getWorldBoxCenter();
//                   rotation = "1 0 0 0";
//                    scale = "1 1 1";
//                   name = "Slipstream-IX Marker "@getTaggedString(%obj.client.name);
//                   dataBlock = "WayPointMarker";
//                   lockCount = "0";
//                   homingCount = "0";
//                   team = %obj.client.team;
//               };
//               MissionCleanup.add(%obj.client.slippoint);
          	   %obj.setImageTrigger(%slot,false);
               ssCalibrate(%obj, 3000);
          }
          else
          {
               messageClient(%obj.client, 'MsgTeleNotEnoughEnergy', '\c2Slipstream-IX does not have enough energy to create a wormhole tag.');
          	   %obj.setImageTrigger(%slot,false);
          }
     }
}

function SlipstreamPackImage::onDeactivate(%data, %obj, %slot)
{
   messageClient(%obj.client, 'MsgSlipStOff', '\c2Slipstream wormhole terminated.');
   SSPackOffToggle(%obj);
	%obj.setImageTrigger(%slot, false);
}

function SlipstreamPackImage::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}
