if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// Synomium Pack

datablock AudioProfile(SynomiumIdle)
{
	filename = "fx/misc/nexus_idle.wav";
	description = ClosestLooping3d;
    preload = true;
};

datablock AudioProfile(SynomiumEngage)
{
	filename = "fx/weapons/chaingun_start.wav";
	description = AudioDefault3D;
    preload = true;
};

datablock AudioProfile(SynomiumOff)
{
	filename = "fx/weapons/chaingun_off.wav";
	description = AudioDefault3D;
    preload = true;
};

datablock ShapeBaseImageData(SynDecalImage)
{
   mountPoint = 1;
   shapeFile = "pack_upgrade_satchel.dts";
   offset = "0 -0.15 0.025";
};

datablock ShapeBaseImageData(SynomiumPackImage)
{
   shapeFile = "pack_upgrade_ammo.dts";
   item = SynomiumPack;
   mountPoint = 1;
   offset = "0 0 0";

   rechargeRateBoost = 0.15;

   usesEnergy = true;
   minEnergy = -1;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = SynomiumIdle;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(SynomiumPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "pack_upgrade_ammo.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "SynomiumPackImage";
	pickUpName = "a synomium device";

};

function synPhase2(%obj)
{
     if(%obj.startSyn)
     {
          %obj.synCount++;
          %obj.isSyn = true;
//          %obj.ib_hp = mFloor((%obj.getDatablock().maxDamage - %obj.getDamageLevel())*100);
//          %obj.ib_hp_max = mFloor((%obj.getDatablock().maxDamage*100));
//          %obj.ib_hp_pct = mFloor((%obj.ib_hp / %obj.ib_hp_max)*100);
//          %obj.ib_vel_ms = mFloor(velToSingle(%obj.getVelocity()));
//          %obj.ib_vel_kph = msToKPH(%obj.ib_vel_ms);
//          %obj.ib_nrg = mFloor(%obj.getEnergyLevel());
//          %obj.ib_nrg_max = mFloor(%obj.getDatablock().maxEnergy);
//          %obj.ib_nrg_pct = mFloor((%obj.ib_nrg / %obj.ib_nrg_max)*100);

         // if($Feature[SynChargeTurbo])   -Nite- Man thats just silly..Same recharge as Ion Heat sink?
          //  %obj.setRechargeRate(0.4);
        //  else
          if(!%obj.getDataBlock().isBastech)
             %obj.setRechargeRate(0.325); //-Nite-  0.2635  0.271 is ePack old 0.486 is epack new O_o

//          echo(%obj.getRechargeRate());
          %obj.hasEnergyPack = false;
          %obj.enPack = true;
          %obj.stasisProof = true;

//          if(getRandom(100) >= 75)
//             %obj.playShieldEffect("0 0 0"); //vectorRandom());
          if(%obj.synCount >= 4)
          {
//               if(%obj.getEnergyPct() > 0.75)
                  %obj.zapObject();

                  if(getRandom(10) >= 8)
                     %obj.zap2Object();

//               else
//                  %obj.zap2Object();

               %obj.synCount = 0;

//               InitContainerRadiusSearch(%obj.getPosition(), 10, $TypeMasks::VehicleObjectType);

//               while((%int = ContainerSearchNext()) != 0)
//               {
//                  %int.zap = new ShockLanceProjectile()
//                  {
//                         dataBlock        = "sfxsbolt";
//                         initialDirection = "0 0 -0.5";
//                         initialPosition  = vectorAdd(%obj.getPosition(), "0 0 0.6");
//                         sourceObject     = %int;
//                         sourceSlot       = 0;
//                         targetId         = %int;
//                  };
//                  MissionCleanup.add(%int.zap);
//              }

//              InitContainerRadiusSearch(%obj.getPosition(), 10, $TypeMasks::ProjectileObjectType);

//               while((%int = ContainerSearchNext()) != 0)
//               {
//                  if(%int.sourceObject != %obj)
//                       %int.delete();
//               }
          }
          
//          commandToClient( %obj.client, 'BottomPrint', ">> Synomium Device self-info bar <<\nHP: "@%obj.ib_hp@"/"@%obj.ib_hp_max@" ("@%obj.ib_hp_pct@"%) | Energy: "@%obj.ib_nrg@"/"@%obj.ib_nrg_max@" ("@%obj.ib_nrg_pct@"%)\nSpeed: "@%obj.ib_vel_ms@" m/s ("@%obj.ib_vel_kph@" KPH)", 0.5, 3);
          schedule(100, 0, "synPhase2", %obj); // 32
     }
     else
     {
          %obj.stasisProof = false;
          %obj.hasEnergyPack = false;
          %obj.enPack = false;

          if(!%obj.getDataBlock().isBlastech)
             %obj.setRechargeRate(0.256);
     }
}

function synomise(%obj)
{
     if(%obj.startSyn)
          schedule(1000, 0, "synPhase2", %obj);
}

function SynomiumPackImage::onMount(%data, %obj, %node)
{
   %obj.isSyn = false;
   %obj.startSyn = false;

   %obj.mountImage(SynDecalImage, 7);
}

function SynomiumPackImage::onUnmount(%data, %obj, %node)
{
	%obj.setImageTrigger(%node, false);
    %obj.isSyn = false;
    %obj.startSyn = false;

    %obj.unmountImage(7);
}

function SynomiumPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.client.isSSX)
   {
      messageClient(%obj.client, 'MsgCantSynTrans', '\c2Cannot turn on Synomium pack while "transformed".');
      return;
   }

   messageClient(%obj.client, 'MsgSynT', '\c2Synomium Device Engaged.');
   %obj.play3D(SynomiumEngage);
   %obj.isSyn = false;
   %obj.startSyn = true;
   %obj.synSlot = %slot;
   %obj.playShieldEffect("0 0 1");
  // %obj.setPassiveJammed(true);  -Nite-
   synomise(%obj);
}

function SynomiumPackImage::onDeactivate(%data, %obj, %slot)
{
     messageClient(%obj.client, 'MsgSynF', '\c2Synomium Device Deactivated.');
	  %obj.setImageTrigger(%slot,false);
     %obj.play3D(SynomiumOff);
     %obj.isSyn = false;
     %obj.startSyn = false;
     %obj.playShieldEffect("0 0 1");
}

function disableSyn(%obj)
{
   if(%obj.isSyn)
   {
     messageClient(%obj.client, 'MsgSynF', '\c2Synomium Device Deactivated.');
	  %obj.setImageTrigger($BackpackSlot,false);
     %obj.play3D(SynomiumOff);
     %obj.isSyn = false;
     %obj.startSyn = false;
     %obj.playShieldEffect("0 0 1");
   }
}

function SynomiumPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

