if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// ------------------------------------------------------------------
// VectorPort PACK
// can be used by any armor type
// while activated, absorbs damage at cost of energy

datablock AudioProfile(VectorPortPackActivateSound)
{
	filename = "fx/vehicles/outrider_engine.wav";
	description = ClosestLooping3d;
    preload = true;
};

datablock ShapeBaseImageData(VectorPortDecalImage)
{
   mountPoint = 1;
   shapeFile = "ammo_mortar.dts";
   offset = "0.15 -0.275 0";
   rotation = "0 1 0 90";
};

datablock ShapeBaseImageData(VectorPortPackImage)
{
   shapeFile = "ammo_mortar.dts";
   item = VectorPortPack;
   mountPoint = 1;

   offset = "-0.15 -0.275 0";
   rotation = "0 1 0 90";

   usesEnergy = true;
   minEnergy = 3;

	stateName[0] = "Idle";
	stateTransitionOnTriggerDown[0] = "Activate";
	
	stateName[1] = "Activate";
	stateScript[1] = "onActivate";
	stateSequence[1] = "fire";
	stateSound[1] = VectorPortPackActivateSound;
//   stateEnergyDrain[1] = 9;
	stateTransitionOnTriggerUp[1] = "Deactivate";
   stateTransitionOnNoAmmo[1] = "Deactivate";

	stateName[2] = "Deactivate";
	stateScript[2] = "onDeactivate";
	stateTransitionOnTimeout[2] = "Idle";
};

datablock ItemData(VectorPortPack)
{
   className = Pack;
   catagory = "Packs";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   rotate = true;
   image = "VectorPortPackImage";
	pickUpName = "a vectorport pack";
};

function VectorPortPackImage::onMount(%data, %obj, %node)
{
   %obj.mountImage(VectorPortDecalImage, 7);
   %obj.wearingVP = true;
}

function VectorPortPackImage::onUnmount(%data, %obj, %node)
{
   %obj.setImageTrigger(%node, false);
   %obj.unmountImage(7);
   %obj.wearingVP = false;
}

function getLOSInfoVP(%obj, %dist)
{
   %vec = %obj.getMuzzleVector(0);
   %pos = %obj.getMuzzlePoint(0);
   %nVec = VectorNormalize(%vec);
   %scVec = VectorScale(%nVec, %dist);
   %end = VectorAdd(%pos, %scVec);
   %result = containerRayCast(%pos, %end, $TypeMasks::NonTransparent, %obj);
   %target = getWord(%result, 0);

   if(isObject(%target))
      return %target;
   else
      return false;
}

function getMuzzleRaycastPtVP(%obj, %slot, %dist)
{
     %vec = %obj.getMuzzleVector(%slot);
     %pos = %obj.getMuzzlePoint(%slot);
     %nVec = VectorNormalize(%vec);
     %scVec = VectorScale(%nVec, %dist);
     %end = VectorAdd(%pos, %scVec);
     %searchResult = containerRayCast(%pos, %end, $TypeMasks::NonTransparent, %obj);
     %raycastPt = posFrRaycast(%searchResult);
     %raycastPt.raycast = %searchResult;
     
     return %raycastPt;
}

function VectorPortPackImage::onActivate(%data, %obj, %slot)
{
   if(%obj.vectorPortUsed)
   {
      commandToClient(%obj.client, 'BottomPrint', "The VectorPort is recharging, please wait.", 3, 1);
      %obj.setImageTrigger(%slot, false);
      return;
   }
   else
   {
      if(%obj.getEnergyLevel() < 60)
      {
         commandToClient(%obj.client, 'BottomPrint', "You must have full energy to use the VectorPort.", 3, 1);
         %obj.setImageTrigger(%slot, false);
         return;
      }

      %point = getLOSInfoVP(%obj, 100);

      if(%point)
      {
         ejectFlag(%obj);
         %obj.setCloaked(true);
         %end = getMuzzleRaycastPtVP(%obj, 0, 100);

         %obj.vectorPortUsed = true;

         schedule(15000, 0, "resetVectorPort", %obj);
         schedule(100, 0, "vpPlayerMove", %obj, %end);
      }
      else
         commandToClient(%obj.client, 'BottomPrint', "No teleport point in range.", 3, 1);

      %obj.setImageTrigger(%slot, false);
   }
}

function vpPlayerMove(%obj, %end)
{
   %pos = %obj.getPosition();
   %obj.setPosition(%end);
   %obj.setVelocity("0 0 0");
   %dist = getDistance3D(%pos, %end);
   %obj.setCloaked(false);
   %obj.useEnergy(60);

   commandToClient(%obj.client, 'BottomPrint', "Distance travelled: "@%dist@"m, 15 seconds until next use.", 4, 1);
}

function resetVectorPort(%obj)
{
   if(isObject(%obj))
   {
      %obj.vectorPortUsed = false;

      if(%obj.wearingVP)
         commandToClient(%obj.client, 'BottomPrint', "The VectorPort is ready.", 3, 1);
   }
}

function VectorPortPackImage::onDeactivate(%data, %obj, %slot)
{
   %obj.setImageTrigger(%slot, false);
}

function VectorPortPack::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

