if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();
//--------------------------------------------------------------------------
// Rocket Booster Module
//--------------------------------------------------------------------------

function BoosterModImage::onActivate(%data, %obj, %slot)
{
   AttemptAugmentVehicle(%data, %obj, %slot);
}

function BoosterModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function BoosterMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

function BoosterModImage::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("BoosterMod", 0);
     %vehicle.augmented = true;
     %vehicle.augType = "Booster Rocket";
     %vehicle.augName = "Booster";
     %vehicle.numBoosts = 5;
     %vehicle.lastBoostTime = 1000;
}

function InitBoosterMod(%obj)
{
   if(isObject(%obj))
   {
      if(%obj.getMountNodeObject(0))
      {
         if((%obj.lastBoostTime + 6000) <= getSimTime())
         {
            resetInfoBar(%obj, 1);

            if(%obj.numBoosts <= 0)
            {
               bottomPrint(%obj.getMountNodeObject(0).client, "Out of solid rockets.", 5, 1);
               return;
            }

            %nvel = %obj.getVelocity();
            %xvel = velToSingle(%nVel);
            %vel = msToKPH(%xvel);

            if(%vel <= 800)
            {
               %obj.numBoosts--;
               %vec = vectorScale(%obj.getMuzzleVector(0), 120); // Adding to the current velocity..
               %force = %obj.getMass();
               %newVec = VectorScale(%vec, %force);
               %obj.applyImpulse(%obj.getTransform(), %newVec);
               %obj.lastBoostTime = getSimTime();
               bottomPrint(%obj.getMountNodeObject(0).client, "Solid rocket booster ignited! "@%obj.numBoosts@" uses left.", 5, 1);
            }
            else
               bottomPrint(%obj.getMountNodeObject(0).client, "You are travelling too fast to use a rocket booster.", 5, 1);
         }
         else
            bottomPrint(%obj.getMountNodeObject(0).client, "Solid rocket booster is reloading.", 5, 1);
      }
   }
}

