if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Flare Module
//--------------------------------------------------------------------------

function FlareModImage::onActivate(%data, %obj, %slot)
{
   AttemptAugmentVehicle(%data, %obj, %slot);
}

function FlareModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function FlareMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

function FlareModImage::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("FlareMod", 0);
     %vehicle.augmented = true;
     %vehicle.numFlares = 5;
     %vehicle.augType = "Flare Pack ["@%vehicle.numFlares@" left]";
     %vehicle.augName = "Flare";
}

function InitFlareMod(%obj)
{
   if(isObject(%obj))
   {
      if(%obj.getMountNodeObject(0)) // cant repulse
      {
         resetInfoBar(%obj, 1);
         if(%obj.numFlares <= 0)
         {
            bottomPrint(%obj.getMountNodeObject(0).client, "Out of flares.", 5, 1);
            return;
         }

         %f = new FlareProjectile()
         {
            dataBlock        = FlareGrenadeProj;
            initialDirection = %obj.getForwardVector();
            initialPosition  = %obj.getWorldBoxCenter();
            sourceObject     = %obj;
            sourceSlot       = 0;
         };
         FlareSet.add(%f);
         MissionCleanup.add(%f);
         %f.schedule(10000, "delete");
      }

      %obj.numFlares--;
      %obj.augType = "Flare Pack ["@%obj.numFlares@" left]";
      bottomPrint(%obj.getMountNodeObject(0).client, %obj.numFlares@" flares left", 5, 1);
   }
}

