if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Vehicle Chaingun Module
//--------------------------------------------------------------------------

function vehicleChaingunModImage::onActivate(%data, %obj, %slot)
{
   // search for a vehicle in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a vehicle base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potVehicle = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::VehicleObjectType);

   if(%potVehicle != 0)    // positon of the vehicle
   {
      if(%potVehicle.getDatablock().getName() $= "ScoutFlyer") // Shrike Filter
      {
         // Not already augmented...
		   messageClient(%obj.client, 'MsgAugShrChain', "\c2Changed Weapon barrel -> Shrike -> Chainguns");
		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
         vehicleChaingunMod::ApplyMod(%data, %obj, %potVehicle);
      }
      else if(%potVehicle.getDatablock().getName() $= "tPOC") // Shrike Filter
      {
         // Not already augmented...
         messageClient(%obj.client, 'MsgAugMarChain', "\c2Changed Weapon barrel -> Marantz -> Chainguns");
         serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
         vehicleChaingunMod::ApplyMod(%data, %obj, %potVehicle);
      }
      else
      {
         messageClient(%obj.client, 'MsgAugCantAug', "\c2Error! You cannot change weapons on this vehicle.");
         %obj.setImageTrigger($BackpackSlot, false);
      }
   }
   else
   {
      // I don't see any vehicle
      messageClient(%obj.client, 'MsgAugORange', "\c2No vehicle within the 5m range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }

}

function vehicleChaingunModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function vehicleChaingunMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(ScoutChaingunZPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_tank_barrelchain.dts";
   item      = Chaingun;
   projectile = TurretChaingunBullet;
   projectileType = TracerProjectile;

//   casing              = ShellDebris;
//   shellExitDir        = "1.0 0.3 1.0";
//   shellExitOffset     = "0.15 -0.56 -0.1";
//   shellExitVariance   = 15.0;
//   shellVelocity       = 3.0;

//   projectileSpread = 3.76 / 1000.0;
   mountPoint = 10;
   offset = "-4 -1.5 -1.5"; //".95 0.6 -0.1";
   rotation = "0 1 0 125";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 3;
   fireEnergy = 4;
   fireTimeout = 200;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSequence[4]         = "Fire_Vis";
   stateSound[4]            = FlierChaingunFireSound;
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 0.2;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.05;
   stateSequence[5]         = "Fire_Vis";
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateSequence[8]         = "Fire_Vis";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(ScoutChaingunZImage) : ScoutChaingunZPairImage
{
   offset = "4 -1.5 -1.5";//"-.95 0.6 -0.1";
   rotation     = "0 1 0 -125";
   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
   stateScript[6]           = "onTriggerUp";
   stateSequence[4]         = "Fire_Vis";
   stateSequence[5]         = "Fire_Vis";
   stateSequence[8]         = "Fire_Vis";
};

datablock ShapeBaseImageData(ScoutChaingunZParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = vChaingunBullet;
   projectileType = TracerProjectile;
};

function ScoutChaingunZImage::onFire(%data,%obj,%slot)
{
   %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 1);

   %p = new TracerProjectile() {
      dataBlock        = "TurretChaingunBullet";
      initialDirection = %vector;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };
   MissionCleanup.add(%p);
   %obj.useEnergy(%data.fireEnergy);

   %obj.nextWeaponFire = 3;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function ScoutChaingunZPairImage::onFire(%data,%obj,%slot)
{
   %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 1);

   %p = new TracerProjectile() {
      dataBlock        = "TurretChaingunBullet";
      initialDirection = %vector;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };
   MissionCleanup.add(%p);
   %obj.useEnergy(%data.fireEnergy);

   %obj.nextWeaponFire = 2;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function vehicleChaingunMod::ApplyMod(%datablock, %player, %vehicle)
{
//     %player.setInventory("vehicleChaingunMod", 0);
//     commandToClient(%player.client, 'endBomberSight');

     %vehicle.unmountImage(0);
     %vehicle.unmountImage(2);
     %vehicle.unmountImage(3);

     %vehicle.mountImage(ScoutChaingunZParam, 0);
     %vehicle.mountImage(ScoutChaingunZImage, 2);
     %vehicle.mountImage(ScoutChaingunZPairImage, 3);
     %vehicle.nextWeaponFire = 2;

     %vehicle.veh_weapon[0] = "Bolter";
     %vehicle.veh_weapon_ammo[0] = true;
     %vehicle.veh_weapon[0].ammo = 1000;

     %vehicle.weapon[1, Display] = true;
     %vehicle.weapon[1, Name] = "Bolter";
     %vehicle.weapon[1, Description] = "";
}
