if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Vehicle Phaser Module
//--------------------------------------------------------------------------

function vehiclePhaserModImage::onActivate(%data, %obj, %slot)
{
   // search for a vehicle in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a vehicle base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potVehicle = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::VehicleObjectType);

   if(%potVehicle != 0)    // positon of the vehicle
   {
      if(%potVehicle.getDatablock().getName() $= "ScoutFlyer") // Shrike Filter
      {
         // Not already augmented...
		   messageClient(%obj.client, 'MsgAugShrMETA', "\c2Changed Weapon barrel -> Shrike -> ZIG-CA MetaLaser");
		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
         vehiclePhaserMod::ApplyMod(%data, %obj, %potVehicle);
      }
      else if(%potVehicle.getDatablock().getName() $= "tPOC") // Shrike Filter
      {
         // Not already augmented...
		   messageClient(%obj.client, '', "\c2Changed Weapon barrel -> Marantz -> ZIG-CA MetaLaser");
		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
         vehiclePhaserMod::ApplyMod(%data, %obj, %potVehicle);
      }
      else
      {
         messageClient(%obj.client, 'MsgAugCantAug', "\c2Error! You cannot change weapons on this vehicle.");
         %obj.setImageTrigger($BackpackSlot, false);
      }
   }
   else
   {
      // I don't see any vehicle
      messageClient(%obj.client, 'MsgAugORange', "\c2No vehicle within the 5m range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

function vehiclePhaserModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function vehiclePhaserMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(ScoutPhaserPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_elf_large.dts";
   item      = Chaingun;
   projectile = SuperPulseBolt;
   projectileType = TracerProjectile;

   mountPoint = 10;
   offset = "-4.25 -2.25 -1.75"; //".95 0.6 -0.1";
   rotation = "0 1 0 125";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 50;
   fireEnergy = 10;
   fireTimeout = 500;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Deploy";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSound[4]            = AAFireSound;
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 0.5;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(ScoutPhaserImage) : ScoutPhaserPairImage
{
   offset = "4.25 -2.25 -1.75";//"-.95 0.6 -0.1";
   rotation = "0 1 0 -135";
   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(ScoutPhaserParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = SuperPulseBolt;
   projectileType = TracerProjectile;
};

function ScoutPhaserImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.setImageTrigger(2, true);
   %obj.setImageTrigger(3, true);
}

function ScoutPhaserPairImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.setImageTrigger(2, true);
   %obj.setImageTrigger(3, true);
}

function vehiclePhaserMod::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("vehiclePhaserMod", 0);
     commandToClient(%player.client, 'endBomberSight');

     %vehicle.unmountImage(0);
     %vehicle.unmountImage(2);
     %vehicle.unmountImage(3);

     %vehicle.mountImage(ScoutPhaserParam, 0);
     %vehicle.mountImage(ScoutPhaserImage, 2);
     %vehicle.mountImage(ScoutPhaserPairImage, 3);
     %vehicle.nextWeaponFire = 2;

     %vehicle.veh_weapon[0] = "ZIG-CA MetaLaser";
     %vehicle.veh_weapon_ammo[0] = "";

     %vehicle.weapon[1, Display] = true;
     %vehicle.weapon[1, Name] = "ZIG-CA MetaLaser";
     %vehicle.weapon[1, Description] = "";
}
