if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Vehicle Rocket Module
//--------------------------------------------------------------------------

function vehicleRocketModImage::onActivate(%data, %obj, %slot)
{
   // search for a vehicle in player's LOS
   %eyeVec = VectorNormalize(%obj.getEyeVector());
   %srchRange = VectorScale(%eyeVec, 5.0); // look 5m for a vehicle base
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potVehicle = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::VehicleObjectType);

   if(%potVehicle != 0)    // positon of the vehicle
   {
      if(%potVehicle.getDatablock().getName() $= "ScoutFlyer") // Shrike Filter
      {
         // Not already augmented...
		   messageClient(%obj.client, 'MsgAugSRL', "\c2Changed Weapon barrel -> Shrike -> Rocket Launcher");
		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
         vehicleRocketMod::ApplyMod(%data, %obj, %potVehicle);
      }
//      else if(%potVehicle.getDatablock().getName() $= "tPOC") // Shrike Filter
//      {
//         // Not already augmented...
//		   messageClient(%obj.client, 'MsgAugMRL', "\c2Changed Weapon barrel -> Marantz -> Rocket Launcher");
//		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
//         vehicleRocketMod::ApplyMod(%data, %obj, %potVehicle);
//      }
      else
      {
         messageClient(%obj.client, 'MsgAugCantAug', "\c2Error! You cannot change weapons on this vehicle.");
         %obj.setImageTrigger($BackpackSlot, false);
      }
   }
   else
   {
      // I don't see any vehicle
      messageClient(%obj.client, 'MsgAugORange', "\c2No vehicle within the 5m range.");
      %obj.setImageTrigger($BackpackSlot, false);
   }
}

function vehicleRocketModImage::onDeactivate(%data, %obj, %slot)
{
	%obj.setImageTrigger($BackpackSlot, false);
}

function vehicleRocketMod::onPickup(%this, %obj, %shape, %amount)
{
	// created to prevent console errors
}

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(ScoutRocketPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_tank_barrelmortar.dts";
   item      = Chaingun;
   projectile = MechRocket;
   projectileType = LinearProjectile;
   mountPoint = 10;
   offset = "4 -2.5 -1.5";
   rotation     = "0 1 0 -125";
   emap = true;
   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 15;
   fireEnergy = -1;
   fireTimeout = 2000;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSequence[4]         = "Fire";
   stateSound[4]            = MechRocketFireSound;
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 2.0;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(ScoutRocketImage) : ScoutRocketPairImage
{
   offset = "-4 -2.5 -1.5";
   rotation     = "0 1 0 125";
   stateSequence[4]         = "Fire";
   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(ScoutRocketParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = StreakRocket;
   projectileType = LinearProjectile;
};

function ScoutRocketImage::onFire(%data,%obj,%slot)
{
   if($Feature[ShrikeRocketAmmo])
   {
      if(%obj.ammo[Rocket] > 0)
      {
         %obj.ammo[Rocket]--;
         bottomPrint(%obj.getMountNodeObject(0).client, "Rockets Left: "@%obj.ammo[Rocket], 3, 1);
         Parent::onFire(%data,%obj,%slot);
      }
      else
         bottomPrint(%obj.getMountNodeObject(0).client, "No more rockets left. Mount another Rocket module for more ammo.", 3, 1);
   }
   else
   {
      Parent::onFire(%data,%obj,%slot);
      %obj.useEnergy(60);
   }

   %obj.nextWeaponFire = 3;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function ScoutRocketPairImage::onFire(%data,%obj,%slot)
{
   if($Feature[ShrikeRocketAmmo])
   {
      if(%obj.ammo[Rocket] > 0)
      {
         %obj.ammo[Rocket]--;
         bottomPrint(%obj.getMountNodeObject(0).client, "Rockets Left: "@%obj.ammo[Rocket], 3, 1);
          %obj.play3d(MechFire2Sound);
           Parent::onFire(%data,%obj,%slot);
      }
      else
         bottomPrint(%obj.getMountNodeObject(0).client, "No more rockets left. Mount another Rocket module for more ammo.", 3, 1);
   }
   else
   {
      Parent::onFire(%data,%obj,%slot);
      %obj.useEnergy(60);
   }

   %obj.nextWeaponFire = 2;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function vehicleRocketMod::ApplyMod(%datablock, %player, %vehicle)
{
     %player.setInventory("vehicleRocketMod", 0);

     %vehicle.unmountImage(0);
     %vehicle.unmountImage(2);
     %vehicle.unmountImage(3);

     %vehicle.mountImage(ScoutRocketParam, 0);
     %vehicle.mountImage(ScoutRocketImage, 2);
     %vehicle.mountImage(ScoutRocketPairImage, 3);
     %vehicle.nextWeaponFire = 2;

     %vehicle.weapon[1, Display] = true;
     %vehicle.weapon[1, Name] = "Dumbfire Rocket Launcher";
     %vehicle.weapon[1, Description] = "";

     %vehicle.ammo[Rocket] = 40;
}
