if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

// VehicleAugs.cs - Augmentory system for Vehicles

// Sounds

datablock AudioProfile(AugmentVehicle)
{
   filename    = "fx/vehicles/mpb_deploy_station.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(AugmentWeapon)
{
   filename    = "fx/vehicles/inventory_pad_appear.wav";
   description = AudioDefault3d;
   preload = true;
};

function toggleVehicleMod(%obj)
{
    %vMod = %obj.getObjectMount().augName;
    %vehicle = %obj.getObjectMount();

    if(%vMod !$= "")
    {
        if(%vMod $= "SelfDestruct")
            InitSelfDestructMod(%vehicle);
        else if(%vMod $= "Cloak")
            InitCloakMod(%vehicle);
        else if(%vMod $= "Booster")
            InitBoosterMod(%vehicle);
        else if(%vMod $= "Dampener")
            InitDampenerMod(%vehicle);
        else if(%vMod $= "Repulsor")
            InitRepulsorMod(%vehicle);
        else if(%vMod $= "WarpCore")
            InitWarpCore(%vehicle);
        else if(%vMod $= "Flare")
            InitFlareMod(%vehicle);

       return;
    }
    else
    {
        %obj.client.infobar = %obj.client.infobar == 1 ? 0 : 1;
        return;
    }
}

function activateInfoBar(%obj)
{
   %obj.haltInfoBar = false;
}

function resetInfoBar(%obj, %time)
{
   %obj.haltInfoBar = true;

   if(isObject(%obj))
      schedule(%time*1000, %obj, activateInfoBar, %obj);
}

function getProperVMod(%int, %obj, %potVehicle)
{
   switch(%int)
   {
      case 0:
         SensorJamModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 1:
         DampenerModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 2:
         LavaShieldModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 3:
         ReactorModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 4:
         BoosterModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 5:
         CloakModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 6:
         SelfDestructModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 7:
         FlareModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      default:
         return -1;
   }
}

function getProperVModR(%int, %obj, %potVehicle)
{
   switch(%int)
   {
      case 0:
         BoosterModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 1:
         BoosterModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 2:
         BoosterModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 3:
         FlareModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 4:
         BoosterModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 5:
         FlareModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 6:
         FlareModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      case 7:
         FlareModImage::ApplyMod(%obj.getDatablock(), %obj, %potVehicle);
      default:
         return -1;
   }
}

function AttemptAugmentVehicle(%data, %obj, %slot)
{
   %eyeVec = VectorNormalize(%obj.getMuzzleVector(0));
   %srchRange = VectorScale(%eyeVec, 10);
   %plTm = %obj.getEyeTransform();
   %plyrLoc = firstWord(%plTm) @ " " @ getWord(%plTm, 1) @ " " @ getWord(%plTm, 2);
   %srchEnd = VectorAdd(%plyrLoc, %srchRange);
   %potVehicle = ContainerRayCast(%obj.getEyeTransform(), %srchEnd, $TypeMasks::VehicleObjectType);
   %mode = %obj.client.mode[VehicleAugmenter];

   if(%potVehicle != 0)
   {
      if($RestrictVehicleMode[%potVehicle.getDatablock().getName(), %mode]) // MrKeen
      {
         messageClient(%obj.client, 'MsgRestrictedMod', '\c5This module cannot be installed on this vehicle');
         %obj.setImageTrigger(%slot, false);
         return;
      }
      else
      {
         if(%potVehicle.augmented != true)
         {
            getProperVMod(%mode, %obj, %potVehicle);
   //         %b.ApplyMod(%obj, %potVehicle);
            messageClient(%obj.client, 'MsgInstalledMod', '\c2Installed: %1 -> %2 %3', %potVehicle.augType, %potVehicle.getDatablock().targetNameTag, %potVehicle.getDatablock().targetTypeTag);
   		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
         }
         else if(%potVehicle.augName $= "Booster" || %potVehicle.augName $= "Flare")
         {
   //         messageClient(%obj.client, 'MsgNotVehicle', '\c2Unable to install: Vehicle augmented with %1.', %potVehicle.augType);
            getProperVModR(%mode, %obj, %potVehicle);
   //         %data.ApplyMod(%obj, %potVehicle);
            messageClient(%obj.client, 'MsgReloadedMod', '\c5Reloaded: %1 -> %2 %3', %potVehicle.augType, %potVehicle.getDatablock().targetNameTag, %potVehicle.getDatablock().targetTypeTag);
   		   serverPlay3D(AugmentVehicle, %potVehicle.getTransform());
         }
         else
         {
            messageClient(%obj.client, 'MsgUnableToLoadMod', '\c2Unable to install: Vehicle augmented with %1.', %potVehicle.augType);
            %obj.setImageTrigger(%slot, false);
         }
      }
   }
   else
   {
      messageClient(%obj.client, 'MsgAugORange', "\c2No vehicle within range.");
      %obj.setImageTrigger(%slot, false);
   }
}

//-------------------------------------- Load Augmentation Images
//

// Mods
exec("scripts/vehaugs/SensorJamMod.cs");
exec("scripts/vehaugs/HeatShieldMod.cs");
exec("scripts/vehaugs/ReactorMod.cs");
exec("scripts/vehaugs/CloakMod.cs");
exec("scripts/vehaugs/BoosterMod.cs");
exec("scripts/vehaugs/DampenerMod.cs");
exec("scripts/vehaugs/SelfDestructMod.cs");
exec("scripts/vehaugs/FlareMod.cs");

// Weapons
exec("scripts/vehaugs/ShrikeRocketMod.cs");
//exec("scripts/vehaugs/ShrikeBomberMod.cs");   -Nite- people hate me anyways .. =[
exec("scripts/vehaugs/ShrikeChaingunMod.cs");
exec("scripts/vehaugs/ShrikeMitziMod.cs");
exec("scripts/vehaugs/ShrikePhaserMod.cs");
exec("scripts/vehaugs/ShrikeEnergyMod.cs");
