if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

datablock ShapeBaseImageData(WildcatChaingunPairImage)
{
   className = WeaponImage;
   shapeFile = "weapon_plasma.dts";
   item      = Chaingun;
   projectile = HBPlasmaBolt;
   projectileType = LinearFlareProjectile;
   mountPoint = 10;
   offset = ".25 .6 .3";
   rotation = "0 -1 0 60";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 15;
   fireEnergy = 15;
   fireTimeout = 1400;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSound[4]            = PlasmaFireSound;
   stateTimeoutValue[4]          = 1.4;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(WildcatChaingunImage) : WildcatChaingunPairImage
{
   offset = "-.25 .6 .3";
   rotation = "0 1 0 60";
   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(WildcatChaingunParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = PlasmaBolt;
   projectileType = LinearFlareProjectile;
};

function ScoutVehicle::onTrigger(%data, %obj, %trigger, %state)
{
   // data = ScoutFlyer datablock
   // obj = ScoutFlyer object number
   // trigger = 0 for "fire", 1 for "jump", 3 for "thrust"
   // state = 1 for firing, 0 for not firing
   if(%trigger == 0)
   {
      switch (%state) {
         case 0:
            %obj.fireWeapon = false;
            %obj.setImageTrigger(2, false);
            %obj.setImageTrigger(3, false);
            %obj.setImageTrigger(4, false);
         case 1:
            %obj.fireWeapon = true;
            if(%obj.nextWeaponFire == 2)
            {
               %obj.setImageTrigger(2, true);
               %obj.setImageTrigger(3, false);
            }
            else {
               %obj.setImageTrigger(2, false);
               %obj.setImageTrigger(3, true);
            }
      }
   }
}

function WildcatChaingunImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 3;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function WildcatChaingunPairImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 2;
   schedule(%data.fireTimeout, 0, "fireNextGun", %obj);
}

function WildcatChaingunImage::onTriggerDown(%this, %obj, %slot)
{
}

function WildcatChaingunImage::onTriggerUp(%this, %obj, %slot)
{
}

function WildcatChaingunImage::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function WildcatChaingunPairImage::onMount(%this, %obj, %slot)
{
//   %obj.setImageAmmo(%slot,true);
}

function WildcatChaingunImage::onUnmount(%this,%obj,%slot)
{
}

function WildcatChaingunPairImage::onUnmount(%this,%obj,%slot)
{
}

datablock ShapeBaseImageData(HBDecal1) : MainAPEImage
{
   offset = "0.8 0 -0.5";
   rotation = calcThisRotD("180 90 0"); //"1 0 0 180";
   shapeFile = "TR2weapon_mortar.dts";   // hjehje

   stateEmitter[3]       = "BikeContrailEmitter"; // emitter
   stateEmitterTime[3]       = 0.053; // 100ms
   stateEmitterNode[3]       = 0; // model node (most models dont come with any nodes)
};

datablock ShapeBaseImageData(HBDecal2) : MainAPEImage
{
   offset = "-0.8 0 -0.275";
   rotation = calcThisRotD("180 -90 0"); //"1 0 0 180";
   shapeFile = "TR2weapon_mortar.dts";   // hjehje

   stateEmitter[3]       = "BikeContrailEmitter"; // emitter
   stateEmitterTime[3]       = 0.053; // 100ms
   stateEmitterNode[3]       = 0; // model node (most models dont come with any nodes)
};

datablock ShapeBaseImageData(HBEngine1)
{
   shapeFile = "turret_assaulttank_plasma.dts";
   offset = "0.53 -0.80 -0.144";
   rotation = calcThisRotD("0 -45 180"); //"0 1 0 -45"; // 90

   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
};

datablock ShapeBaseImageData(HBEngine2)
{
   shapeFile = "turret_assaulttank_plasma.dts";
   offset = "-0.53 -0.80 -0.144";
   rotation = calcThisRotD("0 45 180"); //"0 1 0 45";

   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
};

datablock ShapeBaseImageData(SRDecal1)
{
   offset = "0.8 0 -0.5";
   rotation = "0 0 1 180";
   shapeFile = "stackable4l.dts";
};

datablock ShapeBaseImageData(SRDecal2)
{
   offset = "-0.95 0 -0.5";
   rotation = "0 0 1 180";
   shapeFile = "stackable4l.dts";
};
