if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//**************************************************************
// LOSDown Transporter
//**************************************************************

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

Meltdown.MassVelMod[LOSDownFlyer] = 1.0; //4.0
Meltdown.MaxDmgMod[LOSDownFlyer] = 2.0;
Meltdown.ShieldPctMod[LOSDownFlyer] = 1.0;

datablock FlyingVehicleData(LOSDownFlyer) : AirVehicleDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_bomber.dts";
   multipassenger = true;
   computeCRC = true;

   weaponNode = 1;

   debrisShapeName = "vehicle_air_bomber_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.2;
   density = 1.0;

   mountPose[0] = sitting;
   mountPose[1] = sitting;
   numMountPoints = 3;
   isProtectedMountPoint[0] = true;
   isProtectedMountPoint[1] = true;
   isProtectedMountPoint[2] = true;

   cameraMaxDist = 22;
   cameraOffset = 5;
   cameraLag = 1.0;
   explosion = LargeAirVehicleExplosion;
	explosionDamage = 1.5;
	explosionRadius = 25.0;

   maxDamage = 2.0*Meltdown.MaxDmgMod[LOSDownFlyer];     // Total health
   destroyedLevel = 2.0*Meltdown.MaxDmgMod[LOSDownFlyer];   // Damage textures show up at this health level

   isShielded = true;
   energyPerDamagePoint = 150 / Meltdown.ShieldPctMod[LOSDownFlyer];
   maxEnergy = 300;      // Afterburner and any energy weapon pool
   minDrag = 60;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 1800;        // Angular Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.8;

   // Turbo Jet
   jetForce = 6250*Meltdown.MassVelMod[LOSDownFlyer];      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 40.0;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 4.0;       // Energy use of the afterburners (low number is less drain...can be fractional)
   vertThrustMultiple = 2.0;

   // Auto stabilize speed
   maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 1500;      // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 300;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 5;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 8;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 4700*Meltdown.MassVelMod[LOSDownFlyer];      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1100;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 300;      // Steering jets (how much you heel over when you turn)
   rollForce = 8;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 500;

   dustEmitter = LargeVehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 2.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "3.0 -3.0 0.0 ";
   damageEmitterOffset[1] = "-3.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 2;

   // Rigid body
   mass = 375*Meltdown.MassVelMod[LOSDownFlyer];        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   minImpactSpeed = 8;      // If hit ground at speed above this then it's an impact. Meters/second
   softImpactSpeed = 10;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 25;    // Sound hooks. This is the hard hit.
   speedDamageScale = 0.035;

   collDamageThresholdVel = 20.0;
   collDamageMultiplier   = 0.025;

   //
   minTrailSpeed = 15;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = TurboJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = MPBThrustSound;
   engineSound = BomberFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 15.0;
   mediumSplashSoundVelocity = 30.0;
   hardSplashSoundVelocity = 60.0;
   exitSplashSoundVelocity = 20.0;

   exitingWater      = VehicleExitWaterHardSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterHardSound;
   waterWakeSound    = VehicleWakeHardSplashSound;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingBomberIcon;
   cmdMiniIconName = "commander/MiniIcons/com_bomber_grey";
   targetNameTag = 'LOSDown';
   targetTypeTag = 'Teleporter Transport';
   sensorData = VehiclePulseSensor;

   checkRadius = 7.1895;
   observeParameters = "1 10 10";
   showPilotInfo = 1;
};

//**************************************************************
// WEAPONS
//**************************************************************

//-------------------------------------
// BOMBER BELLY TURRET GUN (projectile)
//-------------------------------------

//-------------------------------------
// BOMBER BELLY TURRET CHARACTERISTICS
//-------------------------------------

datablock TurretData(LOSDownTurret) : TurretDamageProfile
{
   className               = VehicleTurret;
   catagory                = "Turrets";
   shapeFile               = "turret_belly_base.dts";
   preload                 = true;

   mass                    = 1.0;  // Not really relevant
   repairRate              = 0;
   maxDamage               = LOSDownFlyer.maxDamage;
   destroyedLevel          = LOSDownFlyer.destroyedLevel;

   thetaMin                = 90;
   thetaMax                = 180;

   // capacitor
   maxCapacitorEnergy      = 250;
   capacitorRechargeRate   = 0.8;
   
   inheritEnergyFromMount  = true;
   firstPersonOnly         = true;
   useEyePoint             = true;
   numWeapons              = 1;

   targetNameTag           = 'LOSDown Transporter';
   targetTypeTag           = 'Turret';
};

function LOSDownTurret::onDamage(%data, %obj)
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function LOSDownTurret::damageObject(%this, %targetObject, %sourceObject, %position, %amount, %damageType ,%vec, %client, %projectile)
{
   //If vehicle turret is hit then apply damage to the vehicle
   %vehicle = %targetObject.getObjectMount();
   if(%vehicle)
      %vehicle.getDataBlock().damageObject(%vehicle, %sourceObject, %position, %amount, %damageType, %vec, %client, %projectile);
}

function LOSDownTurret::onTrigger(%data, %obj, %trigger, %state)
{
   switch(%trigger)
   {
      case 0:
         if(%state)
            %obj.setImageTrigger(1, true);
         else
            %obj.setImageTrigger(1, false);
      case 2:
         if(%state)
            %obj.getDataBlock().playerDismount(%obj);
   }
}

function LOSDownTurret::playerDismount(%data, %obj)
{
   //Passenger Exiting
   %obj.fireTrigger = 0;
   %obj.setImageTrigger(1, false);

   %client = %obj.getControllingClient();
   %client.player.isBomber = false;
   commandToClient(%client, 'endBomberSight');
//   %client.player.setControlObject(%client.player);
   %client.player.mountVehicle = false;
//   %client.player.getDataBlock().doDismount(%client.player);

   if(%client.player.getState() !$= "Dead")
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);

   setTargetSensorGroup(%obj.getTarget(), 0);
   setTargetNeverVisMask(%obj.getTarget(), 0xffffffff);
}

datablock TurretImageData(LOSDownTeleporterImage)
{
   shapeFile                        = "turret_tank_barrelchain.dts";
   offset                           = "0 0 0";
   mountPoint                       = 1;

//   projectile                       = NuclearBomb;
//   projectileType                   = BombProjectile;
   usesEnergy                       = true;
   useMountEnergy                   = true;
   useCapacitor                     = true;
   fireEnergy                       = 1.0;
   minEnergy                        = 1.0;

   stateName[0]                     = "WaitFire";
   stateTransitionOnTriggerDown[0]  = "Fire";

   stateName[1]                     = "Fire";
   stateTransitionOnTimeout[1]      = "StopFire";
   stateTimeoutValue[1]             = 1.5;
   stateFire[1]                     = true;
   stateAllowImageChange[1]         = false;
   stateSequence[1]                 = "Fire";
   stateScript[1]                   = "onFire";
//   stateSound[1]                    = NukeBombFireSound;

   stateName[2]                     = "StopFire";
   stateTimeoutValue[2]             = 0.1;
   stateTransitionOnTimeout[2]      = "WaitFire";
   stateScript[2]                   = "stopFire";
};

function LOSDownTeleporterImage::onFire(%data,%obj,%slot)
{
   %bomber = %obj.getObjectMount();
   %seat = %bomber.getMountNodeObject(2);

   if(isObject(%seat))
      %loaded = true;
   else
      %loaded = false;

   if(%loaded)
   {
      %vec = %obj.getMuzzleVector(%slot);
      %pos = %obj.getMuzzlePoint(%slot);
      %nVec = VectorNormalize(%vec);
      %scVec = VectorScale(%nVec, 250);
      %end = VectorAdd(%pos, %scVec);
      %searchResult = containerRayCast(%pos, %end, $TypeMasks::EverythingType, %obj);

      if(isObject(%result = firstWord(%searchResult)))
      {
         if(%result.getDataBlock().className $= "Armor")
            LDTBeginTeleportE(%bomber, %result, %bomber.getSlotPosition(2));
         else
         {
            %endPoint = getMuzzleRaycastPt(%obj, 0, 250);
            %vec = vectorNeg(%obj.getMuzzleVector(0));
            %edp = vectorAdd(%vec, %endpoint);
            LDTBeginTeleportL(%bomber, %seat, %edp);
         }
      }
      else
      {
         %endPoint = getMuzzleRaycastPt(%obj, 0, 250);
         LDTBeginTeleportL(%bomber, %seat, %endpoint);
      }
   }
   else
   {
      %vec = %obj.getMuzzleVector(%slot);
      %pos = %obj.getMuzzlePoint(%slot);
      %nVec = VectorNormalize(%vec);
      %scVec = VectorScale(%nVec, 250);
      %end = VectorAdd(%pos, %scVec);
      %searchResult = containerRayCast(%pos, %end, $TypeMasks::EverythingType, %obj);

      if(isObject(%result = firstWord(%searchResult)))
      {
         if(%result.getDataBlock().className $= "Armor")
            LDTBeginTeleportE(%bomber, %result, %bomber.getSlotPosition(2));
      }
   }

   %t = new TargetProjectile()
   {
          dataBlock        = "DesignatorVis";
          initialDirection = %obj.getMuzzleVector(%slot);
          initialPosition  = %obj.getMuzzlePoint(%slot);
          sourceObject     = %obj;
          sourceSlot       = %slot;
          vehicleObject    = 0;
   };
   MissionCleanup.add(%t);
   schedule(250, 0, "killit", %t);
}

function LDTBeginTeleportL(%bomber, %obj, %pos)
{
   %obj.teleportStartFX();
   %obj.play3d(TeleportSound);
   schedule(2000, 0, LDTFinishTeleL, %bomber, %obj, %pos);
}

function LDTFinishTeleL(%bomber, %obj, %pos)
{
   %seat = %bomber.getMountNodeObject(2);

   if(isObject(%seat))
   {
      %seat.getDataBlock().doDismount(%seat, true);
      %seat.setPosition(vectorAdd(%seat.position, "0 0 2"));
   }

   %obj.setPosition(%pos);
   %obj.teleportEndFX();
}

function LDTBeginTeleportE(%bomber, %obj, %pos)
{
   %obj.teleportStartFX();
   %obj.play3d(TeleportSound);
   schedule(2000, 0, LDTFinishTeleE, %bomber, %obj, %pos);
}

function LDTFinishTeleE(%bomber, %obj, %pos)
{
   %seat = %bomber.getMountNodeObject(2);

   if(isObject(%seat))
   {
      %seat.getDataBlock().doDismount(%seat, true);
      %seat.setPosition(vectorAdd(%seat.position, "0 0 2"));
   }

   %obj.setPosition(%bomber.getSlotPosition(2));
   %obj.teleportEndFX();
}
