if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//**************************************************************
// All Terrain Vehicle
//**************************************************************

datablock HoverVehicleData(ATV) : WildcatDamageProfile
{
   spawnOffset = "0 0 1";

   floatingGravMag = 4;

   catagory = "Vehicles";
   shapeFile = "vehicle_air_scout.dts";

   debrisShapeName = "vehicle_air_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 5000.0;

   mountPose[0] = sitting;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 0.5;
	explosionRadius = 5.0;

   maxDamage = 3.0;
   destroyedLevel = 3.0;

   isShielded = false;
   rechargeRate = 1.0;
   energyPerDamagePoint = 0;
   maxEnergy = 200;
   minJetEnergy = 15;
   jetEnergyDrain = 1.3;

   // Rigid Body
   mass = 100;
   bodyFriction = 0.1;
   bodyRestitution = 0.9;
   softImpactSpeed = 999;       // Play SoftImpact Sound
   hardImpactSpeed = 1024;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 999;
   speedDamageScale = 0;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 0;
   collDamageMultiplier   = 0;

   dragForce            = 0.266; // 0.266
   vertFactor           = 0.0;
   floatingThrustFactor = 0.35;

   mainThrustForce    = 36;
   reverseThrustForce = 21;
   strafeThrustForce  = 24;
   turboFactor        = 3.142857;    // 22/7

   brakingForce = 25;
   brakingActivationSpeed = 4;

   stabLenMin = 5.0;
   stabLenMax = 6.25;
   stabSpringConstant  = 30;
   stabDampingConstant = 20;

   gyroDrag = 16;
   normalForce = 60;
   restorativeForce = 20;
   steeringForce = 25;
   rollForce  = 15;
   pitchForce = 15;

   dustEmitter = TankDustEmitter;
   triggerDustHeight = 5;
   dustHeight = 1.0;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 5;
   dustTrailFreqMod = 15.0;

   jetSound         = ScoutFlyerThrustSound;
   engineSound      = HAPCFlyerEngineSound;
   floatSound       = ScoutThrustSound;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   wheelImpactSound = WheelImpactSound;

   forwardJetEmitter = ShrikeEngineEmitter;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 20.0;
   hardSplashSoundVelocity = 30.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterSoftSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterSoftSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeSoftSplashSound;

   minMountDist = 4;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = Tactical;
   cmdIcon = CMDHoverScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Land Speeder';
   targetTypeTag = 'Hypergrav ATV';
   sensorData = VehiclePulseSensor;

   checkRadius = 1.7785;
   observeParameters = "1 10 10";

//   runningLight[0] = ShrikeLight1;

   shieldEffectScale = "0.9375 1.125 0.6";
};

datablock ShapeBaseImageData(ATVFrontDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "1 0 0 -25";
   offset = "0 5.25 -1.5";
};

datablock ShapeBaseImageData(ATVLeftDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = calcThisRotD("-180 150 180"); //"1 0 0 -90";
   offset = "4.6 0 -2.5";
};

datablock ShapeBaseImageData(ATVRightDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = calcThisRotD("-180 -150 180"); //"1 0 0 -90";
   offset = "-4.6 0 -2.5";
};

datablock FlyingVehicleData(ATV2) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_bomber.dts";
   multipassenger = true;

   debrisShapeName = "vehicle_air_bomber_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   mountPose[0] = sitting;
   numMountPoints = 3;
   isProtectedMountPoint[0] = false;
   isProtectedMountPoint[1] = false;
   isProtectedMountPoint[2] = false;
   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = LargeGroundVehicleExplosion;
	explosionDamage = 2.5;
	explosionRadius = 25;

   keepReticle = true;

   maxDamage = 5;
   destroyedLevel = 5;

   isShielded = false;
   energyPerDamagePoint = 0;
   maxEnergy = 1000;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 600;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 2.0;

   maxAutoSpeed = 1;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 700;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 100;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 3;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3000;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1300;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 350;      // Steering jets (how much you heel over when you turn)
   rollForce = 8;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 1250;
   // Turbo Jet
   jetForce = 3000;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 1;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.0;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 0.75;

   // Rigid body
   mass = 150;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 1.0;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 25;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 55.56;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 32;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.03;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 48.0;
   collDamageMultiplier   = 0.0125;
   //
   minTrailSpeed = 400;      // The speed your contrail shows up at.
   trailEmitter = WarpTrailEmitter;
   forwardJetEmitter = TurboJetEmitter;
   downJetEmitter = TurboJetEmitter;

   //
   jetSound = HAPCFlyerThrustSound;
   engineSound = ScoutThrustSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 15.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   //
   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'PQZ StarShine';
   targetTypeTag = 'WarpCore Transport';
   sensorData = AWACPulseSensor;
   sensorRadius = AWACPulseSensor.detectRadius;
   sensorColor = "255 194 9";

   checkRadius = 5.5;
   observeParameters = "1 10 10";

   shieldEffectScale = "0.937 1.125 0.60";
};

datablock AudioProfile(ATVTransform)
{
	filename = "fx/powered/inv_pad_off.wav";
	description = AudioDefault3d;
    preload = true;
};

datablock StaticShapeData(PQZMainDecal)
{
//   mountPoint = 1;
   shapeFile = "vehicle_air_bomber.dts";
};

function phase1Init(%obj)
{
     if(isObject(%obj) && %obj.reactorOn)
     {
          commandToClient( %obj.client, 'BottomPrint', "<color:00FF11><font:sui generis:18>Charging Warp Nacelle Capacitor: "@%obj.nacellePct@"%", 5, 1);
          %obj.playshieldeffect("0 0 1");
          %obj.nacellePct += 1;
          if(%obj.nacellePct <= 100)
               schedule(50, 0, "phase1Init", %obj);
          else
          {
          	%obj.playThread(0, "activate");
               %obj.setFrozenState(true);
               schedule(500, 0, "phase2Init", %obj);
          }
     }
}

function phase2Init(%obj)
{
     if(isObject(%obj) && %obj.reactorOn)
     {
      %obj.zapcnt++;

      if(%obj.zapCnt > 3)
      {
          %obj.client.player.zap = new ShockLanceProjectile()
          {
               dataBlock        = "firelancebolt";
               initialDirection = "0 0 -0.5";
               initialPosition  = vectorAdd(%obj.client.player.getPosition(), "0 0 0.6");
               sourceObject     = %obj;
               sourceSlot       = 0;
               targetId         = %obj;
          };
          MissionCleanup.add(%obj.client.player.zap);
          %obj.zapCnt = 0;
      }
          %obj.nacellePct = 0; // reset fun time :)
          %obj.chargingWarp = true;
          %vec = vectorScale(%obj.getMuzzleVector(0), 2);
          %force = %obj.getDatablock().mass;
          %newVec = VectorScale(%vec, %force);
          %obj.impulse = %newVec;
          %obj.applyImpulse(%obj.getTransform(), %obj.impulse);
          %obj.vel = velToSingle(%obj.getVelocity());
          %obj.load = msToKPH(%obj.vel);
          %obj.wcLoad = (mSqrt(cube(%obj.load * 2.6) / (3.14 * (22/7)))) / 2;
          commandToClient( %obj.client, 'BottomPrint', "<color:CCCC11><font:sui generis:18>Warp Core Load: "@%obj.wcLoad, 5, 1);

          if(%obj.vel < 800)
               schedule(100, 0, "phase2Init", %obj);
          else
          {
               commandToClient(%obj.client, 'BottomPrint', "<color:FF0000><font:sui generis:32>>>>CRITICAL MASS<<<<", 5, 2);
               schedule(1000, 0, "phase3Init", %obj);
          }
     }
}

function phase3Init(%obj)
{
     if(isObject(%obj) && %obj.reactorOn)
     {
          %obj.setFrozenState(false);
          %obj.playShieldEffect("0.0 0.0 1.0");
          loopWarpCounterSpeed(%obj);
     }
}

function loopWarpCounterSpeed(%obj)
{
     if(isObject(%obj) && %obj.reactorOn && %obj.getMountedObject(0))
     {
          %obj.maxSpeed = msToKPH(velToSingle(%obj.getVelocity()));
          %obj.inWarp = true;
          %obj.chargingWarp = false;
          %vec = %obj.getMuzzleVector(0);
          if(%obj.maxSpeed >= 4100)
              %force = %obj.getDatablock().mass*5;
          else
              %force = %obj.getDatablock().mass*15;
          %newVec = VectorScale(%vec, %force);
          %obj.applyImpulse(%obj.getTransform(), %newVec);
          %obj.spd = velToSingle(%obj.getVelocity());
          %obj.spdNrm = msToKPH(%obj.spd);
          %obj.wcCount += 1;
          %obj.wcMax = 1000;
          %obj.wcPct = %obj.wcCount / %obj.wcMax;
          if(%obj.getMountNodeObject(0) && %obj.getMountedObject(0))
               commandToClient(%obj.client, 'BottomPrint', "Speed: "@%obj.spdNrm@" KPH | Warp Core Stress: "@%obj.wcPct@"%", 1, 1);

          if(%obj.wcPct < 100)
               schedule(50, 0, "loopWarpCounterSpeed", %obj);
          else
          {
               if(%obj.getDamageState() !$= Destroyed)      // hehe
                    %obj.setDamageState(Destroyed);
          }
     }
     else if(isObject(%obj))
          warpCoreCoolDown(%obj);
}

function warpCoreCoolDown(%obj)
{
     if(isObject(%obj) && !%obj.inWarp)
     {
          if(%obj.wcCount > 4)
               %obj.wcCount -= 4;
               
          schedule(200, 0, "warpCoreCoolDown", %obj);
     }
}

function enableWarp(%a)
{
     %a.canWarp = true;
}

function ATV2::onTrigger(%data, %obj, %trigger, %state)
{
}

function oldATVTrugger()
{
     if(%trigger == 0)
     {
          if(!%obj.reactorOn && %obj.canWarp)
          {
               %obj.canWarp = false;
               %obj.reactorOn = true;
               %obj.nacellePct = 0;
               %obj.chargingWarp = false;
               %obj.inWarp = false;
               commandToClient( %obj.client, 'BottomPrint', "<font:sui generis:18>Initializing Warp Core Overdrive...", 5, 1); // This should be interesting.....
               schedule(4500, 0, "phase1Init", %obj);
          }
          else if(%obj.reactorOn && (%obj.chargingWarp || %obj.inWarp))
          {
               %obj.reactorOn = false;
               %obj.setFrozenState(false);
               commandtoClient( %obj.client, 'BottomPrint', "<font:sui generis:18>Warp Core De-Activated.", 5, 1); // This should be interesting.....
               schedule(1000, 0, "enableWarp", %obj);
          }
          else return;
     }
}

function enhanceATx(%obj)
{
     if(isObject(%obj))
     {
//          %vec = vectorScale(%obj.getMuzzleVector(0), 2);
//          %force = %obj.getDatablock().mass*32;
          %force2 = %obj.getDatablock().mass*5.5;
//          %newVec = VectorScale(%vec, %force2);
          %newVec2 = VectorScale("0 0 1", %force2);
//          %obj.applyImpulse(%obj.getTransform(), %newVec);
          %obj.applyImpulse(%obj.getTransform(), %newVec2);
          %obj.setEnergyLevel(%obj.getEnergyLevel() - (8/20));
//          schedule(100, 0, "enhanceATx", %obj, %bool);
     }
}

datablock ShapeBaseImageData(ATVTriggerImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   item      = Chaingun;
   mountPoint = 10;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 1;
   fireEnergy = 1;
   fireTimeout = 1;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
//   stateSound[4]            = PlasmaFireSound;
   stateTimeoutValue[4]          = 0.01;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

function ATVxTriggerImage::onFire(%data, %obj, %slot)
{
     enhanceATX(%obj);
}

function UnATV::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
          switch(%state)
          {
               case 0:
               %obj.fireWeapon = false;
               %obj.setImageTrigger(0, false);
               case 1:
               %obj.fireWeapon = true;
               %obj.setImageTrigger(0, true);
          }
//          if(%state)
//               %obj.setImageTrigger(0, true);
//          else
//               %obj.setImageTrigger(0, false);
     }
}

function xATV::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
           %vehicle = new FlyingVehicle()
           {
              dataBlock  = "ATV2";
              respawn    = "0";
              teamBought = %obj.Team;
              team = %obj.Team;
           };
           %pl = %obj.getMountNodeObject(0);   // player mounted in slot 0

           %vehicle.setTransform(modifyTransform(%pl.getTransform(), "0 0 1.5 0 0 0 0"));
           %pl.getDataBlock().onCollision(%pl, %vehicle, 0);
           %data = %vehicle.getDatablock();
           serverPlay3D("ATVTransform", %obj.getTransform());

          %dmg = %obj.getDatablock().maxDamage / %obj.getDamageLevel();
          %vehicle.setDamageLevel(%dmg * %vehicle.getDatablock().maxDamage);

          if((%data.sensorData !$= "") && (%vehicle.getTarget() != -1))
                setTargetSensorData(%vehicle.getTarget(), %data.sensorData);
             %vehicle.setRechargeRate(%data.rechargeRate);
             %vehicle.setEnergyLevel(%obj.getEnergylevel());

          if(%vehicle.mountable || %vehicle.mountable $= "")
                %data.isMountable(%vehicle, true);
             else
                %data.isMountable(%vehicle, false);

          %vehicle.setSelfPowered();

          %vehicle.team = %obj.Team;
          %vehicle.owner = %pl.client;
          MissionCleanup.add(%vehicle);
          %vel = velToSingle(%obj.getVelocity());
          %vec = %obj.getForwardVector();
          %pos = %obj.getWorldBoxCenter();
          %rot = %obj.getRotation();
          %vehicle.applyImpulse(%pos, VectorScale(%vec, %vel));
          %vehicle.setRotation(%rot);

          %obj.setTransform("10000 10000 10000 1 0 0 0");
          %obj.lastDamagedBy = "";
          %obj.applyDamage(10000);
          %obj.delete();

          messageClient(%pl.client, '', '\c2ATV now in Sky Cutter mode.');
     }
}

function xATV2::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
           %vehicle = new HoverVehicle()
           {
              dataBlock  = "ATV";
              respawn    = "0";
              teamBought = %obj.Team;
              team = %obj.Team;
           };
           %pl = %obj.getMountNodeObject(0);   // player mounted in slot 0

           %vehicle.setTransform(modifyTransform(%pl.getTransform(), "0 0 1.5 0 0 0 0"));
           %pl.getDataBlock().onCollision(%pl, %vehicle, 0);
           %data = %vehicle.getDatablock();
           serverPlay3D("ATVTransform", %obj.getTransform());

          %dmg = %obj.getDatablock().maxDamage / %obj.getDamageLevel();
          %vehicle.setDamageLevel(%dmg * %vehicle.getDatablock().maxDamage);

          if((%data.sensorData !$= "") && (%vehicle.getTarget() != -1))
                setTargetSensorData(%vehicle.getTarget(), %data.sensorData);
             %vehicle.setRechargeRate(%data.rechargeRate);
             %vehicle.setEnergyLevel(%obj.getEnergylevel());

          if(%vehicle.mountable || %vehicle.mountable $= "")
                %data.isMountable(%vehicle, true);
             else
                %data.isMountable(%vehicle, false);

          %vehicle.setSelfPowered();

          %vehicle.team = %obj.Team;
          %vehicle.owner = %pl.client;
          MissionCleanup.add(%vehicle);
          %vel = velToSingle(%obj.getVelocity());
          %vec = %obj.getForwardVector();
          %pos = %obj.getWorldBoxCenter();
          %rot = %obj.getRotation();
          %vehicle.applyImpulse(%pos, VectorScale(%vec, %vel));
          %vehicle.setRotation(%rot);

          %obj.setTransform("10000 10000 10000 1 0 0 0");
          %obj.lastDamagedBy = "";
          %obj.applyDamage(10000);
          %obj.delete();

          messageClient(%pl.client, '', '\c2ATV now in Land Skimmer mode.');

     }
}

function ATV::playerDismounted(%data, %obj, %player)
{
     setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

function ATV2::playerDismounted(%data, %obj, %player)
{
     setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

datablock StaticShapeData(WarpBubble)
{
   shapeFile = "grenade_flare.dts";
};

datablock StaticShapeData(WarpCore)
{
   shapeFile = "station_generator_large.dts";
//   emap = true;
   maxDamage = WarpFlyer.maxDamage;
   destroyedLevel = WarpFlyer.destroyedLevel;
};

function WarpCore::onDamage(%data, %obj)
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function WarpCore::damageObject(%this, %targetObject, %sourceObject, %position, %amount, %damageType ,%vec, %client, %projectile)
{
   //If vehicle turret is hit then apply damage to the vehicle
   %vehicle = %targetObject.getObjectMount();
   if(%vehicle)
      %vehicle.getDataBlock().damageObject(%vehicle, %sourceObject, %position, %amount, %damageType, %vec, %client, %projectile);
}

datablock StaticShapeData(HoleEntry)
{
   shapeFile = "energy_explosion.dts";
};

datablock StaticShapeData(Subspace)
{
   shapeFile = "grenade_flare.dts";
};

datablock ShockLanceProjectileData(GeneratorPowerup)
{
   directDamage        = 0;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 0;
   velInheritFactor    = 0;
   sound               = "";

   zapDuration = 6;
   impulse = 0;
   boltLength = 14.0;
   extension = 14.0;            // script variable indicating distance you can shock people from
   lightningFreq = 50.0;
   lightningDensity = 18.0;
   lightningAmp = 0.25;
   lightningWidth = 0.05;


   boltSpeed[0] = 2.0;
   boltSpeed[1] = -0.5;

   texWrap[0] = 1.5;
   texWrap[1] = 1.5;

   startWidth[0] = 0.3;
   endWidth[0] = 0.6;
   startWidth[1] = 0.3;
   endWidth[1] = 0.6;

   texture[0] = "special/jammermap";
   texture[1] = "special/jammermap";
   texture[2] = "special/cloaktexture";
   texture[3] = "special/jammermap";
};

datablock ShockLanceProjectileData(BlueShift)
{
   directDamage        = 0;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 0;
   velInheritFactor    = 0;
   sound               = "";

   zapDuration = 0.4;
   impulse = 0;
   boltLength = 14.0;
   extension = 14.0;            // script variable indicating distance you can shock people from
   lightningFreq = 50.0;
   lightningDensity = 18.0;
   lightningAmp = 0.25;
   lightningWidth = 0.05;


   boltSpeed[0] = 2.0;
   boltSpeed[1] = -0.5;

   texWrap[0] = 1.5;
   texWrap[1] = 1.5;

   startWidth[0] = 0.3;
   endWidth[0] = 0.6;
   startWidth[1] = 0.3;
   endWidth[1] = 0.6;

   texture[0] = "special/shieldenvmap";
   texture[1] = "special/shieldmap";
   texture[2] = "special/shieldenvmap";
   texture[3] = "special/shieldmap";
};

function WarpFlyer::playerDismounted(%data, %obj, %player)
{
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(3, false);
   %obj.setImageTrigger(4, false);
   setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

function WarpPlasmaMainImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 3;
   schedule(250, 0, "fireNextWarp", %obj);
}

function WarpPlasmaSideAImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 4;
   schedule(250, 0, "fireNextWarp", %obj);
}

function WarpPlasmaSideBImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 2;
   schedule(250, 0, "fireNextWarp", %obj);
}

//Warp core functions

function WSInitCore(%obj)
{
   if(!isObject(%obj))
      return;

   if(%obj.WarpCoreActive)
   {
      %obj.zapCnt++;
      if(%obj.zapCnt > 4)
      {
         if(!isObject(%obj.client.player))
            return;
         %obj.client.player.zap = new ShockLanceProjectile()
         {
            dataBlock        = "blueshift";
            initialDirection = "0 0 -0.5";
            initialPosition  = vectorAdd(%obj.client.player.getPosition(), "0 0 0.6");
            sourceObject     = %obj;
            sourceSlot       = 0;
            targetId         = %obj;
         };
         MissionCleanup.add(%obj.client.player.zap);

         %obj.client.player.zap2 = new ShockLanceProjectile()
         {
            dataBlock        = "blueshift";
            initialDirection = "0 0 -0.5";
            initialPosition  = vectorAdd(%obj.client.player.getPosition(), "0 0 0.6");
            sourceObject     = %obj;
            sourceSlot       = 0;
            targetId         = %obj.core;
         };
         MissionCleanup.add(%obj.client.player.zap2);
         %obj.zapCnt = 0;
      }
   }

   %obj.nacellePct++;
   %out = graphBar100(%obj.nacellePct);

   if(%obj.nacellePct < 33)
      %color = "<color:FF0000>";
   else if(%obj.nacellePct < 66)
      %color = "<color:FFFF00>";
   else
      %color = "<color:00FF00>";

   %nacelleFX = %color @ %obj.nacellePct;
   commandToClient( %obj.client, 'BottomPrint', "<color:00FF11><font:sui generis:18>Warp core charging: "@%nacelleFX@"%\n"@%out, 5, 2);

   if(%obj.nacellePct <= 100)
      schedule(50, 0, "WSInitCore", %obj);
   else
   {
      %obj.setFrozenState(true);

      %pos = %obj.getPosition();
      %nvec = vectorNormalize(%obj.getMuzzleVector(0));
      %vec = vectorScale(%nvec, 25);
      %new = vectorAdd(%pos, %vec);

      %wormhole = new StaticShape()
      {
         scale = "15 15 15";
         dataBlock = "Subspace";
      };
      MissionCleanup.add(%wormhole);
      %obj.wormhole = %wormhole;
      %wormhole.setPosition(%new);
      %wormhole.playThread(0, "throw");
      %wormhole.startfade(1000, 0, false);

      %pos2 = %obj.getPosition();
      %nvec2 = vectorNormalize(%obj.getMuzzleVector(0));
      %vec2 = vectorScale(%nvec2, -13);
      %new2 = vectorAdd(%pos2, %vec2);

      %wormhole2 = new StaticShape()
      {
         scale = "50 50 50";
         dataBlock = "HoleEntry";
      };
      MissionCleanup.add(%wormhole2);
      %obj.wormhole2 = %wormhole2;
      %wormhole2.setPosition(%new2);
      %wormhole2.playThread(0, "ambient");
      %wormhole2.startfade(1000, 0, false);
      %wormhole2.setRotation(%obj.getRotation());

      %obj.applyImpulse(%obj.getTransform(), %obj.impulse);
      schedule(500, 0, "WSPhase2", %obj);
   }
}

function WSPhase2(%obj)
{
   if(isObject(%obj) && %obj.WarpCoreActive)
   {
      %obj.zapcnt++;

      if(%obj.zapCnt > 3)
      {
          %field = %obj.getMountNodeObject(6);
          %core = %obj.getMountNodeObject(7);

          %obj.client.player.zap = new ShockLanceProjectile()
          {
               dataBlock        = "firelancebolt";
               initialDirection = "0 0 -0.5";
               initialPosition  = vectorAdd(%obj.client.player.getPosition(), "0 0 0.6");
               sourceObject     = %obj;
               sourceSlot       = 0;
               targetId         = %obj;
          };
          MissionCleanup.add(%obj.client.player.zap);

          %obj.client.player.zap2 = new ShockLanceProjectile()
          {
               dataBlock        = "basicshocker";
               initialDirection = "0 0 -0.5";
               initialPosition  = vectorAdd(%obj.client.player.getPosition(), "0 0 0.6");
               sourceObject     = %obj;
               sourceSlot       = 0;
               targetId         = %core;
          };
          MissionCleanup.add(%obj.client.player.zap2);
          %obj.zapCnt = 0;
      }

      %obj.nacellePct = 0; // reset fun time :)
      %obj.chargingWarp = true;
      %vec = vectorScale(%obj.getMuzzleVector(0), (3 + getRandomT()));
      %force = %obj.getDatablock().mass;
      %newVec = VectorScale(%vec, %force);
      %obj.impulse = %newVec;
      %obj.applyImpulse(%obj.getTransform(), %obj.impulse);
      %obj.vel = velToSingle(%obj.getVelocity());
      %obj.load = msToKPH(%obj.vel);
      %obj.wcLoad = (mSqrt(cube(%obj.load * 2.6) / (3.14 * (22/7)))) / 2;
      %obj.wclPct = mFloor((%obj.wcLoad / 16000) * 100);

//      %out = graphBar100(%obj.wclPct);
      commandToClient( %obj.client, 'BottomPrint', "<color:CCCC11><font:sui generis:18>Warp Core Load: "@%obj.wcLoad@" / 16000 ("@%obj.wclPct@"%)", 5, 1);

      if(%obj.vel < 237.5)
         schedule(100, 0, "WSPhase2", %obj);
      else
      {
         commandToClient(%obj.client, 'BottomPrint', "<color:FF0000><font:sui generis:32>>>>CRITICAL MASS<<<<", 5, 2);
         %obj.setCloaked(true);
         %obj.core.setCloaked(true);
         schedule(1000, 0, "WSPhase3", %obj);
      }
   }
}

function WSPhase3(%obj)
{
     if(isObject(%obj) && %obj.WarpCoreActive)
     {
          %obj.setFrozenState(false);
          %obj.playShieldEffect("0.0 0.0 1.0");
          %obj.applyImpulse(%obj.getPosition(), %obj.vel);
          %obj.wormhole.startfade(5000, 0, true);
          %obj.wormhole2.startfade(5000, 0, true);
          WSPhase4(%obj);
     }
}

function WSPhase4(%obj)
{
     if(isObject(%obj) && %obj.WarpCoreActive && %obj.getMountedObject(0))
     {
          %obj.setCloaked(false);
          %obj.core.setCloaked(false);
          %obj.maxSpeed = msToKPH(velToSingle(%obj.getVelocity()));
          %obj.inWarp = true;
          %obj.chargingWarp = false;
          %vec = vectorNormalize(%obj.getForwardVector());//%obj.getMuzzleVector(7);
          if(%obj.maxSpeed >= 2200) // 5375 // 694.444 m/s
              %force = %obj.getDatablock().mass*5;
          else
//          %force = 694.444 * %obj.getMass() * (%obj.getAccel() * 1000);
              %force = %obj.getDatablock().mass*10;
          %newVec = VectorScale(%vec, %force);
          %obj.applyImpulse(%obj.getTransform(), %newVec);
          %obj.spd = velToSingle(%obj.getVelocity());
          %obj.spdNrm = msToKPH(%obj.spd) / 1000;
          %obj.wcCount += 1;
          %obj.wcMax = 100;
          %obj.wcPct = mFloor(%obj.wcCount / %obj.wcMax);

//          %out = graphBar100R(%obj.wcPct, 75, 85, false);

          if(%obj.getMountNodeObject(0) && %obj.getMountedObject(0))
               commandToClient(%obj.client, 'BottomPrint', "Speed: Warp "@%obj.spdNrm@" >> "@velToSingle(%obj.getVelocity())@" m/s | Warp Core Stress: "@%obj.wcPct@"%", 2, 1);

          if(%obj.wcPct < 100)
               schedule(50, 0, "WSPhase4", %obj);
          else
          {
               if(%obj.getDamageState() !$= Destroyed)      // hehe
                    %obj.setDamageState(Destroyed);
          }
     }
     else if(isObject(%obj))
         warpCoreCoolDown(%obj);
}

function warpCoreCoolDown(%obj)
{
     if(isObject(%obj) && !%obj.inWarp)
     {
          if(%obj.wcCount > 4)
               %obj.wcCount -= 4;

          schedule(200, 0, "warpCoreCoolDown", %obj);
     }
}

function enableWarp(%a)
{
   %a.haltInfoBar = false;
   %a.canWarp = true;
}

function InitWarpCore(%obj)
{
   if(!%obj.canWarp)
      return;

   if(!%obj.WarpCoreActive)
   {
      %obj.WarpCoreActive = true;
      %obj.nacellePct = 0;
      %obj.chargingWarp = false;
      %obj.inWarp = false;

      %obj.client.player.zap = new ShockLanceProjectile()
      {
         dataBlock        = "generatorPowerup";
         initialDirection = "0 0 -0.5";
         initialPosition  = vectorAdd(%obj.client.player.getPosition(), "0 0 0.6");
         sourceObject     = %obj;
         sourceSlot       = 0;
         targetId         = %obj.core;
      };
      %obj.haltInfoBar = true;
      MissionCleanup.add(%obj.client.player.zap);
      %obj.field.startFade(4500, 0, false);
      commandToClient( %obj.client, 'BottomPrint', "<font:sui generis:18>Warp Core powering up...", 5, 1); // This should be interesting.....
      schedule(4500, 0, "WSInitCore", %obj);
   }
   else //if(%obj.WarpCoreActive && (%obj.chargingWarp || %obj.inWarp))
   {
      if(isObject(%obj.wormhole))
         %obj.wormhole.delete();
      if(isObject(%obj.wormhole2))
         %obj.wormhole2.delete();

      %obj.canWarp = false;
      %obj.setCloaked(false);
      %obj.core.setCloaked(false);
      %obj.WarpCoreActive = false;
      %obj.setFrozenState(false);
      %obj.field.startFade(1500, 0, true);
      commandtoClient( %obj.client, 'BottomPrint', "<font:sui generis:18>Warp Core powering down.", 5, 1); // This should be interesting.....
      schedule(5000, 0, "enableWarp", %obj);
   }
}
