if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//**************************************************************
// Hover Bike
//**************************************************************
datablock SensorData(HoverBikeSensor) //the uber eye-in-the-sky
{
   detects = true;
   detectsUsingLOS = true;
   detectsPassiveJammed = true;
   detectsActiveJammed = false;
   detectsCloaked = true;
   detectionPings = true;
   detectRadius = 300;
};

datablock FlyingVehicleData(HoverBike) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_scout.dts";
   multipassenger = false;

   debrisShapeName = "vehicle_grav_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   mountPose[0] = scoutRoot;
   cameraMaxDist = 5.0;
   cameraOffset = 0.7;
   cameraLag = 0.5;
   numMountPoints = 1;
   isProtectedMountPoint[0] = false;
   explosion = TFlakMortarExplosion;
	explosionDamage = 1.125;
	explosionRadius = 25;

   lightOnly = 1;

   maxDamage = 0.4;
   destroyedLevel = 0.4;

   isShielded = false;
   energyPerDamagePoint = 350;
   maxEnergy = 350;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.7;

   maxAutoSpeed = 8;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 360;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
//   autoAngularForce = 678;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 150;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.9;      // Dampen control input so you don't` whack out at very slow speeds
   
   // Maneuvering
   maxSteeringAngle = 4;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 8;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 6;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3250;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1500;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 550;      // Steering jets (how much you heel over when you turn)
   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 2;        // Height off the ground at rest
   createHoverHeight = 2;  // Height off the ground when created
   maxForwardSpeed = 11000;

   // Turbo Jet
   jetForce = 3250;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 16;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.0;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 1.5;

   // Rigid body
   mass = 100;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 40;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 80;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 20;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.01;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 40.0; //20? you sick bastard! Death~bot
   collDamageMultiplier   = 0.02; //0.0446; this was the evil part was 1

   //
   minTrailSpeed = 25;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = TurboJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = AssaultVehicleThrustSound;
   engineSound = MPBEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;
   
   //
   softSplashSoundVelocity = 10.0; 
   mediumSplashSoundVelocity = 15.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound; 
    
   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 0.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   sensorColor = "0 212 45";
   sensorData = HoverBikeSensor;
   sensorRadius = HoverBikeSensor.detectRadius;
   cmdCategory = "Tactical";
   cmdIcon = CMDHoverScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_landscout_grey";
   targetNameTag = 'Hover';
   targetTypeTag = 'Bike';

//   runningLight[0] = WildcatLight1;
//   runningLight[1] = WildcatLight2;
//   runningLight[2] = WildcatLight3;

   shieldEffectScale = "0.937 1.125 0.60";
   numWeapons = 2;
//   keepReticle = true;
};

datablock StaticShapeData(HBMainDecal)
{
   mountPoint = 1;
   shapeFile = "vehicle_air_bomber.dts";
};
//-Nite- Drones removed
//datablock StaticShapeData(DroneMainDecal)
//{
//   mountPoint = 1;
//   shapeFile = "weapon_missile_projectile.dts";
//   emap = true;
//   maxDamage = DroneBike.maxDamage;
//   destroyedLevel = DroneBike.destroyedLevel;
//};
//-Nite- drones removed
//function DroneMainDecal::onDamage(%data, %obj)
//{
//   %newDamageVal = %obj.getDamageLevel();
//   if(%obj.lastDamageVal !$= "")
//      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
//         %obj.getObjectMount().setDamageLevel(%newDamageVal);
//   %obj.lastDamageVal = %newDamageVal;
//}
//-Nite- masa el dronio
//function DroneMainDecal::damageObject(%this, %targetObject, %sourceObject, %position, %amount, %damageType ,%vec, %client, %projectile)
//{
//   //If vehicle turret is hit then apply damage to the vehicle
//   %vehicle = %targetObject.getObjectMount();
//   if(%vehicle)
//      %vehicle.getDataBlock().damageObject(%vehicle, %sourceObject, %position, %amount, %damageType, %vec, %client, %projectile);
//}
//
datablock LinearProjectileData(BikeFlareBomb)
{
   projectileShapeName = "grenade_projectile.dts";
   scale               = "3 3 3";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.0;
   damageRadius        = 10.0;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 3500;
   bubbleEmitTime      = 1.0;

   sound               = GrenadeProjectileSound;
   explosion           = "ConcussionGrenadeExplosion";
   underwaterExplosion = "UnderwaterGrenadeExplosion";
   velInheritFactor    = 0.5;
   splash              = GrenadeSplash;

   baseEmitter         = GrenadeBubbleEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;

   dryVelocity       = 75;
   wetVelocity       = 75;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 500;
   lifetimeMS        = 500;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 2000;

   activateDelayMS = -1;

   hasLight    = false;
};

//**************************************************************
// WEAPONS
//**************************************************************
datablock ShapeBaseImageData(HBBomberImage)
{
   className = WeaponImage;
   shapeFile = "turret_belly_base.dts";
   //item      = Chaingun;
   projectile = BikeFlareBomb;
   projectileType = LinearProjectile;

   mountPoint = 10;       //?
   offset = "0.0 0.85 -0.45";
   //rotation = "1 0 45 -45";

   projectileSpread = 9.0 / 500.0;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 250;
   fireEnergy = 250;
   //fireTimeout = 75;

   //--------------------------------------
   stateName[0]                     = "WaitFire";
   stateTransitionOnTriggerDown[0]  = "Fire";

   stateName[1]                     = "Fire";
   stateTransitionOnTimeout[1]      = "StopFire";
   stateTimeoutValue[1]             = 0.6;
   stateFire[1]                     = true;
   stateRecoil[1]                   = LightRecoil;
   stateAllowImageChange[1]         = false;
   stateSequence[1]                 = "Fire";
   stateScript[1]                   = "onFire";
   stateSound[1]                    = BomberTurretFireSound;

   stateName[2]                     = "StopFire";
   stateTimeoutValue[2]             = 3.0;
   stateTransitionOnTimeout[2]      = "WaitFire";
   stateScript[2]                   = "stopFire";
};

//datablock ShapeBaseImageData(HBChaingunImage)
//{
//   className = WeaponImage;
//   shapeFile = "TR2weapon_chaingun.dts";
//   item      = Chaingun;
//   projectile = BikeFlareBomb;
//   projectileType = LinearProjectile;
//
//   mountPoint = 10;       //?
//   offset = "0.35 0.75 0";
//
//   casing              = ShellDebris;
//   shellExitDir        = "1.0 0.3 1.0";
//   shellExitOffset     = "0.15 -0.56 -0.1";
//   shellExitVariance   = 15.0;
//   shellVelocity       = 6.0;
//
//   usesEnergy = true;
//   useMountEnergy = true;
//   // DAVEG -- balancing numbers below!
//   minEnergy = 2.75;
//   fireEnergy = 2.75;
//   fireTimeout = 75;

//   //--------------------------------------
//   stateName[0]             = "Activate";
//   stateSequence[0]         = "Activate";
//   stateAllowImageChange[0] = false;
//   stateTimeoutValue[0]        = 0.05;
//   stateTransitionOnTimeout[0] = "Ready";
//   stateTransitionOnNoAmmo[0]  = "NoAmmo";
//   //--------------------------------------
//   stateName[1]       = "Ready";
//   stateSpinThread[1] = Stop;
//   stateTransitionOnTriggerDown[1] = "Spinup";
//   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
//   stateName[2]               = "NoAmmo";
//   stateSpinThread[2] = Stop;
//   stateTransitionOnAmmo[2]   = "Ready";
//   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
//   stateName[3]         = "Spinup";
//   stateTimeoutValue[3]          = 0.01;
//   stateSpinThread[3] = SpinUp;
//   stateWaitForTimeout[3]        = false;
//   stateTransitionOnTimeout[3]   = "Fire";
//   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
//   stateName[4]             = "Fire";
//   stateAllowImageChange[4] = false;
//   stateSpinThread[4]       = FullSpeed;
//   stateScript[4]           = "onFire";
//   stateFire[4]             = true;
//   stateEjectShell[4]       = true;
//   stateSequence[4]         = "Fire_Vis";
//   stateSound[4]            = FlierChaingunFireSound;
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
//   stateTimeoutValue[4]          = 0.1;
//   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
//   stateName[5]       = "Spindown";
//   stateSpinThread[5] = SpinDown;
//   stateTimeoutValue[5]            = 1.0;
//   stateWaitForTimeout[5]          = false;
//   stateTransitionOnTimeout[5]     = "Ready";
//   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
//   stateName[6]       = "EmptySpindown";
//   stateTransitionOnAmmo[6]   = "Ready";
//   stateSpinThread[6] = SpinDown;
//   stateWaitForTimeout[6]          = false;
//   stateTimeoutValue[6]        = 1.0;
//   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
//   stateName[7]       = "DryFire";
//   stateSound[7]      = ShrikeBlasterDryFireSound;
//   stateTransitionOnTriggerUp[7] = "NoAmmo";
//   stateTimeoutValue[7]        = 0.25;
//   stateSpinThread[7] = Stop;
//   stateTransitionOnTimeout[7] = "NoAmmo";

//   stateName[8] = "checkState";
//   stateTransitionOnTriggerUp[8] = "Spindown";
//   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
//   stateTimeoutValue[8]          = 0.01;
//   stateTransitionOnTimeout[8]   = "ready";
//};

//datablock ShapeBaseImageData(HBChaingunPairImage) : HBChaingunImage
//{
//   shapeFile = "TR2weapon_chaingun.dts";
//   offset = "-0.65 0.75 0";
//   rotation = "0 1 0 0";
//};

datablock ShapeBaseImageData(HBEngineParam)
{
   mountPoint = 1;
   shapeFile = "turret_assaulttank_plasma.dts"; //nexusbase.dts";
   //scale = "0.5 0.5 0.5";
   offset = "0 -3.0 0"; //.125 .075 -0.2
   rotation = "0 0 1 180"; //"1 0 45 90";

   //projectile = ChaingunBullet;
   //projectileType = TracerProjectile;
};

function HoverBike::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
          if(%obj.selectedWeapon == 1)
          {
               %obj.setImageTrigger(2, false);
               %obj.setImageTrigger(3, false);

               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(4, false);
                   case 1:
                   %obj.fireWeapon = true;
                   %obj.setImageTrigger(4, true);
               }
          }
          else
          {
               %obj.setImageTrigger(4, false);

               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(2, false);
                   %obj.setImageTrigger(3, false);
                   case 1:
                   %obj.fireWeapon = true;
                   %obj.setImageTrigger(2, true);
                   %obj.setImageTrigger(3, true);
               }
          }
     }
}

function HoverBike::playerDismounted(%data, %obj, %player)
{
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(3, false);
//   %obj.setImageTrigger(4, false);
   setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

function HBBomberImage::onFire(%data, %obj, %slot)
{
     if(%obj.getEnergyLevel() < 250)
       {
         serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
         return;
       }

     %p = new LinearProjectile() {
         dataBlock        = "BikeFlareBomb";
         initialDirection = "0 0 1"; //%obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
      MissionCleanup.add(%p);
      FlareSet.add(%p);
      %obj.useEnergy(250);
}

function BikeFlareBomb::onExplode(%data, %proj, %pos, %mod)
{
    // %player = %proj.client;

    // if(%player.DiscMode == 2)
    // {
          %projectile = "FlareGrenadeProj";
          %projectileType = "FlareProjectile";
    // }


     for(%i = 0; %i < 4; %i++)
     {
      %projectileSpread = 2.88;
      %vector = "1 2 1";  // 00-1 it was
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%projectileType)()
      {
         dataBlock        = %projectile;
         initialDirection = %vector;
         initialPosition  = %pos;
         sourceObject     = %proj.sourceObject;
         sourceSlot       = -1;
         vehicleObject    = 0;
      };

      MissionCleanup.add(%p);
     }
     Parent::onExplode(%data, %proj, %pos, %mod);

     //echo("onExplode");
}

function HBBobmerImage::onFire(%data,%obj,%slot)
{
   %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 0);

   %p = new LinearProjectile() {
      dataBlock        = "BikeFlareBomb";
      initialDirection = %vector;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };
   MissionCleanup.add(%p);
   %obj.useEnergy(%data.fireEnergy);
}

//function HBChaingunImage::onFire(%data,%obj,%slot)
//{
//   %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 0);
//
//   %p = new TracerProjectile() {
//      dataBlock        = "ChaingunBullet";
//      initialDirection = %vector;
//      initialPosition  = %obj.getMuzzlePoint(%slot);
//      sourceObject     = %obj;
//      sourceSlot       = %slot;
//      vehicleObject    = %vehicle;
//   };
//   MissionCleanup.add(%p);
//   %obj.useEnergy(%data.fireEnergy);
//}

//function HBChaingunPairImage::onFire(%data,%obj,%slot)
//{
//   %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 0);
//
//   %p = new TracerProjectile() {
//      dataBlock        = "ChaingunBullet";
//      initialDirection = %vector;
//      initialPosition  = %obj.getMuzzlePoint(%slot);
//      sourceObject     = %obj;
//      sourceSlot       = %slot;
//      vehicleObject    = %vehicle;
//   };
//   MissionCleanup.add(%p);
//   %obj.useEnergy(%data.fireEnergy);
//}

// Drone Bike
//-Nite- removed =[
//datablock FlyingVehicleData(DroneBike) : ShrikeDamageProfile
//{
//   spawnOffset = "0 0 2";
//
//   catagory = "Vehicles";
//   shapeFile = "vehicle_grav_scout.dts";
//   multipassenger = false;
//   forceSensitive = true;
//
//   debrisShapeName = "vehicle_grav_scout_debris.dts";
//   debris = ShapeDebris;
//   renderWhenDestroyed = false;
//
//   canControl = true; // test
//   disableMount = true;
//
//   drag    = 0.15;
//   density = 1.0;
//
//   cameraMaxDist = 5.0;
//   cameraOffset = 0.7;
//   cameraLag = 0.5;
//   numMountPoints = 1;
//   isProtectedMountPoint[0] = false;
//   explosion = TFlakMortarExplosion;
//	explosionDamage = 2.5;
//	explosionRadius = 35.0;
//
//   lightOnly = 1;
//
//   maxDamage = 0.3;
//   destroyedLevel = 0.3;
//
//   isShielded = false;
//   energyPerDamagePoint = 0;
//   maxEnergy = 500;      // Afterburner and any energy weapon pool
//   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
//   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
//   rechargeRate = 0.7;
//
//   maxAutoSpeed = 15;       // Autostabilizer kicks in when less than this speed. (meters/second)
// //  autoAngularForce = 400;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
//   autoAngularForce = 200;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
//   autoLinearForce = 200;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
//   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds
//
//   // Maneuvering
//   maxSteeringAngle = 4;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
//   horizontalSurfaceForce = 8;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
//   verticalSurfaceForce = 6;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
//   maneuveringForce = 3000;      // Horizontal jets (W,S,D,A key thrust)
//   steeringForce = 1500;         // Steering jets (force applied when you move the mouse)
//   steeringRollForce = 550;      // Steering jets (how much you heel over when you turn)
//   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
//   hoverHeight = 2;        // Height off the ground at rest
//   createHoverHeight = 2;  // Height off the ground when created
//   maxForwardSpeed = 11000;
//   // Turbo Jet
//   jetForce = 3000;      // Afterburner thrust (this is in addition to normal thrust)
//   minJetEnergy = 16;     // Afterburner can't be used if below this threshhold.
//   jetEnergyDrain = 2.0;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
//   vertThrustMultiple = 1.5;
//
//   // Rigid body
//   mass = 90;        // Mass of the vehicle
//   bodyFriction = 0;     // Don't mess with this.
//   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
//   minRollSpeed = 0;     // Don't mess with this.
//   softImpactSpeed = 40;       // Sound hooks. This is the soft hit.
//   hardImpactSpeed = 80;    // Sound hooks. This is the hard hit.
//
//   // Ground Impact Damage (uses DamageType::Ground)
//   minImpactSpeed = 40;      // If hit ground at speed above this then it's an impact. Meters/second
//   speedDamageScale = 0.03;
//
//   // Object Impact Damage (uses DamageType::Impact)
//   collDamageThresholdVel = 12.5;
//   collDamageMultiplier   = 0.05;
//
//   //
//   minTrailSpeed = 25;      // The speed your contrail shows up at.
//   trailEmitter = ContrailEmitter;
//   forwardJetEmitter = FlyerJetEmitter;
//   downJetEmitter = FlyerJetEmitter;
//
//   //
//   jetSound = ScoutFlyerThrustSound;
//   engineSound = ScoutThrustSound;
//   softImpactSound = SoftImpactSound;
//   hardImpactSound = HardImpactSound;
//   //wheelImpactSound = WheelImpactSound;
//
//   //
//   softSplashSoundVelocity = 10.0;
//   mediumSplashSoundVelocity = 15.0;
//   hardSplashSoundVelocity = 20.0;
//   exitSplashSoundVelocity = 10.0;
//
//   exitingWater      = VehicleExitWaterMediumSound;
//   impactWaterEasy   = VehicleImpactWaterSoftSound;
//   impactWaterMedium = VehicleImpactWaterMediumSound;
//   impactWaterHard   = VehicleImpactWaterMediumSound;
//   waterWakeSound    = VehicleWakeMediumSplashSound;
//
//   dustEmitter = VehicleLiftoffDustEmitter;
//   triggerDustHeight = 4.0;
//   dustHeight = 1.0;
//
//   damageEmitter[0] = SmallLightDamageSmoke;
//   damageEmitter[1] = SmallHeavyDamageSmoke;
//   damageEmitter[2] = DamageBubbles;
//   damageEmitterOffset[0] = "0.0 -1.5 0.5 ";
//   damageLevelTolerance[0] = 0.3;
//   damageLevelTolerance[1] = 0.7;
//   numDmgEmitterAreas = 1;
//
//   minMountDist = 4;
//
//   splashEmitter[0] = VehicleFoamDropletsEmitter;
//   splashEmitter[1] = VehicleFoamEmitter;
//
//   shieldImpact = VehicleShieldImpact;
//
//   cmdCategory = "Tactical";
//   cmdIcon = CMDHoverScoutIcon;
//   cmdMiniIconName = "commander/MiniIcons/com_landscout_grey";
//   targetNameTag = 'Remote';
//   targetTypeTag = 'Drone';
//   sensorData = VehiclePulseSensor;
//
//   runningLight[0] = WildcatLight1;
//   runningLight[1] = WildcatLight2;
//   runningLight[2] = WildcatLight3;
//
//   shieldEffectScale = "0.937 1.125 0.60";
//
//   cantAbandon = true;
//};
//
//function DroneBike::playerDismounted(%data, %obj, %player)
//{
//   setTargetSensorGroup(%obj.getTarget(), %obj.team);
//}

function HBChaingunImage::onFire(%data,%obj,%slot)
{
     Parent::onFire(%data,%obj,%slot);
     %obj.setImageTrigger(3, true);
}

function HBContrailLoop(%obj)
{
   if(isObject(%obj))
   {
      %speed = velToSingle(%obj.getVelocity());
      if(%speed >= 15)
      {
         %obj.setImageTrigger(5, true);
         %obj.setImageTrigger(6, true);
//         %obj.setImageTrigger(1, true);
//         %obj.setImageTrigger(7, true);
//         %obj.setImageTrigger(3, true);
      }
      else
      {
         %obj.setImageTrigger(5, false);
         %obj.setImageTrigger(6, false);
//         %obj.setImageTrigger(1, false);
//         %obj.setImageTrigger(7, false);
//         %obj.setImageTrigger(3, false);
      }

      schedule(50, 0, HBContrailLoop, %obj);
   }
}
