if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//**************************************************************
// SHRIKE SCOUT FLIER
//**************************************************************
//**************************************************************
// SOUNDS
//**************************************************************

datablock AudioProfile(ScoutFlyerThrustSound)
{
   filename    = "fx/vehicles/shrike_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(PWTFireSound)
{
   filename    = "fx/powered/turret_missile_fire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = BlankEffect; //MortarFireEffect;
};

datablock AudioProfile(MiniMissileFireSound)
{
   filename    = "fx/vehicles/crash_ground_vehicle.WAV";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(ScoutFlyerEngineSound)
{
   filename    = "fx/vehicles/shrike_engine.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(ShrikeBlasterFire)
{
   filename    = "fx/vehicles/shrike_blaster.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(ShrikeBlasterProjectile)
{
   filename    = "fx/weapons/shrike_blaster_projectile.wav";
   description = ProjectileLooping3d;
   preload = true;
};

datablock AudioProfile(ShrikeBlasterDryFireSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

//**************************************************************
// LIGHTS
//**************************************************************

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

Meltdown.MassVelMod[ScoutFlyer] = 1.0;
Meltdown.MaxDmgMod[ScoutFlyer] = 1.5;
Meltdown.ShieldPctMod[ScoutFlyer] = 1.25;

datablock FlyingVehicleData(ScoutFlyer) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_scout.dts";
   multipassenger = false;
   computeCRC = true;

   debrisShapeName = "vehicle_air_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   mountPose[0] = sitting;
   numMountPoints = 1;  
   isProtectedMountPoint[0] = true;
   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 0.75;
	explosionRadius = 25.0;

   keepReticle = true;
   
   maxDamage = 1.40*Meltdown.MaxDmgMod[ScoutFlyer];
   destroyedLevel = 1.40*Meltdown.MaxDmgMod[ScoutFlyer];

   isShielded = true;
   energyPerDamagePoint = 150 / Meltdown.ShieldPctMod[ScoutFlyer];
   maxEnergy = 290;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.825;

   maxAutoSpeed = 10;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 350;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 215;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds
   
   // Maneuvering
   maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3500*Meltdown.MassVelMod[ScoutFlyer];      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1300*Meltdown.MassVelMod[ScoutFlyer];         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 425;      // Steering jets (how much you heel over when you turn)
   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 500;

   // Turbo Jet
   jetForce = 2750*Meltdown.MassVelMod[ScoutFlyer];      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 16;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.6;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 2.15;

   // Rigid body
   mass = 138*Meltdown.MassVelMod[ScoutFlyer];        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 25;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 55.56;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 32;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.03;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23.0; //18? you sick bastard! Death~bot
   collDamageMultiplier   = 0.0125; //0.0125; keep it low...

   //
   minTrailSpeed = 30;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = ShrikeEngineEmitter;
   downJetEmitter = TurboJetEmitter;

   //
   jetSound = ScoutFlyerThrustSound;
   engineSound = ScoutFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;
   
   //
   softSplashSoundVelocity = 10.0; 
   mediumSplashSoundVelocity = 15.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound; 
    
   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   //
   max[chaingunAmmo] = 1000;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Shrike';
   targetTypeTag = 'Turbograv-Interceptor';
   sensorData = AWACPulseSensor;
   sensorRadius = AWACPulseSensor.detectRadius;
   sensorColor = "255 194 9";

   numWeapons = 2;

   checkRadius = 5.5;
   observeParameters = "1 10 10";

   runningLight[0] = ShrikeLight1;
//   runningLight[1] = ShrikeLight2;

   shieldEffectScale = "0.937 1.125 0.60";

};

datablock FlyingVehicleData(Explorer) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_tank.dts";
   multipassenger = true;

   debrisShapeName = "vehicle_land_assault_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   mountPose[0] = sitting;
//   mountPose[1] = sitting;
   numMountPoints = 2;
   isProtectedMountPoint[0] = true;
   isProtectedMountPoint[1] = true;

   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 1.25;
	explosionRadius = 12.5;

   maxDamage = 0.75;
   destroyedLevel = 0.75;

   isShielded = false;
   energyPerDamagePoint = 150;
   maxEnergy = 200;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.825;

   maxAutoSpeed = 10;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 350;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 215;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3000;      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1250;         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 425;      // Steering jets (how much you heel over when you turn)
   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 50;

   // Turbo Jet
   jetForce = 2100;      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 16;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.6;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 2.15;

   // Rigid body
   mass = 138;        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 14;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 25;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 23;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.06;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23.0; //18? you sick bastard! Death~bot
   collDamageMultiplier   = 0.0125;

   //
   minTrailSpeed = 30;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = FlyerJetEmitter;
   downJetEmitter = TurboJetEmitter;

   //
   jetSound = ScoutFlyerThrustSound;
   engineSound = ScoutFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 15.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.7;
   damageLevelTolerance[1] = 0.9;
   numDmgEmitterAreas = 1;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Explorer';
   targetTypeTag = 'Stealth Transport';
   sensorData = AWACPulseSensor;
   sensorRadius = AWACPulseSensor.detectRadius;
   sensorColor = "255 194 9";

   numWeapons = 2;

   checkRadius = 5.5;
   observeParameters = "1 10 10";

//   runningLight[0] = ShrikeLight1;
//   runningLight[1] = ShrikeLight2;

   shieldEffectScale = "0.937 1.125 0.60";

};

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(ScoutChaingunPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_fusion_large.dts";
   item      = Chaingun;
//   ammo   = ChaingunAmmo;
   projectile = ScoutChaingunBullet;
   projectileType = TracerProjectile;
   mountPoint = 10;
   offset = "1 1 0.7";
   rotation = "0 1 0 32";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 5;
   fireEnergy = 10;
   fireTimeout = 200;

   stateName[0]             = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateSequence[1]         = "Deploy";
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSound[4]            = ShrikeBlasterFire;
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 0.2;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(ScoutChaingunImage) : ScoutChaingunPairImage
{
   offset = "-1 1 0.7";
   rotation = "0 1 0 -32";
   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(ScoutChaingunParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = ScoutChaingunBullet;
   projectileType = TracerProjectile;
}; 

//=============================================================================
// Marantz v2.0 - MrKeen
// Increased speed, maneuverability, and afterburner thrust. Speed capped at ~1000 KPH
// Doubled front blaster fire rate, not sure if it should have dual mitzi singularities
// If this fails, I'm DLing 1150 and restoring the old Marantz; everything except the shape
//=============================================================================

datablock StaticShapeData(MtzDecal)
{
   mountPoint = 1;
   shapeFile = "weapon_disc.dts";
//   emap = true;
   maxDamage = tPOC.maxDamage;
   destroyedLevel = tPOC.destroyedLevel;
};

function MtzDecal::onDamage(%data, %obj)
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function MtzDecal::damageObject(%this, %targetObject, %sourceObject, %position, %amount, %damageType ,%vec, %client, %projectile)
{
   //If vehicle turret is hit then apply damage to the vehicle
   %vehicle = %targetObject.getObjectMount();
   if(%vehicle)
      %vehicle.getDataBlock().damageObject(%vehicle, %sourceObject, %position, %amount, %damageType, %vec, %client, %projectile);
}

Meltdown.MassVelMod[tPOC] = 1.0;
Meltdown.MaxDmgMod[tPOC] = 1.25;
Meltdown.ShieldPctMod[tPOC] = 1.0;

datablock FlyingVehicleData(tPOC) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_scout.dts";
   multipassenger = false;

   debrisShapeName = "vehicle_air_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.0825;
   density = 1.0;

   mountPose[0] = sitting;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   cameraMaxDist = 15;
   cameraOffset = 2.5;
   cameraLag = 0.9;
   explosion = VehicleExplosion;
	explosionDamage = 0.75;
	explosionRadius = 25.0;

   keepReticle = true;

   maxDamage = 1.5*Meltdown.MaxDmgMod[tPOC];
   destroyedLevel = 1.5*Meltdown.MaxDmgMod[tPOC];

   isShielded = false;
   energyPerDamagePoint = 0; // / Meltdown.ShieldPctMod[tPOC]
   maxEnergy = 250;      // Afterburner and any energy weapon pool
   minDrag = 15;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.7;

   maxAutoSpeed = 20;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 350;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 250;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 2; //3   // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 6;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3000*Meltdown.MassVelMod[tPOC]; //3000     // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1600; //1450        // Steering jets (force applied when you move the mouse)
   steeringRollForce = 1020; //997      // Steering jets (how much you heel over when you turn)
   rollForce = 5;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 3;        // Height off the ground at rest
   createHoverHeight = 2;  // Height off the ground when created
   maxForwardSpeed = 500;

   // Turbo Jet
   jetForce = 5000*Meltdown.MassVelMod[tPOC];      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 16;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.4;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 2.15;

   // Rigid body
   mass = 125*Meltdown.MassVelMod[tPOC];        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 25;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 55.56;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 32;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 1.0; //.03?? wtf

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23.0; //18? you sick bastard! Death~bot
   collDamageMultiplier   = 0.0125;

   //
   minTrailSpeed = 30;      // The speed your contrail shows up at.
   trailEmitter = CutterContrailEmitter;
   forwardJetEmitter = TurboJetEmitter;
   downJetEmitter = FlyerJetEmitter;

   //
   jetSound = ScoutFlyerThrustSound;
   engineSound = ScoutFlyerEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 15.0;
   hardSplashSoundVelocity = 20.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'Marantz';
   targetTypeTag = 'Turbograv';
   sensorData = VehiclePulseSensor;

   numWeapons = 2;

   checkRadius = 5.5;
   observeParameters = "1 10 10";

   shieldEffectScale = "0.937 1.125 0.60";
};

datablock ShapeBaseImageData(tPOCCannonPairImage)
{
   className = WeaponImage;
   shapeFile = "TR2weapon_grenade_launcher.dts";
   item      = Chaingun;
   projectile = ProtronBoltB; //RedPulseBolt;
   projectileType = LinearFlareProjectile; //TracerProjectile;
   mountPoint = 10;
   offset = "2.0 -1.0 -0.25";
   rotation = "0 1 0 0";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 10;
   fireEnergy = 4;
   fireTimeout = 100;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSound[4]            = ShrikeBlasterFire;
   stateSequence[4]         = "Fire";
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 0.1;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(tPOCCannonImage) : tPOCCannonPairImage
{
   shapeFile = "TR2weapon_grenade_launcher.dts";
   offset = "-2.0 -1.0 -0.25";
   rotation = "0 1 0 0";

   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(tPOCCannonParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = ProtronBoltB; //RedPulseBolt;
   projectileType = LinearFlareProjectile; //TracerProjectile;
};

datablock ExplosionData(MiniMitziBlastExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 0.3;
   camShakeRadius = 10.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 75;
   particleRadius = 1.75;
   faceViewer = true;
};

datablock LinearFlareProjectileData(vMitziSingularityBlast)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "3.0 3.0 3.0";
   faceViewer          = true;
   directDamage        = 0.3;
   hasDamageRadius     = true;
   indirectDamage      = 0.15;//0.275;
   damageRadius        = 7.0;
   kickBackStrength    = 500;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MiniMitziBlastExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = TurboJetEmitter; //MiniStreakEmitter;

   dryVelocity       = 250.0;
   wetVelocity       = 400.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "1 0.8 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 1 1";
};

datablock ShapeBaseImageData(tPOCMissilePairImage)
{
   className = WeaponImage;
   shapeFile = "TR2weapon_mortar.dts";
   item      = Chaingun;
   projectile = vMitziSingularityBlast;
   projectileType = LinearFlareProjectile;
   mountPoint = 10;
   offset = "-4.25 -1 -1.9";
   rotation = "0 1 0 125";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 5;
   fireEnergy = 7;
   fireTimeout = 250;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSound[4]            = PlasmaFireSound; // pwtfiresound
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 0.8;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(tPOCMissileImage) : tPOCMissilePairImage
{
   shapeFile = "TR2weapon_mortar.dts";
   offset = "4.25 -1 -1.6";
   rotation = "0 1 0 -125";

   stateScript[3]           = "onTriggerDown";
   stateScript[5]           = "onTriggerUp";
   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(MarantzWingRightDecal)
{
   shapeFile = "vehicle_grav_scout.dts";
   mountPoint = 1;
   offset = "-4.5 0.25 -2.75";
   rotation = "0 1 0 -52.5";
};

datablock ShapeBaseImageData(MarantzWingLeftDecal)
{
   shapeFile = "vehicle_grav_scout.dts";
   mountPoint = 1;
   offset = "4.5 0.25 -2.75";
   rotation = "0 1 0 52.5";
};

function tPOC::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
          if(%obj.selectedWeapon == 1)
          {
               %obj.setImageTrigger(5, false);
               %obj.setImageTrigger(6, false);

               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(2, false);
                   %obj.setImageTrigger(3, false);
                   case 1:
                   %obj.fireWeapon = true;
                   %obj.setImageTrigger(2, true);
                   %obj.setImageTrigger(3, true);
               }
          }
          else
          {
               %obj.setImageTrigger(2, false);
               %obj.setImageTrigger(3, false);

               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(5, false);
                   %obj.setImageTrigger(6, false);
                   %obj.setImageTrigger(2, false);
                   %obj.setImageTrigger(3, false);
                   case 1:
                   %obj.fireWeapon = true;
                   if(%obj.nextWeaponFire == 5)
                   {
                         %obj.setImageTrigger(5, true);
                         %obj.setImageTrigger(6, false);
                        %obj.setImageTrigger(2, false);
                        %obj.setImageTrigger(3, false);
                   }
                   else
                   {
                         %obj.setImageTrigger(5, false);
                         %obj.setImageTrigger(6, true);
                        %obj.setImageTrigger(2, false);
                        %obj.setImageTrigger(3, false);
                   }
               }
          }
     }
}

function tPOC::playerDismounted(%data, %obj, %player)
{
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(3, false);
   %obj.setImageTrigger(5, false);
   %obj.setImageTrigger(6, false);
   setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

function Explorer::playerDismounted(%data, %obj, %player)
{
   setTargetSensorGroup(%obj.getTarget(), %obj.team);
   %player.setCloaked(false);

   if(!%obj.getMountNodeObject(0) && !%obj.getMountNodeObject(1))
      %obj.setCloaked(false);
}

function tPOCMissileImage::onFire(%data,%obj,%slot)
{
   %p = Parent::onFire(%data,%obj,%slot);
//   rBeginProxyV(%p);

   %obj.setImageTrigger(2, true);
   %obj.setImageTrigger(3, true);
}

function tPOCMissilePairImage::onFire(%data,%obj,%slot)
{
   %p = Parent::onFire(%data,%obj,%slot);
//   rBeginProxyV(%p);

   %obj.setImageTrigger(2, true);
   %obj.setImageTrigger(3, true);
}

function tPOCCannonImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 6;
   schedule(125, 0, "fireNextGun", %obj);
}

function tPOCCannonPairImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 5;
   schedule(125, 0, "fireNextGun", %obj);
}

datablock ParticleData(CoolBlueTrailParticle)
{
    dragCoefficient = 0;
    gravityCoefficient = -0.02;
    windCoefficient = 1;
    inheritedVelFactor = 0.1;
    constantAcceleration = 0;
    lifetimeMS = 1200;
    lifetimeVarianceMS = 100;
    useInvAlpha = 0;
    spinRandomMin = -90;
    spinRandomMax = 90;
    textureName = "special/expFlare.png";
    times[0] = 0;
    times[1] = 0.1;
    times[2] = 1;
    colors[0] = "0.228346 0.450000 1.000000 1.000000";
    colors[1] = "0.300000 0.300000 1.000000 0.800000";
    colors[2] = "0.300000 0.300000 1.000000 0.000000";
    sizes[0] = 1;
    sizes[1] = 2;
    sizes[2] = 3;
};

datablock ParticleEmitterData(CoolBlueTrailEmitter)
{
    ejectionPeriodMS = 10;
    periodVarianceMS = 0;
    ejectionVelocity = 1.5;
    velocityVariance = 0.3;
    ejectionOffset =   1;
    thetaMin = 0;
    thetaMax = 50;
    phiReferenceVel = 0;
    phiVariance = 360;
    overrideAdvances = 0;
    orientParticles= 0;
    orientOnVelocity = 1;
    particles = "CoolBlueTrailParticle";
};

datablock ShockwaveData(BomberFusionShockwave)
{
   width = 3;
   numSegments = 24;
   numVertSegments = 6;
   velocity = 15;
   acceleration = 30.0;
   lifetimeMS = 500;
   height = 0.75;
   verticalCurve = 0.5;

   mapToTerrain = false;
   renderBottom = true;
   orientToNormal = true;

   texture[0] = "special/shockwave5";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.4 0.4 0.8 0.5";
   colors[1] = "0.4 0.4 0.8 0.5";
   colors[2] = "0.4 0.4 0.8 0.5";
};

datablock ExplosionData(BExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;
   shockwave      = BomberFusionShockwave;

   faceViewer     = true;
   explosionScale = "1 1 1";

   particleEmitter = DiscExplosionEmitter;
   particleDensity = 300;
   particleRadius = 2.5;

   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "20.0 20.0 20.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;
};

datablock LinearFlareProjectileData(BomberFusionBolt)
{
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.32;
   damageRadius        = 15;
   radiusDamageType    = $DamageType::BellyTurret;
   kickBackStrength    = 1000;

   sound               = discProjectileSound;

   explosion           = "BExplosion";
   splash              = DiscSplash;

   baseEmitter       = CoolBlueTrailEmitter;
   dryVelocity       = 100.0;
   wetVelocity       = 95.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = -1;

   activateDelayMS = -1;

   scale             = "3.0 3.0 3.0";
   numFlares         = 30;
   flareColor        = "0.13 0.41 0.93";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock AudioProfile(PulseCannonFire)
{
   filename    = "fx/vehicles/bomber_turret_fire.wav";
   description = AudioClose3d;
   preload = true;
};

