if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//**************************************************************
// Skyranger v2.0 - MrKeen
// ZIG-CA MetaLaser -> Dual Vulcans
// Justice Missile Array -> MultiPulsar
// Comes with handy dandy tailgunner seat!
//**************************************************************

datablock AudioProfile(MultiPulsarFire)
{
   filename    = "fx/vehicles/bomber_turret_fire.wav";
   description = AudioDefault3d;
   preload = true;
};

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

Meltdown.MassVelMod[Skyranger] = 1.0; // 6.0
Meltdown.MaxDmgMod[Skyranger] = 1.5;
Meltdown.ShieldPctMod[Skyranger] = 1.1;

datablock FlyingVehicleData(Skyranger) : ShrikeDamageProfile
{
   spawnOffset = "0 0 2";

   catagory = "Vehicles";
   shapeFile = "vehicle_air_scout.dts";
   multipassenger = false;

   debrisShapeName = "vehicle_air_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag    = 0.15;
   density = 1.0;

   mountPose[0] = sitting;
   mountPose[1] = sitting;
   numMountPoints = 2;
   isProtectedMountPoint[0] = true;
   isProtectedMountPoint[1] = true;
   
   cameraMaxDist = 22;
   cameraOffset = 5;
   cameraLag = 1.0;
   explosion = LargeAirVehicleExplosion;
	explosionDamage = 1.75;
	explosionRadius = 20;

   maxDamage = 1.40*Meltdown.MaxDmgMod[Skyranger];
   destroyedLevel = 1.40*Meltdown.MaxDmgMod[Skyranger];

   isShielded = true;
   energyPerDamagePoint = 150 / Meltdown.ShieldPctMod[Skyranger];
   maxEnergy = 290;      // Afterburner and any energy weapon pool
   minDrag = 30;           // Linear Drag (eventually slows you down when not thrusting...constant drag)
   rotationalDrag = 900;        // Anguler Drag (dampens the drift after you stop moving the mouse...also tumble drag)
   rechargeRate = 0.825;

   maxAutoSpeed = 10;       // Autostabilizer kicks in when less than this speed. (meters/second)
   autoAngularForce = 350;       // Angular stabilizer force (this force levels you out when autostabilizer kicks in)
   autoLinearForce = 215;        // Linear stabilzer force (this slows you down when autostabilizer kicks in)
   autoInputDamping = 0.95;      // Dampen control input so you don't` whack out at very slow speeds

   // Maneuvering
   maxSteeringAngle = 5;    // Max radiens you can rotate the wheel. Smaller number is more maneuverable.
   horizontalSurfaceForce = 6;   // Horizontal center "wing" (provides "bite" into the wind for climbing/diving and turning)
   verticalSurfaceForce = 4;     // Vertical center "wing" (controls side slip. lower numbers make MORE slide.)
   maneuveringForce = 3100*Meltdown.MassVelMod[Skyranger];      // Horizontal jets (W,S,D,A key thrust)
   steeringForce = 1100*Meltdown.MassVelMod[Skyranger];         // Steering jets (force applied when you move the mouse)
   steeringRollForce = 425;      // Steering jets (how much you heel over when you turn)
   rollForce = 4;                // Auto-roll (self-correction to right you after you roll/invert)
   hoverHeight = 5;        // Height off the ground at rest
   createHoverHeight = 3;  // Height off the ground when created
   maxForwardSpeed = 100;

   // Turbo Jet
   jetForce = 2250*Meltdown.MassVelMod[Skyranger];      // Afterburner thrust (this is in addition to normal thrust)
   minJetEnergy = 16;     // Afterburner can't be used if below this threshhold.
   jetEnergyDrain = 2.6;       // Energy use of the afterburners (low number is less drain...can be fractional)                                                                                                                                                                                                                                                                                          // Auto stabilize speed
   vertThrustMultiple = 2.15;

   // Rigid body
   mass = 150*Meltdown.MassVelMod[Skyranger];        // Mass of the vehicle
   bodyFriction = 0;     // Don't mess with this.
   bodyRestitution = 0.5;   // When you hit the ground, how much you rebound. (between 0 and 1)
   minRollSpeed = 0;     // Don't mess with this.
   softImpactSpeed = 25;       // Sound hooks. This is the soft hit.
   hardImpactSpeed = 55.56;    // Sound hooks. This is the hard hit.

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 32;      // If hit ground at speed above this then it's an impact. Meters/second
   speedDamageScale = 0.03;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 23.0; //18? you sick bastard! Death~bot
   collDamageMultiplier   = 0.0125; //0.0125; keep it low...

   //
   minTrailSpeed = 20;      // The speed your contrail shows up at.
   trailEmitter = ContrailEmitter;
   forwardJetEmitter = ShrikeEngineEmitter;
   downJetEmitter = GreenEngineEmitter;

   //
   jetSound = HAPCFlyerThrustSound;
   engineSound = AssaultVehicleEngineSound;
   softImpactSound = SoftImpactSound;
   hardImpactSound = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;
   
   //
   softSplashSoundVelocity = 10.0; 
   mediumSplashSoundVelocity = 15.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound; 
    
   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 4.0;
   dustHeight = 1.0;

   damageEmitter[0] = LightDamageSmoke;
   damageEmitter[1] = HeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -3.0 0.0 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   minMountDist = 4;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldBubble;

   numWeapons = 2;
   cmdCategory = "Tactical";
   cmdIcon = CMDFlyingScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_scout_grey";
   targetNameTag = 'SilverShark';
   targetTypeTag = 'Patrol Vehicle';
   sensorData = ZIGSensor;

   checkRadius = 7.1895;
   observeParameters = "1 10 10";
};

//**************************************************************
// WEAPONS
//**************************************************************

datablock ShapeBaseImageData(ZIGWeaponPairImage)
{
   className = WeaponImage;
   shapeFile = "turret_assaulttank_plasma.dts";
   item      = Chaingun;
   mountPoint = 10;
   offset = "1.25 0 0.75";
   rotation = "0 1 0 -60";
                                    //ZigBullet
   projectile = GaussBullet; //VulcanBullet; death~bot >:}
   projectileType = TracerProjectile;

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 10;
   fireEnergy = 0;
   fireTimeout = 100;
   emap = true;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 3.0;

   projectileSpread = 8.0 / 1000.0;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateSound[0]            = ChaingunSwitchSound;
   stateAllowImageChange[0] = false;
   //
   stateTimeoutValue[0]        = 0.5;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";

   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   //
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";

   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";

   //--------------------------------------
   stateName[3]         = "Spinup";
//   stateSpinThread[3]   = SpinUp;
   stateSound[3]        = ChaingunSpinupSound;
   //
   stateTimeoutValue[3]          = 0.5;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";

   //--------------------------------------
   stateName[4]             = "Fire";
//   stateSequence[4]            = "Fire";
//   stateSequenceRandomFlash[4] = true;
   stateSpinThread[4]       = FullSpeed;
   stateSound[4]            = ChaingunFireSound;
   //stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateEjectShell[4]       = true;
   //
   stateTimeoutValue[4]          = 0.25;
   stateTransitionOnTimeout[4]   = "Fire";
   stateTransitionOnTriggerUp[4] = "FireSpindown";
   stateTransitionOnNoAmmo[4]    = "EmptySpindown";

   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSound[5]      = ChaingunSpinDownSound;
   stateSpinThread[5] = SpinDown;
   //
   stateTimeoutValue[5]            = 1.0;
   stateWaitForTimeout[5]          = true;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";

   //--------------------------------------
   stateName[6]       = "EmptySpindown";
   stateSound[6]      = ChaingunSpinDownSound;
   stateSpinThread[6] = SpinDown;
   stateEmitter[6]       = "ChaingunFireSmoke";
   stateEmitterTime[6]       = 0.25;
   stateEmitterNode[6]       = 0;

   //
   stateTimeoutValue[6]        = 0.5;
   stateTransitionOnTimeout[6] = "NoAmmo";

   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ChaingunDryFireSound;
   stateTimeoutValue[7]        = 0.5;
   stateTransitionOnTimeout[7] = "NoAmmo";

   //--------------------------------------
   stateName[8]       = "FireSpindown";
   stateSound[8]      = ChaingunSpinDownSound;
   stateSpinThread[8] = SpinDown;
   stateEmitter[8]       = "ChaingunFireSmoke";
   stateEmitterTime[8]       = 0.25;
   stateEmitterNode[8]       = 0;
   //
   stateTimeoutValue[8]            = 1.0;
   stateWaitForTimeout[8]          = true;
   stateTransitionOnTimeout[8]     = "Ready";
   stateTransitionOnTriggerDown[8] = "Spinup";
};

datablock ShapeBaseImageData(ZIGWeaponImage) : ZIGWeaponPairImage
{
   offset = "-1.25 0 0.75";
   rotation = "0 1 0 60";
                                 //ZigBullet
   projectile = GaussBullet;//VulcanBullet;
   projectileType = TracerProjectile;

//   stateScript[3]           = "onTriggerDown";
//   stateScript[5]           = "onTriggerUp";
//   stateScript[6]           = "onTriggerUp";
};

datablock ShapeBaseImageData(ZIGWingsAndParam)
{
   mountPoint = 2;
   offset = "0 -3.5 -1.25";
   rotation = "0 1 0 180";
   shapeFile = "vehicle_grav_scout.dts";   // hjehje

   projectile = SuperPulseBolt;
   projectileType = TracerProjectile;

   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
};

datablock ShapeBaseImageData(ZigWingsImage)
{
   mountPoint = 2;
   offset = "0 1.5 -0.75";
   rotation = "0 1 0 180";
   shapeFile = "vehicle_air_scout.dts";   // hjehje

   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
};

datablock ParticleData(ExtendedAAExplosionParticle1)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/crescent4";
   olors[0]     = "0.8 0.5 0.5 0.5";
   colors[1]     = "0.7 0.4 0.4 0.8";
   colors[2]     = "0.6 0.3 0.3 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 2.0;
   sizes[2]      = 4.5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ExtendedAAExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.5;
   ejectionOffset   = 0.0;
   thetaMin         = 70;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = true;
   lifetimeMS       = 200;
   particles = "ExtendedAAExplosionParticle1";
};

datablock ParticleData(ExtendedAAExplosionParticle2)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = -0.0;
   lifetimeMS           = 600;
   lifetimeVarianceMS   = 000;
   textureName          = "special/blasterHit";
   olors[0]     = "0.8 0.5 0.5 0.5";
   colors[1]     = "0.7 0.4 0.4 0.8";
   colors[2]     = "0.6 0.3 0.3 0.0";
   sizes[0]      = 1.0;
   sizes[1]      = 2.0;
   sizes[2]      = 4.5;
   times[0]      = 0.0;
   times[1]      = 0.5;
   times[2]      = 1.0;
};

datablock ParticleEmitterData(ExtendedAAExplosionEmitter2)
{
   ejectionPeriodMS = 30;
   periodVarianceMS = 0;
   ejectionVelocity = 1;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 80;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   orientParticles  = false;
   lifetimeMS       = 200;
   particles = "ExtendedAAExplosionParticle2";
};

datablock ExplosionData(ExtendedAAExplosion)
{
   soundProfile   = blasterExpSound;
   emitter[0]     = ExtendedAAExplosionEmitter;
   emitter[1]     = ExtendedAAExplosionEmitter2;
};

datablock TracerProjectileData(MoonBikeEnergyBullet)
{
   doDynamicClientHits = true;

   projectileShapeName = "energy_bolt.dts";
   directDamage        = 0.05;
   kickBackStrength    = 0;
   directDamageType    = $DamageType::AATurret;
   explosion           = "ExtendedAAExplosion";
   splash              = ChaingunSplash;

   dryVelocity       = 666.0; // no pun intended :o
   wetVelocity       = 333.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   tracerLength    = 22;
   tracerAlpha     = true;
   tracerMinPixels = 3;
   tracerColor     = "0.1 0.1 1.0 0.75";
	tracerTex[0]  	 = "special/blueSpark";//"special/tracer00";
	tracerTex[1]  	 = "small_circle";//"special/tracercross";
   tracerWidth     = 0.8;
   crossSize       = 1.9;
   crossViewAng    = 0.7;
   renderCross     = true;
   emap = true;
};

datablock ShapeBaseImageData(ZigQuadGun1)
{
   className = WeaponImage;
   shapeFile = "vehicle_grav_scout.dts";
   item      = Chaingun;

   projectile = MoonBikeEnergyBullet;
   projectileType = TracerProjectile;

   mountPoint = 10;
   offset = "3.25 -2 -1.6";
   rotation = "0 1 0 140";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 6;
   fireEnergy = 6;
   fireTimeout = 200;

   stateName[0]                  = "Activate";
   stateTransitionOnNotLoaded[0] = "Dead";
   stateTransitionOnLoaded[0]    = "ActivateReady";

   stateName[1]                  = "ActivateReady";
   stateSequence[1]              = "Activate";
   stateTimeoutValue[1]          = 2;
   stateTransitionOnTimeout[1]   = "Ready";
   stateTransitionOnNotLoaded[1] = "Deactivate";
   stateTransitionOnNoAmmo[1]    = "NoAmmo";

   stateName[2]                    = "Ready";
   stateTransitionOnNotLoaded[2]   = "Deactivate";
   stateTransitionOnTriggerDown[2] = "Fire";
   stateTransitionOnNoAmmo[2]      = "NoAmmo";

   stateName[3]                = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3]        = 0.1;
   stateFire[3]                = true;
   stateRecoil[3]              = LightRecoil;
   stateAllowImageChange[3]    = false;
   stateSequence[3]            = "Fire";
   stateSound[3]               = MultiPulsarFire;
   stateScript[3]              = "onFire";

   stateName[4]                  = "Reload";
   stateTimeoutValue[4]          = 0.1;
   stateAllowImageChange[4]      = false;
   stateSequence[4]              = "Reload";
   stateTransitionOnTimeout[4]   = "Ready";
   stateTransitionOnNotLoaded[4] = "Deactivate";
   stateTransitionOnNoAmmo[4]    = "NoAmmo";

   stateName[5]                = "Deactivate";
   stateSequence[5]            = "Activate";
   stateDirection[5]           = false;
   stateTimeoutValue[5]        = 0.01;
   stateTransitionOnLoaded[5]  = "ActivateReady";
   stateTransitionOnTimeout[5] = "Dead";

   stateName[6]               = "Dead";
   stateTransitionOnLoaded[6] = "ActivateReady";

   stateName[7]             = "NoAmmo";
   stateTransitionOnAmmo[7] = "Reload";
   stateSequence[7]         = "NoAmmo";
};

datablock ShapeBaseImageData(ZigQuadGun2) : ZigQuadGun1
{
   offset = "-3.25 -2 -1.6";
   rotation = "0 1 0 -140";
   shapeFile = "vehicle_grav_scout.dts";
};

datablock ShapeBaseImageData(ZigQuadGun3) : ZigQuadGun1
{
   offset = "4.25 -1.5 -1.75";
   rotation = calcThisRotD("0 -125 180");//"0 0 1 180";
   shapeFile = "turret_tank_barrelmortar.dts";
};

datablock ShapeBaseImageData(ZigQuadGun4) : ZigQuadGun1
{
   offset = "-4.25 -1.5 -1.75";
   rotation = calcThisRotD("0 125 180");//"1 0 0 180";
   shapeFile = "turret_tank_barrelmortar.dts";
};


function Skyranger::onTrigger(%data, %obj, %trigger, %state)
{
     if(%trigger == 0)
     {
          if(%obj.selectedWeapon == 1)
          {
               %obj.setImageTrigger(4, false);
               %obj.setImageTrigger(5, false);
               %obj.setImageTrigger(6, false);
               %obj.setImageTrigger(7, false);
               
               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(2, false);
                   %obj.setImageTrigger(3, false);
                   case 1:
                   %obj.fireWeapon = true;
                   %obj.setImageTrigger(2, true);
                   %obj.setImageTrigger(3, true);
               }
          }
          else
          {
               %obj.setImageTrigger(2, false);
               %obj.setImageTrigger(3, false);

               switch(%state)
               {
                   case 0:
                   %obj.fireWeapon = false;
                   %obj.setImageTrigger(4, false);
                   %obj.setImageTrigger(5, false);
                   %obj.setImageTrigger(6, false);
                   %obj.setImageTrigger(7, false);
                   case 1:
                   %obj.fireWeapon = true;
                  if(%obj.nextWeaponFire == 4)
                  {
                     %obj.setImageTrigger(4, true);
                     %obj.setImageTrigger(5, false);
                     %obj.setImageTrigger(6, false);
                     %obj.setImageTrigger(7, false);
                  }
                  else if(%obj.nextWeaponFire == 5)
                  {
                     %obj.setImageTrigger(4, false);
                     %obj.setImageTrigger(5, true);
                     %obj.setImageTrigger(6, false);
                     %obj.setImageTrigger(7, false);
                  }
                  else if(%obj.nextWeaponFire == 6)
                  {
                     %obj.setImageTrigger(4, false);
                     %obj.setImageTrigger(5, false);
                     %obj.setImageTrigger(6, true);
                     %obj.setImageTrigger(7, false);
                  }
                  else
                  {
                     %obj.setImageTrigger(4, false);
                     %obj.setImageTrigger(5, false);
                     %obj.setImageTrigger(6, false);
                     %obj.setImageTrigger(7, true);
                  }
              }
          }
     }
}

function Skyranger::playerDismounted(%data, %obj, %player)
{
   %obj.fireWeapon = false;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(3, false);
   %obj.setImageTrigger(4, false);
   %obj.setImageTrigger(5, false);
   %obj.setImageTrigger(6, false);
   %obj.setImageTrigger(7, false);
   setTargetSensorGroup(%obj.getTarget(), %obj.team);
}

function ZIGWeaponImage::onFire(%data,%obj,%slot)
{
   Parent::onFire(%data,%obj,%slot);
   %obj.setImageTrigger(3, true);
   %obj.useEnergy(8);
}

function ZigQuadGun1::onFire(%data,%obj,%slot)
{
   if(%obj.MultiPulsarFireThread) // prevent using rapid fire bug (cheat)
   {
      cancel(%obj.MultiPulsarFireThread);
//      return;
   }

   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 5;
   %obj.MultiPulsarFireThread = schedule(%data.fireTimeout, 0, "fireNextMultiPulsar", %obj);
   %obj.useEnergy(7);
}

function ZigQuadGun2::onFire(%data,%obj,%slot)
{
   if(%obj.MultiPulsarFireThread) // prevent using rapid fire bug (cheat)
   {
      cancel(%obj.MultiPulsarFireThread);
//      return;
   }

   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 6;
   %obj.MultiPulsarFireThread = schedule(%data.fireTimeout, 0, "fireNextMultiPulsar", %obj);
   %obj.useEnergy(7);
}

function ZigQuadGun3::onFire(%data,%obj,%slot)
{
   if(%obj.MultiPulsarFireThread) // prevent using rapid fire bug (cheat)
   {
      cancel(%obj.MultiPulsarFireThread);
//      return;
   }

   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 7;
   %obj.MultiPulsarFireThread = schedule(%data.fireTimeout, 0, "fireNextMultiPulsar", %obj);
   %obj.useEnergy(7);
}

function ZigQuadGun4::onFire(%data,%obj,%slot)
{
   if(%obj.MultiPulsarFireThread) // prevent using rapid fire bug (cheat)
   {
      cancel(%obj.MultiPulsarFireThread);
//      return;
   }

   Parent::onFire(%data,%obj,%slot);
   %obj.nextWeaponFire = 4;
   %obj.MultiPulsarFireThread = schedule(%data.fireTimeout, 0, "fireNextMultiPulsar", %obj);
   %obj.useEnergy(6);
}

function fireNextMultiPulsar(%obj)
{
   if(%obj.fireWeapon)
   {
      if(%obj.nextWeaponFire == 4)
      {
         %obj.setImageTrigger(4, true);
         %obj.setImageTrigger(5, false);
         %obj.setImageTrigger(6, false);
         %obj.setImageTrigger(7, false);
      }
      else if(%obj.nextWeaponFire == 5)
      {
         %obj.setImageTrigger(4, false);
         %obj.setImageTrigger(5, true);
         %obj.setImageTrigger(6, false);
         %obj.setImageTrigger(7, false);
      }
      else if(%obj.nextWeaponFire == 6)
      {
         %obj.setImageTrigger(4, false);
         %obj.setImageTrigger(5, false);
         %obj.setImageTrigger(6, true);
         %obj.setImageTrigger(7, false);
      }
      else if(%obj.nextWeaponFire == 7)
      {
         %obj.setImageTrigger(4, false);
         %obj.setImageTrigger(5, false);
         %obj.setImageTrigger(6, false);
         %obj.setImageTrigger(7, true);
      }
   }
   else
   {
      %obj.setImageTrigger(4, false);
      %obj.setImageTrigger(5, false);
      %obj.setImageTrigger(6, false);
      %obj.setImageTrigger(7, false);
   }
}

datablock TurretData(SSTurret) : TurretDamageProfile
{
   className               = VehicleTurret;
   catagory                = "Turrets";
   shapeFile               = "turret_belly_base.dts";
   preload                 = true;

   mass                    = 1.0;  // Not really relevant
   repairRate              = 0;
   maxDamage               = ScoutFlyer.maxDamage;
   destroyedLevel          = ScoutFlyer.destroyedLevel;

   thetaMin                = 90;
   thetaMax                = 180;

   // capacitor
   maxCapacitorEnergy      = 250;
   capacitorRechargeRate   = 0.8;

   inheritEnergyFromMount  = true;
   firstPersonOnly         = true;
   useEyePoint             = true;
   numWeapons              = 1;

   targetNameTag           = 'Shrike Belly';
   targetTypeTag           = 'Turret';
};

datablock TurretImageData(SSTurretBarrel)
{
   shapeFile                        = "turret_belly_barrell.dts";
   mountPoint                       = 0;

   projectileType = TracerProjectile;
   projectile = MoonBikeEnergyBullet;

   usesEnergy                       = true;
   useCapacitor                     = true;
   useMountEnergy                   = true;
   fireEnergy                       = 10.0;
   minEnergy                        = 10.0;

   // Turret parameters
   activationMS                     = 1000;
   deactivateDelayMS                = 1500;
   thinkTimeMS                      = 200;
   degPerSecTheta                   = 360;
   degPerSecPhi                     = 360;

   attackRadius                     = 75;

   // State transitions
   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "WaitFire1";
   stateTimeoutValue[0]             = 0.5;
   stateSequence[0]                 = "Activate";
   stateSound[0]                    = BomberTurretActivateSound;

   stateName[1]                     = "WaitFire1";
   stateTransitionOnTriggerDown[1]  = "Fire1";
   stateTransitionOnNoAmmo[1]       = "NoAmmo1";

   stateName[2]                     = "Fire1";
   stateTransitionOnTimeout[2]      = "Reload1";
   stateTimeoutValue[2]             = 0.13;
   stateFire[2]                     = true;
   stateRecoil[2]                   = LightRecoil;
   stateAllowImageChange[2]         = false;
   stateSequence[2]                 = "Fire";
   stateScript[2]                   = "onFire";
   stateSound[2]                    = BomberTurretFireSound;

   stateName[3]                     = "Reload1";
   stateSequence[3]                 = "Reload";
   stateTimeoutValue[3]             = 0.1;
   stateAllowImageChange[3]         = false;
   stateTransitionOnTimeout[3]      = "WaitFire2";
   stateTransitionOnNoAmmo[3]       = "NoAmmo1";

   stateName[4]                     = "NoAmmo1";
   stateTransitionOnAmmo[4]         = "Reload1";
   // ---------------------------------------------
   // z0dd - ZOD, 5/8/02. Incorrect parameter value
   //stateSequence[4]                 = "NoAmmo";
   stateSequence[4] = "NoAmmo1";

   stateTransitionOnTriggerDown[4]  = "DryFire1";

   stateName[5]                     = "DryFire1";
   stateSound[5]                    = BomberTurretDryFireSound;
   stateTimeoutValue[5]             = 0.5;
   stateTransitionOnTimeout[5]      = "NoAmmo1";

   stateName[6]                     = "WaitFire2";
   stateTransitionOnTriggerDown[6]  = "Fire2";
   // ---------------------------------------------
   // z0dd - ZOD, 5/8/02. Incorrect parameter value
   //stateTransitionOnNoAmmo[6]       = "NoAmmo";
   stateTransitionOnNoAmmo[6] = "NoAmmo2";

   stateName[7]                     = "Fire2";
   stateTransitionOnTimeout[7]      = "Reload2";
   stateTimeoutValue[7]             = 0.13;
   stateScript[7]                   = "FirePair";

   stateName[8]                     = "Reload2";
   stateSequence[8]                 = "Reload";
   stateTimeoutValue[8]             = 0.1;
   stateAllowImageChange[8]         = false;
   stateTransitionOnTimeout[8]      = "WaitFire1";
   stateTransitionOnNoAmmo[8]       = "NoAmmo2";

   stateName[9]                     = "NoAmmo2";
   stateTransitionOnAmmo[9]         = "Reload2";
   // ---------------------------------------------
   // z0dd - ZOD, 5/8/02. Incorrect parameter value
   //stateSequence[9]                 = "NoAmmo";
   stateSequence[9] = "NoAmmo2";

   stateTransitionOnTriggerDown[9]  = "DryFire2";

   stateName[10]                     = "DryFire2";
   stateSound[10]                    = BomberTurretDryFireSound;
   stateTimeoutValue[10]             = 0.5;
   stateTransitionOnTimeout[10]      = "NoAmmo2";
};

datablock TurretImageData(SSTurretBarrelPair)
{
   shapeFile                = "turret_belly_barrell.dts";
   mountPoint               = 1;

   projectileType = TracerProjectile;
   projectile = MoonBikeEnergyBullet;

   usesEnergy                       = true;
   useCapacitor                     = true;
   useMountEnergy                   = true;
   fireEnergy                       = 10.0;
   minEnergy                        = 10.0;

   // Turret parameters
   activationMS                     = 1000;
   deactivateDelayMS                = 1500;
   thinkTimeMS                      = 200;
   degPerSecTheta                   = 360;
   degPerSecPhi                     = 360;

   attackRadius                     = 75;

   stateName[0]                     = "WaitFire";
   stateTransitionOnTriggerDown[0]  = "Fire";

   stateName[1]                     = "Fire";
   stateTransitionOnTimeout[1]      = "StopFire";
   stateTimeoutValue[1]             = 0.13;
   stateFire[1]                     = true;
   stateRecoil[1]                   = LightRecoil;
   stateAllowImageChange[1]         = false;
   stateSequence[1]                 = "Fire";
   stateScript[1]                   = "onFire";
   stateSound[1]                    = BomberTurretFireSound;

   stateName[2]                     = "StopFire";
   stateTimeoutValue[2]             = 0.1;
   stateTransitionOnTimeout[2]      = "WaitFire";
   stateScript[2]                   = "stopFire";
};

datablock TurretImageData(SAIAimingTurretBarrel)
{
   shapeFile            = "turret_muzzlepoint.dts";
   mountPoint           = 3;

   projectile           = MoonBikeEnergyBullet;

   // Turret parameters
   activationMS         = 1000;
   deactivateDelayMS    = 1500;
   thinkTimeMS          = 200;
   degPerSecTheta       = 500;
   degPerSecPhi         = 800;

   attackRadius         = 75;
};

function SSTurretBarrel::firePair(%this, %obj, %slot)
{
   %obj.setImageTrigger( 3, true);
}

function SSTurretBarrelPair::stopFire(%this, %obj, %slot)
{
   %obj.setImageTrigger( 3, false);
}

function SSTurret::onDamage(%data, %obj)
{
   %newDamageVal = %obj.getDamageLevel();
   if(%obj.lastDamageVal !$= "")
      if(isObject(%obj.getObjectMount()) && %obj.lastDamageVal > %newDamageVal)
         %obj.getObjectMount().setDamageLevel(%newDamageVal);
   %obj.lastDamageVal = %newDamageVal;
}

function SSTurret::damageObject(%this, %targetObject, %sourceObject, %position, %amount, %damageType ,%vec, %client, %projectile)
{
   //If vehicle turret is hit then apply damage to the vehicle
   %vehicle = %targetObject.getObjectMount();
   if(%vehicle)
      %vehicle.getDataBlock().damageObject(%vehicle, %sourceObject, %position, %amount, %damageType, %vec, %client, %projectile);
}

function SSTurret::onTrigger(%data, %obj, %trigger, %state)
{
   //error("onTrigger: trigger = " @ %trigger @ ", state = " @ %state);
   //error("obj = " @ %obj @ ", class " @ %obj.getClassName());
   switch (%trigger)
   {
      case 0:
         %obj.fireTrigger = %state;
         if(%obj.selectedWeapon == 1)
         {
            %obj.setImageTrigger(4, false);
            if(%obj.getImageTrigger(6))
            {
               %obj.setImageTrigger(6, false);
               ShapeBaseImageData::deconstruct(%obj.getMountedImage(6), %obj);
            }
            if(%state)
               %obj.setImageTrigger(2, true);
            else
               %obj.setImageTrigger(2, false);
         }
         else if(%obj.selectedWeapon == 2)
         {
            %obj.setImageTrigger(2, false);
            if(%obj.getImageTrigger(6))
            {
               %obj.setImageTrigger(6, false);
               ShapeBaseImageData::deconstruct(%obj.getMountedImage(6), %obj);
            }
            if(%state)
               %obj.setImageTrigger(4, true);
            else
               %obj.setImageTrigger(4, false);
         }
         else
         {
            %obj.setImageTrigger(2, false);
            %obj.setImageTrigger(4, false);
            if(%state)
               %obj.setImageTrigger(6, true);
            else
            {
               %obj.setImageTrigger(6, false);
               BomberTargetingImage::deconstruct(%obj.getMountedImage(6), %obj);
            }
         }

      case 2:
         if(%state)
         {
            %obj.getDataBlock().playerDismount(%obj);
         }
   }
}

function SSTurret::playerDismount(%data, %obj)
{
   //Passenger Exiting
   %obj.fireTrigger = 0;
   %obj.setImageTrigger(2, false);
   %obj.setImageTrigger(4, false);
   if(%obj.getImageTrigger(6))
   {
      %obj.setImageTrigger(6, false);
      ShapeBaseImageData::deconstruct(%obj.getMountedImage(6), %obj);
   }
   %client = %obj.getControllingClient();
   %client.player.isBomber = false;
//   %client.player.setControlObject(%client.player);
   %client.player.mountVehicle = false;
//   %client.player.getDataBlock().doDismount(%client.player);
   if(%client.player.getState() !$= "Dead")
      %client.player.mountImage(%client.player.lastWeapon, $WeaponSlot);
   setTargetSensorGroup(%obj.getTarget(), 0);
   setTargetNeverVisMask(%obj.getTarget(), 0xffffffff);
}
