if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//**************************************************************
// BEOWULF ASSAULT VEHICLE
//**************************************************************
//**************************************************************
// SOUNDS
//**************************************************************

datablock AudioProfile(AssaultVehicleSkid)
{
   filename    = "fx/vehicles/tank_skid.wav";
   description = ClosestLooping3d;
   preload = true;
};

datablock AudioProfile(AssaultVehicleEngineSound)
{
   filename    = "fx/vehicles/tank_engine.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(AssaultVehicleThrustSound)
{
   filename    = "fx/vehicles/tank_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(AssaultChaingunFireSound)
{
   filename    = "fx/vehicles/tank_chaingun.wav";
   description = AudioDefaultLooping3d;
   preload = true;
};

datablock AudioProfile(FlierChaingunFireSound)
{
   filename    = "fx/vehicles/tank_chaingun.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock AudioProfile(AssaultChaingunReloadSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(TankChaingunProjectile)
{
   filename    = "fx/weapons/chaingun_projectile.wav";
   description = ProjectileLooping3d;
   preload = true;
};

datablock AudioProfile(AssaultTurretActivateSound)
{
    filename    = "fx/vehicles/tank_activate.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AssaultChaingunDryFireSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AssaultChaingunIdleSound)
{
   filename    = "fx/misc/diagnostic_on.wav";
   description = ClosestLooping3d;
   preload = true;
};

datablock AudioProfile(AssaultMortarDryFireSound)
{
   filename    = "fx/weapons/mortar_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AssaultMortarFireSound)
{
   filename    = "fx/vehicles/tank_mortar_fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AssaultMortarReloadSound)
{
   filename    = "fx/weapons/mortar_reload.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(AssaultMortarIdleSound)
{
   filename    = "fx/misc/diagnostic_on.wav";
   description = ClosestLooping3d;
   preload = true;
};

//**************************************************************
// LIGHTS
//**************************************************************

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

//Meltdown.MassVelMod[AssaultVehicle] = 3.0; //not used on hover
Meltdown.MaxDmgMod[AssaultVehicle] = 1.5;
Meltdown.ShieldPctMod[AssaultVehicle] = 1.5; //-Nite-  was 1.0 a tad extra shield

datablock HoverVehicleData(AssaultVehicle) : GroundVehicleDamageProfile
{
   spawnOffset = "0 0 4";

   floatingGravMag = 3.5;

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_tank.dts";
   multipassenger = true;
   computeCRC = true;

   weaponNode = 1;

   debrisShapeName = "vehicle_land_assault_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 0.9;

   mountPose[0] = sitting;
   mountPose[1] = sitting;
   numMountPoints = 2;
   isProtectedMountPoint[0] = true;
   isProtectedMountPoint[1] = true;

   cameraMaxDist = 20;
   cameraOffset = 3;
   cameraLag = 1.5;
   explosion = LargeGroundVehicleExplosion;
	explosionDamage = 2.5;
	explosionRadius = 25;

   maxSteeringAngle = 0.5;  // 20 deg.

   maxDamage = 5.0*Meltdown.MaxDmgMod[AssaultVehicle];
   destroyedLevel = 5.0*Meltdown.MaxDmgMod[AssaultVehicle];

   isShielded = true;
   rechargeRate = 1.0;
   energyPerDamagePoint = 100 / Meltdown.ShieldPctMod[AssaultVehicle];
   maxEnergy = 400;
   minJetEnergy = 15;
   jetEnergyDrain = 2.0;

   // Rigid Body
   mass = 1500;
   bodyFriction = 0.8;
   bodyRestitution = 0.5;
   minRollSpeed = 3;
   gyroForce = 400;
   gyroDamping = 0.3;
   stabilizerForce = 20;
   minDrag = 10;

   softImpactSpeed = 999;       // Play SoftImpact Sound
   hardImpactSpeed = 1024;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 999;
   speedDamageScale = 0;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 15;
   collDamageMultiplier   = 0.25;

   dragForce            = 2;
   vertFactor           = 0.0;
   floatingThrustFactor = 0.15;

   mainThrustForce    = 75;
   reverseThrustForce = 50;
   strafeThrustForce  = 40;
   turboFactor        = 1.63;

   brakingForce = 25;
   brakingActivationSpeed = 4;

   stabLenMin = 3.25;
   stabLenMax = 4;
   stabSpringConstant  = 50;
   stabDampingConstant = 20;

   gyroDrag = 20;
   normalForce = 20;
   restorativeForce = 10;
   steeringForce = 15;
   rollForce  = 5;
   pitchForce = 2;

   dustEmitter = TankDustEmitter;
   triggerDustHeight = 3.5;
   dustHeight = 1.0;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 3.6;
   dustTrailFreqMod = 15.0;

   jetSound         = AssaultVehicleThrustSound;
   engineSound      = AssaultVehicleEngineSound;
   floatSound       = AssaultVehicleSkid;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   wheelImpactSound = WheelImpactSound;

   forwardJetEmitter = TankJetEmitter;

   //
   softSplashSoundVelocity = 15.0;
   mediumSplashSoundVelocity = 30.0;
   hardSplashSoundVelocity = 60.0;
   exitSplashSoundVelocity = 20.0;

   exitingWater      = VehicleExitWaterMediumSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterMediumSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeMediumSplashSound;

   minMountDist = 4;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 3.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   cmdCategory = "Tactical";
   cmdIcon = CMDGroundTankIcon;
   cmdMiniIconName = "commander/MiniIcons/com_tank_grey";
   targetNameTag = 'Beowulf';
   targetTypeTag = 'Assault Vehicle';
   sensorData = VehiclePulseSensor;

   checkRadius = 5.5535;
   observeParameters = "1 10 10";
//   runningLight[0] = TankLight1;
//   runningLight[1] = TankLight2;
//   runningLight[2] = TankLight3;
//   runningLight[3] = TankLight4;
   shieldEffectScale = "0.9 1.0 0.6";
   showPilotInfo = 1;
};

//**************************************************************
// WEAPONS
//**************************************************************

//-------------------------------------
// ASSAULT CHAINGUN CHARACTERISTICS
//-------------------------------------

datablock TurretData(AssaultPlasmaTurret) : TurretDamageProfile
{
   className      = VehicleTurret;
   catagory       = "Turrets";
   shapeFile      = "Turret_tank_base.dts";
   preload        = true;

   mass           = 1.0;  // Not really relevant

   maxEnergy               = 1;
   maxDamage               = AssaultVehicle.maxDamage;
   destroyedLevel          = AssaultVehicle.destroyedLevel;
   repairRate              = 0;
   
   // capacitor
   maxCapacitorEnergy      = 250;
   capacitorRechargeRate   = 1.0;

   thetaMin = 0;
   thetaMax = 100;

   inheritEnergyFromMount = true;
   firstPersonOnly = true;
   useEyePoint = true;
   numWeapons = 2;

   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;

   targetNameTag = 'Beowulf Chaingun';
   targetTypeTag = 'Turret';
};

datablock TurretImageData(AssaultPlasmaTurretBarrel)
{
   shapeFile = "turret_tank_barrelchain.dts";
   mountPoint = 1;

   projectile = SuperPulseBolt;
   projectileType = TracerProjectile;

   projectileSpread = 4 / 1000.0;

   casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 3.0;

   useCapacitor = true;
   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 3;
   minEnergy = 3.0;

   // Turret parameters
   activationMS      = 4000;
   deactivateDelayMS = 500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 360;
   degPerSecPhi      = 360;
   attackRadius      = 75;

   // State transitions
   stateName[0]                        = "Activate";
   stateTransitionOnNotLoaded[0]       = "Dead";
   stateTransitionOnLoaded[0]          = "ActivateReady";
   stateSound[0]                       = AssaultTurretActivateSound;

   stateName[1]                        = "ActivateReady";
   stateSequence[1]                    = "Activate";
   stateSound[1]                       = AssaultTurretActivateSound;
   stateTimeoutValue[1]                = 1;
   stateTransitionOnTimeout[1]         = "Ready";
   stateTransitionOnNotLoaded[1]       = "Deactivate";

   stateName[2]                        = "Ready";
   stateTransitionOnNotLoaded[2]       = "Deactivate";
   stateTransitionOnTriggerDown[2]     = "Fire";
   stateTransitionOnNoAmmo[2]          = "NoAmmo";

   stateName[3]                        = "Fire";
   stateSequence[3]                    = "Fire_Vis";
//   stateSequenceRandomFlash[3]         = true;
   stateFire[3]                        = true;
   stateAllowImageChange[3]            = false;
   stateSound[3]                       = AssaultChaingunFireSound;
   stateScript[3]                      = "onFire";
   stateTimeoutValue[3]                = 0.1776;
   stateTransitionOnTimeout[3]         = "Fire";
   stateTransitionOnTriggerUp[3]       = "Reload";
   stateTransitionOnNoAmmo[3]          = "noAmmo";

   stateName[4]                        = "Reload";
   stateSequence[4]                    = "Reload";
   stateTimeoutValue[4]                = 0.1;
   stateAllowImageChange[4]            = false;
   stateTransitionOnTimeout[4]         = "Ready";
   stateTransitionOnNoAmmo[4]          = "NoAmmo";
   stateWaitForTimeout[4]              = true;

   stateName[5]                        = "Deactivate";
   stateSequence[5]                    = "Activate";
   stateDirection[5]                   = false;
   stateTimeoutValue[5]                = 30;
   stateTransitionOnTimeout[5]         = "ActivateReady";

   stateName[6]                        = "Dead";
   stateTransitionOnLoaded[6]          = "ActivateReady";
   stateTransitionOnTriggerDown[6]     = "DryFire";

   stateName[7]                        = "DryFire";
   stateSound[7]                       = AssaultChaingunDryFireSound;
   stateTimeoutValue[7]                = 0.5;
   stateTransitionOnTimeout[7]         = "NoAmmo";

   stateName[8]                        = "NoAmmo";
   stateTransitionOnAmmo[8]            = "Reload";
   stateSequence[8]                    = "NoAmmo";
   stateTransitionOnTriggerDown[8]     = "DryFire";
};

function AssaultPlasmaTurretBarrel::onFire(%data,%obj,%slot)
{
   %vec = %obj.getMuzzleVector(%slot);
   %fwdOffset = getVectorOffset(%obj.getMuzzlePoint(%slot), %vec, 1);
   %vector = calcSpreadVector(%vec, %data.projectileSpread);

   %FFRObject = new StaticShape()
   {
      dataBlock        = mReflector;
   };
   MissionCleanup.add(%FFRObject);
   %FFRObject.setPosition(%fwdOffset);
   %FFRObject.schedule(32, delete);

   %p = new TracerProjectile() {
      dataBlock        = VulcanBullet;
      initialDirection = %vector;
      initialPosition  = %fwdOffset;
      sourceObject     = %FFRObject;
      sourceSlot       = %slot;
      vehicleObject    = %obj;
   };
   MissionCleanup.add(%p);
   %p.bkSourceObject = %obj;
   %obj.useEnergy(%data.fireEnergy);
}

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(TankMinigunImage1)
{
   className = WeaponImage;
   shapeFile = "TR2weapon_chaingun.dts";
   item      = MechMinigun;
//   ammo 	 = MechMinigunAmmo;
   projectile = MechMiniBullet;
   projectileType = TracerProjectile;
   emap = true;
   offset = "0.8 0 0.3";

//   casing              = ShellDebris;
//   shellExitDir        = "1.0 0.3 1.0";
//   shellExitOffset     = "0.15 -0.56 -0.1";
//   shellExitVariance   = 15.0;
//   shellVelocity       = 3.0;

   projectileSpread = 7.5 / 1000.0;

   usesEnergy = true;
   useCapacitor = true;
   minEnergy = 10;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateSound[0]            = MechGunActivate;
   stateAllowImageChange[0] = false;
   //
   stateTimeoutValue[0]        = 0.5;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";

   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   //
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";

   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";

   //--------------------------------------
   stateName[3]         = "Spinup";
   stateScript[3]       = "onSpinup";
   stateSpinThread[3]   = SpinUp;
//   stateSound[3]        = ChaingunSpinupSound;
   //
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";

   //--------------------------------------
   stateName[4]             = "Fire";
   stateSequence[4]            = "Fire";
   stateSequenceRandomFlash[4] = true;
   stateSpinThread[4]       = FullSpeed;
   stateSound[4]            = ChaingunFireSound;
   //stateRecoil[4]           = LightRecoil;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateEjectShell[4]       = true;
   stateEmitter[4]       = "ChaingunFireSmoke";
//   stateEmitterTime[4]       = 0.15;
   stateEmitterNode[4]       = 0;

   stateTimeoutValue[4]          = 0.15;
   stateTransitionOnTimeout[4]   = "Fire";
   stateTransitionOnTriggerUp[4] = "Spindown";
   stateTransitionOnNoAmmo[4]    = "EmptySpindown";

   //--------------------------------------
   stateName[5]       = "Spindown";
   stateScript[5]     = "onSpindown";
//   stateSound[5]      = ChaingunSpinDownSound;
   stateSpinThread[5] = SpinDown;
   //
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = true;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";

   //--------------------------------------
   stateName[6]       = "EmptySpindown";
   stateSound[6]      = ChaingunSpinDownSound;
   stateSpinThread[6] = SpinDown;
   stateScript[6]     = "onSpindown";
   //
   stateTimeoutValue[6]        = 0.5;
   stateTransitionOnTimeout[6] = "NoAmmo";

   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ChaingunDryFireSound;
   stateTimeoutValue[7]        = 0.5;
   stateTransitionOnTimeout[7] = "NoAmmo";
};

datablock ShapeBaseImageData(TankMinigunImage2) : TankMinigunImage1
{
   shapeFile = "TR2weapon_chaingun.dts";
   shellExitDir        = "-1.0 0.3 1.0";
   offset = "-2 0 0.3";
   //offset = "-2.5 0 0";
   stateScript[3] = "onFire";
};

datablock ShapeBaseImageData(TankMinigunImage3) : TankMinigunImage1
{
   shapeFile = "TR2weapon_chaingun.dts";
   offset = "-2 0 -0.3";
  // offset = "0 0 0.6";
   stateScript[3] = "onFire";
};

datablock ShapeBaseImageData(TankMinigunImage4) : TankMinigunImage1
{
   shapeFile = "TR2weapon_chaingun.dts";
   shellExitDir        = "-1.0 0.3 1.0";
   offset = "0.8 0 -0.3";
   //offset = "-2.5 0 0.6";
  stateScript[3] = "onFire";
};

function TankMinigunImage1::onSpinup(%data, %obj, %slot)
{
   %obj.setImageTrigger(3, true);
   %obj.setImageTrigger(5, true);
   %obj.setImageTrigger(6, true);
}

function TankMinigunImage1::onSpindown(%data, %obj, %slot)
{
   %obj.setImageTrigger(3, false);
   %obj.setImageTrigger(5, false);
   %obj.setImageTrigger(6, false);
}

function TMMGFire(%data, %obj, %slot)
{
   %useEnergyObj = %obj.getObjectMount();
   %energy = %useEnergyObj.getEnergyLevel();
   %vehicle = %useEnergyObj;

   if(%useEnergyObj.turretObject.getCapacitorLevel() < 10)
      return;

  %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), 6);

   %p = new TracerProjectile() {
      dataBlock        = "MechMiniBullet";
      initialDirection = %vector;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };
   MissionCleanup.add(%p);
   %vehicle.turretObject.setCapacitorLevel(%vehicle.turretObject.getCapacitorLevel() - 2.25);
}

function TankMinigunImage1::onFire(%data, %obj, %slot)
{
   TMMGFire(%data, %obj, %slot);
}

function TankMinigunImage2::onFire(%data, %obj, %slot)
{
   TMMGFire(%data, %obj, %slot);
}

function TankMinigunImage3::onFire(%data, %obj, %slot)
{
   TMMGFire(%data, %obj, %slot);
}

function TankMinigunImage4::onFire(%data, %obj, %slot)
{
   TMMGFire(%data, %obj, %slot);
}

//-------------------------------------
// ASSAULT MORTAR CHARACTERISTICS
//-------------------------------------

//datablock GrenadeProjectileData(TFlakShot)
//{
//   projectileShapeName = "mortar_projectile.dts";
//   emitterDelay        = -1;
//   directDamage        = 0.0;
//   hasDamageRadius     = true;
//   indirectDamage      = 1.5;
//   damageRadius        = 30.0;
//   radiusDamageType    = $DamageType::Flak;
//   kickBackStrength    = 3500;

//   explosion           = "TFlakMortarExplosion";
//   underwaterExplosion = "TFlakMortarExplosion";
// velInheritFactor    = 1.0;
//   splash              = MortarSplash;
//   depthTolerance      = 10.0; // depth at which it uses underwater explosion
//
//   baseEmitter         = WadRedTrailEmitter;
//   bubbleEmitter       = WadBlueTrailEmitter;
//
//   grenadeElasticity = 0.15;
//   grenadeFriction   = 0.4;
//   armingDelayMS     = 250;
//   muzzleVelocity    = 60;
//   drag              = 0.1;
//
//   sound			 = MortarProjectileSound;
//
//   hasLight    = true;
//   lightRadius = 4;
//   lightColor  = "0.1 0.1 0.1";
//};

//datablock LinearFlareProjectileData(TFlakCharge)
//{
//   projectileShapeName = "turret_muzzlePoint.dts";
//   faceViewer          = false;
//   directDamage        = 0.0;
//   hasDamageRadius     = true;
//   indirectDamage      = 1.5;
//   damageRadius        = 30;
//   radiusDamageType    = $DamageType::Flak;
//   kickBackStrength    = 3500;
//
//   explosion           = "TFlakMortarExplosion";
//   underwaterExplosion = "TFlakMortarExplosion";
//
//   splash              = MissileSplash;
//   velInheritFactor    = 0;
//
//   dryVelocity       = 0.1;
//   wetVelocity       = 0.1;
//   fizzleTimeMS      = 35;
//   lifetimeMS        = 35;
//   explodeOnDeath    = true;
//   reflectOnWaterImpactAngle = 90;
//   explodeOnWaterImpact      = false;
//   deflectionOnWaterImpact   = 0.0;
//   fizzleUnderwaterMS        = 35;
//
//   activateDelayMS = -1;
//
//   numFlares         = 0;
//   flareColor        = "0 0 0";
//   flareModTexture   = "flaremod";
//   flareBaseTexture  = "flarebase";
//};

function TFlakTrigger(%obj)
{
   if(isObject(%obj))
   {
      %p = new LinearFlareProjectile()
      {
         dataBlock        = TFlakCharge;
         initialDirection = "0 0 0";
         initialPosition  = %obj.getWorldBoxCenter();
         sourceObject     = %obj.sourceObject;
         sourceSlot       = 0;
      };
      MissionCleanup.add(%p);

      %obj.delete();
   }
}

function tEnableFlak(%obj)
{
   if(isObject(%obj))
   {
      if(!%obj.flakEnabled)
      {
   //      TFlakTrigger(%obj.lastMortar);

//         %obj.play3d(MortarReloadSound);
         %obj.play3d(StarHammerReloadSound);

         %obj.flakEnabled = true;
      }
   }
}

datablock TurretImageData(AssaultMortarTurretBarrel)
{
   shapeFile = "turret_tank_barrelmortar.dts";
   mountPoint = 0;

   usesEnergy = true;
   useMountEnergy = true;
   fireEnergy = 1;
   minEnergy = -1;
   offset = "-0.5 0 0";
   useCapacitor = true;

   // Turret parameters
   activationMS                        = 4000;
   deactivateDelayMS                   = 1500;
   thinkTimeMS                         = 200;
   degPerSecTheta                      = 360;
   degPerSecPhi                        = 360;
   attackRadius                        = 75;

   stateName[0]                  = "Activate";
   stateTransitionOnNotLoaded[0] = "Dead";
   stateTransitionOnLoaded[0]    = "ActivateReady";

   stateName[1]                  = "ActivateReady";
   stateSequence[1]              = "Activate";
   stateSound[1]                 = MBLSwitchSound;
   stateTimeoutValue[1]          = 2;
   stateTransitionOnTimeout[1]   = "Ready";
   stateTransitionOnNotLoaded[1] = "Deactivate";
   stateTransitionOnNoAmmo[1]    = "NoAmmo";

   stateName[2]                    = "Ready";
   stateTransitionOnNotLoaded[2]   = "Deactivate";
   stateTransitionOnTriggerDown[2] = "Fire";
   stateTransitionOnNoAmmo[2]      = "NoAmmo";

   stateName[3]                = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3]        = 0.3;
   stateFire[3]                = true;
//   stateRecoil[3]              = LightRecoil;
   stateAllowImageChange[3]    = false;
//   stateSequence[3]            = "Fire";
//   stateSound[3]               = AssaultMortarFireSound;
   stateScript[3]              = "onFire";

   stateName[4]                  = "Reload";
   stateTimeoutValue[4]          = 0.05;
   stateAllowImageChange[4]      = false;
   stateSequence[4]              = "Reload";
   stateTransitionOnTimeout[4]   = "Ready";
   stateTransitionOnNotLoaded[4] = "Deactivate";
   stateTransitionOnNoAmmo[4]    = "NoAmmo";

   stateName[5]                = "Deactivate";
   stateSequence[5]            = "Activate";
   stateDirection[5]           = false;
   stateTimeoutValue[5]        = 2;
   stateTransitionOnLoaded[5]  = "ActivateReady";
   stateTransitionOnTimeout[5] = "Dead";

   stateName[6]               = "Dead";
   stateTransitionOnLoaded[6] = "ActivateReady";

   stateName[7]             = "NoAmmo";
   stateTransitionOnAmmo[7] = "Reload";
   stateSequence[7]         = "NoAmmo";
};

function AssaultMortarTurretBarrel::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

//   if(isObject(%obj.lastMortar))
//   {
//      TFlakTrigger(%obj.lastMortar);
//      return;
//   }

//   if(!%obj.flakEnabled)
//       return;

   if(%obj.getObjectMount().turretObject.getCapacitorLevel() >= 100)
   {
      %vehicle = %obj.getObjectMount();
      %p = new LinearProjectile()
      {
         dataBlock        = SBRocket;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };
      MissionCleanup.add(%p);

      %vehicle.turretObject.setCapacitorLevel(%vehicle.turretObject.getCapacitorLevel() - 100);
      %obj.setImageTrigger(%slot, true);
      spawnProjectile(%p, LinearFlareProjectile, MBDisplayCharge);
      projectileTrail(%p, 64, LinearFlareProjectile, ReaverCharge, true);
      %obj.play3d(StarHammerFireSound);
      %obj.flakEnabled = false;
      %obj.getObjectMount().applyImpulse(%obj.getObjectMount().getPosition(), VectorScale(%obj.getMuzzleVector(%slot), -35000));


   //   %obj.lastMortar = %p;
   //   MissionCleanup.add(%p);

      if(%obj.client)
         %obj.client.projectile = %p;

       schedule(2000, 0, "tEnableFlak", %obj);
   }
   else
      %obj.play3d(MortarDryFireSound);
}

datablock TurretImageData(AssaultTurretParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = ImpactMortar;
   projectileType = GrenadeProjectile;

   useCapacitor = true;
   usesEnergy = true;

   // Turret parameters
   activationMS      = 1000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 500;
   degPerSecPhi      = 500;
   
   attackRadius      = 75;
};              

datablock TurretImageData(CMissileTurretParam)
{
   mountPoint = 2;
   shapeFile = "turret_muzzlepoint.dts";

   isSeeker     = true;
   seekRadius   = 325;
   maxSeekAngle = 30;
   seekTime     = 1.0;
   minSeekHeat  = 0.6;
   emap = true;
   minTargetingDistance = 5;

   projectile = TurretMissile;
   projectileType = SeekerProjectile;

   useCapacitor = true;
   usesEnergy = true;

   // Turret parameters
   activationMS      = 1000;
   deactivateDelayMS = 1500;
   thinkTimeMS       = 200;
   degPerSecTheta    = 500;
   degPerSecPhi      = 500;

   attackRadius      = 75;
};

datablock TracerProjectileData(WarpGaussBullet)
{
   projectileShapeName = "chaingun_shot.dts";
   doDynamicClientHits = true;

   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.075;
   damageRadius        = 6.5;
   radiusDamageType    = $DamageType::Gauss;
   kickBackStrength    = 250;

   explosion           = "GaussExplosion";
   underwaterExplosion = "UnderwaterHandGrenadeExplosion";
   splash              = ChaingunSplash;
   sound 			   = ChaingunProjectile;

   dryVelocity       = 250.0;
   wetVelocity       = 175.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1000;

   baseEmitter     = GaussBulletEmitter;
   tracerLength    = 5;
   tracerAlpha     = false;
   tracerMinPixels = 3;
   tracerColor     = "1 0 0 1";
	tracerTex[0]  	 = "special/landSpikeBolt";
	tracerTex[1]  	 = "special/landSpikeBoltCross";
	tracerWidth     = 0.35;
   crossSize       = 0.79;
   crossViewAng    = 0.990;
   renderCross     = true;
};

datablock ShapeBaseImageData(TankPilotChaingunImage)
{
   className = WeaponImage;
   shapeFile = "turret_assaulttank_plasma.dts";
   item      = Chaingun;
   projectile = WarpGaussBullet;
   projectileType = TracerProjectile;
   mountPoint = 10;       //?
   offset = "0 4.5 -3";
   rotation = "0 1 0 180";

   usesEnergy = true;
   useMountEnergy = true;
   // DAVEG -- balancing numbers below!
   minEnergy = 10;
   fireEnergy = 10;
   fireTimeout = 250;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateAllowImageChange[0] = false;
   stateTimeoutValue[0]        = 0.05;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";
   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   stateSequence[1]         = "Activate";
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";
   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateTransitionOnTriggerDown[2] = "DryFire";
   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateTimeoutValue[3]          = 0.01;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";
   //--------------------------------------
   stateName[4]             = "Fire";
   stateSpinThread[4]       = FullSpeed;
   stateRecoil[4]           = LightRecoil;
   stateSequence[4]         = "Fire";
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   stateSound[4]            = AssaultChaingunFireSound;
   // IMPORTANT! The stateTimeoutValue below has been replaced by fireTimeOut
   // above.
   stateTimeoutValue[4]          = 0.25;
   stateTransitionOnTimeout[4]   = "checkState";
   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSpinThread[5] = SpinDown;
   stateTimeoutValue[5]            = 0.01;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";
   //--------------------------------------
   stateName[6]       = "EmptySpindown";
//   stateSound[6]      = ChaingunSpindownSound;
   stateSpinThread[6] = SpinDown;
   stateTransitionOnAmmo[6]   = "Ready";
   stateTimeoutValue[6]        = 0.01;
   stateTransitionOnTimeout[6] = "NoAmmo";
   //--------------------------------------
   stateName[7]       = "DryFire";
   stateSound[7]      = ShrikeBlasterDryFireSound;
   stateTransitionOnTriggerUp[7] = "NoAmmo";
   stateTimeoutValue[7]        = 0.25;
   stateTransitionOnTimeout[7] = "NoAmmo";

   stateName[8] = "checkState";
   stateTransitionOnTriggerUp[8] = "Spindown";
   stateTransitionOnNoAmmo[8]    = "EmptySpindown";
   stateTimeoutValue[8]          = 0.01;
   stateTransitionOnTimeout[8]   = "ready";
};

datablock ShapeBaseImageData(TankPilotChaingunParam)
{
   mountPoint = 6;
   shapeFile = "turret_muzzlepoint.dts";

   projectile = BomberFusionBolt;
   projectileType = LinearFlareProjectile;
};

function AssaultVehicle::onTrigger(%data, %obj, %trigger, %state)     // there.
{
     if(%trigger == 0)
     {
          switch(%state)
          {
               case 0:
                    %obj.fireWeapon = false;
                    %obj.setImageTrigger(6, false);
               case 1:
                    %obj.fireWeapon = true;
                    %obj.setImageTrigger(6, true);
          }
     }
}
