if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//**************************************************************
// WILDCAT GRAV CYCLE
//**************************************************************
//**************************************************************
// SOUNDS
//**************************************************************

datablock AudioProfile(ScoutSqueelSound)
{
   filename    = "fx/vehicles/outrider_skid.wav";
   description = ClosestLooping3d;
   preload = true;
};

// Scout
datablock AudioProfile(ScoutEngineSound)
{
   filename    = "fx/vehicles/outrider_engine.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   effect = BlankEffect; //ScoutEngineEffect;
};

datablock AudioProfile(ScoutThrustSound)
{
   filename    = "fx/vehicles/outrider_boost.wav";
   description = AudioDefaultLooping3d;
   preload = true;
   effect = BlankEffect; //ScoutThrustEffect;
};

//**************************************************************
// LIGHTS
//**************************************************************

//**************************************************************
// VEHICLE CHARACTERISTICS
//**************************************************************

datablock HoverVehicleData(ScoutVehicle) : WildcatDamageProfile
{
   spawnOffset = "0 0 1";

   floatingGravMag = 3.5;

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_scout.dts";
   computeCRC = true;

   debrisShapeName = "vehicle_grav_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 0.9;
   maxSteeringAngle = 0.65;

   mountPose[0] = scoutRoot;
   cameraMaxDist = 5.0;
   cameraOffset = 0.7;
   cameraLag = 0.5;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   explosion = TFlakMortarExplosion;
	explosionDamage = 0.5;
	explosionRadius = 15.0;

   lightOnly = 1;

   maxDamage = 1.5;
   destroyedLevel = 1.5;

   isShielded = true;
   rechargeRate = 0.7;
   energyPerDamagePoint = 75;
   maxEnergy = 300;
   minJetEnergy = 15;
   jetEnergyDrain = 1.3;

   // Rigid Body
   mass = 400;
   bodyFriction = 0.1;
   bodyRestitution = 0.5;  
   softImpactSpeed = 60;       // Play SoftImpact Sound
   hardImpactSpeed = 88;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 50;
   speedDamageScale = 0.01;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 40.0; //10? you sick bastard! Death~bot
   collDamageMultiplier   = 0.0225;
   //
   dragForce            = 1.5; // 0.55555555555555555555
   vertFactor           = 0.0;
   floatingThrustFactor = 0.45;

   mainThrustForce    = 67.5;
   reverseThrustForce = 48;
   strafeThrustForce  = 34;
   turboFactor        = 1.5;

   brakingForce = 10;
   brakingActivationSpeed = 4;

   stabLenMin = 2.25;
   stabLenMax = 3.75;
   stabSpringConstant  = 30;
   stabDampingConstant = 16;

   gyroDrag = 8;
   normalForce = 30;
   restorativeForce = 20;
   steeringForce = 15;
   rollForce  = 7;
   pitchForce = 4;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 2.5;
   dustHeight = 1.0;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 3.6;
   dustTrailFreqMod = 15.0;

   jetSound         = ScoutSqueelSound;
   engineSound      = ScoutEngineSound;
   floatSound       = ScoutThrustSound;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0; 
   mediumSplashSoundVelocity = 20.0;   
   hardSplashSoundVelocity = 30.0;   
   exitSplashSoundVelocity = 10.0;
   
   exitingWater      = VehicleExitWaterSoftSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterSoftSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeSoftSplashSound; 

   minMountDist = 4;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 0.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;
   
   forwardJetEmitter = WildcatJetEmitter;

   cmdCategory = Tactical;
   cmdIcon = CMDHoverScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_landscout_grey";
   targetNameTag = 'WildCat';
   targetTypeTag = 'Grav Cycle';
   sensorData = VehiclePulseSensor;

   checkRadius = 1.7785;
   observeParameters = "1 10 10";

//   runningLight[0] = WildcatLight1;
//   runningLight[1] = WildcatLight2;
//   runningLight[2] = WildcatLight3;

   shieldEffectScale = "0.9375 1.125 0.6";
};

datablock HoverVehicleData(TurboCat) : WildcatDamageProfile
{
   spawnOffset = "0 0 1";

   floatingGravMag = 4.25;

   catagory = "Vehicles";
   shapeFile = "vehicle_grav_scout.dts";
   computeCRC = true;

   debrisShapeName = "vehicle_grav_scout_debris.dts";
   debris = ShapeDebris;
   renderWhenDestroyed = false;

   drag = 0.0;
   density = 2500.0;
   maxSteeringAngle = 0.65;

   mountPose[0] = scoutRoot;
   cameraMaxDist = 5.0;
   cameraOffset = 0.7;
   cameraLag = 0.5;
   numMountPoints = 1;
   isProtectedMountPoint[0] = true;
   explosion = TFlakMortarExplosion;
	explosionDamage = 0.5;
	explosionRadius = 15.0;

   lightOnly = 1;

   maxDamage = 2;
   destroyedLevel = 2;

   isShielded = false;
   rechargeRate = 1.0;
   energyPerDamagePoint = 75;
   maxEnergy = 400;
   minJetEnergy = 15;
   jetEnergyDrain = 1.3;

   // Rigid Body
   mass = 410;
   bodyFriction = 0.1;
   bodyRestitution = 0.5;
   softImpactSpeed = 75;       // Play SoftImpact Sound
   hardImpactSpeed = 90;      // Play HardImpact Sound

   // Ground Impact Damage (uses DamageType::Ground)
   minImpactSpeed = 50;
   speedDamageScale = 0.01;

   // Object Impact Damage (uses DamageType::Impact)
   collDamageThresholdVel = 45.0; //10? you sick bastard! Death~bot
   collDamageMultiplier   = 0.0225;

   dragForce            = 1.45; // 0.55555555555555555555
   vertFactor           = 0.0;
   floatingThrustFactor = 0.625;

   mainThrustForce    = 79;
   reverseThrustForce = 56;
   strafeThrustForce  = 34;
   turboFactor        = 1.5;

   brakingForce = 10;
   brakingActivationSpeed = 4;

   stabLenMin = 3.5;
   stabLenMax = 4.25;
   stabSpringConstant  = 10;
   stabDampingConstant = 16;

   gyroDrag = 8;
   normalForce = 30;
   restorativeForce = 20;
   steeringForce = 16;
   rollForce  = 9;
   pitchForce = 7;

   dustEmitter = VehicleLiftoffDustEmitter;
   triggerDustHeight = 5.0;
   dustHeight = 1.5;
   dustTrailEmitter = TireEmitter;
   dustTrailOffset = "0.0 -1.0 0.5";
   triggerTrailHeight = 3.6;
   dustTrailFreqMod = 15.0;

   jetSound         = ScoutSqueelSound;
   engineSound      = ScoutEngineSound;
   floatSound       = ScoutThrustSound;
   softImpactSound  = GravSoftImpactSound;
   hardImpactSound  = HardImpactSound;
   //wheelImpactSound = WheelImpactSound;

   //
   softSplashSoundVelocity = 10.0;
   mediumSplashSoundVelocity = 20.0;
   hardSplashSoundVelocity = 30.0;
   exitSplashSoundVelocity = 10.0;

   exitingWater      = VehicleExitWaterSoftSound;
   impactWaterEasy   = VehicleImpactWaterSoftSound;
   impactWaterMedium = VehicleImpactWaterSoftSound;
   impactWaterHard   = VehicleImpactWaterMediumSound;
   waterWakeSound    = VehicleWakeSoftSplashSound;

   minMountDist = 4;

   damageEmitter[0] = SmallLightDamageSmoke;
   damageEmitter[1] = SmallHeavyDamageSmoke;
   damageEmitter[2] = DamageBubbles;
   damageEmitterOffset[0] = "0.0 -1.5 0.5 ";
   damageLevelTolerance[0] = 0.3;
   damageLevelTolerance[1] = 0.7;
   numDmgEmitterAreas = 1;

   splashEmitter[0] = VehicleFoamDropletsEmitter;
   splashEmitter[1] = VehicleFoamEmitter;

   shieldImpact = VehicleShieldImpact;

   forwardJetEmitter = FlyerJetEmitter;

   cmdCategory = Tactical;
   cmdIcon = CMDHoverScoutIcon;
   cmdMiniIconName = "commander/MiniIcons/com_landscout_grey";
   targetNameTag = 'TurboCat';
   targetTypeTag = 'Grav Cycle';
   sensorData = VehiclePulseSensor;

   checkRadius = 1.7785;
   observeParameters = "1 10 10";

//   runningLight[0] = WildcatLight1;
//   runningLight[1] = WildcatLight2;
//   runningLight[2] = WildcatLight3;

   shieldEffectScale = "0.9375 1.125 0.6";
};

datablock ShapeBaseImageData(TurbocatFrontDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "1 0 0 0";
   offset = "0 0.5 -0.4";
};

datablock ShapeBaseImageData(TurbocatLeftDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "0 1 0 -90";
   offset = "0.8 -2.65 -0.35";
};

datablock ShapeBaseImageData(TurbocatRightDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "0 1 0 90";
   offset = "-0.8 -2.65 -0.35";
};

datablock ShapeBaseImageData(TurbocatLeftFoldDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "0 1 0 0";
   offset = "1.8 -2.5 -0.6";
};

datablock ShapeBaseImageData(TurbocatRightFoldDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "0 1 0 0";
   offset = "-1.8 -2.5 -0.6";
};

datablock ShapeBaseImageData(TurbocatLeftWingDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "0 1 0 60";
   offset = "1.2 -2.5 1.0";
};

datablock ShapeBaseImageData(TurbocatRightWingDecal)
{
   mountPoint = 1;
   shapeFile = "nexuscap.dts";
   rotation = "0 1 0 -60";
   offset = "-1.2 -2.5 1.0";
};

function resolveWingTriggerTimeout(%obj)
{
   if(isObject(%obj))
      %obj.wingTriggerTimeout = 0;
}

function TurboCat::onTrigger(%data, %obj, %trigger, %state)
{
   // trigger = 0 for "fire", 1 for "jump", 3 for "thrust"
   // state = 1 for firing, 0 for not firing
   if(%trigger == 0)
   {
      if(!%obj.wingTriggerTimeout)
      {
         if(%obj.wingsOut)
         {
            %obj.unmountImage(2);
            %obj.unmountImage(3);
            %obj.unmountImage(6);
            %obj.unmountImage(7);
            %obj.mountImage(TurbocatLeftDecal, 6);
            %obj.mountImage(TurbocatRightDecal, 7);
   
            %obj.play3D(MissileReloadSound);
            %obj.wingsOut = false;
            %obj.wingTriggerTimeout = 500;
            schedule(%obj.wingTriggerTimeout, 0, resolveWingTriggerTimeout, %obj);
         }
         else
         {
            %obj.unmountImage(6);
            %obj.unmountImage(7);
            %obj.mountImage(TurbocatLeftWingDecal, 2);
            %obj.mountImage(TurbocatRightWingDecal, 3);
            %obj.mountImage(TurbocatLeftFoldDecal, 6);
            %obj.mountImage(TurbocatRightFoldDecal, 7);

            %obj.play3D(MissileReloadSound);
            %obj.wingsOut = true;
            %obj.wingTriggerTimeout = 500;
            schedule(%obj.wingTriggerTimeout, 0, resolveWingTriggerTimeout, %obj);
         }
      }
   }
}

//**************************************************************
// WEAPONS
//**************************************************************

