function old_testCanMove(%pos, %vec, %increment, %iterations)
{
   %success = false;
   if(%iterations > 255)
      %iterations = 255;

   if((%iterations || %increment) <= 0)
      return false;

   %int = 1;
   %ivec = vectorScale(%vec, %increment);
   %intPos[0] = %pos;

   for(%i = 1;  %i < %iterations; %i++)
   {
      %intPos[%i] = vectorAdd(%ivec, %intPos[%i-1]);
//      echo(%intPos[%i] SPC "|" SPC %pos);
   }

   while(%int <= %iterations)
   {
      InitContainerRadiusSearch(%intPos[%int], %increment, $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType);

      while((%test = ContainerSearchNext()) != 0)
      {
         if(%test)
            continue;
         else
         {
            %end = vectorAdd(%intPos[%int], vectorNeg(vectorScale(%vec, (%increment*3))));
            %cast = containerRayCast(%end, %pos, $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType);
            %success = posFrRaycast(%cast);
            break; // stop the loop!
         }
      }

      %int++;
   }

   echo(%int);
   echo(%success);
   return %success; // the result
}

function testCanMove(%pos, %vec, %dist, %mask) // yay
{
   if($noWorkyWallWalking)
      return false;

   if(!%dist)
      return false;

   if(!%mask)
      %mask = $TypeMasks::InteriorObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::VehicleObjectType;

   %fwVec = vectorScale(%vec, %dist);
   %endPos = vectorAdd(%pos, %fwVec);

   if(containerBoxEmpty(%mask, %endPos, 0.1)) // anything there?
      return posFrRaycast(containerRayCast(%endpos, %pos, %mask)) SPC %vec;
   else
      return false;
}

function replicateProjectile(%proj, %pos, %vec, %src, %del)
{
   if(!isObject(%proj))
      return;

   if(!%pos)
      %pos = %proj.getPosition();

   if(!%vec)
      %vec = %proj.initialDirection;

   if(!%src)
      %src = %proj.sourceObject;

   %replicator = new StaticShape()
   {
      dataBlock        = mReflector;
   };
   MissionCleanup.add(%replicator);
   %replicator.setPosition(%pos);

   %p = new(%proj.getClassName())()
   {
      dataBlock        = %proj.getDatablock().getName();
      initialDirection = %vec; //vectorNeg(%int.initialDirection);
      initialPosition  = %pos;
      sourceObject     = %replicator;
      sourceSlot       = 0;
      vehicleObject    = 0;
   };
   MissionCleanup.add(%p);
   %p.bkSourceObject = %proj.sourceObject;

   if(%proj.trailThread)
      projectileTrail(%p, %proj.trailThreadTime, %proj.trailThreadProjType, %proj.trailThreadProj, false, %proj.trailThreadOffset);

   if(%proj.proxyThread)
      rBeginProxy(%p);

   if(%proj.starburstMode)
      %p.starburstMode = %proj.starburstMode;

   if(%del)
      %proj.delete();

   %replicator.schedule(32, delete);

   return %p;
}

function SpeedPlasmaBolt::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
//   echo(%targetObject.getClassName());
   if(!isObject(%targetObject))
      return;

   if(%targetObject.reflectGun)
      return;

   if(%projectile.lockedMissileThread) // radar-seeking projectiles
      %projectile.lockedMissileThread = false;

   if(%projectile.bkSourceObject)
      if(isObject(%projectile.bkSourceObject))
         %projectile.sourceObject = %projectile.bkSourceObject;

     if(%targetObject.getClassName() $= "ForceFieldBare")
     {
         if(isObject(%targetObject.deployBase))
         {
            if(%data.hasDamageRadius)
                 %targetObject.deployBase.damage(%projectile.sourceObject, %position, %data.indirectDamage * %modifier, %data.indirectDamageType);
            else
                 %targetObject.deployBase.damage(%projectile.sourceObject, %position, %data.directDamage * %modifier, %data.directDamageType);
         }
         FFReflectProjectile(%projectile, %object);
     }
     else
          %targetObject.damage(%projectile.sourceObject, %position, %data.directDamage * %modifier, %data.directDamageType);

//   %mov = testCanMove(%position, %projectile.initialDirection, 1, 5);

   %mov = testCanMove(%position, %projectile.initialDirection, 2, $TypeMasks::DefaultLOSType);
   if(%mov)
   {
      if(!%projectile.wentThroughWall)
      {
         %proj = replicateProjectile(%projectile, %mov, getWords(%mov, 3, 5));
         %proj.wentThroughWall = true;
      }
   }

}
