if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------
// Ecstacy Cannon
//--------------------------------------

//--------------------------------------------------------------------------
// Sounds
//--------------------------------------
datablock AudioProfile(EcstacyFireSound)
{
   filename    = "fx/explosions/grenade_flash_explode.wav";
   description = AudioDefault3d;
   preload = true;
};

datablock TracerProjectileData(EcstacyBolt)
{
   doDynamicClientHits = true;
  // isBallistic = false;
   directDamage        = 0.0; // MrKeen
   hasDamageRadius     = true;
   indirectDamage      = 0.032;
   damageRadius        = 2.0;
   radiusDamageType    = $DamageType::Ecstacy;
   explosion           = "ScoutHPRChaingunExplosion";
   splash              = ChaingunSplash;

   directDamageType    = $DamageType::Ecstacy;
   kickBackStrength  = 0.0;

   sound = ShrikeBlasterProjectileSound;

   dryVelocity       = 250.0;
   wetVelocity       = 250.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1500;
   lifetimeMS        = 1500;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1500;

   tracerLength    = 45.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = "1 1 1 1";
	tracerTex[0]  	 = "special/blasterBolt";
	tracerTex[1]  	 = "special/blasterBoltCross";
	tracerWidth     = 0.55;
   crossSize       = 0.99;
   crossViewAng    = 0.990;
   renderCross     = true;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(EcstacyCapacitor)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_grenade.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some ecstacy capacitor charges";
   cantPickup = true;

   emap = true;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(EcstacyCannon)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "turret_elf_large.dts";
   image = EcstacyCannonImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "an ecstacy charge cannon";
};

datablock ShapeBaseImageData(EcstacyCannonImage)
{
   className = WeaponImage;
   shapeFile = "turret_elf_large.dts";
   item = EcstacyCannon;
   ammo = EcstacyCapacitor;

   offset = "0 0.2 0.05";
   emap = true;
   usesEnergy = true;
   minEnergy = -1;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Deploy";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";

   stateName[2]                     = "Fire";
   stateFire[2]                     = true;
   stateAllowImageChange[2]         = false;
   stateScript[2]                   = "onFire";
   stateTransitionOnTriggerUp[2]    = "Deconstruction";

   stateName[3]                     = "Deconstruction";
   stateScript[3]                   = "onRelease";
   stateTimeoutValue[3]             = 0.5;
   stateTransitionOnTimeout[3]      = "Ready";
};

datablock ShapeBaseImageData(PCDecalAImage)
{
   shapeFile = "pack_upgrade_ammo.dts";
   offset = "0.12 0.85 0";
   emap = true;
   rotation = "0 0 1 -90";

   stateName[0]                     = "idle";
   stateSequence[0]                 = "fire";
};

datablock ShapeBaseImageData(PCDecalBImage)
{
   shapeFile = "pack_upgrade_ammo.dts";
   offset = "-0.12 0.85 0";
   emap = true;
   rotation = "0 0 1 90";

   stateName[0]                     = "idle";
   stateSequence[0]                 = "fire";
};

datablock ShapeBaseImageData(PCDecalCImage)
{
   shapeFile = "pack_upgrade_energy.dts";
   offset = "0 0.6 0.32";
   emap = true;
   rotation = calcThisRot("-1.57 0 0");//"0 0 1 180";

   stateName[0]                     = "idle";
   stateSequence[0]                 = "fire";
};

function EcstacyCannonImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
//   %obj.mountImage(PCDecalAImage, 4);
//   %obj.mountImage(PCDecalBImage, 5);
//   %obj.mountImage(PCDecalCImage, 6);
   %obj.ecs_EcstacyOnHand = %obj.getMountedImage(0);
}

//function EcstacyCannonImage::onUnmount(%this,%obj,%slot)
//{
//   Parent::onUnmount(%this, %obj, %slot);
//   %obj.unmountImage(4);
//   %obj.unmountImage(5);
//   %obj.unmountImage(6);
//}

function ecstacyFire(%data, %player, %charge, %ecstacy, %offset, %isEcstacy)
{
   %data.lightStart = getSimTime();

   if(!%player.getMountedImage(0) == %isEcstacy)
        return false;
          
   if(%player.chargeProjectile)
        %player.chargeProjectile.delete();

   for(%i=0; %i < %charge; %i++)
   {
      %vector = %player.getMuzzleVector(%ecstacy);
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * (%offset / 1000);
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * (%offset / 1000);
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * (%offset / 1000);
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new TracerProjectile()
      {
          dataBlock        = "EcstacyBolt";
          initialDirection = %vector; // %player.getMuzzleVector(%ecstacy);
          initialPosition  = %player.getMuzzlePoint(%ecstacy);
          sourceObject     = %player;
          sourceSlot       = %ecstacy;
          vehicleObject    = 0;
      };

        if (isObject(%player.lastProjectile) && %player.deleteLastProjectile)
           %player.lastProjectile.delete();

        %player.lastProjectile = %p;
        %player.deleteLastProjectile = %data.deleteLastProjectile;
        MissionCleanup.add(%p);
    }

    %player.setInventory(%data.ammo,0);     // start from scratch

   // AI hook
   if(%player.client)
      %player.client.projectile = %p;

   serverPlay3D(AAFireSound, %player.getTransform());
}

function ecstacyCharge(%data, %player, %ecstacy)       // should work....
{
     if(!isObject(%player))
          return;
     
     %ammo = %player.getInventory(%data.ammo);
     %ammoMax = %player.getDatablock().max["EcstacyCapacitor"];
     %ecstacyOnHand = %player.ecs_EcstacyOnHand;
     
     if(%player.ecstacy)
     {
          if(%player.getMountedImage(0) == %ecstacyOnHand)
          {
            if(!%player.isEMP)
            {
               %q = new ShockLanceProjectile()
               {
                  dataBlock        = "FirelanceBolt";
                  initialDirection = %player.getMuzzleVector(0);
                  initialPosition  = %player.getMuzzlePoint(0);
                  sourceObject     = %player;
                  sourceSlot       = 0;
               };
               MissionCleanup.add(%q);

               %player.incInventory(EcstacyCapacitor, 1);

               if(%ammo > %ammoMax)
                    %ammo = %ammoMax;   // quick non-overcharge hack
            }
            else
               %player.setInventory(EcstacyCapacitor, 0);

               if(%player.isSyn)
                    schedule(50, 0, "ecstacyCharge", %data, %player, %ecstacy);
               else
                    schedule(100, 0, "ecstacyCharge", %data, %player, %ecstacy);
          }
     }
     else
     {
          if(%player.getMountedImage(0) == %ecstacyOnHand)
          {
               %charge = mFloor(%ammo / 4);
               %offset = %ammo / 65; // MrKeen
               ecstacyFire(%data, %player, %charge, %ecstacy, %offset, %ecstacyOnHand);
               return;
          }
     }
}

$Ecstacy::ChargeDrain = 0.17;

function EcstacyCannonImage::onFire(%data,%obj,%slot)
{
   if(getSightInfo(%obj, 1, $TypeMasks::ForceFieldObjectType))
      return;

     if(!%obj.ecstacy || !%obj.ecstacy == true)
     {
          %ammo = %obj.getInventory(%data.ammo);
          %ammoMax = %obj.getDatablock().max["EcstacyCapacitor"];
//          %obj.setRechargeRate(%obj.getRechargeRate() - $Ecstacy::ChargeDrain); // MrKeen

          %obj.ecstacy = true;
          %obj.incInventory(EcstacyCapacitor, 1);

          if(%obj.isSyn)
               schedule(50, 0, "ecstacyCharge", %data, %obj, %slot);
          else
               schedule(100, 0, "ecstacyCharge", %data, %obj, %slot);
     }
}

function EcstacyCannonImage::onRelease(%data,%obj,%slot)
{
     %obj.ecstacy = false;
//     %obj.setRechargeRate(%obj.getRechargeRate() + $Ecstacy::ChargeDrain);
}

