if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------
// Mitzi Blast Cannon II
//--------------------------------------

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------
datablock ParticleData(MBExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 150;
   textureName          = "particleTest";
   colors[0]     = "1.0 1.0 1.0 1.0";
   colors[1]     = "1.0 1.0 0.1 0.0";
   sizes[0]      = 2;
   sizes[1]      = 5;
};

datablock ParticleEmitterData(MBExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "MBExplosionParticle";
};

datablock ExplosionData(MitziBlastExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 150;
   particleRadius = 3.5;
   faceViewer = true;
};

datablock ExplosionData(MBXSubExplosion)//1) --- typo? (ST)
{
   explosionShape = "effect_plasma_explosion.dts";
   faceViewer           = true;

   delayMS = 1;

   offset = 0;

   playSpeed = 0.5;

   sizes[0] = "1.5 1.5 1.5";
   sizes[1] = "3 3 3";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(MitziBlastXExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
   soundProfile   = plasmaExpSound;

   sizes[0] = "4 4 4";
   sizes[1] = "4 4 4";
   times[0] = 0.0;
   times[1] = 1.0;
   
   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
   subExplosion[0] = MBXSubExplosion;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 300;
   particleRadius = 7;
   faceViewer = true;
};

datablock ExplosionData(MitziBlastXUWExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   sizes[0] = "4 4 4";
   sizes[1] = "4 4 4";
   times[0] = 0.0;
   times[1] = 1.0;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = DiscMistEmitter;
   particleDensity = 300;
   particleRadius = 7;
   faceViewer = true;
   
   bubbleEmitter = "DiscExplosionBubbleEmitter";
};

datablock ExplosionData(UMitziBlastExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 150;
   particleRadius = 3.5;
   faceViewer = true;
   
   bubbleEmitter = "DiscExplosionBubbleEmitter";
};

//--------------------------------------------------------------------------
// Trail
//--------------------------------------

datablock ParticleData(MBTrailParticle)
{
   dragCoefficient      = 2.75;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 0;
   textureName          = "particleTest";
   colors[0]     = "1.0 1.0 1.0 1.0";
   colors[1]     = "0.5 0.5 0.1 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 1.5;
};

datablock ParticleEmitterData(MBTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 12;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance  = true;
   particles = "MBTrailParticle";
};

datablock ParticleData(MBXTrailParticle)
{
   dragCoefficient      = 2.75;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 0;
   textureName          = "particleTest";
   colors[0]     = "1.0 1.0 1.0 1.0";
   colors[1]     = "0.5 0.5 0.1 0.0";
   sizes[0]      = 4.0;
   sizes[1]      = 2;
};

datablock ParticleEmitterData(MBXTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 12;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance  = true;
   particles = "MBXTrailParticle";
};

datablock ParticleData(MBEMPTrailParticle)
{
   dragCoefficient      = 2.75;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 900;
   lifetimeVarianceMS   = 0;
   textureName          = "particleTest";
   colors[0]     = "0.2 1.0 0.2 1.0";
   colors[1]     = "0.01 0.9 0.1 0.0";
   sizes[0]      = 2.0;
   sizes[1]      = 1.5;
};

datablock ParticleEmitterData(MBEMPTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 12;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance  = true;
   particles = "MBEMPTrailParticle";
};
//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearFlareProjectileData(MitziBlast)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "6.0 6.0 6.0";
   faceViewer          = true;
   directDamage        = 0.6;
   directDamageType    = $DamageType::MB;
   hasDamageRadius     = true;
   indirectDamage      = 0.45;
   damageRadius        = 14.0;
   kickBackStrength    = 1000;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MitziBlastExplosion";
   underwaterExplosion = "UMitziBlastExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MBTrailEmitter;

   dryVelocity       = 45.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "1 0.8 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 1 1";
};

datablock LinearFlareProjectileData(MitziEMPBlast)
{
   scale               = "5.0 5.0 5.0";
   faceViewer          = true;
   hasDamageRadius     = true;
   indirectDamage      = 0.001;
   damageRadius        = 15.0;
   radiusDamageType    = $DamageType::EMP;

   explosion           = "EMPExplosion";
   underwaterExplosion = "EMPExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MBTrailEmitter;

   dryVelocity       = 45.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "0.2 1 0.2";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "0.2 1 0.2";
};

datablock LinearFlareProjectileData(MitziSingularityBlast)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "3.0 3.0 3.0";
   faceViewer          = true;
   directDamageType    = $DamageType::MB;
   directDamage        = 0.3;
   hasDamageRadius     = true;
   indirectDamage      = 0.275;
   damageRadius        = 7.0;
   kickBackStrength    = 500;
   radiusDamageType    = $DamageType::MB;

   explosion           = "FireballAtmosphereBoltExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MiniStreakEmitter; //ContrailEmitter;

   dryVelocity       = 180.0; // -nite- was 150
   wetVelocity       = 300.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "1 0.8 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 1 1";
};

datablock LinearFlareProjectileData(MitziBooster)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "6.0 6.0 6.0";
   faceViewer          = true;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.001;
   damageRadius        = 10.0;
   kickBackStrength    = 7500;
   radiusDamageType    = $DamageType::Default;

   explosion           = "ConcussionGrenadeExplosion";
   underwaterExplosion = "ConcussionGrenadeExplosion";
   splash              = PlasmaSplash;

   dryVelocity       = 45.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 5000;
   lifetimeMS        = 5000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 5000;

   activateDelayMS = -1;
   numFlares         = 0;
   flareColor        = "1 0.6 0.7";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "0 0 0";
};

datablock LinearFlareProjectileData(MitziX2)
{
   scale               = "12.0 12.0 12.0";
   faceViewer          = true;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.9;
   damageRadius        = 14.0;
   kickBackStrength    = 2000;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MitziBlastXExplosion";
   underwaterExplosion = "MitziBlastXUWExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MBXTrailEmitter;

   dryVelocity       = 45.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 7500;
   lifetimeMS        = 7500;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "1 0.8 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 1 1";
};

datablock LinearFlareProjectileData(MitziX2Singularity)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "3.0 3.0 3.0";
   faceViewer          = true;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.45;
   damageRadius        = 6.0;
   kickBackStrength    = 500;
   radiusDamageType    = $DamageType::MB;

   explosion           = "FireballAtmosphereBoltExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MiniStreakEmitter; //ContrailEmitter;

   dryVelocity       = 180.0; // -nite- was 150
   wetVelocity       = 300.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "1 0.8 0.9";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = true;
   lightRadius = 8.0;
   lightColor  = "1 1 1";
};

datablock ShockwaveData(MBDispSShockwave)
{
   width = 5.0;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 15;
   acceleration = -30;
   lifetimeMS = 500;
   height = 1.0;
   verticalCurve = 0.5;
//   is2D = true;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 1.0 1.0 0.75";
   colors[1] = "1.0 1.0 0.5 0.5";
   colors[2] = "1.0 1.0 0.1 0.0";

   mapToTerrain = false;
   orientToNormal = true;
   renderBottom = true;
};

datablock ExplosionData(MBDispSExplosion)
{
   soundProfile   = plasmaExpSound;
   shockwave = MBDispSShockwave;

   faceViewer = true;
};

datablock LinearFlareProjectileData(MBDisplayCharge)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.0001;//0.000; --- must be > 0 (ST)
   damageRadius        = 10;
   radiusDamageType    = $DamageType::MB;
   kickBackStrength    = 750;

   explosion           = "MBDispSExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(MBCannonCapacitor)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "extra mitzi capacitor charges";
   cantPickup = true;
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(MBCannon)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = MBCannonImage;
   ammo = MBCannonCapacitor;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a mitzi blast cannon";

   emap = true;
};

datablock ShapeBaseImageData(MBCannonImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   item = MBCannon;
   ammo = MBCannonCapacitor;
   offset = "0 0 0";
   emap = true;

//   projectile = MitziBlast;
   projectileType = LinearFlareProjectile;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = BlasterSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateSequence[3] = "Recoil";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.8;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
//   stateSound[3] = PlasmaFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.75;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = DiscDryFireSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateScript[5] = "onCharge";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = MortarDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};

datablock ShapeBaseImageData(MBChargerAImage)
{
   shapeFile = "weapon_targeting.dts";
   offset = "0.075 0 0.215";
   emap = true;
};

datablock ShapeBaseImageData(MBChargerBImage)
{
   shapeFile = "weapon_targeting.dts";
   offset = "-0.1 0 -0.1";
   rotation = "0 1 0 135";
   emap = true;
};

datablock ShapeBaseImageData(MBChargerCImage)
{
   shapeFile = "weapon_targeting.dts";
   offset = "0.25 0 -0.075"; //.075";
   rotation = "0 1 0 -135";
   emap = true;
};

function MBCannonImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(MBChargerAImage, 4);
   %obj.mountImage(MBChargerBImage, 5);
   %obj.mountImage(MBChargerCImage, 6);
}

function MBCannonImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}

function MBCannonImage::onCharge(%data,%obj,%slot)
{
     if(%obj.charging = false || !%obj.charging)
          ChargeMBC(%obj);
}

function ChargeMBC(%player)       // should work....
{
   %ammo = %player.getInventory(MBCannonCapacitor);
   %ammoMax = %player.getDatablock().max[MBCannonCapacitor];

   if(%ammo > -1)   // jury rig for now
   {
      if(%ammo < %ammoMax)
      {
         if(!%player.isEMP)
         {
           %player.incInventory(MBCannonCapacitor, 1);
           %player.charging = true;
         }
         else
           %player.setInventory(MBCannonCapacitor, 0);

         if(%player.isSyn)
         {
            if(%ammo < 50)
               schedule(250, %player, "ChargeMBC", %player);
            else if(%ammo < 75)
               schedule(500, %player, "ChargeMBC", %player);
            else
               schedule(750, %player, "ChargeMBC", %player);
         }
         else
         {
            if(%ammo < 50)
               schedule(500, %player, "ChargeMBC", %player);
            else if(%ammo < 75)
               schedule(750, %player, "ChargeMBC", %player);
            else
               schedule(1000, %player, "ChargeMBC", %player);
         }
      }
      else
         %player.charging = false;
   }
}

function MBCannonImage::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

   if(getSightInfo(%obj, 1, $TypeMasks::ForceFieldObjectType))
      return;

//   if( %obj.station $= "" && %obj.isCloaked() )
//   {
//      if( %obj.respawnCloakThread !$= "" )
//      {
//         Cancel(%obj.respawnCloakThread);
//         %obj.setCloaked( false );
//         %obj.respawnCloakThread = "";
//      }
//      else
//      {
//         if( %obj.getEnergyLevel() > 20 )
//         {
//            %obj.setCloaked( false );
//            %obj.reCloak = %obj.schedule( 500, "setCloaked", true );
//         }
//      }
//   }

     %weapon = %obj.getMountedImage(0).item;
     if(%obj.client.mode[%weapon] == 0)
     {
         %projectile = MitziBlast;
         %energyUse = 10;
         %type = "Standard Mitzi Blast";
     }
     else if(%obj.client.mode[%weapon] == 1)
     {
         %projectile = MitziSingularityBlast;
         %energyUse = 5;
         %type = "Output x0.5 Blast";
     }
     else if(%obj.client.mode[%weapon] == 2)
     {
         %projectile = MitziX2;
         %energyUse = 20;
         %type = "Output x2 Blast";
     }
     else if(%obj.client.mode[%weapon] == 3)
     {
         %projectile = MitziBooster;
         %energyUse = 25;
         %type = "Mitzi Booster";
     }
     else if(%obj.client.mode[%weapon] == 4)
     {
         %projectile = MitziAnnihalator;
         %energyUse = 100;
         %type = "Mitzi Annihalator";
     }
     else if(%obj.client.mode[%weapon] == 5)
     {
         %projectile = MitziRumbleBlast;
         %energyUse = 150;
         %type = "Rumble Shield Ignore Blast";
     }
     //-Nite- removed thremo Nuke mode
    // else if(%obj.client.mode[%weapon] == 6)
    // {
     //    %projectile = MitziNukeBlast;
     //    %energyUse = 150;
     //    %type = "Thermonuclear Blast";
    // }

     %nrg = %energyUse -1;

   %vehicle = 0;

   if(%obj.client.mode[%weapon] == 4 && $Feature[AnniSafety] && Meltdown.AnniSafetyActive)
   {
      if(isObject(getLOSInfo(%obj, $Feature[AnniSafety, minFireDist])))
      {
         bottomPrint(%obj.client, "<color:ffffff>Annihalator Safety System <color:ff1313>v1.1\n<color:42dbea>You are too close to something to fire the Annihalator. Min distance is "@$Feature[AnniSafety, minfireDist]@"m", 5, 2);
         %obj.play3d(ShockLanceDryFireSound);
         return;
      }
      else if(velToSingle(%obj.getVelocity()) > 1 && !$Feature[AnniSafety, fireWhenMoving])
      {
         bottomPrint(%obj.client, "<color:ffffff>Annihalator Safety System <color:ff1313>v1.1\n<color:42dbea>You cannot move and fire the Annihalator at the same time.", 5, 2);
         %obj.play3d(ShockLanceDryFireSound);
         return;
      }
      else if(getDamagePct(%obj) > 0.8 && $Feature[AnniSafety, damageDependantFiring])
      {
         bottomPrint(%obj.client, "<color:ffffff>Annihalator Safety System <color:ff1313>v1.1\n<color:42dbea>Your health is less than 20%, you must repair over this to use the Annihalator.", 5, 2);
         %obj.play3d(ShockLanceDryFireSound);
         return;
      }
   }

   if(%obj.getInventory(%data.ammo) < %energyUse)
   {
      bottomPrint(%obj.client, "Not enough energy to fire "@%type@".", 3, 1);
      %obj.play3d(ShockLanceDryFireSound);
      return;
   }
   else if(%obj.client.mode[%weapon] != 4) // special Anni fire
   {
      %p = new LinearFlareProjectile()
      {
         dataBlock        = %projectile;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
     };

     if(%obj.client.mode[%weapon] == 3)
        projectileTrail(%p, 250, LinearFlareProjectile, MBDisplayCharge, true);
   }
   else
   {
      %rnd = 1337 + getRandom(300); //1000 and random: 200
      schedule(%rnd, 0, "MBAFire", %data, %obj, %slot);
      %obj.play3d(RMSSBDeploySound); //ShockLanceDryFireSound);                                                                  //100
      bottomPrint(%obj.client, "<color:ffffff>Mitzi Control System\n<color:42dbea>Overvolting Mitzi electron emitters...", ((%rnd+200) / 1000), 2);
      return;
   }

   if(isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;
      
   %obj.play3d(PlasmaFireSound);
   %obj.decInventory(%data.ammo, %nrg);
   
   if(!%obj.charging)
      ChargeMBC(%obj);
}

function MBAFire(%data, %obj, %slot)
{
   if(isObject(getLOSInfo(%obj, 10)))
   {
      bottomPrint(%obj.client, "Not enough room to create the Annihalator blast; shutting down", 4, 1);
      %obj.play3d(ShockLanceDryFireSound);
      %obj.decInventory(%data.ammo, 25);

      if(!%obj.charging)
         ChargeMBC(%obj);

      return;
   }

   if(isObject(%obj))
   {
      %p = new LinearFlareProjectile()
      {
         dataBlock        = MitziAnnihalator;
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = 0;
     };

     %obj.applyKick(-2000);

     if(isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
        %obj.lastProjectile.delete();

     %obj.lastProjectile = %p;
     %obj.deleteLastProjectile = %data.deleteLastProjectile;
     MissionCleanup.add(%p);

     // AI hook
     if(%obj.client)
        %obj.client.projectile = %p;

     %obj.play3d(PlasmaFireSound);
     %obj.decInventory(%data.ammo, 100);

     if(!%obj.charging)
        ChargeMBC(%obj);
   }
}
