if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------
// Mitzi Flak Gun 
//--------------------------------------

datablock GrenadeProjectileData(MFGrenade)
{
   projectileShapeName = "grenade_projectile.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.29;
   damageRadius        = 26;
   radiusDamageType    = $DamageType::MB;
   kickBackStrength    = 1500;
   bubbleEmitTime      = 1.0;

   sound               = GrenadeProjectileSound;
   explosion           = "MitziBlastExplosion";
   velInheritFactor    = 1.0;
   splash              = GrenadeSplash;

   baseEmitter         = MBTrailEmitter;
//   bubbleEmitter       = MBTrailEmitter;

   grenadeElasticity = 0.35;
   grenadeFriction   = 0.2;
   armingDelayMS     = 250;
   muzzleVelocity    = 100;
   drag = 0.1;
};

datablock LinearProjectileData(MFCharge)
{
   projectileShapeName = "turret_muzzlepoint.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.25;
   damageRadius        = 22.5;
   radiusDamageType    = $DamageType::MB;
   kickBackStrength    = 1500;

   sound 				= GrenadeProjectileSound;
   explosion           = "MitziBlastExplosion";
   splash              = MortarSplash;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 250;
   lifetimeMS        = 250;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 250;

   activateDelayMS = -1;
   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0.1 0.1 0.1";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(MFGImage)
{
   className = WeaponImage;
   shapeFile = "weapon_plasma.dts";
   item = MFG;
   offset = "0 0 0";
   emap = true;

   usesEnergy = true;
   minEnergy = -1;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = GrenadeSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.2;
   stateFire[3] = true;
//   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
//   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
//   stateSound[3] = GrenadeFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.01;
   stateAllowImageChange[4] = false;
//   stateSequence[4] = "Reload";
//   stateSound[4] = GrenadeReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = GrenadeDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};

datablock ItemData(MFG)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_plasma.dts";
   image = MFGImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a mitzi flak gun";
};

datablock ShapeBaseImageData(SOPDecalAImage)
{
   shapeFile = "weapon_energy.dts";
   offset = "0 0 0.05";
   emap = true;
};

datablock ShapeBaseImageData(SOPDecalBImage)
{
   shapeFile = "weapon_repair.dts";
   offset = "-0.3 0.1 0.275";
   rotation = "0 1 0 -135";
   emap = true;
};

datablock ShapeBaseImageData(SOPDecalCImage)
{
   shapeFile = "weapon_repair.dts";
   offset = "0.3 0.1 0.25";
   rotation = "0 1 0 135";
   emap = true;
};

function MFGImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.MFGEnabled = true;

   %obj.mountImage(SOPDecalAImage, 4);
   %obj.mountImage(SOPDecalBImage, 5);
   %obj.mountImage(SOPDecalCImage, 6);
}

function MFGImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}

function enableMFG(%obj)
{
   %obj.play3d(GrenadeReloadSound);
   %obj.MFGEnabled = true;
}

function MFGTrigger(%obj)
{
   %p = new LinearProjectile()
   {
      dataBlock        = MFCharge;
      initialDirection = "0 0 0";
      initialPosition  = %obj.getWorldBoxCenter();
      sourceObject     = %obj.sourceObject;
      sourceSlot       = 0;
   };
   MissionCleanup.add(%p);

   schedule(50, 0, killit, %obj);
}

function MFGImage::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

   if(isObject(%obj.lastMFG))
   {
      MFGTrigger(%obj.lastMFG);
      return;
   }

   if(!%obj.MFGEnabled)
      return;

//   if( %obj.station $= "" && %obj.isCloaked() )
//   {
//      if( %obj.respawnCloakThread !$= "" )
//      {
//         Cancel(%obj.respawnCloakThread);
//         %obj.setCloaked( false );
//         %obj.respawnCloakThread = "";
//      }
//      else
//      {
//         if( %obj.getEnergyLevel() > 20 )
//         {
//            %obj.setCloaked( false );
//            %obj.reCloak = %obj.schedule( 500, "setCloaked", true );
//         }
//      }
//   }

   %p = new GrenadeProjectile() {
      dataBlock        = MFGrenade;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = 0;
   };

   %obj.lastMFG = %p;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

    %obj.useEnergy(20);
    %obj.play3d(GrenadeFireSound);
    %obj.MFGEnabled = false;
    schedule(1000, 0, "enableMFG", %obj);
}
