if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Particle Beam Weapon
//--------------------------------------------------------------------------

datablock AudioProfile(PBWSwitchSound)
{
   filename    = "fx/misc/diagnostic_on.wav";
   description = AudioClosest3d;
   preload = true;
   effect = SniperRifleSwitchEffect;
};

datablock AudioProfile(PBWFireSound)
{
   filename    = "fx/misc/lightning_impact.wav";
   description = AudioClose3d;
   preload = true;
   effect = SniperRifleFireEffect;
};

datablock AudioProfile(PBWProjectileSound)
{
   filename    = "fx/powered/turret_aa_fire.wav";
   description = AudioClose3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Explosion
//--------------------------------------
datablock AudioProfile(PBWExpSound)
{
   filename    = "fx/powered/turret_plasma_explode.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock ShockwaveData(PBWShockwave)
{
   width = 6;
   numSegments = 32;
   numVertSegments = 7;
   velocity = 40;
   acceleration = 35.0;
   lifetimeMS = 999;
   height = 0.5;
   verticalCurve = 0.375;

   mapToTerrain = false;
   renderBottom = true;
   orientToNormal = true;

   texture[0] = "special/shockwave5";
   texture[1] = "special/gradient";
   texWrap = 1.5;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.6 0.6 1.0 1.0";
   colors[1] = "0.6 0.3 1.0 0.5";
   colors[2] = "0.0 0.0 1.0 0.0";
};

datablock ShockwaveData(PBWFireShockwave)
{
   width = 6;
   numSegments = 32;
   numVertSegments = 7;
   velocity = 30;
   acceleration = 10.0;
   lifetimeMS = 300;
   height = 0.5;
   verticalCurve = 0.375;

   mapToTerrain = false;
   renderBottom = true;
   orientToNormal = true;

   texture[0] = "special/shockwave5";
   texture[1] = "special/gradient";
   texWrap = 1.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "1.0 0.3 1.0 1.0";
   colors[1] = "0.5 0.8 0.5 0.5";
   colors[2] = "0.0 1.0 0.0 0.0";
};

datablock ExplosionData(PBWExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = PBWExpSound;
   shockwave      = PBWShockwave;
   faceViewer     = true;
   playSpeed      = 0.3;

   sizes[0] = "2 2 2";
   sizes[1] = "2 2 2";
   times[0]      = 0.0;
   times[1]      = 1.0;

   shakeCamera = true;
   camShakeFreq = "10.0 6.0 9.0";
   camShakeAmp = "15.0 15.0 15.0";
   camShakeDuration = 1.5;
   camShakeRadius = 10.0;
};

//--------------------------------------
// Projectile
//--------------------------------------
datablock SniperProjectileData(ParticleBeam) //lots changed death~bot
{
   directDamage        = 0.95;
   velInheritFactor    = 1.0;
   faceViewer          = true;
   sound 			   = PBWProjectileSound;
   explosion           = "PBWExplosion";
   splash              = PlasmaSplash;
   directDamageType    = $DamageType::PBW;

   maxRifleRange       = 1500;
   rifleHeadMultiplier = 2;
   beamColor           = "1 1 1"; //0.1 1 0.1";
   fadeTime            = 1.0; //for gat pbw..

   startBeamWidth		  = 0.40; //0.05
   endBeamWidth 	     = 0.40; //0.05
   pulseBeamWidth 	  = 0.025;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 3.0;
   pulseLength         = 0.4;

   lightRadius         = 5.0;
   lightColor          = "1 1 1"; //0.1 1 0.1";

   textureName[0]   = "special/flare";
  textureName[1]   = "special/nonlingradient";
  textureName[2]   = "special/laserrip01";
  textureName[3]   = "special/laserrip02";
  textureName[4]   = "special/laserrip03";
  textureName[5]   = "special/laserrip04";
  textureName[6]   = "special/laserrip05";
  textureName[7]   = "special/laserrip06";
  textureName[8]   = "special/laserrip07";
  textureName[9]   = "special/laserrip08";
  textureName[10]   = "special/laserrip09";
  textureName[11]   = "special/shocklance_effect02";

   //textures[0] = "special/ELFBeam";    //changed this solely for gat PBW
   //textures[1] = "special/ELFLightning";
   //textureName[0]      = "special/ELFBeam";
   //textureName[1]      = "special/ELFLightning";
};

datablock SniperProjectileData(MaserBeam)
{
   directDamage        = 0.25;
   velInheritFactor    = 1.0;
   faceViewer          = true;
   sound 			   = PBWProjectileSound;
   explosion           = "IncendiaryExplosion";
   splash              = PlasmaSplash;
   directDamageType    = $DamageType::Plasma;

   maxRifleRange       = 1750;
   rifleHeadMultiplier = 2;
   beamColor           = "0.1 1 0.1";
   fadeTime            = 6.0;

   startBeamWidth		  = 0.05;
   endBeamWidth 	     = 0.05;
   pulseBeamWidth 	  = 0.025;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 3.0;
   pulseLength         = 0.4;

   lightRadius         = 5.0;
   lightColor          = "0.1 1 0.1";

   textures[0] = "special/plsam05";
   textures[1] = "special/plsam05";
   textureName[0]      = "special/plsam05";
   textureName[1]      = "special/plsam05";
};

datablock TargetProjectileData(PBWLaserProj)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 500;
   beamColor           	= "0.85 0.9 0.25";

   startBeamWidth			= 0.20;
   pulseBeamWidth 	   = 0.15;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "special/ELFBeam";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "special/ELFLightning";
   textureName[3]      	= "special/BlueImpact";
};

datablock TargetProjectileData(MaserProj)
{
   directDamage        	= 0.0;
   hasDamageRadius     	= false;
   indirectDamage      	= 0.0;
   damageRadius        	= 0.0;
   velInheritFactor    	= 1.0;

   maxRifleRange       	= 750;
   beamColor           	= "1 1 1";

   startBeamWidth			= 0.25;
   pulseBeamWidth 	   = 0.1;
   beamFlareAngle 	   = 3.0;
   minFlareSize        	= 0.0;
   maxFlareSize        	= 400.0;
   pulseSpeed          	= 6.0;
   pulseLength         	= 0.150;

   textureName[0]      	= "skins/plsam05";
   textureName[1]      	= "special/flare";
   textureName[2]      	= "skins/plasma05";
   textureName[3]      	= "skins/plasma05";
};

datablock ItemData(PBW)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_missile.dts";
   image        = PBWImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a particle beam weapon (PBW)";
};

datablock ShapeBaseImageData(PBWImage)
{
	className = WeaponImage;
   shapeFile = "weapon_missile.dts";
   item = PBW;
   projectileType = SniperProjectile;
   offset = "0 0.65 0";
   muzzleFlash = PBWFireShockwave;

	usesEnergy = true;
	minEnergy = 8.5;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = PBWSwitchSound;
   stateTimeoutValue[0]             = 0.5;
//   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "CheckWet";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.25;
   stateFire[3]                     = true;
//   stateRecoil[3]                   = LightRecoil;
   stateShockwave[3] = true;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "reload";
   stateScript[3]                   = "onFire";
//   stateEmitter[3]           = "UnderwaterMineExplosionSmokeEmitter";
//   stateEmitterTime[3]       = 0.24;
//   stateEmitterNode[3]       = 0;

   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.25;
   stateAllowImageChange[4]         = false;

   stateName[5]                     = "CheckWet";
   stateTransitionOnWet[5]          = "DryFire";
   stateTransitionOnNotWet[5]       = "Fire";

   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";
   stateSequence[6]                 = "NoAmmo";

   stateName[7]                     = "DryFire";
   stateSound[7]                    = ShockLanceDryFireSound;
   stateTimeoutValue[7]             = 0.5;
   stateTransitionOnTimeout[7]      = "Ready";
};

function deletePBWFireTimeout(%obj)
{
    %obj.PBWFireTimeout = false;
}

function PBWImage::onFire(%data,%obj,%slot)
{
   %weapon = %obj.getMountedImage(0).item;
   if(%obj.client.mode[%weapon] == 0)
   {
       if(%obj.PBWFireTimeout == true)
           return;

       if(%obj.getEnergyLevel() < %obj.getDatablock().maxEnergy)
       {
         serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
         return;
       }

      if(!%obj.hasEnergyPack)
      {
         messageClient(%obj.client, 'MsgPBWNeedEnPack', '\c2You need the energy pack to operate the Particle Beam Weapon (PBW).');
         serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
         return;
      }
      //-Nite- Moved %T before %P, might help that help no damage thing
     %t = new TargetProjectile()
      {
             dataBlock        = "PBWLaserProj";
             initialDirection = %obj.getMuzzleVector(%slot);
             initialPosition  = %obj.getMuzzlePoint(%slot);
             sourceObject     = %obj;
             sourceSlot       = %slot;
             vehicleObject    = 0;
      };
      MissionCleanup.add(%t);
      
      %p = new (%data.projectileType)() {
         dataBlock        = "ParticleBeam";
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         damageFactor     = 2.56;
         sourceSlot       = %slot;
      };
      //%t was here -Nite-
      %obj.lastProjectile = %p;
      MissionCleanup.add(%p);
      serverPlay3D(PBWFireSound, %obj.getTransform());


      // AI hook
      if(%obj.client)
         %obj.client.projectile = %p;

       %obj.PBWFireTimeout = true;
       schedule(3000, 0, "deletePBWFireTimeout", %obj);

      %obj.setEnergyLevel(0);
      schedule(350, 0, "killit", %t);
   }
   else
   {
       if(%obj.PBWFireTimeout == true)
           return;

       if(%obj.getEnergyLevel() < 55)
       {
         serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
         return;
       }

      if(!%obj.hasEnergyPack)
      {
         messageClient(%obj.client, 'MsgPBWNeedEnPack', '\c2You need the energy pack to operate the Particle Beam Weapon (PBW).');
         serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
         return;
      }

//      %endPoint = getMuzzleRaycastPt(%obj, 0, 2500);
//      if(!%endpoint)
//         %endPoint = "65535 65535 65535";

      %p = new (%data.projectileType)() {
         dataBlock        = "MaserBeam";
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         damageFactor     = 0.1;
         sourceSlot       = %slot;
      };

      %obj.lastProjectile = %p;
      MissionCleanup.add(%p);

//      %q = new LinearFlareProjectile() {
//         dataBlock        = "SpeedPlasmaBolt";
//         initialDirection = %obj.getMuzzleVector(%slot);
//         initialPosition  = %endPoint;
//         sourceObject     = %obj;
//         damageFactor     = 0.0;
//         sourceSlot       = %slot;
//      };
//      MissionCleanup.add(%q);

      serverPlay3D(PBWFireSound, %obj.getTransform());

      %t = new TargetProjectile()
      {
             dataBlock        = "MaserProj";
             initialDirection = %obj.getMuzzleVector(%slot);
             initialPosition  = %obj.getMuzzlePoint(%slot);
             sourceObject     = %obj;
             sourceSlot       = %slot;
             vehicleObject    = 0;
      };
      MissionCleanup.add(%t);
      // AI hook
      if(%obj.client)
         %obj.client.projectile = %p;

       %obj.PBWFireTimeout = true;
       schedule(1500, 0, "deletePBWFireTimeout", %obj);

      %obj.useEnergy(65);
      schedule(350, 0, "killit", %t);
   }
}

function xxPBWImage::onFire(%data,%obj,%slot)
{
   %weapon = %obj.getMountedImage(0).item;
   if(%obj.client.mode[%weapon] == 0)
   {
       if(%obj.PBWFireTimeout == true)
           return;

       if(%obj.getEnergyLevel() < %obj.getDatablock().maxEnergy)
       {
         serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
         return;
       }

      if(!%obj.hasEnergyPack)
      {
         messageClient(%obj.client, 'MsgNeedEnPackPBW', '\c2You need the energy pack to operate the Particle Beam Weapon (PBW).');
         serverPlay3D(ShockLanceDryFireSound, %obj.getTransform());
         return;
      }

      %p = new (%data.projectileType)() {
         dataBlock        = "ParticleBeam";
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         damageFactor     = 2.56;
         sourceSlot       = %slot;
      };

      %obj.lastProjectile = %p;
      MissionCleanup.add(%p);
      serverPlay3D(PBWFireSound, %obj.getTransform());

      %t = new TargetProjectile()
      {
             dataBlock        = "PBWLaserProj";
             initialDirection = %obj.getMuzzleVector(%slot);
             initialPosition  = %obj.getMuzzlePoint(%slot);
             sourceObject     = %obj;
             sourceSlot       = %slot;
             vehicleObject    = 0;
      };
      MissionCleanup.add(%t);
      // AI hook
      if(%obj.client)
         %obj.client.projectile = %p;

       %obj.PBWFireTimeout = true;
       schedule(3000, 0, "deletePBWFireTimeout", %obj);

      %obj.setEnergyLevel(0);
      schedule(350, 0, "killit", %t);
   }
   else
   {
//      if(%obj.PBWFireTimeout == true)
//         return;

      %end = getLOSEnd(%obj, 500);

//      %los = getLOSInfo(%obj, 500);
//         if(%los)
//            %pos =
      %l = new Lightning(Lightning)
      {
         position = %end;//%obj.getWorldBoxCenter(); //%obj.getMuzzleVector(0);
        	rotation = %obj.getRotation();
        	scale = "1 1 1001";
       	dataBlock = "DefaultStorm";
       	lockCount = "0";
       	homingCount = "0";
       	strikesPerMinute = 240;
       	strikeWidth = "2.5";
       	chanceToHitTarget = 100;
       	strikeRadius = "20";
       	boltStartRadius = "20";
       	color = "1.000000 1.000000 1.000000 1.000000";
       	fadeColor = "0.100000 0.100000 1.000000 1.000000";
       	useFog = "0";
     	};
      %l.schedule(1000, delete);

//       %obj.PBWFireTimeout = true;
//       schedule(1000, 0, "deletePBWFireTimeout", %obj);
   }
}

datablock ShapeBaseImageData(PBWDecalAImage)
{
   shapeFile = "weapon_disc.dts";
   offset = "-0.175 0.275 0.35";
   rotation = "0 1 0 225";
   emap = true;
};

datablock ShapeBaseImageData(PBWDecalBImage)
{
   shapeFile = "weapon_disc.dts";
   offset = "-0.175 0.275 0.2";
   rotation = "0 1 0 -45";
   emap = true;
};

function PBWImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(PBWDecalAImage, 4);
   %obj.mountImage(PBWDecalBImage, 5);
}

function PBWImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
}
