if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//-------------------------------------------
// PWT (Pocket Rocket) - MrKeen
//------------------------------

datablock LinearFlareProjectileData(PocketRocket)
{
   projectileShapeName = "weapon_missile_projectile.dts";
   hasDamageRadius     = true;
   indirectDamage      = 0.121212;
   damageRadius        = 10;
   radiusDamageType    = $DamageType::PWT;
   kickBackStrength    = 200;
   explosion           = "ReaverExplosion";
   underwaterExplosion = "UnderwaterReaverExplosion";
   splash              = PlasmaSplash;

   dryVelocity       = 250;
   wetVelocity       = 150;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1500;
   lifetimeMS        = 1500;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1500;

   activateDelayMS = -1;

   baseEmitter         = MiniStreakEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;

   scale             = "2 2 2";
   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(PWTAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_missile.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some pocket rockets";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(PWT)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "turret_mortar_large.dts";
   image = PWTImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "an automatic pocket rocket";

   emap = true;
};

datablock ShapeBaseImageData(PocketRocketImage)
{
   shapeFile = "weapon_missile_projectile.dts";
   offset = "0 1 0.125";
};

datablock ShapeBaseImageData(PWTImage)
{
   className = WeaponImage;
   shapeFile = "weapon_shocklance.dts";
   item = PWT;
   ammo = PWTAmmo;
   offset = "0 0 0";
   emap = true;
//   rotation = "0 1 0 180";

   projectile = PocketRocket;
   projectileType = LinearFlareProjectile;
   projectileSpread = 5 / 1000;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateTimeoutValue[0]             = 0.5;
   stateSound[0]                    = MissileSwitchSound;
   stateSequence[0]                 = "Activate";

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateSequence[2]                 = "Deploy";
   stateScript[2]                   = "ready";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "Power";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.1;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3]                    = MiniMissileFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSequence[4]                 = "Spin";
//   stateSound[4]                    = MissileReloadSound;

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = MissileDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "ActivateReady";
};

function PWTImage::onFire(%this,%obj,%slot)
{
   Parent::onFire(%this, %obj, %slot);
   %obj.unmountImage(4);
}

function PWTImage::ready(%this,%obj,%slot)
{
   %obj.mountImage(PocketRocketImage, 4);
}

function PWTImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
}
