if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Rapid Fire Laser
//--------------------------------------------------------------------------

//--------------------------------------
// Projectile
//--------------------------------------

datablock SniperProjectileData(RFLShot)
{
   directDamage        = 0.0;
   hasDamageRadius     = false;
   indirectDamage      = 0.0;
   damageRadius        = 0.0;
   velInheritFactor    = 1.0;
   sound 				  = SniperRifleProjectileSound;
   explosion           = "SniperExplosion";
   splash              = SniperSplash;
   directDamageType    = $DamageType::Laser;

   maxRifleRange       = 225;
  rifleHeadMultiplier = 0.1;//0.0; --- x*1=x (ST)
   beamColor           = "1 0.1 0.1";
   fadeTime            = 0.25;

   startBeamWidth		  = 0.145;
   endBeamWidth 	     = 0.25;
   pulseBeamWidth 	  = 0.5;
   beamFlareAngle 	  = 3.0;
   minFlareSize        = 0.0;
   maxFlareSize        = 400.0;
   pulseSpeed          = 6.0;
   pulseLength         = 0.150;

   lightRadius         = 1.0;
   lightColor          = "0.3 0.0 0.0";

   textureName[0]      = "special/flare";
   textureName[1]      = "special/nonlingradient";
   textureName[2]      = "special/laserrip01";
   textureName[3]      = "special/laserrip02";
   textureName[4]      = "special/laserrip03";
   textureName[5]      = "special/laserrip04";
   textureName[6]      = "special/laserrip05";
   textureName[7]      = "special/laserrip06";
   textureName[8]      = "special/laserrip07";
   textureName[9]      = "special/laserrip08";
   textureName[10]     = "special/laserrip09";
   textureName[11]     = "special/sniper00";
};

function RFLShot::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
   if(%projectile.bkSourceObject)
      if(isObject(%projectile.bkSourceObject))
         %projectile.sourceObject = %projectile.bkSourceObject;

   if(%targetObject.isFF)
          %targetObject.deployBase.damage(%projectile.sourceObject, %position, %data.directDamage, %data.directDamageType);
   else
          %targetObject.damage(%projectile.sourceObject, %position, %projectile.damageFactor, %data.directDamageType);
}

//function RFLShot::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
//{
//   %targetObject.damage(%projectile.sourceObject, %position, %projectile.damageFactor, %data.directDamageType);
//}

datablock ItemData(RFLCapacitor)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_plasma.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some rapid fire capacitor charges";
   cantPickup = true;
};

datablock ItemData(RFL)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_missile.dts";
   image        = RFLImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a rapid fire laser (RFL)";
};

datablock ShapeBaseImageData(RFLImage)
{
   className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   offset = "0 0 0";
//   rotation = "1 0 0 90";
   item = RFL;
   ammo = RFLCapacitor;
   emap = true;

   usesEnergy = true;
   minEnergy = -1;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Deploy";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.01;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateTransitionOnTriggerDown[1]  = "Fire";

   stateName[2]                     = "Fire";
   stateFire[2]                     = true;
   stateScript[2]                   = "onFire";
   stateAllowImageChange[2]         = false;
   stateTransitionOnTriggerUp[2]    = "Deconstruction";

   stateName[3]                     = "Deconstruction";
   stateScript[3]                   = "onRelease";
   stateTimeoutValue[3]             = 0.01;
   stateTransitionOnTimeout[3]      = "Ready";
};

function RFLImage::onRelease(%data,%obj,%slot)
{
   %obj.RFLActive = false;

   if(!%obj.chargingRFL)
      ChargeRFL(%obj);
}

function ChargeRFL(%player)
{
//   echo(%player);
//   echo(%player.client);
//   echo(%player.player);

   %ammo = %player.getInventory(RFLCapacitor);
   %ammoMax = %player.getDatablock().max[RFLCapacitor];

   if(%ammo > -1)   // jury rig for now
   {
      if(%ammo < %ammoMax)
      {
         if(!%player.isEMP)
         {
            if(!%player.RFLActive)
               %player.incInventory(RFLCapacitor, getRandom(3, 1));

            %player.chargingRFL = true;
         }
         else
            %player.setInventory(RFLCapacitor, 0);

         if(%player.isSyn)
            schedule(100, %player, "ChargeRFL", %player);
         else
            schedule(200, %player, "ChargeRFL", %player);
      }
      else
         %player.chargingRFL = false;
   }
}

function getNextRFLFire(%obj)
{
   if(%obj.RFLFire == 0)
      return 4;
   else if(%obj.RFLFire == 4)
      return 5;
   else if(%obj.RFLFire == 5)
      return 6;
   else if(%obj.RFLFire == 6)
      return 4;
   else
      return 4;
}

function RFLFireTimeoutClear(%obj)
{
   %obj.fireTimeoutRFL = 0;
}

function RFLActiveFire(%player)
{
   if(!%player.RFLActive)
      return;

   if(%player.fireTimeoutRFL)
      return;

//   %data.lightStart = getSimTime();

   %player.fireTimeoutRFL = 250;
   %player.powerRFL = 0.125;
   %player.minChargeRFL = 13+getRandom(1, 4);

   schedule(%player.fireTimeoutRFL, 0, "RFLFireTimeoutClear", %player);

   if(%player.getInventory(RFLCapacitor) <= %player.minChargeRFL)
   {
      serverPlay3D(SniperRifleDryFireSound, %player.getTransform());
      %player.RFLFire = getNextRFLFire(%player);
      schedule(%player.fireTimeoutRFL, 0, "RFLActiveFire", %player);
      return;
   }

   %p = new SniperProjectile()
   {
      dataBlock        = RFLShot;
      initialDirection = %player.getMuzzleVector(%player.RFLFire);
      initialPosition  = %player.getMuzzlePoint(%player.RFLFire);
      sourceObject     = %player;
      damageFactor     = %player.powerRFL;
      sourceSlot       = %player.RFLFire;
   };

   %player.lastProjectile = %p;
   MissionCleanup.add(%player);
   %sound = getRandomB() ? SniperExpSound : SniperRifleFireSound;
   serverPlay3D(%sound, %player.getTransform());
   %p.setEnergyPercentage(1);

   %player.setImageTrigger(%player.RFLFire, true);
   %player.setImageTrigger(%player.RFLFire, false);
   %player.RFLFire = getNextRFLFire(%player);
   schedule(%player.fireTimeoutRFL, 0, "RFLActiveFire", %player);
   %player.decInventory(RFLCapacitor, %player.minChargeRFL);

   if(!%player.chargingRFL)
      ChargeRFL(%player);
}

function RFLImage::onFire(%data,%obj,%slot)
{
   if(!%obj.RFLActive || !%obj.RFLActive == true)
   {
      %obj.RFLActive = true;
      RFLActiveFire(%obj);
   }
}

datablock ShapeBaseImageData(RFLGun1Image)
{
   className = WeaponImage;
   shapeFile = "weapon_grenade_launcher.dts";
   emap = true;
   item = RFL;

   rotation = "0 1 0 180";

   usesEnergy = true;
   minEnergy = -1;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.1;
   stateSequence[1]                 = "Activation";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "ambient";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.25;
   stateFire[3]                     = true;
   stateSequence[3]                 = "Fire";

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
//   stateAllowImageChange[4]         = false;
//   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 0.01;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(RFLGun2Image)
{
   className = WeaponImage;
   shapeFile = "weapon_grenade_launcher.dts";
   emap = true;
   item = RFL;

   rotation = "0 1 0 60";

   usesEnergy = true;
   minEnergy = -1;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.1;
   stateSequence[1]                 = "Activation";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "ambient";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.25;
   stateFire[3]                     = true;
   stateSequence[3]                 = "Fire";

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
//   stateAllowImageChange[4]         = false;
//   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 0.01;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(RFLGun3Image)
{
   className = WeaponImage;
   shapeFile = "weapon_grenade_launcher.dts";
   emap = true;
   item = RFL;

   rotation = "0 1 0 -60";

   usesEnergy = true;
   minEnergy = -1;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.1;
   stateSequence[1]                 = "Activation";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "ambient";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.25;
   stateFire[3]                     = true;
   stateSequence[3]                 = "Fire";

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
//   stateAllowImageChange[4]         = false;
//   stateSequence[4]                 = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateTimeoutValue[6]             = 0.01;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

function RFLImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);

   %obj.mountImage(RFLGun1Image, 4);
   %obj.mountImage(RFLGun2Image, 5);
   %obj.mountImage(RFLGun3Image, 6);
}

function RFLImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}
