 if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------
// Reaver   -Nite- new proxy search added.Looks for Projectiles ,namely a flare.If found it sets off the reaver charge..
//--------------------------------------

//--------------------------------------------------------------------------
// Sounds
//-------------------------------------

datablock AudioProfile(MiniMissileFireSound)
{
   filename    = "fx/vehicles/crash_ground_vehicle.WAV";
   description = AudioDefault3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearProjectileData(ReaverRocket)
{
   scale = "2.0 2.0 2.0";
   doDynamicClientHits = true;
   projectileShapeName = "grenade_projectile.dts";
   emitterDelay        = 250;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.1;
   damageRadius        = 8;
   radiusDamageType    = $DamageType::Flak;
   kickBackStrength    = 100;
   bubbleEmitTime      = 1.0;

   explosion           = "ReaverExplosion";
   underwaterExplosion = "UnderwaterReaverExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;

   baseEmitter         = MiniStreakEmitter;
//   delayEmitter        = MissileFireEmitter;
   puffEmitter         = MissilePuffEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   dryVelocity       = 125;
   wetVelocity       = 75;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 1500; //1000
   lifetimeMS        = 1500; //1000
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1000;

   activateDelayMS = -1;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.5 0.5 0.5";
};

datablock LinearFlareProjectileData(ReaverCharge)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.1;
   damageRadius        = 12.5; // 9.5
   radiusDamageType    = $DamageType::Flak;
   kickBackStrength    = 100;

   explosion           = "ReaverExplosion";
   underwaterExplosion = "UnderwaterReaverExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

datablock DebrisData(ReaverShellDebris)
{
   shapeName = "weapon_missile_projectile.dts";

   lifetime = 5.0;

   minSpinSpeed = 300.0;
   maxSpinSpeed = 400.0;

   elasticity = 0.5;
   friction = 0.2;

   numBounces = 3;

   fade = true;
   staticOnMaxBounce = true;
   snapOnMaxBounce = true;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(ReaverAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_disc.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some reaver flak shots";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(Reaver)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = ReaverImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a reaver flak cannon";
   emap = true;
};

datablock ShapeBaseImageData(ReaverImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   offset = "0 0 0";
   rotation = "0 0 1 0";
   item      = Reaver;
   ammo      = ReaverAmmo;
   emap = true;
//   usesEnergy = true;
//   minEnergy = 10;

   casing              = ReaverShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 3.0;

   projectileType = LinearProjectile;
   projectile = ReaverRocket;

   projectileSpread = 1.75 / 1000;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0]         = "Activate";
   stateSound[0]            = ChaingunSwitchSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateSpinThread[2] = Stop;
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.1;
   stateFire[3] = true;
   stateSequence[3]            = "fire";
   stateSound[3]            = MiniMissileFireSound;
//   stateRecoil[3]           = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3]           = "onFire";
   stateFire[3]             = true;
   stateEjectShell[3]       = true;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateSequence[4]            = "recoil";
   stateAllowImageChange[4] = false;
   stateTimeoutValue[4] = 0.1;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateSpinThread[5] = Stop;
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6] = "DryFire";
   stateTimeoutValue[6] = 0.3;
   stateSound[6] = BlasterDryFireSound;
   stateSpinThread[6] = Stop;
   stateTransitionOnTimeout[6] = "Ready";
};

datablock ShapeBaseImageData(Reaver2Image) : ReaverImage
{
   shapeFile = "weapon_plasma.dts";
   offset = "0.075 0 0.025";
   rotation = "0 1 0 180";
   stateScript[3] = "onFire";
   emap = true;
};

datablock ShapeBaseImageData(Reaver3Image) : ReaverImage
{
   shapeFile = "weapon_plasma.dts";
   offset = "0.075 0 0.025";
   rotation = "0 1 0 60";
   stateScript[3] = "onFire";
   emap = true;
};

datablock ShapeBaseImageData(Reaver4Image) : ReaverImage
{
   shapeFile = "weapon_plasma.dts";
   offset = "0.075 0 0.025";
   rotation = "0 1 0 -60";
   stateScript[3] = "onFire";
   emap = true;
};

function rProxyTrigger(%obj)
{
   if(isObject(%obj))
   {
      %p = new LinearFlareProjectile()
      {
            dataBlock        = ReaverCharge;
            initialDirection = "0 0 0";
            initialPosition  = %obj.getPosition();
            sourceObject     = %obj.sourceObject;
            sourceSlot       = 0;
      };
      MissionCleanup.add(%p);

      %obj.delete();
   }
}
//-Nite- New Proxy search..Find us a Flare!
function rBeginFlare(%obj)
{
   if(isObject(%obj))
   {
      %obj.proxyThread = true;
      InitContainerRadiusSearch(%obj.getPosition(), 10, $TypeMasks::ProjectileObjectType);  // lets look for projectiles shall we -Nite-
      while((%int = ContainerSearchNext()) != 0)
      {   //-Nite-
        //is it a flare? if so blow up already.
             if(%int.getdatablock().getname() $= "FlareGrenadeProj")
               rProxyTrigger(%obj);
      }

      schedule(100, %obj, "rBeginFlare", %obj);
   }
}
function rBeginProxy(%obj)
{
   if(isObject(%obj))
   {
      %obj.proxyThread = true;
      InitContainerRadiusSearch(%obj.getPosition(), 4, $TypeMasks::VehicleObjectType | $TypeMasks::PlayerObjectType );   //%obj.getPosition(), 7, -Nite-  reduced search area
      while((%int = ContainerSearchNext()) != 0)
      {
        if((%int.team || %int.client.team) != %obj.sourceObject.team) //
           if(%int.getHeat() > 0.35) //-Nite- 0.25 increased heat needed for proxy to go off
               rProxyTrigger(%obj); //-Nite- Damn i hate this gun! but its got cool code in it!
      }

      schedule(100, %obj, "rBeginProxy", %obj);
   }
}

function rBeginSeeker(%obj, %target, %createTime, %endTime)
{
   if(isObject(%obj))
   {
      if(%obj.lockedMissileThread)
      {
         if(!isObject(%target))
         {
            rProxyTrigger(%p);
            return;
         }

         %FFRObject = new StaticShape()
         {
            dataBlock        = mReflector;
         };
         MissionCleanup.add(%FFRObject);
         %FFRObject.setPosition(%obj.getPosition());
         %FFRObject.schedule(32, delete);
         %dir = getVectorFromObjects(%obj, %target);
   //      echo(%dir SPC %obj.sr_initDir SPC vectorCompare(%dir, %obj.sr_initDir));

//         %p = new EnergyProjectile()
//         %p = new LinearProjectile()
         %p = new LinearFlareProjectile()
//         %p = new GrenadeProjectile()
         {
//               dataBlock        = EnergyBolt;
//               dataBlock        = DiscProjectile;
   //            dataBlock        = ReaverRocket;
               dataBlock        = MitziBlast;
//               dataBlock        = ImpactMortar;
               initialDirection = %dir;
               initialPosition  = %obj.position;
               sourceObject     = %FFRObject;
               sourceSlot       = 0;
         };
         MissionCleanup.add(%p);
         %p.lockedMissileThread = true;
         %p.bkSourceObject = %obj.bkSourceObject;
         %p.sr_initDir = %obj.sr_initDir;

         if(getObjectDistance(%obj, %target) >= 0.5)
            %hasDist = true;

         if(!%hasDist)
            %endTime = getSimTime();

         if(%hasDist && getSimTime() < (%createTime+%endtime))
            schedule(100, %p, "rBeginSeeker", %p, %target, %createTime, %endTime);

         %obj.delete();
      }
   }
}

function rBeginDetectLoop(%obj)
{
   if(isObject(%obj))
   {
      if(%obj.r_detectLoop)
      {
         %target = getLOSInfo(%obj, 350); // scan for enemies
         if(%target) // target?
         {
            if(%target.client) // player?
//            if(true) // temp
            {
               if(%target.client.team != %obj.client.team) // enemy?
//               if(true) // temp
               {
                  %obj.r_lockedTarget = %target;

                  if(%target == %obj.r_lockedTarget) // same person?
                  {
//                     echo("target found! "@%target SPC %target.client SPC %target.getClassName());

                     if(%obj.r_lockedTarget) // make sure it != 0
                     {
                        if(%obj.r_targetLockCount < 1) // red for 1 count
                        {
                           activateDeploySensorRed(%obj); // lock warning
                           %obj.r_missileLockTarget = 0;
                        }
                        else if(%obj.r_targetLockCount >= 1) // green for >= 1
                        {
                           activateDeploySensorGrn(%obj); // fire ready
                           %obj.r_missileLockTarget = %target;
                        }

                        %obj.r_targetLockCount++; //inc the count
                     }
                     else
                     {
                        deactivateDeploySensor(%obj);
                        %obj.r_missileLockTarget = 0; // make sure we dont have instant lock on someone else
                        %obj.r_lockedTarget = %target; // set new target
                        %obj.r_targetLockCount = 0; // reset the lock count
                     }
                  }
                  else
                  {
                     deactivateDeploySensor(%obj);
                     %obj.r_missileLockTarget = 0; // make sure we dont have instant lock on someone else
                     %obj.r_lockedTarget = %target; // set new target
                     %obj.r_targetLockCount = 0; // reset the lock count
                  }
               }
               else
               {
                  deactivateDeploySensor(%obj);
                  %obj.r_missileLockTarget = 0; // make sure we dont have instant lock on someone else
                  %obj.r_lockedTarget = %target; // set new target
                  %obj.r_targetLockCount = 0; // reset the lock count
               }
            }
            else
            {
               deactivateDeploySensor(%obj); // turn off the light
               %obj.r_lockedTarget = 0; // set new target
               %obj.r_missileLockTarget = 0; // make sure we dont have instant lock on someone else
               %obj.r_targetLockCount = 0; // reset the lock count
            }
         }
         else
         {
            deactivateDeploySensor(%obj); // turn off the light
            %obj.r_lockedTarget = 0; // set new target
            %obj.r_missileLockTarget = 0; // make sure we dont have instant lock on someone else
            %obj.r_targetLockCount = 0; // reset the lock count
         }

         schedule(333, %obj, "rBeginDetectLoop", %obj);
      }
   }
}

function ReaverFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

//   if( %obj.station $= "" && %obj.isCloaked() )
//   {
//      if( %obj.respawnCloakThread !$= "" )
//      {
//         Cancel(%obj.respawnCloakThread);
//         %obj.setCloaked( false );
//         %obj.respawnCloakThread = "";
//      }
//      else
//      {
//         if( %obj.getEnergyLevel() > 20 )
//         {
//            %obj.setCloaked( false );
//            %obj.reCloak = %obj.schedule( 500, "setCloaked", true );
//         }
//      }
//   }

   %vehicle = 0;

     %p = new LinearProjectile()
     {
         dataBlock        = "ReaverRocket";
         initialDirection = %obj.getMuzzleVector(%obj.nextWeaponFire);
         initialPosition  = %obj.getMuzzlePoint(%obj.nextWeaponFire);
         sourceObject     = %obj;
         sourceSlot       = %obj.nextWeaponFire;
         vehicleObject    = %vehicle;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);
   %p.bkSourceObject = %obj;
   %p.sr_initDir = %obj.getMuzzleVector(%obj.nextWeaponFire);
   %p.lockedMissileThread = true;

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

      %obj.decInventory(%data.ammo,1);
//   %obj.useEnergy(7);

//   if(%obj.r_missileLockTarget)
//      rBeginSeeker(%p, %obj.r_missileLockTarget, getSimTime(), 10000);
//   else
//      rBeginSeeker(%p, %obj, getSimTime(), 1000);

   rBeginFlare(%p); //-Nite- blow up if a flare is in the way!
   rBeginProxy(%p);
}

function ReaverImage::onFire(%data, %obj, %slot)
{
   if(getSightInfo(%obj, 1, $TypeMasks::ForceFieldObjectType))
      return;

   if(!%obj.nextWeaponFire || %obj.nextWeaponFire >= 6)
      %obj.nextWeaponFire = 0;

   ReaverFire(%data, %obj, %slot);

   if(%obj.nextWeaponFire == 0)
      %obj.nextWeaponFire = 4;
   else if(%obj.nextWeaponFire == 4)
      %obj.nextWeaponFire = 5;
   else if(%obj.nextWeaponFire == 5)
      %obj.nextWeaponFire = 6;
   else if(%obj.nextWeaponFire == 6)
      %obj.nextWeaponFire = 0;
   else
      %obj.nextWeaponFire = 0;
}

function Reaver2Image::onFire(%data, %obj, %slot)
{
   ReaverFire(%data, %obj, %slot);

   %obj.setImageTrigger(%obj.nextWeaponFire, false);
   %obj.nextWeaponFire = 5;
}

function Reaver3Image::onFire(%data, %obj, %slot)
{
   ReaverFire(%data, %obj, %slot);

   %obj.setImageTrigger(%obj.nextWeaponFire, false);
   %obj.nextWeaponFire = 6;
}

function Reaver4Image::onFire(%data, %obj, %slot)
{
   ReaverFire(%data, %obj, %slot);

   %obj.setImageTrigger(%obj.nextWeaponFire, false);
   %obj.nextWeaponFire = 0;
}

function ReaverImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
   %obj.setArmThread(look);
//   %obj.r_detectLoop = true;
//   %obj.r_missileLockTarget = 0;
//   %obj.r_lockedTarget = 0;

//   rBeginDetectLoop(%obj);
   %obj.mountImage(Reaver2Image, 4);
   %obj.mountImage(Reaver3Image, 5);
   %obj.mountImage(Reaver4Image, 6);
}

function ReaverImage::onUnmount(%this,%obj,%slot)
{
   %obj.setImageTrigger(%slot, false);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
//   deactivateDeploySensor(%obj); // turn off the light
//   %obj.r_detectLoop = false;
//   %obj.r_missileLockTarget = 0;
//   %obj.r_lockedTarget = 0;
}
