//--------------------------------------
// Ripper v1.9 (modified by MrKeen - not 100% complete) - still a few bugs to fix and ammo issues. This was seriously a 5 minute job. Should be easy to fix.
// There's 2 different looks to this, just change $RipperSpecial to true. #2 looks like it could be too good for a charging disc (maybe another weapon).
//--------------------------------------

//--------------------------------------------------------------------------
// Sounds
//--------------------------------------
datablock AudioProfile(RipperChargeSound)
{
   filename    = "fx/misc/nexus_idle.wav";
   description = ClosestLooping3d;
   effect = DiscIdleEffect;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearProjectileData(RipperDisc)
{
   projectileShapeName = "disc.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.1;
   damageRadius        = 0.5;
   radiusDamageType    = $DamageType::Disc;
   kickBackStrength    = 1750;

   sound 				= discProjectileSound;
   explosion           = "DiscExplosion";
   underwaterExplosion = "UnderwaterDiscExplosion";
   splash              = DiscSplash;

   dryVelocity       = 50;
   wetVelocity       = 50;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 3000;
   lifetimeMS        = 3000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   activateDelayMS = 200;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.175 0.175 0.5";
};

function RipperDisc::onExplode(%data, %proj, %pos, %mod)
{
   if(%proj.bkSourceObject)
      if(isObject(%proj.bkSourceObject))
         %proj.sourceObject = %proj.bkSourceObject;

   if (%data.hasDamageRadius) 
      RipperRadiusExplosion(%proj, %pos, %data.damageRadius, %data.indirectDamage, %data.kickBackStrength, %proj.sourceObject, %data.radiusDamageType);
}

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(RipperAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_disc.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some ripper discs";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(Ripper)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_disc.dts";
   image = RipperImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a ripper";
   emap = true;
};

datablock ShapeBaseImageData(RipperImage)
{
   className = WeaponImage;
   shapeFile = "weapon_disc.dts";
   item = Ripper;
   ammo = RipperAmmo;
   offset = "0 0 0";
   emap = true;

//   offset = "0 0.2 -0.3";
   emap = true;
   usesEnergy = true;
   minEnergy = -1;

   stateName[0]                     = "Activate";
   stateSequence[0]                 = "Activated";
	stateSound[0]                    = TargetingLaserSwitchSound;
   stateTimeoutValue[0]             = 0.5;
   stateTransitionOnTimeout[0]      = "Ready";

   stateName[1]                     = "Ready";
   stateSound[1]                    = DiscLoopSound;
   stateSequence[1]                 = "DiscSpin";
   stateTransitionOnTriggerDown[1]  = "Fire";

   stateName[2]                     = "Fire";
   stateFire[2]                     = true;
   stateAllowImageChange[2]         = false;
	stateSound[2]                    = RipperChargeSound;
   stateScript[2]                   = "onFire";
   stateSequence[2]                 = "DiscSpin";
   stateTransitionOnTriggerUp[2]    = "Deconstruction";

   stateName[3]                     = "Deconstruction";
   stateScript[3]                   = "onRelease";
   stateSequence[3]                 = "Fire";
   stateTimeoutValue[3]             = 1.125;
   stateTransitionOnTimeout[3]      = "Ready";
};

datablock ShapeBaseImageData(RipperDecalAImage)
{
   shapeFile = "weapon_elf.dts";
   offset = "0.025 -0.25 0.225";
   rotation = "0 1 0 180";
};

//datablock ShapeBaseImageData(RipperDecalBImage)
//{
//   shapeFile = "ammo_mortar.dts";
//   offset = "0.0 0.4 0.0";
//   rotation = "0 0 1 90";
//};

//datablock ShapeBaseImageData(RipperDecalCImage)
//{
//   shapeFile = "ammo_mortar.dts";
//   offset = "-0.3 0.4 0.0";
//   rotation = "0 0 1 90";
//};

datablock ShapeBaseImageData(RipperDecalB2Image)
{
   shapeFile = "ammo_mortar.dts";
   offset = "0.05 0.35 0.1";
   rotation = "0 0 1 90";
};

datablock ShapeBaseImageData(RipperDecalC2Image)
{
   shapeFile = "ammo_mortar.dts";
   offset = "-0.35 0.35 0.1";
   rotation = "0 0 1 90";
};

function RipperImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);

   %obj.mountImage(RipperDecalAImage, 4);
   %obj.mountImage(RipperDecalB2Image, 5);
   %obj.mountImage(RipperDecalC2Image, 6);

   %obj.rip_RipOnHand = %obj.getMountedImage(0);
}

function RipperImage::onUnmount(%this,%obj,%slot)
{
   %obj.setImageTrigger(%slot, false);

   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);

   %obj.setInventory(RipperAmmo, 0);
   %obj.RipperCharge = 0;
}

function RipperFire(%data, %player, %charge, %Rip, %isCL)
{
   %data.lightStart = getSimTime();

   if(!%player.getMountedImage(0) == %isCL)
        return false;

   %projectile = "RipperDisc";

   %player.fLastVel = %player.getVelocity();
   %player.fLastPos = %player.getPosition();
   %nVec = %player.getMuzzleVector(%Rip);
   %vel = vectorScale(%nVec, %charge*4);
   %player.setVelocity(%vel);

   %p = new LinearProjectile()
   {
          dataBlock        = %projectile;
          initialDirection = vectorNormalize(%player.getVelocity()); //%player.getMuzzleVector(%Rip);
          initialPosition  = %player.getMuzzlePoint(%Rip);
          sourceObject     = %player;
          sourceSlot       = %Rip;
          vehicleObject    = 0;
   };

     %player.lastProjectile = %p;
     MissionCleanup.add(%p);

     %player.setInventory(%data.ammo, 0);     // start from scratch
     %player.RipperCharge = 0;

     %player.setVelocity(%player.fLastVel);
     %player.setPosition(%player.fLastPos);

   // AI hook
   if(%player.client)
      %player.client.projectile = %p;

   serverPlay3D(MechDiscFireSound, %player.getTransform());
}

function OLExplode(%obj, %pos)
{
   if(isObject(%obj))
   {
      %p = new LinearFlareProjectile()
      {
            dataBlock        = ReaverCharge;
            initialDirection = "0 0 0";
            initialPosition  = %pos;
            sourceObject     = %obj;
            sourceSlot       = 0;
      };
      MissionCleanup.add(%p);
   }
}

function RipperCharge(%data, %player, %Rip)       // should work....
{
     if(!isObject(%player))
          return;

     %ammo = %player.getInventory(%data.ammo);
     %ammoMax = %player.getArmorSize() $= "Light" ? 50 : 100; //50 for light, 100 for everyone else
     %RipOnHand = %player.rip_RipOnHand;

     if(%player.Rip)
     {
          if(%player.getMountedImage(0) == %RipOnHand)
          {
            if(!%player.isEMP)
            {
               if(%ammo++ > %ammoMax)
                  %player.overchargeCount[Ripper]++;   // overcharge check

               %player.RipperCharge = %player.RipperCharge >= %ammoMax ? %ammoMax : %player.RipperCharge++;
               %player.setInventory(RipperAmmo, %player.RipperCharge, true);

               if(%player.overchargeCount[Ripper] >= 150) // uh oh 15 seconds
               {
                  %player.setInventory(RipperAmmo, 0);
                  %player.RipperCharge = 0;

                  switch(getRandom(3))
                  {
                     case 0:
                        bottomPrint(%player.client, "ERROR: Ripper power source overload!", 3, 1);
                        return;

                     case 1:
                        %player.EMPObject();
                        bottomPrint(%player.client, "ERROR: Ripper power source overloaded!", 3, 1);
                        return;

                     case 2:
                        %player.BurnObject(%player);
                        bottomPrint(%player.client, "ERROR: Ripper power source overloaded!", 3, 1);
                        return;

                     case 3:
                        %player.setInventory(Ripper, 0);
                        OLExplode(%player, %player.getMuzzlePoint(0));
                        bottomPrint(%player.client, "ERROR: Ripper power source MAJOR overload!", 3, 1);
                        return;

                     default:
                        bottomPrint(%player.client, "ERROR: Ripper power source overload!", 3, 1);
                        return;
                  }
               }
            }
            else
               %player.setInventory(RipperAmmo, 0);

             schedule(100, 0, "RipperCharge", %data, %player, %Rip);
          }
     }
     else
     {
          if(%player.getMountedImage(0) == %RipOnHand)
          {
               RipperFire(%data, %player, %ammo, %Rip, %RipOnHand);
               return;
          }
     }
}

function RipperImage::onFire(%data,%obj,%slot) // Uses CL(tm) code
{
   if(getSightInfo(%obj, 1, $TypeMasks::ForceFieldObjectType))
      return;

     if(!%obj.Rip || !%obj.Rip == true)
     {
          %obj.Rip = true;
          %obj.incInventory(RipperAmmo, 1);

          schedule(100, 0, "RipperCharge", %data, %obj, %slot);
     }
}

function RipperImage::onRelease(%data,%obj,%slot)
{
     %obj.Rip = false;
     %obj.overchargeCount[Ripper] = 0; // reset the count
}
