if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// Shotgun
//--------------------------------------------------------------------------

datablock TracerProjectileData(ShotgunBullet)
{
   doDynamicClientHits = true;

   directDamage        = 0.069;
   directDamageType    = $DamageType::Shotgun;
   explosion           = "ChaingunExplosion";
   splash              = ChaingunSplash;

   kickBackStrength  = 0.0;
   sound 				= ChaingunProjectile;

   dryVelocity       = 500.0;
   wetVelocity       = 300.5;
   velInheritFactor  = 1.0; //0.0 - MrKeen
   fizzleTimeMS      = 500; //3000
   lifetimeMS        = 500;  //3000
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 750;

   tracerLength    = 15.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = 211.0/255.0 @ " " @ 215.0/255.0 @ " " @ 120.0/255.0 @ " 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.10;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;
};

function ShotgunBullet::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal)
{
   if(detectIsWet(%position))
      serverPlay3d("ChaingunWaterImpact", %position);
   else
      serverPlay3d("ChaingunImpact", %position);

   Parent::onCollision(%data, %projectile, %targetObject, %modifier, %position, %normal);
}

datablock ExplosionData(xShotgunExplosion)
{
   explosionShape = "effect_plasma_explosion.dts";
//   soundProfile   = plasmaExpSound;
   faceViewer = true;
   playSpeed = 0.5;

   sizes[0] = "0.5 0.5 0.5";
   sizes[1] = "0.5 0.5 0.5";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock LinearFlareProjectileData(xShotgunCharge)
{
   projectileShapeName = "turret_muzzlePoint.dts";
   faceViewer          = false;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.1;
   damageRadius        = 3;
   radiusDamageType    = $DamageType::Flak;
   kickBackStrength    = 100;

   explosion           = "xShotgunExplosion";
   underwaterExplosion = "UnderwaterReaverExplosion";

   splash              = MissileSplash;
   velInheritFactor    = 0;

   dryVelocity       = 0.1;
   wetVelocity       = 0.1;
   fizzleTimeMS      = 35;
   lifetimeMS        = 35;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 90;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 35;

   activateDelayMS = -1;

   numFlares         = 0;
   flareColor        = "0 0 0";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";
};

function xShotSpawnExplosion(%obj) // MrKeen
{
//   trace(1);
   %src = %obj.sourceObject;
   %pos = %obj.getPosition();

   %FFRObject = new StaticShape()
   {
      dataBlock = mReflector;
   };
   MissionCleanup.add(%FFRObject);
   %FFRObject.setPosition(%pos);
   %FFRObject.schedule(32, delete);

   %p = new LinearFlareProjectile()
   {
      dataBlock        = ReaverCharge; //xShotgunCharge;
      initialDirection = %obj.initialDirection;
      initialPosition  = %pos;
      sourceObject     = %FFRObject;
      sourceSlot       = 0;
      vehicleObject    = 0;
      bkSourceObject   = %src;
   };

   MissionCleanup.add(%p);

   switch(getRandom(2))
   {
      case 0:
      %p.play3D(SolPisFireSound);

      case 1:
      %p.play3D(ReaverExplosionSound);

      case 2:
      %p.play3D(PlasmaExpSound);
   }

   %obj.delete();
//   trace(0);
}

datablock TracerProjectileData(xShotgunBullet)
{
   doDynamicClientHits = true;

   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.075*1.125;
   damageRadius        = 3.0; 
   radiusDamageType    = $DamageType::Flak;

   explosion           = "xShotgunExplosion";
   underwaterExplosion = "UnderwaterReaverExplosion";
   splash              = ChaingunSplash;

   kickBackStrength  = 0.0;
   sound 				= ChaingunProjectile;

   dryVelocity       = 420.0;
   wetVelocity       = 300.0;
   velInheritFactor  = 1.0; //0.0 - MrKeen
   fizzleTimeMS      = 250; //3000
   lifetimeMS        = 250;  //3000
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 250;

   tracerLength    = 15.0;
   tracerAlpha     = false;
   tracerMinPixels = 6;
   tracerColor     = 211.0/255.0 @ " " @ 215.0/255.0 @ " " @ 120.0/255.0 @ " 0.75";
	tracerTex[0]  	 = "special/tracer00";
	tracerTex[1]  	 = "special/tracercross";
	tracerWidth     = 0.10;
   crossSize       = 0.20;
   crossViewAng    = 0.990;
   renderCross     = true;

   decalData[0] = ChaingunDecal1;
   decalData[1] = ChaingunDecal2;
   decalData[2] = ChaingunDecal3;
   decalData[3] = ChaingunDecal4;
   decalData[4] = ChaingunDecal5;
   decalData[5] = ChaingunDecal6;
};


function xShotgunBullet::onExplode(%data, %proj, %pos, %mod)
{
   switch(getRandom(2))
   {
      case 0:
      %proj.play3D(SolPisFireSound);

      case 1:
      %proj.play3D(ReaverExplosionSound);

      case 2:
      %proj.play3D(PlasmaExpSound);
   }

   Parent::onExplode(%data, %proj, %pos, %mod);
}

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(ShotgunAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_chaingun.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some shotgun shells";
};

//--------------------------------------
// Rifle and item...
//--------------------------------------

datablock ItemData(Shotgun)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_sniper.dts";
   image        = ShotgunImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
	pickUpName = "a shotgun";
};

datablock ShapeBaseImageData(ShotgunImage)
{
	className = WeaponImage;
   shapeFile = "turret_muzzlepoint.dts";
   item = Shotgun;
   ammo = ShotgunAmmo;
  // projectile = ShotgunBullet;
   //projectileType = TracerProjectile;

   offset = "0 1.05 0";

    casing              = ShellDebris;
   shellExitDir        = "1.0 0.3 1.0";
   shellExitOffset     = "0.15 -0.56 -0.1";
   shellExitVariance   = 15.0;
   shellVelocity       = 3.0;

  // projectileSpread = 16.0 / 1000.0;

   stateName[0]                     = "Activate";
   stateTransitionOnTimeout[0]      = "ActivateReady";
   stateSound[0]                    = SniperRifleSwitchSound;
   stateTimeoutValue[0]             = 0.5;

   stateName[1]                     = "ActivateReady";
   stateTransitionOnLoaded[1]       = "Ready";
   stateTransitionOnNoAmmo[1]       = "NoAmmo";

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 0.5;
   stateFire[3]                     = true;
   stateAllowImageChange[3]         = false;
   stateScript[3]                   = "onFire";
//   stateSound[3]                    = MortarFireSound;
   stateEjectShell[3]               = true;
   stateRecoil[3]                   = LightRecoil;

   stateName[4]                     = "Reload";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 1.0;
   stateAllowImageChange[4]         = false;
   stateEmitter[4]       = "ChaingunFireSmoke";
   stateEmitterTime[4]       = 0.25;
   stateEmitterNode[4]       = 0;
   stateSound[4]                    = GrenadeSwitchSound;

   stateName[6]                     = "NoAmmo";
   stateTransitionOnAmmo[6]         = "Reload";
   stateTransitionOnTriggerDown[6]  = "DryFire";

   stateName[7]                     = "DryFire";
   stateSound[7]                    = SniperRifleDryFireSound;
   stateTimeoutValue[7]             = 0.5;
   stateTransitionOnTimeout[7]      = "Ready";
};
//-nite- made this because it seems to fire smoother *shrugs
function ShotgunImage::onFire(%data, %obj, %slot) // MrKeen - modified for firewall mode
{
   %weapon = %obj.getMountedImage(0).item;

   if(%obj.client.mode[%weapon] == 0)
   {
      %projectile = "ShotgunBullet";
      %loop = 12;
      %spread = 16;
      %special = false;
   }
   else
   {
      %projectile = "xShotgunBullet";
      %loop = 24;
      %spread = 28;
      %special = true;
   }

   if(%obj.getInventory(%data.ammo) >= %loop)
   {
      %count = %loop / 4;
      sgFireBurst(%data, %obj, %slot, %projectile, %vector, %spread, %count, %idx);
   }
   else
      %obj.play3d(SniperRifleDryFireSound);
}

function sgFireBurst(%data, %obj, %slot, %projectile, %vector, %spread, %loop, %idx)
{
   if(%idx < %loop)
   {
      for(%i = 0; %i < %loop; %i++)
      {
         %vector = calcSpreadVector(%obj.getMuzzleVector(%slot), %spread);  // was 9 -nite- MrKeen - 14
         %p = new TracerProjectile()
         {
            dataBlock        = %projectile;
            initialDirection = %vector;
            initialPosition  = %obj.getMuzzlePoint(%slot);
            sourceObject     = %obj;
            sourceSlot       = %slot;
            vehicleObject    = %vehicle;
         };
         MissionCleanup.add(%p);

//         if(%special)
//            %p.collisionCourse = schedule(getRandom(300, 200), 0, "xShotSpawnExplosion", %p); // MrKeen - random field of explosive; firewall
      }
      %obj.lastProjectile = %p;

      // AI hook
      if(%obj.client)
         %obj.client.projectile = %p;

      %obj.decInventory(%data.ammo, %loop);

//      %loopTime = %loop == 3 ? 200 : 150;
      %idx++;
      %obj.play3d(MortarFireSound);
      schedule(200, 0, sgFireBurst, %data, %obj, %slot, %projectile, %vector, %spread, %loop, %idx);
   }
}

datablock ShapeBaseImageData(SGDecalAImage)
{
   shapeFile = "weapon_grenade_launcher.dts";
   offset = "0.2 0 0";
   rotation = "0 1 0 90";
   emap = true;
};

datablock ShapeBaseImageData(SGDecalBImage)
{
   shapeFile = "weapon_grenade_launcher.dts";
   offset = "-0.2 0 0";
  rotation = "0 1 0 -90";
   emap = true;
};

datablock ShapeBaseImageData(SGDecalCImage)
{
   shapeFile = "weapon_energy.dts";
   offset = "0 0 -0.1";
//  rotation = "0 1 0 -90";
   emap = true;
};

function ShotgunImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(SGDecalAImage, 4);
   %obj.mountImage(SGDecalBImage, 5);
   %obj.mountImage(SGDecalCImage, 6);
}

function ShotgunImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}

