if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//----------------------------------------------
// Cluster Bomb Cannon
// Originally a mode in devastator...
// needed to control it more, so, new weapon ^_^
//----------------------------------------------

// Projectile
datablock LinearProjectileData(DevastatorShocker)
{
   emitterDelay        = -1;
   projectileShapeName = "Bomb.dts";
   scale               = "4 4 4";
   directDamage        = 0.00;
   indirectDamage      = 0.01;
   damageRadius        = 20.0;
   hasDamageRadius     = true;
   kickBackStrength    = 2500.0;
   directDamageType    = $DamageType::Default;
   radiusDamageType    = $DamageType::Default;
   bubbleEmitTime      = 1.0;

   explosion           = "ImpactExplosion";
   splash              = MortarSplash;
   velInheritFactor    = 0.5;
   underwaterExplosion = "ImpactExplosion";

   baseEmitter = DevastatorVortexSmokeEmitter;

   dryVelocity       = 95;
   wetVelocity       = 95;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 4000;
   lifetimeMS        = 4000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   sound        = DevastatorProjectileSound;
   fireSound    = DevastatorFireSound;

   hasLight    = true;
   lightRadius = 10.0;
   lightColor  = "1 1 1";
   expProj     = "ShockerBomb";
   ShockerBombCount = 20;
};

//========================================================================
// Shocker Bomb projectile
//========================================================================
datablock LinearProjectileData(ShockerBomb)
{
   projectileShapeName = "Energy_bolt.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   radiusDamage        = 0.0;
   damageRadius        = 0.5;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 1750*1.5;

   explosion           = "ImpactExplosion";
   underwaterExplosion = "ImpactExplosion";
   shockwave           = DevastatorAfroWave2;
   velInheritFactor    = 0.5;
   splash              = MortarSplash;

//   baseEmitter         = ShockTrailEmitter;
//   bubbleEmitter       = ShockTrailEmitter;

   dryVelocity       = 95;
   wetVelocity       = 95;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 500;
   lifetimeMS        = 500;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 300;

//   sound			 = MortarProjectileSound;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "1 0 0 1";

   hasLightUnderwaterColor = true;
   underWaterLightColor = "0.05 0.075 0.2";
   expProj     = "ImpactShot";
   ImpactShotCount = 5;

};

//------------------------------------------------
// Part 2  same as above
//------------------------------------------------
datablock LinearProjectileData(ShockerBomb2)
{
   projectileShapeName = "energy_bolt.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   radiusDamage        = 0.5;
   damageRadius        = 10.5;
   radiusDamageType    = $DamageType::Default;
   kickBackStrength    = 1750*1.5;

   explosion           = "BurstMortarExplosion";
   underwaterExplosion = "BurstMortarExplosion";
   shockwave           = BurstMortarShockwave;
   velInheritFactor    = 0.5;
   splash              = MortarSplash;
   depthTolerance      = 5.0; // depth at which it uses underwater explosion

//   baseEmitter         = ShockTrailEmitter;
//   bubbleEmitter       = ShockTrailEmitter;

   dryVelocity       = 95;
   wetVelocity       = 95;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 500;
   lifetimeMS        = 500;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 15.0;
   explodeOnWaterImpact      = true;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 300;

//   sound			 = MortarProjectileSound;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "1 0 0 1";

   hasLightUnderwaterColor = true;
   underWaterLightColor = "0.05 0.075 0.2";
   expProj     = "ImpactShot";
   ImpactShotCount = 5;

};

//------------------------------------------------
// Shocker bomb part 3 projectile
//------------------------------------------------
datablock GrenadeProjectileData(ShockerShot)
{
   projectileShapeName = "bomb.dts";
   emitterDelay        = -1;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.7;
   damageRadius        = 30.0;
   radiusDamageType    = $DamageType::Mortar;
   kickBackStrength    = 2500;

   shockwave           = "BurstMortarShockwave";
   explosion           = "ImpactExplosion";
   underwaterExplosion = "UnderwaterMortarExplosion";
   velInheritFactor    = 0.5;
   splash              = MortarSplash;
   depthTolerance      = 10.0; // depth at which it uses underwater explosion

//   baseEmitter         = MortarSmokeEmitter;
//   bubbleEmitter       = MortarBubbleEmitter;

   grenadeElasticity = 0.15;
   grenadeFriction   = 0.4;
   armingDelayMS     = 250;    // Key to impact was 0 but console errors for <250
   muzzleVelocity    = 63.7;
   drag              = 0.1;

   sound			 = MortarProjectileSound;

   hasLight    = true;
   lightRadius = 4;
   lightColor  = "0.9 0.4 0.0";

   hasLightUnderwaterColor = true;
   underWaterLightColor = "0.9 0.4 0.0";

};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------------------------------------------
datablock ItemData(ClusterAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some Cluster Cannon ammo";

   computeCRC = true;

};

//------------------------------------------------------------------------
// Shocker Command
//------------------------------------------------------------------------
function DevastatorShocker::onExplode(%data, %proj, %pos, %mod)
{

          %projectile = "Shockerbomb";
          %projectileType = "LinearProjectile";



     for(%i = 0; %i < 10; %i++)
     {
      %projectileSpread = 5;
      %vector = "2 2 2";  // 0 0 -1
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%projectileType)()
      {
         dataBlock        = %projectile;
         initialDirection = %vector;
         initialPosition  = %pos;
         sourceObject     = %proj.sourceObject;
         sourceSlot       = -1;
         vehicleObject    = 0;
      };

      MissionCleanup.add(%p);
     }
     Parent::onExplode(%data, %proj, %pos, %mod);
}

//--------------------------------------------------------------------------
// stage two: ShockerBomb explosion
//--------------------------------------------------------------------------
function ShockerBomb::onExplode(%data, %proj, %pos, %mod)
{

          %projectile = "ShockerBomb2";
          %projectileType = "LinearProjectile";



     for(%i = 0; %i < 5; %i++)
     {
      %projectileSpread = 5;
      %vector = "0 0 -0.5";  // 50 50 -0.5 for bomberbomb
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%projectileType)()
      {
         dataBlock        = %projectile;
         initialDirection = %vector;
         initialPosition  = %pos;
         sourceObject     = %proj.sourceObject;
         sourceSlot       = -1;
         vehicleObject    = 0;
      };

      MissionCleanup.add(%p);
     }
     Parent::onExplode(%data, %proj, %pos, %mod);
}

//------------------------------------------
// Part 3
//------------------------------------------
function ShockerBomb2::onExplode(%data, %proj, %pos, %mod)
{

          %projectile = "shockershot";  //BomberBomb LOL!   //shockershot
          %projectileType = "GrenadeProjectile";   //Bombprojectile  //grenadeprojectile



     for(%i = 0; %i < 3; %i++)
     {
      %projectileSpread = 2.88;
      %vector = "0 0 -0.5";  // 50 50 -0.5 for bomberbomb
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %projectileSpread;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%projectileType)()
      {
         dataBlock        = %projectile;
         initialDirection = %vector;
         initialPosition  = %pos;
         sourceObject     = %proj.sourceObject;
         sourceSlot       = -1;
         vehicleObject    = 0;
      };

      MissionCleanup.add(%p);
     }
     Parent::onExplode(%data, %proj, %pos, %mod);
}

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(ClusterImage)
{
   className = WeaponImage;
   shapeFile = "weapon_mortar.dts";
   offset = "0 0.2 0.0";
   rotation = "0 1 0 0";
   armThread = lookms;
   ammo = ClusterAmmo;
   item = Cluster;
   projectile = DevastatorShocker;
   projectileType =  LinearProjectile;


   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   statesound[0]                    = DevastatorStartSound;

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 1.0;
   stateSequence[1]                 = "Activated";
   stateSound[1]                    = DevastatorSwitchSound;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "DiscSpin";
   stateSound[2]                    = DevastatorLoopSound;

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 10.0;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateScript[3]                   = "onFire";
   stateSound[3]                    = DevastatorFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 0.1;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSound[4]                    = DevastatorReloadSound;
//   stateScript[4]                   = "Reload";

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = DevastatorDryFireSound;
   stateTimeoutValue[6]             = 2.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";

};

//--------------------------------------------------------------------------
datablock ItemData(Cluster)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = ClusterImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a Cluster Cannon";
};

//weapon model
datablock ShapeBaseImageData(CCDecalAImage)
{
   shapeFile = "weapon_mortar.dts";
   offset = "-0.2 0 -0.2";
   rotation = "0 1 0 60";
};

datablock ShapeBaseImageData(CCDecalBImage)
{
   shapeFile = "weapon_mortar.dts";
   offset = "0.2 0 -0.1";
   rotation = "0 1 0 -60";
};

datablock ShapeBaseImageData(CCDecalCImage)
{
   shapeFile = "weapon_mortar.dts";
   offset = "0.1 0 0.3";
   rotation = "0 1 0 180";
};

function ClusterImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(CCDecalAImage, 4);
   %obj.mountImage(CCDecalBImage, 5);
   %obj.mountImage(CCDecalCImage, 6);
}

function ClusterImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}

