if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------
// Fission Rifle
//--------------------------------------

//--------------------------------------------------------------------------
// Sounds
//--------------------------------------

datablock AudioProfile(FRDryFireSound)
{
   filename    = "fx/weapons/chaingun_dryfire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock LinearFlareProjectileData(FissionBolt)
{
   directDamage        = 0.09;
   directDamageType    = $DamageType::SentryTurret;
   doDynamicClientHits = true;

   explosion           = "SentryTurretExplosion";
   kickBackStrength  = 0.0;
   activateDelayMS = -1;

   dryVelocity       = 1500.0;
   wetVelocity       = 750.0;
   velInheritFactor  = 1.0;
   fizzleTimeMS      = 2000;
   lifetimeMS        = 3000;
   explodeOnDeath    = false;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 3000;

   numFlares         = 10;
   size              = 0.35;
   flareColor        = "1 0.35 0.35";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

   sound = SentryTurretProjectileSound;

   hasLight    = true;
   lightRadius = 1.5;
   lightColor  = "1 0.35 0.35";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(FissionRifleImage)
{
   className = WeaponImage;
   shapeFile = "weapon_disc.dts";
   item = FissionRifle;
   usesEnergy = true;
   minEnergy = 2;
   fireEnergy = 2;

   projectile = FissionBolt; // MrKeen
   projectileType = LinearFlareProjectile;
   emap = true;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.25;
   stateSequence[0] = "Activate";
   stateSound[0] = GrenadeReloadSound;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";

   stateName[3] = "Fire";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.13;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateSequence[3] = "Fire";
   stateScript[3] = "onFire";
   stateSound[3] = SentryTurretFireSound;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 0.40;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
//   stateSound[4] = PlasmaReloadSound;
   stateEjectShell[4]       = true;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = FRDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};

datablock ItemData(FissionRifle)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_disc.dts";
   image = FissionRifleImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a fission rifle";
};

datablock ShapeBaseImageData(FRDecalAImage)
{
   shapeFile = "weapon_sniper.dts";
   offset = "0.2 0 0.1";
   rotation = "0 1 0 90";
   emap = true;
};

datablock ShapeBaseImageData(FRDecalBImage)
{
   shapeFile = "weapon_sniper.dts";
   offset = "-0.2 0 0.1";
   rotation = "0 1 0 -90";
   emap = true;
};

datablock ShapeBaseImageData(FRDecalCImage)
{
   shapeFile = "weapon_sniper.dts";
   offset = "0 0 0.2";
   rotation = "0 1 0 180";
   emap = true;
};

function FissionRifleImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %obj.mountImage(FRDecalAImage, 4);
   %obj.mountImage(FRDecalBImage, 5);
   %obj.mountImage(FRDecalCImage, 6);
}

function FissionRifleImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);
}
