if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------------------------------------------
// MechRocketGun
//--------------------------------------

datablock AudioProfile(MechGunActivate)
{
   filename    = "fx/weapons/grenadelauncher_activate.wav";
   description = AudioDefault3d;
   preload = true;
};
datablock AudioProfile(MechRocketFireSound)
{
     filename = "fx/Bonuses/high-level4-blazing";
     description = AudioBIGExplosion3d;
   preload = true;
};
datablock AudioProfile(MechFire2Sound)
{
     filename = "fx/Bonuses/down_passback3_rocket.wav";
     description = AudioBIGExplosion3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(MechRocketGunAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_plasma.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "some mech rockets";
};

//--------------------------------------------------------------------------
// Weapon and item
//--------------------------------------

datablock ShapeBaseImageData(MechRocketGun2Image)
{
   className = WeaponImage;
   shapeFile = "turret_missile_large.dts";
   item = MechRocketGun;
   ammo = MechRocketGunAmmo;
   offset = "-1 0 0";
   emap = true;

   projectile = MechRocket;
   projectileType = LinearProjectile;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   stateSequence[0]                 = "Deploy";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSound[1]                    = MechGunActivate;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "Deploy";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 1;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateSound[3]                    = MechRocketFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 1;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSound[4]                    = MissileReloadSound;

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(MechRocketGunDImage)
{
   className = WeaponImage;
   shapeFile = "turret_missile_large.dts";
   item = MechRocketGun;
   ammo = MechRocketGunAmmo;
   offset = "-1.25 0 0";
   emap = true;

   projectile = MechRocket;
   projectileType = LinearProjectile;

   // State Data
   stateName[0]                     = "Preactivate";
   stateTransitionOnLoaded[0]       = "Activate";
   stateTransitionOnNoAmmo[0]       = "NoAmmo";
   stateSequence[0]                 = "Deploy";

   stateName[1]                     = "Activate";
   stateTransitionOnTimeout[1]      = "Ready";
   stateTimeoutValue[1]             = 0.5;
   stateSound[1]                    = MechGunActivate;

   stateName[2]                     = "Ready";
   stateTransitionOnNoAmmo[2]       = "NoAmmo";
   stateTransitionOnTriggerDown[2]  = "Fire";
   stateSequence[2]                 = "Deploy";

   stateName[3]                     = "Fire";
   stateTransitionOnTimeout[3]      = "Reload";
   stateTimeoutValue[3]             = 1;
   stateFire[3]                     = true;
   stateRecoil[3]                   = LightRecoil;
   stateAllowImageChange[3]         = false;
   stateSequence[3]                 = "Fire";
   stateSound[3]                    = MechRocketFireSound;

   stateName[4]                     = "Reload";
   stateTransitionOnNoAmmo[4]       = "NoAmmo";
   stateTransitionOnTimeout[4]      = "Ready";
   stateTimeoutValue[4]             = 1;
   stateAllowImageChange[4]         = false;
   stateSequence[4]                 = "Reload";
   stateSound[4]                    = MissileReloadSound;

   stateName[5]                     = "NoAmmo";
   stateTransitionOnAmmo[5]         = "Reload";
   stateSequence[5]                 = "NoAmmo";
   stateTransitionOnTriggerDown[5]  = "DryFire";

   stateName[6]                     = "DryFire";
   stateSound[6]                    = MortarDryFireSound;
   stateTimeoutValue[6]             = 1.0;
   stateTransitionOnTimeout[6]      = "NoAmmo";
};

datablock ShapeBaseImageData(MechRocketGunImage) : MechRocketGun2Image
{
   offset = "0.1 0 0";
   stateSequence[2]                 = "Deploy";
   stateScript[3] = "onFire";
};

datablock ItemData(MechRocketGun)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "turret_missile_large.dts";
   image = MechRocketGunImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
   pickUpName = "a mechrocketgun";
   emap = true;
};

function MechRocketGunImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);

   if(%obj.client.race $= Bioderm)
      %obj.mountImage(MechRocketGunDImage, 4);
   else
      %obj.mountImage(MechRocketGun2Image, 4);
}

function MechRocketGunImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
}

function MechRocketGunImage::onFire(%data, %obj, %slot)
{
   if(getSightInfo(%obj, 1, $TypeMasks::ForceFieldObjectType))
      return;


   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
   };
   %obj.applyKick(-7500);
   MissionCleanup.add(%p);
   %obj.decInventory(%data.ammo,1);
   %obj.lastProjectile = %p;
   %client.projectile = %p;
   %obj.play3d(MechFire2Sound);
   return MechRocketGun2Image::onFire(MechRocketGun2Image,%obj,4);
}

function MechRocketGun2Image::onFire(%data,%obj,%slot)
{


   %obj.setImageTrigger(4, true);
   %p = new (%data.projectileType)() {
      dataBlock        = %data.projectile;
      initialDirection = %obj.getMuzzleVector(%slot);
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
   };
   %obj.applyKick(-7500);
   MissionCleanup.add(%p);
   %obj.lastProjectile = %p;
   %client.projectile = %p;
   %obj.play3d(MechFire2Sound);
   return %obj.setImageTrigger(4, false);
}
