if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();


// MrKeen - moved to Chaingun.cs

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ShapeBaseImageData(ProtronImage)
{
   className = WeaponImage;
   shapeFile = "weapon_chaingun.dts";
   item      = Protron;
   ammo 	 = ProtronAmmo;
   emap = true;

   projectileSpread = 5.8 / 1000.0;

   //--------------------------------------
   stateName[0]             = "Activate";
   stateSequence[0]         = "Activate";
   stateSound[0]            = ChaingunSwitchSound;
   stateAllowImageChange[0] = false;
   //
   stateTimeoutValue[0]        = 0.5;
   stateTransitionOnTimeout[0] = "Ready";
   stateTransitionOnNoAmmo[0]  = "NoAmmo";

   //--------------------------------------
   stateName[1]       = "Ready";
   stateSpinThread[1] = Stop;
   //
   stateTransitionOnTriggerDown[1] = "Spinup";
   stateTransitionOnNoAmmo[1]      = "NoAmmo";

   //--------------------------------------
   stateName[2]               = "NoAmmo";
   stateTransitionOnAmmo[2]   = "Ready";
   stateSpinThread[2]         = Stop;
   stateScript[2] = "onCharge";
   stateTransitionOnTriggerDown[2] = "DryFire";

   //--------------------------------------
   stateName[3]         = "Spinup";
   stateSpinThread[3]   = SpinUp;
   stateSound[3]        = ChaingunSpinupSound;
   //
   stateTimeoutValue[3]          = 0.2;
   stateWaitForTimeout[3]        = false;
   stateTransitionOnTimeout[3]   = "Fire";
   stateTransitionOnTriggerUp[3] = "Spindown";

   //--------------------------------------
   stateName[4]             = "Fire";
   stateSequence[4]            = "Fire";
   stateSequenceRandomFlash[4] = true;
   stateSpinThread[4]       = FullSpeed;
//   stateSound[4]            = ChaingunFireSound;
   stateAllowImageChange[4] = false;
   stateScript[4]           = "onFire";
   stateFire[4]             = true;
   //
   stateTimeoutValue[4]          = 0.1;
   stateTransitionOnTimeout[4]   = "Fire";
   stateTransitionOnTriggerUp[4] = "Spindown";
   stateTransitionOnNoAmmo[4]    = "EmptySpindown";

   //--------------------------------------
   stateName[5]       = "Spindown";
   stateSound[5]      = ChaingunSpinDownSound;
   stateSpinThread[5] = SpinDown;
   //
   stateTimeoutValue[5]            = 2.5;
   stateWaitForTimeout[5]          = false;
   stateTransitionOnTimeout[5]     = "Ready";
   stateTransitionOnTriggerDown[5] = "Spinup";

   //--------------------------------------
   stateName[6]       = "EmptySpindown";
   stateSound[6]      = ChaingunSpinDownSound;
   stateSpinThread[6] = SpinDown;
   //
   stateTimeoutValue[6]        = 0.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
   
   //--------------------------------------
   stateName[7]       = "DryFire";
//   stateSound[7]      = ChaingunDryFireSound;
   stateTimeoutValue[7]        = 0.5;
   stateTransitionOnTimeout[7] = "NoAmmo";
};

datablock ItemData(ProtronAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some protron ammo";
   cantPickup = true;
};

datablock ItemData(Protron)
{
   className    = Weapon;
   catagory     = "Spawn Items";
   shapeFile    = "weapon_chaingun.dts";
   image        = ProtronImage;
   mass         = 1;
   elasticity   = 0.2;
   friction     = 0.6;
   pickupRadius = 2;
   pickUpName   = "a protron";
   cantPickup = true;

   emap = true;
};

function ProtronImage::onCharge(%data,%obj,%slot)
{
   if(%obj.chargingProt = false || !%obj.chargingProt)
      ChargeProtron(%obj, %data);
}

function ChargeProtron(%player, %datablock)       // should work....
{
   %ammo = %player.getInventory(ProtronAmmo);
   %ammoMax = %player.getDatablock().max[ProtronAmmo];

   if(%ammo > -1)   // jury rig for now
   {
      if(%ammo < %ammoMax)
      {
         if(!%player.isEMP)
         {
            %pct = %player.getEnergyPct();

//            if(%pct >= 0.25)
               %player.incInventory(ProtronAmmo, 1);

            %player.chargingProt = true;
         }
         else
            %player.setInventory(ProtronAmmo, 0);


         if(%pct == 1)
         {
            if(%player.isSyn)
               %mult = 125; //250
            else
               %mult = 250; //500
         }
         else
         {
            if(%player.isSyn)
               %mult = 250; //500
            else
               %mult = 500; //1000
         }

         schedule(%mult, %player, "ChargeProtron", %player, %datablock);
      }
      else
         %player.chargingProt = false;
   }
}

function ProtronImage::onFire(%data, %obj, %slot)
{
   %weapon = %obj.getMountedImage(0).item;
   if(%obj.client.mode[%weapon] == 0)
   {
      %rnd = getRandom(5);
      switch(%rnd)
      {
         case 0:
         %projectile = "ProtronBoltR";

         case 1:
         %projectile = "ProtronBoltG";

         case 2:
         %projectile = "ProtronBoltB";

         case 3:
         %projectile = "ProtronBoltY";

         case 4:
         %projectile = "ProtronBoltW";

         case 5:
         %projectile = "ProtronBoltC";

         default:
         %projectile = "PulseBolt"; //lol
      }

      %energyUse = 3;
   }
   else if(%obj.client.mode[%weapon] == 1)
   {
      %projectile = "PulseBolt";
      %energyUse = 4;
   }
   else if(%obj.client.mode[%weapon] == 2)
   {
      %energyUse = 7;
      %projectile = "BlueEnergyBolt";
   }
   %nrg = %energyUse--;

   if(%obj.getInventory(%data.ammo) < %energyUse)
   {
      %obj.play3d(ChaingunDryFireSound);
      return;
   }

   %data.lightStart = getSimTime();

   %vehicle = 0;

   %vector = %obj.getMuzzleVector(%slot);
   %x = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
   %y = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
   %z = (getRandom() - 0.5) * 2 * 3.1415926 * %data.projectileSpread;
   %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
   %vector = MatrixMulVector(%mat, %vector);

   if(%obj.client.mode[%weapon] == 0)
      %mode = "LinearFlareProjectile";
   else if(%obj.client.mode[%weapon] == 1)
      %mode = "LinearFlareProjectile";
   else if(%obj.client.mode[%weapon] == 2)
      %mode = "EnergyProjectile";

   %p = new(%mode)()
   {
      dataBlock        = %projectile;
      initialDirection = %vector;
      initialPosition  = %obj.getMuzzlePoint(%slot);
      sourceObject     = %obj;
      sourceSlot       = %slot;
      vehicleObject    = %vehicle;
   };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

//   if(%obj.client.mode[%weapon] == 0)
//      %obj.useEnergy(0.93);
//      %obj.decInventory(%data.ammo,1);
//   if(%obj.client.mode[%weapon] == 1)
//      %obj.useEnergy(1.36);
//      %obj.decInventory(%data.ammo,2);
//   if(%obj.client.mode[%weapon] == 2)
//      %obj.useEnergy(4);
//      %obj.decInventory(%data.ammo,5);

   %obj.play3d(FChaingunFireSound);
   %obj.decInventory(%data.ammo,%nrg);

   if(!%obj.chargingProt)
      ChargeProtron(%obj, %data);
}

datablock ShapeBaseImageData(GBDecalAImage)
{
   shapeFile = "ammo_mortar.dts";
   offset = "-0.05 0.25 0.1";
   rotation = "0 0 1 90";
};

datablock ShapeBaseImageData(GBDecalBImage)
{
   shapeFile = "ammo_plasma.dts";
   offset = "-0.1 -0.25 -0.1";
   rotation = "1 0 0 90";
};

datablock ShapeBaseImageData(GBDecalCImage)
{
   shapeFile = "ammo_plasma.dts";
   offset = "0.25 -0.25 -0.1";
   rotation = "1 0 0 90";
};

function ProtronImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
//   %obj.createSlotExtension(0);
//   %obj.createSlotExtension(1);

   %obj.mountImage(GBDecalAImage, 4);
   %obj.mountImage(GBDecalBImage, 5);
   %obj.mountImage(GBDecalCImage, 6);

//   %obj.slotExtension[0].mountImage(ASRDecalAImage, 0);
//   %obj.slotExtension[0].mountImage(ASRDecalBImage, 1);
//   %obj.slotExtension[0].mountImage(ASRDecalCImage, 2);
//   %obj.slotExtension[0].mountImage(LaserCannonDecalBImage, 3);
//   %obj.slotExtension[0].mountImage(LaserCannonDecalCImage, 4);
//   %obj.slotExtension[0].mountImage(SGDecalAImage, 5);
//   %obj.slotExtension[0].mountImage(SGDecalBImage, 6);
//   %obj.slotExtension[0].mountImage(SGDecalCImage, 7);

//   %obj.slotExtension[1].mountImage(ERDecalAImage, 0);
//   %obj.slotExtension[1].mountImage(ERDecalBImage, 1);
//   %obj.slotExtension[1].mountImage(ERDecalCImage, 2);
//   %obj.slotExtension[1].mountImage(ERDecalDImage, 3);
//   %obj.slotExtension[1].mountImage(SGDecalAImage, 4);
//   %obj.slotExtension[1].mountImage(SGDecalBImage, 5);
//   %obj.slotExtension[1].mountImage(SGDecalCImage, 6);
//   %obj.slotExtension[1].mountImage(RipperDecalAImage, 7);
}

function ProtronImage::onUnmount(%this,%obj,%slot)
{
   %obj.unmountImage(4);
   %obj.unmountImage(5);
   %obj.unmountImage(6);

//   %obj.deleteSlotExtension(0);
//   %obj.deleteSlotExtension(1);
}
