if(isObject(Meltdown))
   Meltdown.DSOFileCount++;
else
   quit();

//--------------------------------------
// Starburst Cannon
//--------------------------------------

datablock AudioProfile(StarburstFireSound)
{
   filename    = "fx/powered/turret_mortar_fire.wav";
   description = AudioDefault3d;
   preload = true;
   effect = MortarFireEffect;
};

datablock AudioProfile(StarburstMount)
{
   filename    = "fx/vehicles/bomber_turret_reload.wav";
   description = AudioDefault3d;
   preload = true;
};

//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearProjectileData(StarburstShell)
{
   projectileShapeName = "grenade.dts";
   emitterDelay        = 250;
   directDamage        = 0.0;
   hasDamageRadius     = true;
   indirectDamage      = 0.1;//0.0 --- must be < 0 (ST)
   damageRadius        = 5.0;//0.0 --- must be < 0 (ST)
   radiusDamageType    = $DamageType::Mortar;
   kickBackStrength    = 500;
   bubbleEmitTime      = 1.0;

   explosion           = "StarburstExplosion";
   splash              = MissileSplash;
   velInheritFactor    = 1.0;

   baseEmitter         = PulseCannonTrailEmitter;
   bubbleEmitter       = GrenadeBubbleEmitter;
   bubbleEmitTime      = 1.0;

   dryVelocity       = 80;
   wetVelocity       = 50;
   velInheritFactor  = 0.5;
   fizzleTimeMS      = 1500;
   lifetimeMS        = 1500;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 1500;

   activateDelayMS = -1;

   hasLight    = true;
   lightRadius = 6.0;
   lightColor  = "0.175 0.175 0.5";
   
   expProj     = "PlasmaBomb";
   mortarCount = 15;
};

function StarburstShell::onExplode(%data, %proj, %pos, %mod)
{
   %player = %proj.client;
     
   %maxSeed = 40;
   %minSeed = 10;

   if(%proj.StarburstMode $= "")
      %proj.StarburstMode = 0;

   if(%proj.StarburstMode == 0)
   {                         
      %projectile = "EnergyBolt"; 
      %projectileType = "EnergyProjectile";
      %maxSeed = 65;
      %minSeed = 30;
//      %spread = 3.1415926;
//      %vector = "0 0 1";
      %modifier = 0.5; // 25
   }
   else if(%proj.StarburstMode == 1)
   {
      if($SBRAXXPlasma)
      {
         %projectile = "RAXXFlame";
         %projectileType = "LinearProjectile";
         %maxSeed = 30;
         %minSeed = 30;
         %modifier = 0.25;
      }
      else
      {
         %projectile = "PlasmaBolt";
         %projectileType = "LinearFlareProjectile";
         %maxSeed = 50;
         %minSeed = 35;
         %modifier = 0.5; // 175
      }
   }
   else if(%proj.StarburstMode == 2)
   {
      %projectile = "DiscProjectile";
      %projectileType = "LinearProjectile";
      %maxSeed = 35;
      %minSeed = 20;
      %modifier = 0.5; // 25
   }
   else if(%proj.StarburstMode == 3)
   {
      %projectile = "BasicGrenade";
      %projectileType = "GrenadeProjectile";
      %maxSeed = 25;
      %minSeed = 15;
      %modifier = 1.0; // 7
   }
   else if(%proj.StarburstMode == 4)
   {
      %projectile = "PlasmaBolt";
      %projectileType = "LinearFlareProjectile";
      %maxSeed = 14;
      %minSeed = 7;
   }

   %seed = getRandom(%maxSeed, %minSeed);
   %spread = 3.1415926;
   %spread4 = 0.064;
   %vector = "0 0 1";
   %vector4 = "0 0 -1";
   %mode = %proj.StarburstMode;

   %FFRObject = new StaticShape()
   {
      dataBlock        = mReflector;
   };
   MissionCleanup.add(%FFRObject);
   %FFRObject.setPosition(%pos);
   %FFRObject.schedule(32, delete);

   for(%i = 0; %i < %seed; %i++)
   {
      %tspread = %mode != 4 ? %spread : %spread4;
      %x = (getRandom() - 0.5) * 2 * 3.1415926 * %tspread;  //3.1415926;
      %y = (getRandom() - 0.5) * 2 * 3.1415926 * %tspread; //3.1415926;
      %z = (getRandom() - 0.5) * 2 * 3.1415926 * %tspread; //1.5707963;//3.1415926;
      %mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
      %vector = %mode == 4 ? %vector4 : %vector;
      %vector = MatrixMulVector(%mat, %vector);

      %p = new (%projectileType)() // MrKeen
      {
         dataBlock        = %projectile;
         initialDirection = %vector;
         initialPosition  = %pos;
         sourceObject     = %FFRObject;
         sourceSlot       = 0;
         vehicleObject    = 0;
         bkSourceObject   = %proj.sourceObject;
         pDmgMod          = %modifier;
         starburstSpawned = true;
      };

      MissionCleanup.add(%p);
   }
   Parent::onExplode(%data, %proj, %pos, %mod);
}

//--------------------------------------------------------------------------
// Ammo
//--------------------------------------

datablock ItemData(StarburstAmmo)
{
   className = Ammo;
   catagory = "Ammo";
   shapeFile = "ammo_mortar.dts";
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "some starburst ammo";
};

//--------------------------------------------------------------------------
// Weapon
//--------------------------------------
datablock ItemData(Starburst)
{
   className = Weapon;
   catagory = "Spawn Items";
   shapeFile = "weapon_mortar.dts";
   image = StarburstImage;
   mass = 1;
   elasticity = 0.2;
   friction = 0.6;
   pickupRadius = 2;
	pickUpName = "a starburst cannon";

   emap = true;
};

datablock ShapeBaseImageData(StarburstImage)
{
   className = WeaponImage;
   shapeFile = "weapon_missile.dts";
   item = Starburst;
   ammo = StarburstAmmo;
   emap = true;

//   muzzleFlash = StarburstMuzzleFlash;

   stateName[0] = "Activate";
   stateTransitionOnTimeout[0] = "ActivateReady";
   stateTimeoutValue[0] = 0.5;
   stateSequence[0] = "Activate";
   stateSound[0] = StarburstMount;

   stateName[1] = "ActivateReady";
   stateTransitionOnLoaded[1] = "Ready";
   stateTransitionOnNoAmmo[1] = "NoAmmo";

   stateName[2] = "Ready";
   stateTransitionOnNoAmmo[2] = "NoAmmo";
   stateTransitionOnTriggerDown[2] = "Fire";
   stateSound[2] = MortarIdleSound;

   stateName[3] = "Fire";
   stateSequence[3] = "Recoil";
   stateTransitionOnTimeout[3] = "Reload";
   stateTimeoutValue[3] = 0.8;
   stateFire[3] = true;
   stateRecoil[3] = LightRecoil;
   stateAllowImageChange[3] = false;
   stateScript[3] = "onFire";
   stateSound[3] = StarburstFireSound;
//   stateShockwave[3] = true;

   stateName[4] = "Reload";
   stateTransitionOnNoAmmo[4] = "NoAmmo";
   stateTransitionOnTimeout[4] = "Ready";
   stateTimeoutValue[4] = 2.0;
   stateAllowImageChange[4] = false;
   stateSequence[4] = "Reload";
   stateSound[4] = MortarReloadSound;

   stateName[5] = "NoAmmo";
   stateTransitionOnAmmo[5] = "Reload";
   stateSequence[5] = "NoAmmo";
   stateTransitionOnTriggerDown[5] = "DryFire";

   stateName[6]       = "DryFire";
   stateSound[6]      = MortarDryFireSound;
   stateTimeoutValue[6]        = 1.5;
   stateTransitionOnTimeout[6] = "NoAmmo";
};

function StarburstImage::onFire(%data, %obj, %slot)
{
   %data.lightStart = getSimTime();

   if(getSightInfo(%obj, 1, $TypeMasks::ForceFieldObjectType))
      return;

   %vehicle = 0;

      %weapon = %obj.getMountedImage(0).item;
     if(%obj.client.mode[%weapon] == 2)
          %ammoUse = 2;
     else if(%obj.client.mode[%weapon] == 3)
          %ammoUse = 3;
     else
          %ammoUse = 1;

     if(%ammoUse > %obj.getInventory(%data.ammo))
          return;
          
      %p = new LinearProjectile() {
         dataBlock        = "StarburstShell";
         initialDirection = %obj.getMuzzleVector(%slot);
         initialPosition  = %obj.getMuzzlePoint(%slot);
         sourceObject     = %obj;
         sourceSlot       = %slot;
         vehicleObject    = %vehicle;
      };

   if (isObject(%obj.lastProjectile) && %obj.deleteLastProjectile)
      %obj.lastProjectile.delete();

   %obj.lastProjectile = %p;
   %obj.deleteLastProjectile = %data.deleteLastProjectile;
   MissionCleanup.add(%p);

     %p.client = %obj.client;
     %p.client.player = %obj.client.player;
     %p.client.player.slot = %slot;
     %p.StarburstMode = %obj.client.mode[%weapon];
     %proj = %p.getDatablock();

   // AI hook
   if(%obj.client)
      %obj.client.projectile = %p;

   %obj.decInventory(%data.ammo,%ammoUse);
   return %p;
}

datablock ShapeBaseImageData(SBDecalAImage)
{
   shapeFile = "weapon_mortar.dts";
   offset = "-0.2 0 0.3";
   rotation = "1 0 0 180";
   emap = true;
};

datablock ShapeBaseImageData(SBDecalBImage)
{
   shapeFile = "stackable4m.dts";
   offset = "-0.1 0.3 0.3";
   rotation = "1 0 0 90";
   emap = true;
};

datablock ShapeBaseImageData(SBDecalB2Image)
{
   shapeFile = "stackable4l.dts";
   offset = "-0.1 0.3 0.3";
   rotation = "1 0 0 90";
   emap = true;
};

function StarburstImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this, %obj, %slot);
   %weapon = %obj.getMountedImage(0).item;
   if(%obj.client.mode[%weapon] <= 1)
   {
      %obj.mountImage(SBDecalAImage, 4);
      %obj.mountImage(SBDecalBImage, 5);
   }
   else
   {
      %obj.mountImage(SBDecalAImage, 4);
      %obj.mountImage(SBDecalB2Image, 5);
   }
}

function StarburstImage::onUnmount(%this,%obj,%slot)
{
   Parent::onUnmount(%this, %obj, %slot);
   %obj.unmountImage(4);
   %obj.unmountImage(5);
//   %obj.unmountImage(6);
}
