//--------------------------------------------------
// BlueMitziMod
// Changes the Mitzi Blast Cannon to its Blue counterpart from MDPV
// By: Deathscythe~40
//--------------------------------------------------

datablock ParticleData(MBExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 0.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 750;
   lifetimeVarianceMS   = 150;
   textureName          = "particleTest";
   colors[0]     = "0.0 0.2 0.9 0.7";
   colors[1]     = "0.1 0 1 0.0";
   sizes[0]      = 2;
   sizes[1]      = 5;
};

datablock ParticleEmitterData(MBExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvances = false;
   particles = "MBExplosionParticle";
};

datablock ExplosionData(MitziBlastExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 150;
   particleRadius = 3.5;
   faceViewer = true;
};

datablock ExplosionData(MBXSubExplosion1)
{
   explosionShape = "disc_explosion.dts";
   faceViewer           = true;

   delayMS = 1;

   offset = 0;

   playSpeed = 0.5;

   sizes[0] = "1.5 1.5 1.5";
   sizes[1] = "3 3 3";
   times[0] = 0.0;
   times[1] = 1.0;
};

datablock ExplosionData(MitziBlastXExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   sizes[0] = "2 2 2";
   sizes[1] = "2 2 2";
   times[0] = 0.0;
   times[1] = 1.0;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;
   subExplosion[0] = MBXSubExplosion1;

   shockwave = SuperPlasmaShockwave2D;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 300;
   particleRadius = 7;
   faceViewer = true;
};

datablock ExplosionData(MitziBlastXUWExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   sizes[0] = "4 4 4";
   sizes[1] = "4 4 4";
   times[0] = 0.0;
   times[1] = 1.0;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = DiscMistEmitter;
   particleDensity = 300;
   particleRadius = 7;
   faceViewer = true;

   bubbleEmitter = "DiscExplosionBubbleEmitter";
};

datablock ExplosionData(UMitziBlastExplosion)
{
   explosionShape = "disc_explosion.dts";
   soundProfile   = plasmaExpSound;

   shakeCamera = true;
   camShakeFreq = "8.0 9.0 7.0";
   camShakeAmp = "25.0 25.0 25.0";
   camShakeDuration = 1.3;
   camShakeRadius = 25.0;

   particleEmitter = MBExplosionEmitter;
   particleDensity = 150;
   particleRadius = 3.5;
   faceViewer = true;

   bubbleEmitter = "DiscExplosionBubbleEmitter";
};

//--------------------------------------------------------------------------
// Trail
//--------------------------------------

datablock ParticleData(MBTrailParticle)
{
   dragCoefficient      = 2.75;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 0;
   textureName          = "flarebase.png"; //particleTest";
   colors[0]     = "0.3 0.3 0.7 0.5";
   colors[1]     = "0.7 0.7 1 0.03";
   colors[2]     = "0.1 0.1 0.1 0.01";
   sizes[0]      = 1.5;
   sizes[1]      = 1.0;
   sizes[2]      = 0.5;
};

datablock ParticleEmitterData(MBTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 12;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance  = true;
   particles = "MBTrailParticle";
};

datablock ParticleData(MBXTrailParticle)
{
   dragCoefficient      = 2.75;
   gravityCoefficient   = 0.1;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 1200;
   lifetimeVarianceMS   = 0;
   textureName          = "flarebase.png"; //particleTest";
   colors[0]     = "0.3 0.3 0.7 0.5";
   colors[1]     = "0.7 0.7 1 0.03";
   colors[2]     = "0.1 0.1 0.1 0.01";
   sizes[0]      = 3.0;
   sizes[1]      = 1;
   sizes[2]      = 0.5;
};

datablock ParticleEmitterData(MBXTrailEmitter)
{
   ejectionPeriodMS = 10;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 12;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance  = true;
   particles = "MBXTrailParticle";
};
//--------------------------------------------------------------------------
// Projectile
//--------------------------------------
datablock LinearFlareProjectileData(MitziBlast)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "6.0 6.0 6.0";
   faceViewer          = true;
   directDamage        = 0.6;
   hasDamageRadius     = true;
   indirectDamage      = 0.45;
   damageRadius        = 14.0;
   kickBackStrength    = 1000;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MitziBlastExplosion";
   underwaterExplosion = "UMitziBlastExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MBTrailEmitter;

   dryVelocity       = 45.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   size[0]           = 0.4;
   size[1]           = 8;
   size[2]           = 3;
   numFlares         = 50;
   flareColor        = "0.0 0.0 1";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = false;
   lightRadius = 8.0;
   lightColor  = "0.1 0 1";
};

datablock LinearFlareProjectileData(MitziSingularityBlast)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "3.0 3.0 3.0";
   faceViewer          = true;
   directDamage        = 0.3;
   hasDamageRadius     = true;
   indirectDamage      = 0.275;
   damageRadius        = 7.0;
   kickBackStrength    = 500;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MiniMitziBlastExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = TDMStreakEmitter;

   dryVelocity       = 150.0;
   wetVelocity       = 300.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 15000;
   lifetimeMS        = 15000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 35;
   flareColor        = "0 0 1";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = false;
   lightRadius = 8.0;
   lightColor  = "0.1 0 1";
};

datablock LinearFlareProjectileData(MitziBooster)
{
//   projectileShapeName = "grenade_flare.dts";
//   scale               = "2.0 2.0 2.0";
   scale               = "6.0 6.0 6.0";
   faceViewer          = true;
   directDamage        = 0.001;
   hasDamageRadius     = true;
   indirectDamage      = 0.001;
   damageRadius        = 10.0;
   kickBackStrength    = 7500;
   radiusDamageType    = $DamageType::Default;

   explosion           = "ConcussionGrenadeExplosion";
   underwaterExplosion = "ConcussionGrenadeExplosion";
   splash              = PlasmaSplash;

   dryVelocity       = 45.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 10000;
   lifetimeMS        = 10000;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   numFlares         = 32;
   flareColor        = "0 0 1";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = false;
   lightRadius = 8.0;
   lightColor  = "0.1 0 1";
};

datablock LinearFlareProjectileData(MitziX2)
{
   scale               = "12.0 12.0 12.0";
   faceViewer          = true;
   directDamage        = 0;
   hasDamageRadius     = true;
   indirectDamage      = 0.9;
   damageRadius        = 14.0;
   kickBackStrength    = 2000;
   radiusDamageType    = $DamageType::MB;

   explosion           = "MitziBlastXExplosion";
   underwaterExplosion = "MitziBlastXUWExplosion";
   splash              = PlasmaSplash;
   baseEmitter         = MBXTrailEmitter;

   dryVelocity       = 45.0;
   wetVelocity       = 75.0;       // faster uw
   velInheritFactor  = 0.3;
   fizzleTimeMS      = 7500;
   lifetimeMS        = 7500;
   explodeOnDeath    = true;
   reflectOnWaterImpactAngle = 0.0;
   explodeOnWaterImpact      = false;
   deflectionOnWaterImpact   = 0.0;
   fizzleUnderwaterMS        = 15000;

   activateDelayMS = -1;
   size[0]           = 0.4;
   size[1]           = 14;
   size[2]           = 3;
   numFlares         = 50;
   flareColor        = "0 0 1";
   flareModTexture   = "flaremod";
   flareBaseTexture  = "flarebase";

	sound      = PlasmaProjectileSound;
   fireSound    = PlasmaFireSound;
   wetFireSound = PlasmaFireWetSound;

   hasLight    = false;
   lightRadius = 8.0;
   lightColor  = "0.1 0 1";
};

datablock ShockwaveData(MBDispSShockwave)
{
   width = 0.3;
   numSegments = 32;
   numVertSegments = 6;
   velocity = 15;
   acceleration = -30;
   lifetimeMS = 600;
   height = 0.5;
   verticalCurve = 0.5;
//   is2D = true;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0]     = "1 1 1 0.2"; //colors[0] = "1.0 1.0 1.0 0.75";
   colors[1]     = "0.5 0.5 1.0"; //colors[1] = "1.0 1.0 0.5 0.5";
   colors[2]     = "0.5 0.0 1 0.0";   //colors[2] = "1.0 1.0 0.1 0.0";


   mapToTerrain = false;
   orientToNormal = true;
   renderBottom = true;
};

