// Player Reservation - version 1.5 (4-19-03)
// Holds a place on the server for people specified by reserve()
// Code by Southtown (ST)

$VoteMessage["VoteVipPlayer"] = "vip player";

package PlayerReservation
{

function GameConnection::onConnect(%client, %name, %raceGender, %skin, %voice, %voicePitch)
{
   %count = getVipCount(); // --- Subtract the ones already in the server (ST)
   for(%i = 0; %i < ClientGroup.getCount(); %i++)
   {
      %client = ClientGroup.getObject(%i);
      for(%j = 0; $Reserved[%j] !$= ""; %j++)
         if(getField(%client.getAuthInfo(), 0) $= $Reserved[%j])
            %count--;
            
      for(%k = 0; %k < getFieldCount($Host::VipList); %k++)
         if(getField(%client.getAuthInfo(), 0) $= getField($Host::VipList, %k))
            %count--;
   }

   if(%count && (($Host::MaxPlayers - %count) <= $HostGamePlayerCount))
   {
      if(isOnVipList(getField(%client.getAuthInfo(), 0)))
      {
         Parent::onConnect(%client, %name, %raceGender, %skin, %voice, %voicePitch);
         return;
      }
      for(%i = 0; $Reserved[%i] !$= ""; %i++)
      {
         if(getField(%client.getAuthInfo(), 0) $= $Reserved[%i])
         {
            unReserve(%name);
            Parent::onConnect(%client, %name, %raceGender, %skin, %voice, %voicePitch);
            return;
         }
      }
   }
   else
   {
      Parent::onConnect(%client, %name, %raceGender, %skin, %voice, %voicePitch);
      return;
   }
   %client.setDisconnectReason("The rest of the space on this server has been reserved.");
   %client.schedule(700, "delete");
}

function DefaultGame::sendGamePlayerPopupMenu(%game, %client, %targetClient, %key)
{
   Parent::sendGamePlayerPopupMenu(%game, %client, %targetClient, %key);

   // --- Add a little something to the bottom (ST)
   if(%client.isAdmin)
   {
      if(isOnVipList(getField(%client.getAuthInfo(), 0)))
         messageClient(%client, 'MsgPlayerPopupItem', "", %key, "VipPlayer", "", 'Remove From VIP List', 28);
      else
         messageClient(%client, 'MsgPlayerPopupItem', "", %key, "VipPlayer", "", 'Add To VIP List', 28);
   }
}

function LobbyPlayerPopup::onSelect(%this, %id, %text)
{
   error("LobbyPlayerPopup::onSelect(): %id = "@ %id);
   if(%id == 28) // --- second one of mine (ST)
   {
      if(!isOnVipList(getField(%this.player.client.getAuthInfo(), 0)))
         MessageBoxYesNo("CONFIRM", "Are you sure you want to add "@ %this.player.name @" to the VIP List?",
                         "lobbyPlayerVote( VoteVipPlayer, \"VIP player\", "@ %this.player.clientId @");");
      else
         MessageBoxYesNo("CONFIRM", "Are you sure you want to remove "@ %this.player.name @" from the VIP List?",
                         "lobbyPlayerVote( VoteVipPlayer, \"VIP player\", "@ %this.player.clientId @");");
   }
   // --- Should be called regardless (ST)
   Parent::onSelect(%this, %id, %text);
}

function DefaultGame::evalVote(%game, %typeName, %admin, %arg1, %arg2, %arg3, %arg4)
{
   if(%typeName $= "voteVipPlayer") // --- Intercepted!! (ST)
      %game.voteVipPlayer(%admin, %arg1, %arg2, %arg3, %arg4);
   else
      Parent::evalVote(%game, %typeName, %admin, %arg1, %arg2, %arg3, %arg4);
}

function DefaultGame::voteVipPlayer(%game, %admin, %client)
{
   error("DefaultGame::voteVipPlayer()");
   if(%admin)
   {
      %name = getField(%client.getAuthInfo(), 0);
      if(!isOnVipList(%name))
         addToVipList(%name);
      else
         removeFromVipList(%name);

      messageClient(%client, 'Msg', "\c2"@ getVipCount() @" places reserved on server.~wfx/misc/bounty_bonus.wav");
   }
}

};
activatePackage(PlayerReservation);

function reserve(%name)
{
   if(%name !$= "")
   {
      %count = 0;
      for(%i = 0; $Reserved[%i] !$= ""; %i++)
         %count++;

      if($HostGamePlayerCount < ($Host::MaxPlayers - getVipCount()))
         MessageBoxYesNo("CONFIRM", "Reserve a place on this server for "@ %name @"? ("@
                         getVipCount() @" currently reserved)", "if(!isOnVipList(\'"@ %name @
                         "\'))$Reserved["@ %count @"] = \'"@ %name @"\';");
      else
         MessageBoxOK("REJECTED", "The server only has "@ $Host::MaxPlayers - $HostGamePlayerCount @
                      " spots available but needs "@ getVipCount() + 1 @".");
   }
}

function unReserve(%name)
{
   if(%name !$= "")
   {
      %num = 99; // --- Greater-than maxPlayers LOL (ST)
      for(%i = 0; $Reserved[%i] !$= ""; %i++)
      {
         if($Reserved[%i] $= %name)
         {
            $Reserved[%i] = "";
            %num = %i;
         }
         else if(%i > %num)
         {
            $Reserved[%i - 1] = $Reserved[%i];
            $Reserved[%i] = "";
         }
      }
   }
}

function addToVipList(%name)
{
   error("addToVipList() name = "@ %name);
   error("addToVipList() preOp = "@ $Host::VipList);
   if(%name !$= "")
   {
      %count = getFieldCount($Host::VipList);
      for(%i = 0; %i < %count; %i++)
      {
         %vip = getField($Host::VipList, %i);
         if(%vip $= %name)
         {
            unReserve(%name);
            return;  // They're already there!
         }
      }

      if(%count == 0)
         $Host::VipList = %name;
      else
         $Host::VipList = $Host::VipList TAB %name;

      export("$Host::*", "prefs/ServerPrefs.cs", false);
      unReserve(%name);
   }
   error("addToVipList() postOp = "@ $Host::VipList);
}

function removeFromVipList(%name)
{
   error("removeFromVipList() name = "@ %name);
   error("removeFromVipList() preOp = "@ $Host::VipList);
   if(%name !$= "")
   {
      %count = getFieldCount($Host::VipList);
      %bookmark = 999; // --- Greater-than count =) (ST)
      %newList = "";
      for ( %i = 0; %i < %count; %i++ )
      {
         %vip = getField($Host::VipList, %i);
         if ( %vip $= %name )
         {
            if(%i != 0)
               %newList = getFields($Host::VipList, 0, %i);
            %bookmark = %i;
         }
         else if(%i > %bookmark)
            %newList = %newList TAB %vip;
      }

      if(getSubStr(%newList, 0, 1) $= "\t")
         %newList = getSubStr(%newList, 1, strLen(%newList) - 1);

      if(%vip !$= "")
      {
         $Host::VipList = %newList;
         export( "$Host::*", "prefs/ServerPrefs.cs", false );
      }
   }
   error("removeFromVipList() postOp = "@ $Host::VipList);
}

function isOnVipList(%name)
{
   if(%name !$= "")
      for(%i = 0; %i < getFieldCount($Host::VipList); %i++)
         if(getField(getRecord($Host::VipList, 0), %i) $= %name)
            return true;

   return false;
}

function getVipCount()
{
   %count = getFieldCount($Host::VipList);
   for(%i = 0; $Reserved[%i] !$= ""; %i++)
      %count++;

   return %count;
}

function clearVip()
{
   for(%i = 0; $Reserved[%i] !$= ""; %i++)
      $Reserved[%i] = "";
      
   $Host::VipList = "";
   export( "$Host::*", "prefs/ServerPrefs.cs", false );
}


