//--------------------------------------------------------------------------
// Plugin Name: voteSilencePlayer.mod version 1.2
// Created by: Southtown - 4/14/03
// Description: Adds a voting option to totally silence a player in the game
//--------------------------------------------------------------------------
$VoteMessage["VoteSilencePlayer"] = "silence player";

package voteSilencePlayer      //Bensam = 131323
{

function chatMessageTeam( %sender, %team, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 )
{
   if ( ( %msgString $= "" ) || spamAlert( %sender ) || %sender.isSilenced )
      return;

   if( %sender.isSilenced )
   {
      chatMessageClient( %sender, %sender, %sender.voiceTag, %sender.voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
      return;
   }

   %count = ClientGroup.getCount();
   for ( %i = 0; %i < %count; %i++ )
   {
      %obj = ClientGroup.getObject( %i );
      if ( %obj.team == %sender.team )
         chatMessageClient( %obj, %sender, %sender.voiceTag, %sender.voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
   }
}

function cannedChatMessageTeam( %sender, %team, %msgString, %name, %string, %keys )
{
   if ( ( %msgString $= "" ) || spamAlert( %sender ) || %sender.isSilenced )
      return;

   if( %sender.isSilenced )
   {
      cannedChatMessageClient( %sender, %sender, %msgString, %name, %string, %keys );
      return;
   }

   %count = ClientGroup.getCount();
   for ( %i = 0; %i < %count; %i++ )
   {
      %obj = ClientGroup.getObject( %i );
      if ( %obj.team == %sender.team )
         cannedChatMessageClient( %obj, %sender, %msgString, %name, %string, %keys );
   }
}

function chatMessageAll( %sender, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 )
{
   if ( ( %msgString $= "" ) || spamAlert( %sender ) || %sender.isSilenced )
      return;

   if( %sender.isSilenced )
   {
      chatMessageClient( %sender, %sender, %sender.voiceTag, %sender.voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
      return;
   }

   %count = ClientGroup.getCount();
   for ( %i = 0; %i < %count; %i++ )
   {
		%obj = ClientGroup.getObject( %i );
		if(%sender.team != 0)
	      chatMessageClient( %obj, %sender, %sender.voiceTag, %sender.voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
		else
		{
			// message sender is an observer -- only send message to other observers
			if(%obj.team == %sender.team || %obj.isAdmin || %obj.isSuperAdmin)
		      chatMessageClient( %obj, %sender, %sender.voiceTag, %sender.voicePitch, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10 );
		}
	}
}

function cannedChatMessageAll( %sender, %msgString, %name, %string, %keys )
{
   if ( ( %msgString $= "" ) || spamAlert( %sender ) )
      return;

   if( %sender.isSilenced )
   {
      cannedChatMessageClient( %sender, %sender, %msgString, %name, %string, %keys );
      return;
   }

   %count = ClientGroup.getCount();
   for ( %i = 0; %i < %count; %i++ )
      cannedChatMessageClient( ClientGroup.getObject(%i), %sender, %msgString, %name, %string, %keys );
}

function DefaultGame::sendGamePlayerPopupMenu( %game, %client, %targetClient, %key )
{
   Parent::sendGamePlayerPopupMenu( %game, %client, %targetClient, %key );

   // --- Add a little something to the bottom (ST)
   %isAdmin = ( %client.isAdmin || %client.isSuperAdmin );
   %isTargetAdmin = ( %targetClient.isAdmin || %targetClient.isSuperAdmin );
   %isTargetSelf = ( %client == %targetClient );
   %outrankTarget = false;
   if ( %client.isSuperAdmin )
      %outrankTarget = !%targetClient.isSuperAdmin;
   else if ( %client.isAdmin )
      %outrankTarget = !%targetClient.isAdmin;

   if ( %game.scheduleVote $= "" && !%isAdmin && !%isTargetAdmin )
   {
      if ( !%isTargetSelf )
      {
         if(%client.isSilenced)
            messageClient( %client, 'MsgPlayerPopupItem', "", %key, "SilencePlayer", "", 'Vote to Unsilence', 27 );
         else
            messageClient( %client, 'MsgPlayerPopupItem', "", %key, "SilencePlayer", "", 'Vote to Silence', 27 );
      }
   }
   else if ( %isAdmin && !isDemo() )
   {
      if ( !%isTargetSelf && %outrankTarget )
      {
         if(%client.isSilenced)
            messageClient( %client, 'MsgPlayerPopupItem', "", %key, "SilencePlayer", "", 'Unsilence', 27 );
         else
            messageClient( %client, 'MsgPlayerPopupItem', "", %key, "SilencePlayer", "", 'Silence', 27 );
      }
   }
}

function LobbyPlayerPopup::onSelect( %this, %id, %text )
{
   error("LobbyPlayerPopup::onSelect(): %id = "@ %id);
   if(%id == 27) // --- My age... I think (ST)
   {
      error("%id = 27");
      MessageBoxYesNo( "CONFIRM", "Are you sure you want to silence " @ %this.player.name @ "?",
      "lobbyPlayerVote( VoteSilencePlayer, \"SILENCE player\", " @ %this.player.clientId @ " );" );
   }
   Parent::onSelect( %this, %id, %text );
}

function DefaultGame::evalVote(%game, %typeName, %admin, %arg1, %arg2, %arg3, %arg4)
{
   if(%typeName $= "voteSilencePlayer") // --- Intercepted!! (ST)
      %game.voteSilencePlayer(%admin, %arg1, %arg2, %arg3, %arg4);
   else
      Parent::evalVote(%game, %typeName, %admin, %arg1, %arg2, %arg3, %arg4);
}

function DefaultGame::voteSilencePlayer(%game, %admin, %client)
{
   error("DefaultGame::voteSilencePlayer()");
   %cause = "";
   %undo = "";
   if(%client.isSilenced)
      %undo = "un";
      
   if(%admin)
   {
      if(%client.isSilenced)
      {
         %client.isSilenced = false;
         messageAll('MsgAdminForce', '\c2The Admin has unsilenced %1.', %client.name);
      }
      else
      {
         %client.isSilenced = true;
         messageAll('MsgAdminForce', '\c2The Admin has stuffed a sock in %1.', %client.name);
      }
      %cause = "(admin)";
   }
   else
   {
      %totalVotes = %game.totalVotesFor + %game.totalVotesAgainst;
      if(%totalVotes > 0 && (%game.totalVotesFor / (ClientGroup.getCount() - $HostGameBotCount)) > ($Host::VotePasspercent / 100))
      {
         if(%client.isSilenced)
         {
            %client.isSilenced = false;
            messageAll('MsgAdminForce', '\c2%1 has been silenced by vote.', %client.name);
         }
         else
         {
            %client.isSilenced = true;
            messageAll('MsgAdminForce', '\c2%1 has been silenced by vote.', %client.name);
         }
         %cause = "(vote)";
      }
      else
      {
         if(%client.isSilenced)
            messageAll('MsgVoteFailed', '\c2Vote to unsilence %1 did not pass: %2 percent.', %client.name, mFloor(%game.totalVotesFor/(ClientGroup.getCount() - $HostGameBotCount) * 100));
         else
            messageAll('MsgVoteFailed', '\c2Vote to silence %1 did not pass: %2 percent.', %client.name, mFloor(%game.totalVotesFor/(ClientGroup.getCount() - $HostGameBotCount) * 100));
      }
   }
   if(%cause !$= "")
      logEcho(%client.nameBase SPC %undo @"silenced "@ %cause);
}

};
activatePackage(voteSilencePlayer);

